#include <qapplication.h>
#include <qwidget.h>
#include <qthread.h>
#include <qpainter.h>
#include <qframe.h>
#include <qcolor.h>

#define  NoAmpel  12

QWaitCondition ampelCond; // Globale Condition-Variable

//............................................................ Klasse Ampel
class Ampel : public QWidget, QThread
{
public:
   Ampel( int nr, QColor color, QWidget *parent = 0 ) : QWidget( parent ) {
      farbe = color;
      setGeometry( nr%4*100, nr/4*200, 100, 200 );
      show();
      QThread::start();
   }

protected:
   void run() {
       while(1) {
          repaint( false );
          if ( farbe == red ) {
             ampelCond.wait(); //... Warten auf's Aufwecken 
             msleep( 100 );
             farbe = yellow; repaint( false ); //... rot -> gelb
             msleep( 100 );
          }
          farbe = green; repaint( false ); //... gelb -> gruen
          msleep( 400 );
          farbe = yellow; repaint( false ); //... gruen -> gelb
          msleep( 100 );
          farbe = red;    //... gelb -> rot
          ampelCond.wakeOne(); //... Einen wartenden Thread aufwecken
       }
   }

   virtual void paintEvent( QPaintEvent * ) {
      QPainter p( this );
      QColor ausFarbe( 150, 150, 150 );

      p.setPen( QPen( black, 5 ) );
      p.drawRect( 0, 0, 90, 190 );
      p.setPen( QPen( black, 1 ) );
      p.setBrush( (farbe == red) ? farbe : ausFarbe );
      p.drawEllipse( 30, 30, 40, 40 );
      p.setBrush( (farbe == yellow) ? farbe : ausFarbe );
      p.drawEllipse( 30, 80, 40, 40 );
      p.setBrush( (farbe == green) ? farbe : ausFarbe );
      p.drawEllipse( 30, 130, 40, 40 );
      p.flush();
   }

private:
   QColor farbe;
};

//.................................................................... main
int main( int argc, char *argv[] ) {
    QApplication app(argc, argv);

    QWidget myWidget;

    Ampel *ampel[ NoAmpel ];

    ampel[0] = new Ampel( 0, Qt::green, &myWidget );
    for ( int i=1; i<NoAmpel; i++ )
       ampel[i] = new Ampel( i, Qt::red, &myWidget );

    app.setMainWidget( &myWidget);

    myWidget.resize( 400, 600 );
    myWidget.show();

    return app.exec();
}
