#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qcolor.h>

//............................................................ Klasse Ampel
class Ampel : public QWidget
{
public:
   Ampel( QWidget *parent = 0 ) : QWidget( parent ) {
      ampel = 0;
      redId = yellow1Id = yellow2Id = greenId = -1;
      farbe[0] = Qt::yellow;
      yellow1Id = startTimer( 500 );
      farbe[1] = Qt::red;
      setGeometry( 0, 0, 400, 400 );
      repaint( false );
      show();
   }

protected:
   virtual void paintEvent( QPaintEvent * ) {
      QPainter p( this );
      maleAmpel( &p, 0 );
      maleAmpel( &p, 1 );
   }

   virtual void timerEvent( QTimerEvent *e ) {
      if ( e->timerId() == redId ) {
         if ( farbe[ampel] == Qt::red ) {
            farbe[ampel] = Qt::yellow;
            farbe[(ampel+1)%2] = Qt::red;
            yellow1Id = startTimer( 500 );
            killTimer( redId );
            redId = -1;
         }
      } else if ( e->timerId()==yellow1Id ) {
         if ( farbe[ampel] == Qt::yellow ) {
            farbe[ampel] = Qt::green;
            greenId = startTimer( 2000 );
            killTimer( yellow1Id );
            yellow1Id = -1;
         }
      } else if ( e->timerId()==greenId ) {
         if ( farbe[ampel] == Qt::green ) {
            farbe[ampel] = Qt::yellow;
            yellow2Id = startTimer( 500 );
            killTimer( greenId );
            greenId = -1;
         }
      } else if ( e->timerId()==yellow2Id ) {
         if ( farbe[ampel] == Qt::yellow ) {
            redId = startTimer( 2000 );
            killTimer( yellow2Id );
            ampel = ++ampel%2;
            yellow2Id = -1;
         }
      }
      repaint( false );
   }

private:
   int    redId, yellow1Id, yellow2Id, greenId;
   int    ampel;
   QColor farbe[2];

   void maleAmpel( QPainter *p, int nr ) {
      QColor ausFarbe( 150, 150, 150 );

      p->setBrush( Qt::lightGray );
      p->setPen( QPen( Qt::black, 5 ) );
      p->drawRect( nr*100, 0, 90, 190 );
      p->setBrush( Qt::black );
      p->drawRect( nr*100+35, 190, 20, 200 );

      p->setPen( QPen( Qt::black, 1 ) );
      p->setBrush( (farbe[nr] == Qt::red) ? farbe[nr] : ausFarbe );
      p->drawEllipse( nr*100 + 30, 30, 40, 40 );
      p->setBrush( (farbe[nr] == Qt::yellow) ? farbe[nr] : ausFarbe );
      p->drawEllipse( nr*100 + 30, 80, 40, 40 );
      p->setBrush( (farbe[nr] == Qt::green) ? farbe[nr] : ausFarbe );
      p->drawEllipse( nr*100 + 30, 130, 40, 40 );
   }
};

//.................................................................... main
int main( int argc, char *argv[] ) {
    QApplication app(argc, argv);

    QWidget myWidget;
    (void)new Ampel( &myWidget );

    app.setMainWidget( &myWidget);

    myWidget.resize( 200, 400 );
    myWidget.show();

    return app.exec();
}
