#include <qapplication.h>
#include <qwidget.h>
#include <qdatetime.h>
#include <qtimer.h>
#include <qpainter.h>
//................................................... Klasse AnalogUhr
class AnalogUhr : public QWidget {
    Q_OBJECT
public:
    AnalogUhr( QWidget *p=0, const char *nam=0 ) : QWidget( p, nam ) {
       zeit = QTime::currentTime();
       QTimer *uhrTimer = new QTimer( this );
       QObject::connect( uhrTimer, SIGNAL(timeout()), SLOT(timeout()) );
       uhrTimer->start( 500 ); 
    }
protected:
    void paintEvent( QPaintEvent * ) { QPainter paint(this); maleUhr(&paint); }
private slots:
    void timeout() {
       QTime neu_zeit = QTime::currentTime();
       if ( neu_zeit.second() != zeit.second() )  // Eine Sekunde weiter
          repaint();
    }
    void maleUhr( QPainter* );
private:
    QTime zeit;
};
//................................................. AnalogUhr::maleUhr
void AnalogUhr::maleUhr( QPainter *p ) {
    QPointArray pkte;
    QPoint cp = rect().center();    // Mittelpunkt dieses Widgets
    int   d = QMIN( width(), height() ); // Minimum aus Breite u. Hhe 
    zeit = QTime::currentTime(); // aktuelle Zeit
    QWMatrix matrix;
     matrix.translate( cp.x(), cp.y() );  // Nullpunkt in Mitte
     matrix.scale( d/1000.0, d/1000.0 );  // Koord.-System verkleinern
    float stdGrad = 30*(zeit.hour()%12-3) + zeit.minute()/2;
     matrix.rotate( stdGrad ); // Drehen, um Stdzeiger zu zeichnen
     p->setWorldMatrix( matrix );
     p->setPen( Qt::blue );
     p->setBrush( Qt::blue );
     pkte.setPoints( 4, -20,0,  0,-20, 300,0, 0,20 );
     p->drawPolygon( pkte ); // Stdzeiger zeichnen
     matrix.rotate( -stdGrad );  // Rotieren rueckgaengig
    float minGrad = (zeit.minute()-15)*6;
     matrix.rotate( minGrad ); // Drehen, um Minzeiger zu zeichnen 
     p->setWorldMatrix( matrix );
     pkte.setPoints( 4, -10,0, 0,-10, 400,0, 0,10 );
     p->drawPolygon( pkte );  // Minzeiger zeichnen
     matrix.rotate( -minGrad );  // Rotieren rueckgaengig
    float secGrad = (zeit.second()-15)*6;
     matrix.rotate( secGrad ); // Drehen, um Sekzeiger zu zeichnen 
     p->setWorldMatrix( matrix );
     p->setPen( QPen( Qt::yellow, 2 ) );
     p->drawLine( -10,0, 400,0 );  // Sekzeiger zeichnen
     matrix.rotate( -secGrad );  // Rotieren rueckgaengig
    for ( int i=0; i<60; i++ ) {  // Uhrzeiten malen
       p->setWorldMatrix( matrix );
       p->setPen( QPen( Qt::red, (i%5==0) ? 4 : 2 ) );
       p->drawLine( (i%5==0) ? 430 : 450, 0, 460, 0 );
       matrix.rotate( 6 );
    }
}
//............................................................... main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    AnalogUhr *uhr = new AnalogUhr;
    uhr->resize( 400, 400 );
    a.setMainWidget( uhr );
    uhr->show();
    return a.exec();
}
#include "analoguhr.moc"
