#include <qapplication.h>
#include <qwidget.h>
#include <qlistbox.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <qstring.h>

QString tiere[] = { "Elefant",  "Kuh",       "Forelle", "Ameise.xpm",
                    "Schwalbe", "Krebs.xpm", "Karpfen" };
QString blumen[] = { "Veilchen", "Rose", "Nelke", "Sonnenblume",
                     "Gaensebluemchen", "Enzian", "Tulpe",
                     "Schneegloeckchen", "Butterblume" };
QString laender[] = { "Frankreich", "Italien", "Deutschland.xpm",
                      "Spanien", "Grossbritannien.xpm", "Norwegen" };
const int tiereZahl   = sizeof(tiere)   / sizeof(*tiere);
const int blumenZahl  = sizeof(blumen)  / sizeof(*blumen);
const int laenderZahl = sizeof(laender) / sizeof(*laender);
//--------------------------------- Klasse Auswahl --------
class Auswahl : public QWidget {
   Q_OBJECT
public:
   Auswahl();
private slots:
   void ok_slot();
private:
   QListBox  *listeTiere, *listeBlumen, *listeLaender;
   QComboBox *comboTiere, *comboBlumen, *comboLaender;
   QLabel*    textausgabe;
};
#include "auswahlw.moc"
//---------------------------- Konstruktor Buttons --------
Auswahl::Auswahl() {
   setFont( QFont( "Times", 12) );
   listeTiere = new QListBox(this);
   listeTiere->setGeometry( 20, 20, 150, 100 );
   comboTiere = new QComboBox( false, this );
   comboTiere->setGeometry( 20, 150, 150, 50 );
   for (int i=0; i<tiereZahl; i++)
      if (tiere[i].right(4) != ".xpm") {
         listeTiere->insertItem( tiere[i] );
         comboTiere->insertItem( tiere[i] );
      } else {
         listeTiere->insertItem( QPixmap( tiere[i] ) );
         comboTiere->insertItem( QPixmap( tiere[i] ) );
      }
   listeTiere->setSelected( 4, true );

   listeBlumen = new QListBox(this);
   listeBlumen->setSelectionMode( QListBox::Multi );  //.... Multi
   listeBlumen->setGeometry( 210, 20, 150, 100 );
   comboBlumen = new QComboBox( true, this );
   comboBlumen->setGeometry( 210, 150, 150, 50 );
   for (int i=0; i<blumenZahl; i++) {
      listeBlumen->insertItem( blumen[i] );
      comboBlumen->insertItem( blumen[i] );
   }
   listeBlumen->sort();
   listeBlumen->setSelected( 1, true );
   comboBlumen->setCurrentItem( 1 );

   listeLaender = new QListBox(this);
   listeLaender->setSelectionMode( QListBox::Extended ); //.... Extended
   listeLaender->setGeometry( 400, 20, 150, 100 );
   for (int i=0; i<laenderZahl; i++)
      if (laender[i].right(4) != ".xpm")
         listeLaender->insertItem( laender[i] );
      else
         listeLaender->insertItem( QPixmap( laender[i] ) );
   listeLaender->setSelected( 2, true );

   QPushButton* ok     = new QPushButton( "Ok", this );
    ok->setGeometry( 20, 220, 100, 40);
    ok->setPaletteBackgroundColor( Qt::green ); 
   QPushButton* quit = new QPushButton( "Quit", this );
    quit->setGeometry( 450, 220, 100, 40);
    quit->setPaletteBackgroundColor( Qt::red ); 
   QObject::connect( ok, SIGNAL( clicked() ), SLOT( ok_slot() ) );
   QObject::connect( quit, SIGNAL( clicked() ), qApp, SLOT( quit() ) );

   textausgabe = new QLabel( "Bisher keine Wahl", this );
   textausgabe->setPaletteBackgroundColor( Qt::white ); 
   textausgabe->setGeometry( 20, 300, 570, 290 );
   textausgabe->setFrameStyle( QFrame::Panel | QFrame::Raised );
}
//----------------------------------------- ok_slot --------
void Auswahl::ok_slot() {
   uint i, tier = listeTiere->currentItem();

   QString neuer_text( "Gerade ausgewaehlte Listboxen-Eintraege:\n" );
   neuer_text += "   Tier: ";
   if (tiere[tier].right(4) != ".xpm") 
      neuer_text += listeTiere->text(tier);
   else
      neuer_text += tiere[tier].left(tiere[tier].length() - 4);
   neuer_text += "\n   Blumen: ";
   for ( i=0; i < listeBlumen->count(); i++ )
      if ( listeBlumen->isSelected( i ) ) {
         neuer_text += listeBlumen->text( i );
         neuer_text += ", ";
      }
   neuer_text += "\n   Laender: ";
   for ( i=0; i < listeLaender->count(); i++ ) {
      if (listeLaender->isSelected( i ) ) {
         neuer_text += "\n      - ";
         if (laender[i].right(4) != ".xpm")
            neuer_text += listeLaender->text(i);
         else
            neuer_text += laender[i].left(laender[i].length() - 4);
      }
   }
   tier  = comboTiere->currentItem();
   neuer_text += "\n\nGerade ausgewaehlte Komboboxen-Eintraege:\n";
   neuer_text += "   Tier: ";
   if (tiere[tier].right(4) != ".xpm") 
      neuer_text += comboTiere->text(tier);
   else
      neuer_text += tiere[tier].left(tiere[tier].length() - 4);
   neuer_text += "\n   Blume: ";
   neuer_text += comboBlumen->text( comboBlumen->currentItem() );
   textausgabe->setText( neuer_text );
}
//------------------------------------------- main --------
int main( int argc, char *argv[] ) {
   QApplication myapp( argc, argv );
   Auswahl* mywidget = new Auswahl();
   mywidget->setGeometry( 10, 10, 600, 620 );
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
