#include <qapplication.h>
#include <qlabel.h>
#include <qmessagebox.h>
#include <qpixmap.h>
#include "flowlayout.h"

const char *picNames[] = {
      "Ameise.xpm",    "Butterfly.xpm", "monalisa.xpm", "Deutschl.xpm",
      "Grossbri.xpm",  "Krebs.xpm",     "Pinguin.xpm",  "Suse.xpm",
      "Wizard.xpm",    "HandReach.xpm", "Eggs.xpm",     "3dpaint.xpm",
      "DeskGlobe.xpm", "HandOpen.xpm",  "smiley.xpm" };

const int picNo = sizeof( picNames ) / sizeof( picNames[0] );

int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );

    QWidget *w = new QWidget;

    QPixmap bild;
    FlowLayout *b = new FlowLayout( w );
    for ( int i=0; i<picNo; i++ ) {
       if ( !bild.load( picNames[i] ) ) {
          QString  text;
          text.sprintf( "Kann Bild-Datei `%s' nicht laden", picNames[i] );
          QMessageBox::information( 0, "Ladefehler", text,
                                    QMessageBox::Ok );
          qApp->quit();
       }
       QLabel *l = new QLabel( w );
       l->setFrameStyle( QFrame::Box | QFrame::Sunken );
       l->setMargin( 10 );
       l->setLineWidth( 5 );
       l->setPixmap( bild );
       b->add( l );
    }
    a.setMainWidget( w );
    w->resize( 400, 400 );
    w->show();
    return a.exec();
}
