#include "flowlayout.h"
//............................................................... doLayout
int FlowLayout::doLayout( const QRect &r, bool testonly ) {
    int  x = r.x(), y = r.y(), h = 0;
    QPtrListIterator<QLayoutItem> it(list);
    QLayoutItem *o;
    while ( (o=it.current()) != 0 ) {
       ++it;
       int nextX = x + o->sizeHint().width() + spacing();
       if ( nextX - spacing() > r.right() && h > 0 ) {
          x = r.x();
          y = y + h + spacing();
          nextX = x + o->sizeHint().width() + spacing();
          h = 0;
       }
       if ( !testonly )
          o->setGeometry( QRect( QPoint( x, y ), o->sizeHint() ) );
          x = nextX;
          h = QMAX( h,  o->sizeHint().height() );
    }
    return y + h - r.y();
}
//......................................................... heightforWidth
int FlowLayout::heightForWidth( int w ) const {
    if ( cached_width != w ) {
       FlowLayout * mthis = (FlowLayout*)this;
       int h = mthis->doLayout( QRect(0,0,w,0), true );
       mthis->cached_hfw = h;
       return h;
    }
    return cached_hfw;
}
//............................................................ minimumSize
QSize FlowLayout::minimumSize() const {
    QSize s(0,0);

    QPtrListIterator<QLayoutItem> it(list);
    QLayoutItem *o;

    while ( (o=it.current()) != 0 ) {
       s = s.expandedTo( o->minimumSize() );
       ++it;
    }
    return s;
}
