#ifndef FLOWLAYOUT_H
#define FLOWLAYOUT_H

#include <qlayout.h>
#include <qptrlist.h>
//.................................................. Klasse FlowLayoutIterator
class FlowLayoutIterator : public QGLayoutIterator {
public:
    FlowLayoutIterator( QPtrList<QLayoutItem> *l ) : idx(0), il(l) {}
    uint count() const     { return il->count();                                 }
    QLayoutItem *current() { return idx < int(count()) ? il->at(idx) : 0;        }
    QLayoutItem *next()    { idx++;  return current();                           }
    QLayoutItem *takeCurrent() { return idx < int(count()) ? il->take( idx ) : 0;}
private:
    int   idx;
    QPtrList<QLayoutItem> *il;
};
//.......................................................... Klasse FlowLayout
class FlowLayout : public QLayout {
public:
      //............ Konstruktoren, die identisch zu denen von QLayout sind
    FlowLayout( QWidget *p, int margin=0, int space=-1 )
                  : QLayout( p, margin, space )  { cached_width = 0; }
    FlowLayout( QLayout* p, int space=-1 )
                           : QLayout( p, space )  { cached_width = 0; }
    FlowLayout( int space=-1 ) : QLayout( space ) { cached_width = 0; }
    ~FlowLayout() { deleteAllItems(); } //.. loescht alle Elemente des Layouts
    void addItem( QLayoutItem *item ) { list.append( item ); }
    QLayoutIterator iterator() {
        return QLayoutIterator( new FlowLayoutIterator( &list ) );
    }
    bool hasHeightForWidth() const { return true; }
    QSize sizeHint() const { return minimumSize(); }
    QSizePolicy::ExpandData expanding() const { return QSizePolicy::NoDirection; }
    int    heightForWidth( int ) const;
    QSize  minimumSize() const;
protected:
    void setGeometry( const QRect &r ) {  //.............. setGeometry
        QLayout::setGeometry( r );
        doLayout( r );
    }
private:
    int doLayout( const QRect&, bool testonly = false );

    QPtrList<QLayoutItem> list;
    int   cached_width, cached_hfw;
};
#endif
