#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <stdlib.h>
#include <time.h>

const char *rasterOp[] = {
     "CopyROP",  "OrROP",     "XorROP",    "NotAndROP", "NotCopyROP",
     "NotOrROP", "NotXorROP", "AndROP",    "NotROP",    "ClearROP",
     "SetROP",   "NopROP",    "AndNotROP", "OrNotROP",
     "NandROP",  "NorROP" };
const int rasterOpNr = sizeof( rasterOp) / sizeof( *rasterOp );
//........................................................ Klasse MalFenster
class MalFenster : public QWidget {
 protected:
   virtual void mousePressEvent( QMouseEvent * ) { repaint( true ); }
   virtual void paintEvent( QPaintEvent* ) {
      int         i, x, y;
      QString     text;
      QColor      pufferFarbe( ::rand()&255, ::rand()&255, ::rand()&255 );
      QPixmap     puffer( 100, 100 );
      QPainter pix;
       pix.begin( &puffer );
       pix.setBrush( pufferFarbe );
       pix.drawRect( 0, 0, 100, 100 );
       pix.end();
      QPainter maler;
      maler.begin( this );
      for ( i = 0; i<5; i++ )
          maler.fillRect( i*150, 0, (i+1)*150, 650,
                i % 2 == 0 ? pufferFarbe :
                QColor( ::rand()&255, ::rand()&255, ::rand()&255 ) );
      for ( i = 0; i< rasterOpNr; i++ ) {
         x = (i % 4) * 150+100;
         y = (i / 4) * 150+50;
         bitBlt( this, x, y+10, &puffer, 0, 0, 100, 100, (RasterOp)i );
         text.sprintf("%s", rasterOp[i] );
         maler.drawText( x, y, text ); 
      }
      maler.end();
   }
};
//..................................................................... main
int main( int argc, char *argv[] ) {
   QApplication myapp( argc, argv );
   MalFenster* mywidget = new MalFenster();
   mywidget->setGeometry( 0, 0, 750, 650 );
   mywidget->setMaximumSize( 750, 650 );
   ::srand( time( NULL ) ); 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
