#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <stdlib.h>
#include <time.h>

const char *rasterOp[] = {
     "CopyROP",  "OrROP",     "XorROP",    "NotAndROP", "NotCopyROP",
     "NotOrROP", "NotXorROP", "AndROP",    "NotROP",    "ClearROP",
     "SetROP",   "NopROP",    "AndNotROP", "OrNotROP",
     "NandROP",  "NorROP" };
const int rasterOpNr = sizeof( rasterOp) / sizeof( *rasterOp );
const int  maxx = 750, maxy = 650;
//........................................................ Klasse MalFenster
class MalFenster : public QWidget {
 public:
   MalFenster() { setBackgroundMode( NoBackground ); }
 protected:
   virtual void mousePressEvent( QMouseEvent * ) { repaint( neuMalen = true ); }
   virtual void resizeEvent( QResizeEvent * ) {
      static bool ersteMal = true;
      neuMalen = ersteMal;
      ersteMal = false;
   }
   virtual void paintEvent( QPaintEvent *e ) {
      int         i, x, y;
      QString     text;

      if ( neuMalen ) {
         QColor      rectFarbe( ::rand()&255, ::rand()&255, ::rand()&255 );
         bild.resize( maxx, maxy );
         maler.begin( &bild );
         for ( i = 0; i<5; i++ )
             maler.fillRect( i*150, 0, (i+1)*150, 650,
                   i % 2 == 0 ? rectFarbe :
                   QColor( ::rand()&255, ::rand()&255, ::rand()&255 ) );
         for ( i = 0; i< rasterOpNr; i++ ) {
            x = (i % 4) * 150+100;
            y = (i / 4) * 150+50;
            text.sprintf("%s", rasterOp[i] );
            maler.drawText( x, y, text ); 
            maler.setRasterOp( (RasterOp)i );
            maler.setBrush( rectFarbe );
            maler.drawRect( x, y+10, 100, 100 );
            maler.setRasterOp( CopyROP );
         }
         neuMalen = false;
         maler.end();
      } 
      bitBlt( this, e->rect().topLeft(), &bild, e->rect() );
   }
 private:
   QPixmap  bild;
   QPainter maler;
   bool     neuMalen;
};
//..................................................................... main
int main( int argc, char *argv[] ) {
   QApplication myapp( argc, argv );
   MalFenster* mywidget = new MalFenster();
   mywidget->setGeometry( 0, 0, maxx, maxy );
   mywidget->setMaximumSize( maxx, maxy );
   srand( time( NULL ) ); 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
