#include <iostream>

using namespace std;
//............................................................. Klasse Bruch
class Bruch {
 private:
    int zaehler;  // Zhler des Bruches
    int nenner;   // Nenner des Bruches

    int ggT( int n, int m) { return (m==0) ? n : ggT(m, n%m); }

    void kuerzen( void ) {
       int ggTeiler = ggT( zaehler, nenner );
       zaehler /= ggTeiler;
       nenner  /= ggTeiler;
    }

 public:
    Bruch( int z = 1, int n = 1 ) { // Konstruktor zur Initialisierung
       zaehler = z;
       nenner  = n;
    }
    void add( Bruch& zahl ) {             // Addition eines Bruches
       zaehler = zaehler*zahl.nenner + zahl.zaehler*nenner;
       nenner *= zahl.nenner;
       kuerzen();
    }
    friend Bruch add( Bruch z1, Bruch z2 ); // globale friend-Funktion

    void print( void ) { cout << zaehler << "/" << nenner; }
};
//..................................................... globale add-Funktion
Bruch add( Bruch z1, Bruch z2 ) { // Addition 2er Brche
   Bruch  temp;
   temp.zaehler = z1.zaehler*z2.nenner + z2.zaehler*z1.nenner;
   temp.nenner  = z1.nenner * z2.nenner;
   temp.kuerzen();
   return temp;
}
//..................................................................... main
int main(void) {
    Bruch  b1( 1, 4 );  // 1. Bruch (1/4)
    Bruch  b2( 3, 8 );  // 2. Bruch (3/8)
    Bruch  b3;          // 3. Bruch (1/1)

    b1.add( b2 );       // Addiere b2 zu b1
    cout << "b1 = "; b1.print(); cout << endl; // Ausgabe von b1
       // Da add eine friend-Funktion ist, kann sie wie eine andere
       // globale Funktion aufgerufen werden, ohne dass man zuerst
       // ein Objekt der Klasse Bruch erzeugen muss
    b3 = add( b1, b2 ); // Addiere b1 und b2 --> b3
    cout << "b3 = "; b3.print(); cout << endl; // Ausgabe von b3
    return 0;
}
