#include <iostream>

using namespace std;
//............................................................. Klasse Bruch
class Bruch {
 private:
    int zaehler, nenner;

    int ggT( int n, int m) { return (m==0) ? n : ggT(m, n%m); }
 public:
    Bruch( int z = 1, int n = 1 ) { // Konstruktor zur Initialisierung
       zaehler = z;
       nenner  = n;
    }
    Bruch& operator+= ( Bruch& zahl ) { // Addition eines Bruches mit +=
       zaehler = zaehler*zahl.nenner + zahl.zaehler*nenner;
       nenner *= zahl.nenner;
       return( *this );
    }
    Bruch& operator-= ( Bruch& zahl ) { // Addition eines Bruches mit -=
       zaehler = zaehler*zahl.nenner - zahl.zaehler*nenner;
       nenner *= zahl.nenner;
       return( *this );
    }
    friend Bruch operator+ ( Bruch z1, Bruch z2 ); // Addition 2er Brche
    friend Bruch operator- ( Bruch z1, Bruch z2 ); // Subtrakt. 2er Brche

    Bruch operator++ () { // Prefix-Inkrementieren von Bruch
       zaehler += nenner;
       return( *this );
    }
    Bruch operator++ ( int ) { // Postfix-Inkrementieren von Bruch
       Bruch temp = *this;
       zaehler += nenner;
       return( temp );
    }
    Bruch operator-- () { // Prefix-Dekrementieren von Bruch
       zaehler -= nenner;
       return( *this );
    }
    Bruch operator-- ( int ) { // Postfix-Dekrementieren von Bruch
       Bruch temp = *this;
       zaehler -= nenner;
       return( temp );
    }
    void print( void ) {                  // Ausgabe eines Bruches
       cout << zaehler << "/" << nenner;
    }
    void kuerzen( void ) {
       int ggTeiler = ggT( zaehler, nenner );
 
       zaehler /= ggTeiler;
       nenner  /= ggTeiler;
    } 
};
//................................................ globale friend-Funktionen
Bruch operator+ ( Bruch z1, Bruch z2 ) { // Addition 2er Brche
   Bruch  temp;
   temp.zaehler = z1.zaehler*z2.nenner + z2.zaehler*z1.nenner;
   temp.nenner  = z1.nenner * z2.nenner;
   return temp;
}
Bruch operator- ( Bruch z1, Bruch z2 ) { // Subtrakt. 2er Brche
   Bruch  temp;
   temp.zaehler = z1.zaehler*z2.nenner - z2.zaehler*z1.nenner;
   temp.nenner  = z1.nenner * z2.nenner;
   return temp;
}
//..................................................................... main
int main(void) {
    Bruch  b1( 4, 7 ), b2( 2, 8 );
    Bruch  b3, b4, b5(1,3), b6, b7(1,3), b8, b9(4,3), b10, b11(4,3);

    b1 += b2;
    b1 += b2; b1.kuerzen(); cout << "b1 = "; b1.print(); cout << endl;
    b1 -= b2; b1.kuerzen(); cout << "b1 = "; b1.print(); cout << endl;
    b3 = b1 + b2; b3.kuerzen(); cout << "b3 = "; b3.print(); cout << endl;
    b4 = b5++; b4.kuerzen(); cout << "b4 = "; b4.print(); cout << ";  ";
               b5.kuerzen(); cout << "b5 = "; b5.print(); cout << endl;
    b6 = ++b7; b6.kuerzen(); cout << "b6 = "; b6.print(); cout << ";  ";
               b7.kuerzen(); cout << "b7 = "; b7.print(); cout << endl;
    b8 = b9--; b8.kuerzen(); cout << "b8 = "; b8.print(); cout << ";  ";
               b9.kuerzen(); cout << "b9 = "; b9.print(); cout << endl;
    b10 = --b11; b10.kuerzen(); cout << "b10 = "; b10.print(); cout << ";  ";
                 b11.kuerzen(); cout << "b11 = "; b11.print(); cout << endl;
    return 0;
}
