#include <qapplication.h>
#include <qbuttongroup.h>
#include <qhbox.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <qgroupbox.h>
#include <qpushbutton.h>
#include <qvbox.h>
//......................................... ButtonGruppe-Klasse ..........
class ButtonGruppe : public QVBox {
    Q_OBJECT
public:
    ButtonGruppe( QWidget *parent = 0 );
protected:
    QCheckBox    *zustand;
    QRadioButton *radio21, *radio22, *radio23;
protected slots:    
    void schalteGrp3EinAus() {
       radio21->setEnabled( zustand->isChecked() );
       radio22->setEnabled( zustand->isChecked() );
       radio23->setEnabled( zustand->isChecked() );
    }
};
#include "button_gruppe.moc"
//.................................... ButtonGruppe-Konstruktor ..........
ButtonGruppe::ButtonGruppe( QWidget *parent ) : QVBox( parent ) {
      //..... Widgets fuer ein einfaches Layout
    QHBox *box1 = new QHBox( this );
    QHBox *box2 = new QHBox( this );
      //..... Erste Buttongruppe (exklusive Auswahl)
    QButtonGroup *grp1 = new QButtonGroup( 1, Horizontal,
                           "Buttongruppe 1 (exklusiv)", box1);
    grp1->setExclusive( true );
    QRadioButton *radio11 = new QRadioButton( "&Radiobutton 1", grp1 );
    radio11->setChecked( TRUE );
    (void)new QRadioButton( "R&adiobutton 2", grp1 );
    (void)new QRadioButton( "Ra&diobutton 3", grp1 );
      //..... Zweite Buttongruppe (nicht-exklusive Auswahl)
    QButtonGroup *grp2 = new QButtonGroup( 1, Horizontal,
                    "Buttongruppe 2 (nicht-exklusiv)", box1 );
    grp2->setExclusive( false );
    (void)new QCheckBox( "&Checkbox 1", grp2 );
    QCheckBox *check12 = new QCheckBox( "C&heckbox 2", grp2 );
    check12->setChecked( true );
    QCheckBox *check13 = new QCheckBox( "Drei &Zustaende-Button", grp2 );
    check13->setTristate( true ); // 3-Zustnde Button
    check13->setChecked( true );
      //..... Dritte Buttongruppe (ein-/ausschaltbare Radiobuttons)
    QButtonGroup *grp3 = new QButtonGroup( 1, Horizontal,
                   "ein-/ausschaltbare Radiobutton-Gruppe", box2 );
    grp3->setRadioButtonExclusive( true );
    radio21 = new QRadioButton( "Rad&iobutton 1", grp3 );
    radio22 = new QRadioButton( "Radi&obutton 2", grp3 );
    radio23 = new QRadioButton( "Radio&button 3", grp3 );
    radio23->setChecked( true );
    zustand = new QCheckBox( "E&nable Radiobuttons", grp3 );
    zustand->setChecked( true );
    connect( zustand, SIGNAL( clicked() ),
             this, SLOT( schalteGrp3EinAus() ) );
      //..... Vierte Buttongruppe (Push- und Togglebutton)
    QButtonGroup *grp4 = new QButtonGroup( 1, Horizontal,
                   "Gruppenbox mit Push- und Togglebutton", box2 );
    (void)new QPushButton( "&Pushbutton", grp4 );
    QPushButton *toggle = new QPushButton( "&Togglebutton", grp4 );
    toggle->setToggleButton( true );
    toggle->setOn( true );
}
//........................................................ main ..........
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    ButtonGruppe buttonGrp;
    buttonGrp.resize( 650, 250 );
    buttonGrp.setCaption( "Beispiele zu Buttons und Gruppen" );
    a.setMainWidget( &buttonGrp );
    buttonGrp.show();
    return a.exec();
}
