#include <qapplication.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <stdlib.h>
//......................................... KomfoPopup-Klasse ........
class KomfoPopup : public QLabel {
    Q_OBJECT
public:
    KomfoPopup( QWidget* parent = 0, const char* name=0) :
                          QLabel( parent, name, WType_Popup ) {
       setFont( QFont( "Times", 12 ) );
       setAlignment( AlignCenter );
       setPalette( QPalette( Qt::darkGray, Qt::darkGray ) );
       resize( 150, 100 );
       setMouseTracking( true );
    }
    void popup( QWidget* parent = 0) {
       popupParent = parent;
       move( popupParent->mapToGlobal( popupParent->rect().bottomLeft() ) );
       show();
    }
protected:
    virtual void mouseMoveEvent( QMouseEvent *e ) {
       QString s;
       s.sprintf("%d/%d", e->pos().x(), e->pos().y());
       setText(s);
    }
    virtual void closeEvent( QCloseEvent *e ) {
       e->accept(); // versteckt ein KomfoPopup-Objekt
    }
private:
    QWidget* popupParent;
};
//.............................................. Frame-Klasse ........
class Frame : public QFrame {
    Q_OBJECT
public:
    Frame( QWidget *parent=0, const char*  name=0);
private slots:
    void button1Clicked() {
       popup1->move( mapToGlobal( button1->geometry().bottomLeft() ) );
       popup1->show();
    }
    void button2Clicked() { popup2->popup(button2); }
    void farbeAendern() {
       QColor f( rand()&0xff, rand()&0xff, rand()&0xff );
       button1Label->setPalette( QPalette( f, f ) );
    }
private:
    QPushButton *button1, *button2, *button1Button, *button1Beenden;
    QLabel      *button1Label;
    QFrame      *popup1;
    KomfoPopup  *popup2;
};
#include "button_popup.moc"
//......................................... Frame-Konstruktor ........
Frame::Frame(QWidget* parent, const char* name): QFrame(parent, name) {
    setFont( QFont( "Times", 12 ) );
    button1 = new QPushButton("Einfaches Popup", this);
     button1->setGeometry(20, 20, 140, 30);
     connect ( button1, SIGNAL( clicked() ), this, SLOT( button1Clicked() ) );
    button2 = new QPushButton("Komfortableres Popup", this);
     button2->setGeometry(200, 20, 140, 30);
     connect ( button2, SIGNAL( clicked() ), this, SLOT( button2Clicked() ) );
    resize(360, 200);
    popup1 = new QFrame( this, 0, WType_Popup );
     popup1->resize( 150, 130 );
     popup1->setPalette( QPalette( Qt::darkGray, Qt::darkGray ) );
    QColor f( rand()&255, rand()&255, rand()&255 );
    button1Label = new QLabel( popup1 );
     button1Label->setGeometry(10, 10, 130, 30);
     button1Label->setPalette( QPalette( f, f ) );
    button1Button = new QPushButton( "Aendere Farbe", popup1 );
     button1Button->setGeometry(10, 50, 130, 30);
     connect( button1Button, SIGNAL( clicked() ), this, SLOT( farbeAendern() ) );
    button1Beenden = new QPushButton( "Schliessen", popup1 );
     button1Beenden->setGeometry(10, 90, 130, 30);
     connect( button1Beenden, SIGNAL( clicked() ), popup1, SLOT( hide() ) );
    popup2 = new KomfoPopup( this );
}
//...................................................... main ........
int main( int argc, char *argv[] ) {
    QApplication a(argc,argv);
    Frame frame;
    frame.setCaption("Pushbuttons, die ein Popmen einblenden");
    a.setMainWidget(&frame);
    frame.show();
    return a.exec();
}
