#include <qapplication.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qbuttongroup.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qvbox.h>
#include <qframe.h>
//....................................................... Klasse Anzeige
class Anzeige : public QLabel {
 public:
   Anzeige( QWidget *p ) : QLabel( p ) {
      setFont( QFont( "Times", 12 ) );
      setPaletteBackgroundColor( Qt::white );
      setText( "Noch kein Button gedrckt" );
      resize( sizeHint() );
   }
};
//...................................................... Klasse Buttons1
class Buttons1 : public QVBox {
  Q_OBJECT
public:
   Buttons1( QWidget *p ) : QVBox( p ) {
      setSpacing( 10 );
      b1 = new QPushButton( "Button 1", this );
       QObject::connect( b1, SIGNAL( clicked() ), SLOT( slotB1() ) );
      b2 = new QPushButton( "Button 2", this );
       QObject::connect( b2, SIGNAL( clicked() ), SLOT( slotB2() ) );
      b3 = new QPushButton( "Button 3", this );
       QObject::connect( b3, SIGNAL( clicked() ), SLOT( slotB3() ) );
      label = new Anzeige( this );
   }
private slots:
   void slotB1() { label->setText( "Button 1 gedrueckt" ); }
   void slotB2() { label->setText( "Button 2 gedrueckt" ); }
   void slotB3() { label->setText( "Button 3 gedrueckt" ); }
private:
   QPushButton   *b1, *b2, *b3;
   Anzeige       *label;
};
//...................................................... Klasse Buttons2
class Buttons2 : public QVBox {
   Q_OBJECT
public:
   Buttons2( bool frame, QWidget *p ) : QVBox( p ) {
      buttonBox = new QButtonGroup( 3, Vertical, this );
      if ( !frame )
         buttonBox->setFrameStyle( QFrame::NoFrame );
      b1 = new QPushButton( "Button 1", buttonBox );
      b2 = new QPushButton( "Button 2", buttonBox );
      b3 = new QPushButton( "Button 3", buttonBox );
      QObject::connect( buttonBox, SIGNAL( clicked( int ) ),
                        SLOT( slotAlleButtons( int ) ) );
      label = new Anzeige( this );
   }
private slots:
   void slotAlleButtons( int i ) {
      QString text;
      text.sprintf( "Button %d gedrueckt", i+1 );
      label->setText( text );
   }
private:
   QButtonGroup  *buttonBox;
   QPushButton   *b1, *b2, *b3;
   Anzeige       *label;
};
#include "button_slot.moc"
//................................................................. main
int main( int argc, char* argv[] ) {
   QApplication myapp( argc, argv );
   QWidget* mywidget = new QWidget;
   QGridLayout *layout = new QGridLayout( mywidget, 1, 3, 20 );
   Buttons1 *buttons1 = new Buttons1( mywidget );
    layout->addWidget( buttons1, 0, 0 );
   Buttons2 *buttons2a = new Buttons2( true, mywidget );
    layout->addWidget( buttons2a, 0, 1 );
   Buttons2 *buttons2b = new Buttons2( false, mywidget );
    layout->addWidget( buttons2b, 0, 2 );
   myapp.setMainWidget( mywidget );
   mywidget->show();
   mywidget->resize( mywidget->sizeHint() );
   return myapp.exec();
}
