#include <qdatetime.h>
#include <qmainwindow.h>
#include <qstatusbar.h>
#include <qmenubar.h>
#include <qapplication.h>
#include <qkeycode.h>
#include <qpainter.h>
#include <qlabel.h>
#include <qimage.h>
#include "canvas.h"
//.................................................. FlyingPic::advance
void FlyingPic::advance(int stage) {
   if ( stage == 0 ) {
      double vx = xVelocity();
      double vy = yVelocity();
      if ( vx == 0.0 && vy == 0.0 ) {
         initSpeed();
         vx = xVelocity();
         vy = yVelocity();
      }
      double nx = x() + vx;
      double ny = y() + vy;
      if ( nx < 0 || nx >= canvas()->width() )
          vx = -vx;
      if ( ny < 0 || ny >= canvas()->height() )
          vy = -vy;
      for (int bounce=0; bounce<4; bounce++) {
          QCanvasItemList l = collisions(false);
          for (QCanvasItemList::Iterator it=l.begin(); it!=l.end(); ++it) {
            QCanvasItem *hit = *it;
            if ( hit->rtti()==ghost_rtti && hit->collidesWith(this) ) {
                switch ( bounce ) {
                  case 0:  vx = -vx;           break;
                  case 1:  vy = -vy; vx = -vx; break;
                  case 2:  vx = -vx;           break;
                  case 3:  vx = 0; vy = 0;     break;
                }
                setVelocity(vx,vy);
                break;
            }
          }
      }
      if ( x()+vx < 0 || x()+vx >= canvas()->width() )
          vx = 0;
      if ( y()+vy < 0 || y()+vy >= canvas()->height() )
          vy = 0;
      setVelocity(vx,vy);
   } else if ( stage == 1 )
      QCanvasItem::advance(stage);
}
//.................................................. Main (Konstruktor)
Main::Main( QString pic1, QString pic2, QCanvas& c, QWidget* par)
                                           : QMainWindow(par), canvas(c) {
    ::srand( time( NULL ) );
     butterfly_fn = pic1;
     picture_fn = pic2;
    editor = new FigureEditor(canvas,(QWidget *)this);
     QMenuBar* menu = menuBar();
    QPopupMenu* file = new QPopupMenu;
     file->insertItem( "&Fill canvas", this, SLOT(init()), CTRL+Key_F);
     file->insertItem( "&Erase canvas", this, SLOT(clear()), CTRL+Key_E);
     file->insertItem( "&New view", this, SLOT(newView()), CTRL+Key_N);
     file->insertSeparator();
     file->insertItem( "E&xit", qApp, SLOT(quit()), CTRL+Key_Q);
     menu->insertItem( "&File", file);
    QPopupMenu* edit = new QPopupMenu;
     edit->insertItem( "Add &Circle", this, SLOT(addCircle()), CTRL+Key_C);
     edit->insertItem( "Add C&hair", this, SLOT(addChair()), CTRL+Key_H);
     edit->insertItem( "Add &Line", this, SLOT(addLine()), CTRL+Key_L);
     edit->insertItem( "Add &Rectangle", this, SLOT(addRectangle()), CTRL+Key_R);
     edit->insertItem( "Add &Sprite", this, SLOT(addSprite()), CTRL+Key_S);
     edit->insertItem( "Add &Alpha-blended image", this,
                       SLOT(addButterfly()), CTRL+Key_A);
     edit->insertSeparator();
     edit->insertItem( "&Enlarge", this, SLOT(enlarge()), CTRL+Key_Plus);
     edit->insertItem( "Shr&ink", this, SLOT(shrink()), CTRL+Key_Minus);
     menu->insertItem( "&Edit", edit);
    setCentralWidget(editor);
    init();
}
