#include <qapplication.h>
#include <qcanvas.h>
#include "canvas.h"

int main( int argc, char*argv[] ) {
    QApplication app(argc,argv);

    QCanvas canvas( 800, 600 );
    canvas.setAdvancePeriod( 30 );
    Main m( argc>1 ? argv[1] : "butterfly.png",
            argc>2 ? argv[2] : "monalisa.xpm",
            canvas );
    m.resize( m.sizeHint() );
    qApp->setMainWidget( &m );
    if ( QApplication::desktop()->width() > m.width() + 10 &&
         QApplication::desktop()->height() > m.height() +30 )
       m.show();
    else
       m.showMaximized();
    m.show();
    qApp->setMainWidget(0);
    QObject::connect( qApp, SIGNAL(lastWindowClosed()), qApp, SLOT(quit()) );
    return app.exec();
}

