#include <qapplication.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <qimage.h>
#include <qclipboard.h>
#include <qpopupmenu.h>
#include <stdlib.h>
#include <time.h>
//......................................................... Klasse einBild
class einBild : public QLabel {
   Q_OBJECT

   public:
      einBild( QWidget* p=0, const char* nam=0) : QLabel(p, nam) {
         ::srand( time(NULL) );
         popupMenu = new QPopupMenu();
         popupMenu->insertItem( "Ausschneiden", this, SLOT( cutImage() ) );
         popupMenu->insertItem( "Kopieren", this, SLOT( copyImage() ) );
         einfuegeElement = popupMenu->insertItem( "Einfuegen",
                                            this, SLOT( pasteImage() ) );
         clipboard = QApplication::clipboard();
         popupMenu->setItemEnabled( einfuegeElement,
            !clipboard->pixmap(QClipboard::Clipboard).isNull() ? true : false );
         QString bildDatei;
         switch ( rand()%3 ) {
             case 0: bildDatei = "Suse.xpm";                       break;
             case 1: bildDatei = "Crab.xpm";                       break;
            default: bildDatei.sprintf( "%d.bmp", ::rand()%52+1 ); break;
         }
         bild.load( bildDatei );
         setPixmap( bild );
      }
   protected:
      void mouseReleaseEvent( QMouseEvent* event ) {
         if ( event->button() == RightButton ) {
            popupMenu->setItemEnabled( einfuegeElement,
             !clipboard->pixmap(QClipboard::Clipboard).isNull() ? true : false );
            popupMenu->popup( mapToGlobal( event->pos() ) );
         }
      }
   private slots:
      void cutImage() {
         clipboard->setImage( bild.convertToImage(), QClipboard::Clipboard );
         clear(); 
      }
      void copyImage() {
         clipboard->setImage( bild.convertToImage(), QClipboard::Clipboard );
      }
      void pasteImage() {
         bild.convertFromImage( clipboard->image(), QClipboard::Clipboard );
         setPixmap( bild );
         resize( bild.width(), bild.height() ); 
      }
   private:
      QPopupMenu*  popupMenu;
      QClipboard*  clipboard;
      int          einfuegeElement;
      QPixmap      bild;
};
#include "clipboardimage.moc"
//.................................................................. main
int main( int argc, char* argv[] ) {
   QApplication a( argc, argv );
   einBild* b = new einBild();
   a.setMainWidget( b );
   b->show();
   QObject::connect(qApp, SIGNAL(lastWindowClosed()), qApp, SLOT(quit()));
   return a.exec();
}
