#include <qapplication.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <qimage.h>
#include <qclipboard.h>
#include <qtimer.h>
#include <stdlib.h>
#include <time.h>

//......................................................... Klasse einBild
class einBild : public QLabel
{
   Q_OBJECT

   public:
      einBild( QWidget* parent=0, const char* name=0 ) :
                                       QLabel( parent, name ) {
         clipboard = QApplication::clipboard();

         QString bildDatei;
         int     w;

         if ( ( w = rand()%10 ) < 8 )
            bildDatei.sprintf( "%d.bmp", rand()%52+1 );
         else if ( w < 9 )
            bildDatei = "Suse.xpm";
         else
            bildDatei = "Crab.xpm";

         bild.load( bildDatei );
         setPixmap( bild );
         resize( bild.width()+20, bild.height()+20 ); 
         setAlignment( Qt::AlignCenter );
         QObject::connect( clipboard, SIGNAL( dataChanged() ),
                           this, SLOT( pasteImage() ) );

         timer = new QTimer( this );
         connect( timer, SIGNAL(timeout()), SLOT(copyImage()) );
         timer->start( rand()%5000+1000, false );
      }

   private slots:
      void copyImage() {
         clipboard->setImage( bild.convertToImage(), QClipboard::Clipboard );
         timer->start( rand()%5000+1000, false );
         setPaletteBackgroundColor( Qt::red );
      }

      void pasteImage() {
         if ( rand() % 15 == 0 ) {
            bild.convertFromImage( clipboard->image(QClipboard::Clipboard) );
            setPixmap( bild );
            resize( bild.width()+20, bild.height()+20 ); 
            setPaletteBackgroundColor( Qt::green );
         } else
            setPaletteBackgroundColor( Qt::lightGray );
      }

   private:
      QClipboard *clipboard;
      QPixmap     bild;
      QTimer     *timer;
};

#include "clipboardsend.moc"

//.................................................................. main
int main( int argc, char* argv[] )
{
   QApplication a( argc, argv );
  
   ::srand( time(NULL) );

   einBild* b[5];
   for (int i=0; i<5; i++) {
      b[i] = new einBild();
      b[i]->show();
   }
   QObject::connect(qApp, SIGNAL(lastWindowClosed()), qApp, SLOT(quit()));
   return a.exec();
}
