#include <qwidget.h>
#include <qapplication.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qcolordialog.h>

//............................................................... MeinFarbe
class MeinFarbe : public QWidget {
    Q_OBJECT
public:
    MeinFarbe::MeinFarbe() : QWidget( 0, 0) {
        palette = new QPalette;
        palette->setColor( QColorGroup::Foreground, aktFarbe = Qt::blue );
        palette->setColor( QColorGroup::Background, Qt::white );

        farbeButton = new QPushButton( "Neue Farbe", this );
        connect( farbeButton, SIGNAL( clicked() ), SLOT( neueFarbe() ) );
        label = new QLabel ( this );
        label->setPalette( *palette );
        label->setAlignment( Qt::AlignCenter );
        label->setFont( QFont( "Helvetica", 36 ) );
        label->setGeometry( 0, 30, 400, 370 );
        showText();
    }

private slots:
    void  neueFarbe() {
       QColor neuFarbe;
       neuFarbe = QColorDialog::getColor( aktFarbe, 0 );
       if ( neuFarbe.isValid() ) {
          aktFarbe = neuFarbe;
          showText();
       }
    }

private:
    void showText() {
       palette->setColor( QColorGroup::Foreground, aktFarbe );
       label->setPalette( *palette );
       label->setText( "Text" );
       label->show();
    }

    QPushButton *farbeButton;
    QColor       aktFarbe;
    QPalette    *palette;
    QLabel      *label;
};

#include "colordialog2.moc"

//.................................................................... main
int main( int argc, char *argv[] )
{
  QApplication a( argc, argv );

  MeinFarbe *w = new MeinFarbe;
  w->show();
  w->resize( 400, 400 );
 
  a.setMainWidget( w );
  return a.exec();
}
