#include <iostream.h>

//........................................................... Klasse Complex
class Complex
{
private:
    double real;     // Realteil der komplexen Zahl
    double imag;     // Imaginaerteil der komplexen Zahl

public:
                                          // Konstruktor zur Initialisierung
    Complex( double init_re = 0.0, double init_im = 0.0 ) {
       real = init_re;
       imag = init_im;
    }
                              
    void add( Complex zahl ) {              // Addition einer komplexen Zahl
       real += zahl.real;
       imag += zahl.imag;
    }

    friend Complex add( Complex z1, Complex z2 ) { // Add. 2er kompl. Zahlen
       Complex  temp;

       temp.real = z1.real + z2.real;
       temp.imag = z1.imag + z2.imag;

       return temp;
    }

    void print( void ) {                     // Ausgabe einer komplexen Zahl
       cout << "(" << real << ", " << imag << "i)";
    }
};

//..................................................................... main
int main(void) {
    Complex  c1( 7.0, 4.0 );  // 1. Komplexe Zahl (7.0 + 4.0i)
    Complex  c2( 1.3, 8.2 );  // 2. Komplexe Zahl (1.3 + 8.2i)
    Complex  c3;              // 3. Komplexe Zahl (0.0 + 0.0i)

    c1.add( c2 );       // Addiere c2 zu c1
    cout << "c1 = "; c1.print(); cout << endl; // Ausgabe von c1

            // Da add eine friend-Funktion ist, kann sie wie eine andere
            // globale Funktion aufgerufen werden, ohne dass man zuerst
            // ein Objekt der Klasse Complex erzeugen muss
    c3 = add( c1, c2 ); // Addiere c1 und c2 --> c3
    cout << "c3 = "; c3.print(); cout << endl; // Ausgabe von c3

    return 0;
}
