#include <iostream.h>

//........................................................... Klasse Complex
class Complex
{
private:
    double real;     // Realteil der komplexen Zahl
    double imag;     // Imaginaerteil der komplexen Zahl

public:
                                          // Konstruktor zur Initialisierung
    Complex( double init_re = 0.0, double init_im = 0.0 ) {
       real = init_re;
       imag = init_im;
    }
                              
    Complex& operator+=( Complex zahl ) {  // Addition einer komplexen Zahl
       real += zahl.real;
       imag += zahl.imag;
       return( *this );
    }

    Complex& operator-=( Complex zahl ) { // Subtrakion einer komplexen Zahl
       real -= zahl.real;
       imag -= zahl.imag;
       return( *this );
    }

    friend Complex operator+ ( Complex z1, Complex z2 ) {    // Addition 2er
       Complex  temp;                                    // komplexer Zahlen

       temp.real = z1.real + z2.real;
       temp.imag = z1.imag + z2.imag;
       return temp;
    }

    friend Complex operator- ( Complex z1, Complex z2 ) { // Subtraktion 2er
       Complex  temp;                                    // komplexer Zahlen
       temp.real = z1.real - z2.real;
       temp.imag = z1.imag - z2.imag;
       return temp;
    }

    Complex operator++ () {      // Praefix-Inkrementieren von real und imag
       real += 1;
       imag += 1;
       return( *this );
    }

    Complex operator++ ( int ) { // Postfix-Inkrementieren von real und imag
       Complex  temp;
       real += 1;
       imag += 1;
       return temp;
    }

    Complex operator-- () {      // Praefix-Dekrementieren von real und imag
       real -= 1;
       imag -= 1;
       return( *this );
    }

    Complex operator-- ( int ) { // Postfix-Dekrementieren von real und imag
       Complex  temp;
       real -= 1;
       imag -= 1;
       return temp;
    }

    void print( void ) {                     // Ausgabe einer komplexen Zahl
       cout << "(" << real << ", " << imag << "i)";
    }
};

//..................................................................... main
int main(void) {
    Complex  c1( 7.0, 4.0 );  // 1. Komplexe Zahl (7.0 + 4.0i)
    Complex  c2( 1.3, 8.2 );  // 2. Komplexe Zahl (1.3 + 8.2i)
    Complex  c3, c4, c5, c6, c7, c8, c9, c10, c11;

    c1 += c2;
    c1 += c2;
    cout << "c1 = "; c1.print(); cout << endl; // Ausgabe von c1

    c1 -= c2;
    cout << "c1 = "; c1.print(); cout << endl; // Ausgabe von c1

    c3 = c1 + c2;
    cout << "c3 = "; c3.print(); cout << endl; // Ausgabe von c3

    c4 = c5++;
    cout << "c4 = "; c4.print(); cout << ", ";
    cout << "c5 = "; c5.print(); cout << endl;

    c6 = ++c7;
    cout << "c6 = "; c6.print(); cout << ", ";
    cout << "c7 = "; c7.print(); cout << endl;

    c8 = c9--;
    cout << "c8 = "; c8.print(); cout << ", ";
    cout << "c9 = "; c9.print(); cout << endl;

    c10 = --c11;
    cout << "c10 = "; c10.print(); cout << ", ";
    cout << "c11 = "; c11.print(); cout << endl;

    return 0;
}
