#include <ctype.h>
#include <iostream>
#include <iomanip>

using namespace std;
//............................................... Klasse CQueue ...........
class CQueue  
{
public:
   CQueue(int iMaxEntries);            // Konstruktor
   ~CQueue() { delete [] m_entries; }  // Destruktor (inline)

   bool    isEmpty() { return m_iCount==0;      } // Queue leer ? (inline)
   bool    isFull()  { return m_iCount==m_iMax; } // Queue voll ? (inline)
   char    Get();
   bool    Put(char name);
   void    Contents();

private:
   char    *m_entries;
   int     m_iCount;
   int     m_iFirst, m_iLast, m_iMax;

   bool    Init();
};
//........................................................ main ...........
int main(void)
{
   const int iMaxQueue = 10;
   CQueue    queue(iMaxQueue);
   char      eingabe;
   char      name;
 
   while (1) {
      cout << endl << endl
           << "A   Ankunft eines neuen Patienten\n"
              "B   Bedienung des naechsten Patienten\n"
              "Q   Aktuellen Queue-Inhalt anzeigen\n"
              "E   Ende des Programms\n\n"
              "               Deine Wahl: ";
      cin >> eingabe;
      cout << endl;
      
      if (eingabe == 'e')
         break;
      else if (eingabe == 'a') {
         if (!queue.isFull()) {
            cout << "... Name des Patienten (als Buchstabe): ";
            cin >> name;
            queue.Put(name);
         } else
            cout << "...... Wartezimmer ist voll ...." << endl;
      } else if (eingabe == 'b') {
         if (queue.isEmpty())
            cout << "...... Wartezimmer ist leer ...." << endl;
         else
            cout << "...... '" << queue.Get() << "' wird nun bedient" << endl;
      } else if (eingabe == 'q') {
         queue.Contents();
      }
   } 
   return 0;
}
//................................................. Konstruktor ...........
CQueue::CQueue(int iMaxEntries)
{
   Init();

   m_entries = new char[iMaxEntries+1];

   if (m_entries)
      m_iMax=iMaxEntries;
}
//........................................................ Init ...........
bool CQueue::Init()
{
   m_iLast = m_iMax = m_iFirst = m_iCount = 0;
   m_entries=NULL;

   return true;
}
//......................................................... Put ...........
bool CQueue::Put(char Name)
{
   if(!m_entries || isFull())
      return false;

   m_entries[m_iLast] = Name;
   
   if(m_iLast < m_iMax)
      m_iLast++;
   else if(m_iLast == m_iMax)
      m_iLast=0;

   m_iCount++;

   return true;
}
//......................................................... Get ...........
char CQueue::Get()
{
   char name;

   if(isEmpty() || !m_entries)
      return ' ';

   name = m_entries[m_iFirst];

   if(m_iFirst < m_iMax)
      m_iFirst++;
   else if(m_iFirst == m_iMax)
      m_iFirst=0;

   m_iCount--;

   return name; 
}
//.................................................... Contents ...........
void CQueue::Contents()
{
   int i, j;

   if (isEmpty())
      cout << "...... Wartezimmer ist leer ...." << endl;
   else if (m_iLast > m_iFirst) {
      for (i=m_iFirst, j=1; i<m_iLast; i++, j++)
         cout << setw(2) << j << ". " << m_entries[i] << endl;
   } else {
      for (i=m_iFirst, j=1; i<=m_iMax; i++, j++)
         cout << setw(2) << j << ". " << m_entries[i] << endl;
      for (i=0; i<m_iLast; i++, j++)
         cout << setw(2) << j << ". " << m_entries[i] << endl;

   }
}
