#include <qapplication.h>
#include <qbitmap.h>
#include <qpushbutton.h>
#include <qcursor.h>
#include <stdlib.h>
#include <time.h>

// cb_bits und cm_bits wurden mit dem X-Programm bitmap erzeugt
#define cb_width  32
#define cb_height 32
static unsigned char cb_bits[] = {      // cursor bitmap
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf8, 0x0f, 0x00,
   0x00, 0x06, 0x30, 0x00, 0x80, 0x01, 0xc0, 0x00, 0x40, 0x00, 0x00, 0x01,
   0x20, 0x00, 0x00, 0x02, 0x10, 0x00, 0x00, 0x04, 0x08, 0x3e, 0x3e, 0x08,
   0x08, 0x03, 0xe0, 0x08, 0xc4, 0x00, 0x00, 0x11, 0x04, 0x1e, 0x78, 0x10,
   0x02, 0x0c, 0x30, 0x20, 0x02, 0x40, 0x00, 0x20, 0x02, 0x40, 0x00, 0x20,
   0x02, 0x40, 0x00, 0x20, 0x02, 0x20, 0x04, 0x20, 0x02, 0x20, 0x04, 0x20,
   0x02, 0x10, 0x08, 0x20, 0x02, 0x08, 0x08, 0x20, 0x02, 0xf0, 0x07, 0x20,
   0x04, 0x00, 0x00, 0x10, 0x04, 0x00, 0x00, 0x10, 0x08, 0x00, 0xc0, 0x08,
   0x08, 0x3c, 0x30, 0x08, 0x10, 0xe6, 0x19, 0x04, 0x20, 0x00, 0x0f, 0x02,
   0x40, 0x00, 0x00, 0x01, 0x80, 0x01, 0xc0, 0x00, 0x00, 0x06, 0x30, 0x00,
   0x00, 0xf8, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00};

#define cm_width  32
#define cm_height 32

static unsigned char cm_bits[] = {      // cursor bitmap mask
   0x00, 0x00, 0x00, 0x00, 0x00, 0xf8, 0x1f, 0x00, 0x00, 0xfe, 0x3f, 0x00,
   0x80, 0x07, 0xf0, 0x00, 0xc0, 0x01, 0xc0, 0x01, 0x60, 0x00, 0x00, 0x03,
   0x30, 0x00, 0x00, 0x06, 0x18, 0x00, 0x00, 0x0c, 0x0c, 0x3e, 0x3e, 0x18,
   0x0e, 0x03, 0xe0, 0x18, 0xc6, 0x00, 0x00, 0x31, 0x07, 0x1e, 0x78, 0x30,
   0x03, 0x0c, 0x30, 0x60, 0x03, 0x40, 0x00, 0x60, 0x03, 0x40, 0x00, 0x60,
   0x03, 0x40, 0x00, 0x60, 0x03, 0x20, 0x04, 0x60, 0x03, 0x20, 0x04, 0x60,
   0x03, 0x10, 0x08, 0x60, 0x03, 0x08, 0x08, 0x60, 0x03, 0xf0, 0x07, 0x60,
   0x06, 0x00, 0x00, 0x30, 0x06, 0x00, 0x00, 0x30, 0x0c, 0x00, 0xc0, 0x18,
   0x0c, 0x3c, 0x30, 0x18, 0x18, 0xe6, 0x19, 0x0c, 0x30, 0x00, 0x0f, 0x06,
   0x60, 0x00, 0x00, 0x03, 0xc0, 0x01, 0xc0, 0x01, 0x80, 0x07, 0xf0, 0x00,
   0x00, 0xfe, 0x3f, 0x00, 0x00, 0xf8, 0x0f, 0x00};

const char *fileName[] = {
             "hi.xpm",    "chess.xpm", "penguin.xpm", "monalisa.xpm",
             "snake.xpm", "suse.xpm",  "gv.xpm",      "lausbub.xpm"   };

//....................................................... Klasse CursorMove
class CursorMove : public QWidget
{
public:
    CursorMove() {
       QPushButton *b = new QPushButton( "Quit", this );
       QObject::connect( b,    SIGNAL( clicked() ),
                         qApp, SLOT( quit() ) );
    }

protected:
    virtual void mousePressEvent( QMouseEvent * ) {
       if ( ::rand()%9 < 8 ) {
          QPixmap  cb( fileName[::rand()%8] );
          QCursor custom( cb, 0, 0 );
          setCursor(custom);
       } else {
          QBitmap cb( cb_width, cb_height, cb_bits, true );
          QBitmap cm( cm_width, cm_height, cm_bits, true );
          QCursor custom( cb, cm );
          setCursor(custom);
       }
    }
};

//.................................................................... main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    ::srand( time( NULL ) );
    CursorMove   v;
    a.setMainWidget( &v );
    v.show();
    return a.exec();
}
