#include <qwidget.h>
#include <qapplication.h>
#include <qpushbutton.h>
#include <qcolordialog.h>
#include <qfile.h>
//............................................................... MeinFarbe
class MeinFarbe : public QWidget {
    Q_OBJECT
public:
    MeinFarbe::MeinFarbe() : QWidget( 0, 0) {
       setPaletteBackgroundColor( aktFarbe = Qt::white );
       farbeButton = new QPushButton( "Neue Farbe", this );
       connect( farbeButton, SIGNAL( clicked() ), SLOT( neueFarbe() ) );
       setGeometry( 0, 0, 400, 400 );
         //... Laden der gesicherten Custom colors
       if ( QFile::exists("eigeneFarben") ) {
          QFile meineFarbenDatei("eigeneFarben");
          if ( meineFarbenDatei.open( IO_ReadOnly ) ) {
             QDataStream stream( &meineFarbenDatei );
             int farbZahl;
             stream >> farbZahl;
             if ( farbZahl >= 0 && farbZahl <=16 )
                for (int i=0; i<farbZahl; i++) {
                   int rot, gruen, blau, alpha;
                   stream >> rot;
                   stream >> gruen;
                   stream >> blau;
                   stream >> alpha;
                   QColorDialog::setCustomColor( i, qRgba(rot,gruen,blau,alpha) );
                }
              meineFarbenDatei.close();
          }
       }
    }
public slots:
    void sichereCustomColors() { //... Sichern der eingestellten Custom colors
       QFile meineFarbenDatei("eigeneFarben");
       if ( meineFarbenDatei.open( IO_WriteOnly ) ) {
          QDataStream stream( &meineFarbenDatei );
          stream << QColorDialog::customCount();
          for (int i=0; i<QColorDialog::customCount(); i++) {
             QRgb rgb = QColorDialog::customColor( i );
             stream << qRed( rgb );
             stream << qGreen( rgb );
             stream << qBlue( rgb );
             stream << qAlpha( rgb );
          }
          meineFarbenDatei.close();
       }
    }
private slots:
    void  neueFarbe() {
       QColor neuFarbe;
       neuFarbe = QColorDialog::getColor( aktFarbe, 0 );
       if ( neuFarbe.isValid() ) {
          setPaletteBackgroundColor( aktFarbe = neuFarbe );
          repaint();
       }
    }
private:
    QPushButton *farbeButton;
    QColor       aktFarbe;
};
#include "customcolor.moc"
//.................................................................... main
int main( int argc, char *argv[] ) {
  QApplication a( argc, argv );
  MeinFarbe *w = new MeinFarbe;
  w->show();
  a.setMainWidget( w );
  QObject::connect( qApp, SIGNAL( lastWindowClosed() ),
                    w,    SLOT( sichereCustomColors() ) );
  return a.exec();
}
