#include <qapplication.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qtimer.h>
#include <stdlib.h>
#include <time.h>

#define NoWindows  4
//................................................ Klasse EmpfaengerWidget
class EmpfaengerWidget : public QLabel {
 public:
    EmpfaengerWidget( int id, QWidget *p ) : QLabel( p ), nr(id) {
       QString t;
       t.sprintf( "EmpfaengerWidget %d", nr+1 );
       setCaption( t );
       setAlignment( Qt::AlignCenter );
       setFont( QFont( "Helvetica", 30 ) );
       setGeometry( nr*100+400, 100+nr*120, 300, 150 );
       show();
    }
 protected:
    virtual void customEvent( QCustomEvent *ev ) {
       if ( ev->type() == 20000+nr ) {
          setPaletteBackgroundColor( QColor(rand()&255,rand()&255,rand()&255) );
          setText( (*(QString *)ev->data() ) );
       }
    }
 private:
    int  nr;
};
//.................................................... Klasse SenderWidget
class SenderWidget: public QLabel {
    Q_OBJECT
public:
    SenderWidget( QWidget *p=0, const char *name=0 ) : QLabel( p, name ) {
       wieoft = 0;
       setFont( QFont( "Helvetica", 100 ) );
       setAlignment( Qt::AlignCenter );
       for ( int i=0; i<NoWindows; i++)
          window[i] = new EmpfaengerWidget( i, 0 );
       QTimer *timer = new QTimer;
       connect( timer, SIGNAL( timeout() ), this, SLOT( colorChangeSlot() ) );
       timer->start( 1000, false );
    }
private slots:
    void colorChangeSlot( void ) {
       int  whichWindow = rand() % NoWindows;
       QCustomEvent *event = new QCustomEvent( 20000+whichWindow );
       QString *t = new QString;
       t->sprintf("%d (%d)", whichWindow+1, ++wieoft );
       setText( *t );
       t->sprintf("%d", wieoft );
       event->setData( t );
       QApplication::postEvent( window[whichWindow], event );
    }
private:
    EmpfaengerWidget *window[ NoWindows ];
    int              wieoft;
};
//................................................................... main
int main( int argc, char *argv[] ) {
    QApplication app( argc, argv );
    srand( time( NULL ) );
    SenderWidget *control = new SenderWidget;
    control->setCaption( "SenderWidget" );
    control->setGeometry( 100, 200, 300, 300 );
    app.setMainWidget( control );
    control->show();
    return app.exec();
}
#include "customevent.moc"
