#include <qapplication.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qfile.h>
#include <qdatastream.h>
#include <qcolor.h>
#include <qdatetime.h>
#include <stdlib.h>
#include <time.h>
//........................................................... Klasse FarbZeit
class FarbZeit : public QWidget {
   Q_OBJECT
public:
   FarbZeit() {
      QPushButton *b1 = new QPushButton( "Neue Farbe/Zeit", this);
      b1->setGeometry( 50, 50, 300, 50 );
      connect( b1, SIGNAL( clicked() ), this, SLOT( neuFarbZeit() ) );
      label = new QLabel( this );
      label->setGeometry( 50, 110, 300, 120 );
      label->setAlignment( AlignCenter );
      label->setPaletteBackgroundColor( Qt::white );
      QPushButton *b2 = new QPushButton( "Beenden", this);
      b2->setGeometry( 50, 250, 300, 50 );
      connect( b2, SIGNAL( clicked() ), qApp, SLOT( quit() ) );
   }
private slots:
   void neuFarbZeit( void ) {
      generiereNeuFarbZeit();
      liesNeuFarbZeit();
   }
private:
   void generiereNeuFarbZeit( void ) {
      QFile datei( "/tmp/farbzeit.cfg" );
       datei.open( IO_WriteOnly );
      QDataStream schreib( &datei );
       schreib << QColor ( rand()%256, rand()%256, rand()%256 );
       schreib << QDateTime::currentDateTime();  
      datei.close();
   }
   void liesNeuFarbZeit( void ) {
      QColor     farbe;
      QDateTime  aktZeit;
      QFile      datei( "/tmp/farbzeit.cfg" );

      datei.open( IO_ReadOnly );
      QDataStream lies( &datei );
      lies >> farbe;
      lies >> aktZeit;
      label->setPaletteBackgroundColor( farbe );
      label->setText( aktZeit.toString() );
      datei.close();
   }
   QLabel  *label;
};
#include "datastream.moc"
//..................................................................... main
int main( int argc, char* argv[] ) {
   QApplication myapp( argc, argv );
   FarbZeit* mywidget = new FarbZeit();
   mywidget->setGeometry( 50, 50, 400, 350 );
   ::srand( time( NULL ) ); 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
