#include <qapplication.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qfile.h>
#include <qdatastream.h>
#include <qscrollview.h>
#include <qpixmap.h>
#include <qfont.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>

QString fontName[] = { "Helvetica", "Courier", "Times" };
QString picNames[] = {
           "Pinguin.xpm", "Wizard.xpm", "lausbub.xpm", "monalisa.xpm" };

//............................................................ Klasse PicFont
class PicFont : public QWidget
{
   Q_OBJECT
public:
   PicFont() {
      picFont = new QWidget();
      picFont->setGeometry( 450, 50, 400, 400 );      

      picView = new QScrollView( picFont );
      picView->setGeometry( 0, 0, 400, 200 );      
      picLabel = new QLabel( picView->viewport() );

      fontLabel = new QLabel( picFont );
      fontLabel->setAlignment( AlignCenter );
      fontLabel->setPalette( QPalette( Qt::white ) );
      fontLabel->setGeometry( 0, 200, 400, 200 );
      
      QPushButton *b1 = new QPushButton( "Neues Bild/Font", this);
      b1->setGeometry( 50, 50, 300, 50 );
      connect( b1, SIGNAL( clicked() ), this, SLOT( newPicFont() ) );
      QPushButton *b2 = new QPushButton( "Beenden", this);
      b2->setGeometry( 50, 100, 300, 50 );
      connect( b2, SIGNAL( clicked() ), qApp, SLOT( quit() ) );
   }
   
private slots:
   void newPicFont( void ) {
      makeNewPicFont();
      readNewPicFont();
   }

private:
   void makeNewPicFont( void )
   {
      QString picName = picNames[rand()%4 ];
      QPixmap  pic( picName );

      QFile file( "/tmp/picfont.cfg" );
      file.open( IO_WriteOnly );

      QDataStream write( &file );

      write << QString( picName );
      write << pic;
      write << QFont( fontName[ rand()%3 ], rand()%40+8 );

      file.close();
   }

   void readNewPicFont( void )
   {
      QString  picName;
      QPixmap  pic;
      QFont    font;

      QFile    file( "/tmp/picfont.cfg" );
      file.open( IO_ReadOnly );

      QDataStream read( &file );

      read >> picName;
      read >> pic;
      read >> font;

      file.close();

      picLabel->setPixmap( pic );
      picLabel->resize( picLabel->sizeHint() );
      picView->addChild( picLabel );

      fontLabel->setFont( font );
      fontLabel->setText( picName );
      picFont->show();
   }

   QWidget     *picFont;
   QScrollView *picView;
   QLabel      *picLabel,
               *fontLabel;
};

#include "datastream2.moc"

//..................................................................... main
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   PicFont* mywidget = new PicFont();
   mywidget->setGeometry( 30, 50, 400, 200 );

   ::srand( time( NULL ) ); 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
