#include <qapplication.h>
#include <qlistview.h>
#include <qsqldatabase.h>
#include <qsqlcursor.h>

int main( int argc, char* argv[] ) {
   QApplication app( argc, argv );
    //... Verbindung zur Datenbank herstellen
   QSqlDatabase* adrVerwalt = QSqlDatabase::addDatabase( "QMYSQL3" );
   if ( adrVerwalt ) {
      adrVerwalt->setHostName( "localhost" );
      adrVerwalt->setDatabaseName( "adrVerwaltung" );
      adrVerwalt->setUserName( "root" );
      adrVerwalt->setPassword( "" );

      if ( adrVerwalt->open() ) { //... ffnen der Datenbank
          //... Erzeugen einer Listenansicht
         QListView adrView;
         app.setMainWidget( &adrView );
         adrView.addColumn( "Nachname" );
         adrView.addColumn( "Vorname" );
         adrView.addColumn( "Telefon" );
         adrView.addColumn( "Strasse" );
         adrView.addColumn( "PLZ" );
         adrView.addColumn( "Wohnort" );
         adrView.addColumn( "Geburtstag" );
         adrView.show();
          // Erzeugen und Ausfhren eines QSqlCursor-Objekts
         QSqlCursor cursor( "privatAdressen" );
         QStringList reihenFolge =
               QStringList() << "nachName" << "vorName" << "geburtsTag";
         QSqlIndex sortierFolge = cursor.index( reihenFolge );
         cursor.select( sortierFolge );

         if ( cursor.isActive() ) {
            while ( cursor.next() ) {
               new QListViewItem( &adrView,
                      cursor.value( "nachName" ).toString(),
                      cursor.value( "vorName" ).toString(),
                      cursor.value( "telNummer" ).toString(),
                      cursor.value( "strasse" ).toString(),
                      cursor.value( "plz" ).toString(),
                      cursor.value( "wohnOrt" ).toString(),
                      cursor.value( "geburtsTag" ).toString() );
            }
         }
         return app.exec();
      } else
          adrVerwalt->lastError().showMessage( "Fehler bei Verbindung\n");
   } else
        qDebug( "Aktivierung des Datenbank-Treibers nicht mglich" );
   return 1;
}
