#include <qapplication.h>
#include <qdatabrowser.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qsqldatabase.h>
#include <qsqlcursor.h>
#include <qsqlform.h>
#include <qdatetimeedit.h>
//................................................................... FormDialog
class FormDialog : public QDataBrowser {
 public:
   FormDialog() {
        //... Anlegen des Formulars mit Labels und Eingabemglichkeiten
      QGridLayout *grid = new QGridLayout( this );
      grid->setSpacing( 10 );
      grid->setMargin( 20 );
      grid->addWidget(new QLabel( "Vorname:",      this ), 0, 0);
      grid->addWidget(new QLabel( "Nachname:",     this ), 0, 1);
      grid->addWidget(new QLabel( "Telefon:",      this ), 0, 2);
      grid->addWidget(new QLabel( "Geburtsdatum:", this ), 0, 3);
      grid->addWidget(vorName  = new QLineEdit(this) , 1, 0);
      grid->addWidget(nachName = new QLineEdit(this),  1, 1);
      grid->addWidget(telNr    = new QLineEdit(this),  1, 2);
      grid->addWidget(geburt   = new QDateEdit(this),  1, 3);
      grid->addWidget(new QLabel( "Strasse:", this ), 2, 0);
      grid->addWidget(new QLabel( "PLZ:", this),      2, 1);
      grid->addWidget(new QLabel( "Wohnort:", this ), 2, 2);
      grid->addWidget(strasse = new QLineEdit(this),  3, 0);
      grid->addWidget(plz     = new QLineEdit(this),  3, 1);
      grid->addWidget(wohnOrt = new QLineEdit(this),  3, 2);
        //... Anlegen der Buttons zum Vor- und Zurckblttern in den Datenstzen
      QPushButton *prevButton = new QPushButton( "<", this );
      QPushButton *nextButton = new QPushButton( ">", this );
      connect( prevButton, SIGNAL( clicked() ), this, SLOT( prev() ) );
      connect( this,       SIGNAL( prevRecordAvailable(bool) ),
               prevButton, SLOT( setEnabled(bool) ) );
      connect( nextButton, SIGNAL( clicked() ), this, SLOT( next() ) );
      connect( this,       SIGNAL( nextRecordAvailable(bool) ),
               nextButton, SLOT( setEnabled(bool) ) );
      grid->addMultiCellWidget( new QLabel( this ), 4, 4, 0, 3 );
      grid->addWidget(prevButton, 5, 0);
      grid->addWidget(nextButton, 5, 3);

      QPushButton *insertButton = new QPushButton( "Einfgen", this );
      QPushButton *updateButton = new QPushButton( "Aktualisieren", this );
      QPushButton *deleteButton = new QPushButton( "Lschen", this );
      connect( insertButton, SIGNAL( clicked() ), this, SLOT( insert() ) );
      connect( updateButton, SIGNAL( clicked() ), this, SLOT( update() ) );
      connect( deleteButton, SIGNAL( clicked() ), this, SLOT( del() ) );
      grid->addMultiCellWidget( new QLabel( this ), 6, 6, 0, 3 );
      grid->addWidget(insertButton, 7, 0);
      grid->addWidget(updateButton, 7, 1);
      grid->addWidget(deleteButton, 7, 3);

      grid->activate();

       //... Anlegen eines QSqlCursor-Objekts fr Tabelle 'privatAdressen'
      QSqlCursor *cursor = new QSqlCursor ( "privatAdressen" );;
       //... Anlegen eines Formulars
      QSqlForm *sqlForm = new QSqlForm( this );
      sqlForm->insert( vorName,  "vorName" );
      sqlForm->insert( nachName, "nachName" );
      sqlForm->insert( telNr,    "telNummer" );
      sqlForm->insert( strasse,  "strasse" );
      sqlForm->insert( plz,      "plz" );
      sqlForm->insert( wohnOrt,  "wohnOrt" );
      sqlForm->insert( geburt,   "geburtsTag" );
       //... Konfigurieren des QDataBrowser-Objekts
      setForm( sqlForm );  // Formular fr QDataBrowser-Objekt festlegen
      setSqlCursor( cursor ); // QSqlCursor-Objekt fr QDataBrowser-Objekt
      setSort( cursor->index( // Sortierkriterien fr QDataBrowser-Objekt
                  QStringList() << "nachName" << "vorName" << "geburtsTag" ) );
//      setReadOnly( true ); // kein Zurckschreiben genderter Daten mglich
      refresh(); // Daten aus Datenbanktabelle lesen
      first();   // auf ersten Datensatz positionieren und im Formular anzeigen
      setConfirmEdits( true );
      setConfirmDelete( true );
      setConfirmInsert( true );
      setConfirmUpdate( true );
   }
   ~FormDialog() { }
 private:
   QLineEdit *nachName, *vorName, *telNr, *strasse, *plz, *wohnOrt;
   QDateEdit *geburt;
};
//......................................................................... main
int main( int argc, char *argv[] ) {
   QApplication app( argc, argv );
   QSqlDatabase* adrVerwalt = QSqlDatabase::addDatabase( "QMYSQL3" );
   if ( adrVerwalt ) {
      adrVerwalt->setHostName( "localhost" );
      adrVerwalt->setDatabaseName( "adrVerwaltung" );
      adrVerwalt->setUserName( "root" );
      adrVerwalt->setPassword( "" );
      if ( adrVerwalt->open() ) { //... ffnen der Datenbank
         FormDialog *formDialog = new FormDialog();
         formDialog->show();
         app.setMainWidget( formDialog );
         return app.exec();
      } else
          adrVerwalt->lastError().showMessage( "Fehler bei Verbindung\n");
   } else
        qDebug( "Aktivierung des Datenbank-Treibers nicht mglich" );
   return 1;
}
