#include <qapplication.h>
#include <qsqldatabase.h>
#include <qsqlcursor.h>
#include <qdatatable.h>

int main( int argc, char* argv[] ) {
   QApplication app( argc, argv );
   QSqlDatabase* lohnDatenbank = QSqlDatabase::addDatabase( "QMYSQL3" );
   if ( lohnDatenbank ) {
      lohnDatenbank->setHostName( "localhost" );
      lohnDatenbank->setDatabaseName( "personalAbt" );
      lohnDatenbank->setUserName( "root" );
      lohnDatenbank->setPassword( "" );
      if ( lohnDatenbank->open() ) {
         QSqlCursor cursor( "gehalt" );
         //..................................... Einfgen drei neuer Mitarbeiter
         QStringList::Iterator n, v, l;
         QStringList namen = QStringList() << "Schmitt" << "Ahlers" << "Maler",
                     vor   = QStringList() << "Emma"    << "Gunter" << "Fritz",
                     lohn  = QStringList() << "2192"    << "1987"   << "2765";
         for ( n=namen.begin(), v=vor.begin(), l=lohn.begin();
               n != namen.end();
               ++n, ++v, ++l ) {
            cursor.select();
            if ( cursor.last() ) {
               int id = cursor.at()+2; // interne Zhlung beginnt bei 0
               QSqlRecord *puffer = cursor.primeInsert(); // Einfgen festlegen
               puffer->setValue( "id",  id );
               puffer->setValue( "nachName",  *n );
               puffer->setValue( "vorName",   *v );
               puffer->setValue( "monGehalt", *l );
               cursor.insert();
            }
         }
         //................. Mitarbeiter 'Ahlers Gunter' bekommt Gehaltserhhung
         cursor.select( "nachName='Ahlers'" );
         if ( cursor.next() ) { // Auf Mitarbeiter mit 'Ahlers' positionieren
            QSqlRecord *puffer = cursor.primeUpdate(); // ndern festlegen
            int gehalt    = puffer->value( "monGehalt" ).toInt();
            int neuGehalt = gehalt + 210;
            puffer->setValue( "monGehalt", neuGehalt );
            cursor.update();
         }
         //..................... Mitarbeiterin 'Schmitt Emma' verlsst die Firma
         cursor.select( "id=3" );
         if ( cursor.next() ) {
            cursor.primeDelete(); // Lschen festlegen
            cursor.del();
         }
         //......................... Anzeigen der manipulierten Datenbanktabelle
         QDataTable *tabelle = new QDataTable( &cursor );
         tabelle->addColumn( "nachName",  "Nachname" );
         tabelle->addColumn( "vorName",   "Vorname" );
         tabelle->addColumn( "monGehalt", "Monatsgehalt" );
         tabelle->refresh();
         tabelle->show();
         app.setMainWidget( tabelle );
         int ret = app.exec();
         delete tabelle;
         return ret;
      } else
          lohnDatenbank->lastError().showMessage( "Fehler bei Verbindung");
   } else
        qDebug( "Aktivierung des Datenbank-Treibers nicht mglich" );
   return 1;
}
