#include <qapplication.h>
#include <qsqldatabase.h>
#include <qsqlquery.h>
#include <qdatatable.h>

int main( int argc, char* argv[] ) {
   QApplication app( argc, argv );
   QSqlDatabase* lohnDatenbank = QSqlDatabase::addDatabase( "QMYSQL3" );
   if ( lohnDatenbank ) {
      lohnDatenbank->setHostName( "localhost" );
      lohnDatenbank->setDatabaseName( "personalAbt" );
      lohnDatenbank->setUserName( "root" );
      lohnDatenbank->setPassword( "" );
      if ( lohnDatenbank->open() ) {
         //............................................ Navigieren mit QSqlQuery
         QSqlQuery query("SELECT id, nachName, vorName, monGehalt FROM gehalt;");
         if ( query.isActive() ) {
            qDebug("... %d Datenstze in Datenbank", query.size());
            query.first(); //... Auf ersten Datensatz positionieren
            qDebug("... nun auf ersten (%d.) Datensatz", query.at() );
            query.last(); //... Auf letzten Datensatz positionieren
            qDebug("... nun auf letzten (%d.) Datensatz", query.at() );
            query.seek( query.size() / 2 ); //... Auf mittleren Datensatz pos.
            qDebug("... nun auf mittleren (%d.) Datensatz", query.at() );
         }
         //.......................... Direktes Manipulieren ber SQL-Anweisungen
         int zeilen = 0;
         query.exec( "INSERT INTO gehalt (id, nachName, vorName, monGehalt) "
                     "VALUES ( 6, 'Kern', 'Fred', 3876 );" );
         if ( query.isActive() )
            zeilen += query.numRowsAffected() ;
         query.exec( "UPDATE gehalt SET monGehalt=3199 WHERE nachName='Maler';");
         if ( query.isActive() )
            zeilen += query.numRowsAffected() ;
         query.exec( "DELETE FROM gehalt WHERE vorName='Helmut';" );
         if ( query.isActive() )
            zeilen += query.numRowsAffected() ;
         qDebug( "..... %d Zeilen wurden manipuliert", zeilen);
         //......................... Anzeigen der manipulierten Datenbanktabelle
         QSqlCursor cursor( "gehalt" );
         QDataTable *tabelle = new QDataTable( &cursor );
         tabelle->addColumn( "nachName",  "Nachname" );
         tabelle->addColumn( "vorName",   "Vorname" );
         tabelle->addColumn( "monGehalt", "Monatsgehalt" );
         tabelle->refresh();
         tabelle->show();
         app.setMainWidget( tabelle );
         int ret = app.exec();
         delete tabelle;
         return ret;
      } else
          lohnDatenbank->lastError().showMessage( "Fehler bei Verbindung");
   } else
        qDebug( "Aktivierung des Datenbank-Treibers nicht mglich" );
   return 1;
}
