#include  <stdio.h>
#include  <string.h>
#include  <time.h>

struct datum {
   int    tag;
   int    monat;
   int    jahr;

     //---------------------------------- Verschiedene Konstruktoren

   datum() {                       //................ 1. Konstruktor
      struct tm h = heute_datum();
      tag   = h.tm_mday;
      monat = h.tm_mon+1; // Zaehlung beginnt bei 0
      jahr  = h.tm_year+1900;
   }

   datum(int tag, int monat) {    //................ 2. Konstruktor
      struct tm h = heute_datum();
        // Zwei Moeglichkeiten, um Membervariablen von anderen
        // Variablen  (hier Parameter) gleichen Namens zu unterscheiden
      datum::tag  = tag;
      this->monat = monat;
      jahr        = h.tm_year+1900;
   }

   datum(int t, int m, int j) {   //................ 3. Konstruktor
      tag   = t;
      monat = m;
      jahr  = j;
   }

   datum(int t, char *m, int j) { //................ 4. Konstruktor
      tag   = t;
      monat = 0;
      char *monat_name[] = { "Jan", "Feb", "Mar", "Apr", "Mai", "Jun",
                             "Jul", "Aug", "Sep", "Okt", "Nov", "Dez" };
      for (int i=0; i<12; i++)
         if ( !strcmp( monat_name[i], m) ) {
            monat = i+1;
            break;
         }
      jahr  = j;
   }
                                  //................ 5. Konstruktor
   datum(struct datum& d, int abstand) {
      tag   = d.tag + abstand;
      monat = d.monat;
      jahr  = d.jahr;
   }

     //---------------------------------- Andere public-Routinen
   void gibaus( char *name ) {
      printf("%-15s: %d.%d.%d\n", name, tag, monat, jahr);
   }
   
   struct datum&  hole( void ) {
      return *this;
   } 

private:
   struct tm heute_datum() {
       time_t  zeit = time(NULL);
       return *localtime( &zeit );
   }
};

//-------------------------------------------------- main ---------------
int main(void)
{
   //... Verwendung von verschiedenen Konstruktoren zum statischen Anlegen
   struct datum  heute;                       // verwendet 1. Konstruktor
   struct datum  april25( 25, 4 );            // verwendet 2. Konstruktor
   struct datum  weih2001( 24, 12, 2001 );    // verwendet 3. Konstruktor
   struct datum  weih2000( 24, "Dez", 2000 ); // verwendet 4. Konstruktor
   struct datum  morgen( heute.hole(), 1 );   // verwendet 5. Konstruktor

   heute.gibaus( "heute" );
   april25.gibaus( "april25" );
   weih2000.gibaus( "weih2000" );
   weih2001.gibaus( "weih2001" );
   morgen.gibaus( "morgen" );
  
   //... und nun zum dynamischen Anlegen
   struct datum  *silvester2002, *vorgestern;

   silvester2002 = new datum( 31, "Dez", 2002 ); // verwendet 4. Konstruktor
   silvester2002->gibaus( "silvester2002" );
   vorgestern = new datum( heute.hole(), -2 );   // verwendet 5. Konstruktor
   vorgestern->gibaus( "vorgestern" );

   return 0;
}
