#include <qwidget.h>
#include <qapplication.h>
#include <qdialog.h>
#include <qpushbutton.h>
#include <qmessagebox.h>
#include <stdio.h>
//.............................................................. MeinDialog
class MeinDialog : public QDialog {
  public:
    MeinDialog::MeinDialog( QWidget *parent, QString name, bool modal=true )
                                    : QDialog( parent, name ) {
        setModal( modal );
        QPushButton *ok = new QPushButton( "OK", this );
        ok->setGeometry( 10,10, 100,30 );
        connect( ok, SIGNAL(clicked()), SLOT(accept()) );

        if ( modal ) {
           QPushButton *cancel = new QPushButton( "Cancel", this );
           cancel->setGeometry( 10,60, 100,30 );
           connect( cancel, SIGNAL(clicked()), SLOT(reject()) );
        }
    }
};
//.................................................................... main
int main( int argc, char *argv[] ) {
  QApplication a( argc, argv );

  QWidget *w = new QWidget;
  w->setGeometry( 10, 10, 300, 300 );
  w->setPalette( QPalette( Qt::blue, Qt::blue ) );
  w->show();

  if ( argc > 1 && !strcmp( argv[1], "-m" ) ) {
     MeinDialog  *modal = new MeinDialog( w, 0, true );
     modal->setCaption( "Modaler Dialog" );
     modal->setPaletteBackgroundColor( Qt::red );
     int r = modal->exec();
     QString s;
     s.sprintf("Du hast `%s' gedrueckt!",
               r == QDialog::Accepted ? "OK" : "Cancel" );
     QMessageBox::information( 0, "Nur zu deiner Info", s );
  } else {
     MeinDialog  *nichtModal = new MeinDialog( w, 0, false );
     nichtModal->setCaption( "Nicht-Modaler Dialog" );
     nichtModal->setPaletteBackgroundColor( Qt::red );
     nichtModal->show();
  }
 
  a.setMainWidget( w );
  return a.exec();
}
