#include <qapplication.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qbuttongroup.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qdialog.h>
//....................................................... Klasse MyExtension
class MyExtension : public QWidget {
  public:
    MyExtension( QWidget *p=0, const char *name=0 ) : QWidget( p, name ) {
       setPaletteBackgroundColor( Qt::white );
       QGridLayout *bilder2 = new QGridLayout( this, 2, 2, 20, 10 );
       bilder2->setAutoAdd( true );
       QLabel *geraet[4];
       for ( int i=0; i<4; i++ ) {
          QString str;
          geraet[i] = new QLabel( this );
          str.sprintf("geraet%d.png", i+1);
          geraet[i]->setPixmap( str );
       }
    }
};
//.......................................................... Klasse MyDialog
class MyDialog : public QDialog {
    Q_OBJECT
  public:
    MyDialog( QWidget *parent=0, const char *name=0, bool modal=false )
                                       : QDialog( parent, name ) {
       setModal( modal );
       QGridLayout *grid = new QGridLayout( this, 2, 2, 20, 10 );
       QGridLayout *bilder1 = new QGridLayout( grid, 2, 3, 10 );
       QLabel *bildschirm[6];
       for ( int i=0; i<6; i++ ) {
          QString str;
          bildschirm[i] = new QLabel( this );
          str.sprintf("%s%d.png", (i<=2) ? "screen" : "pda", i%3+1);
          bildschirm[i]->setPixmap( str );
          bilder1->addWidget(bildschirm[i], i/3, i%3 );
       }
       QButtonGroup *hb = new QButtonGroup( 4, Qt::Horizontal, this );
       b1 = new QPushButton( "Ok", hb );
       QObject::connect( b1, SIGNAL( clicked() ), this, SLOT( accept() ) );
       b2 = new QPushButton( "Cancel", hb );
       QObject::connect( b2, SIGNAL( clicked() ), this, SLOT( reject() ) );
       b3 = new QPushButton( ">>>>", hb );
       QObject::connect( b3, SIGNAL( clicked() ), this, SLOT( zeigExtension1() ));
       grid->addMultiCellWidget( hb, 1, 1, 0, 1 );

       cb = new QCheckBox( "Erweiterung\nanzeigen", this );
       grid->addWidget(cb, 0, 1 );
       QObject::connect( cb,   SIGNAL( toggled(bool) ),
                         this, SLOT( zeigExtension2( bool ) ) );

       extension = new MyExtension( this );
       setExtension( extension );
       extensionSichtbar = false;
    }
  public slots:
    void zeigExtension1(void) {
       extensionSichtbar = !extensionSichtbar;
       showExtension( extensionSichtbar );
       b3->setText( extensionSichtbar ? "<<<<" : ">>>>" );
       cb->setChecked( extensionSichtbar );
    }
    void zeigExtension2(bool b) {
       showExtension( extensionSichtbar = b );
       b3->setText( b ? "<<<<" : ">>>>" );
    }
  private:
    QPushButton *b1, *b2, *b3;
    QCheckBox   *cb;
    MyExtension *extension;
    bool         extensionSichtbar;
};
#include "dialogext.moc"
//..................................................................... main
int main( int argc, char *argv[] ) {
    QApplication app( argc, argv );

    MyDialog dlg( 0, 0, true );

    return dlg.exec();
}
