#include <qapplication.h>
#include <qtimer.h>
#include <qlcdnumber.h>
#include <qdatetime.h>
//...................................................... Klasse DigitalUhr
class DigitalUhr : public QLCDNumber {
    Q_OBJECT
public:
    DigitalUhr( QWidget *p=0, const char *nam=0 ) : QLCDNumber( 10, p, nam ) {
       dpkt = false;
       setFrameStyle( QFrame::Panel | QFrame::Raised );
       setLineWidth( 5 );
       setPaletteBackgroundColor( Qt::blue.light( 160 ) );
       zeigeZeit();     // aktuelle Zeit anzeigen
       zeit = new QTimer( this );
       QObject::connect( zeit, SIGNAL( timeout() ), SLOT( zeigeZeit() ) );
       zeit->start( 500, false ); // Timer-Events fuer Zeit alle 0.5 Sek.
       datum = new QTimer( this );
       QObject::connect( datum, SIGNAL( timeout() ), SLOT( stopDatum() ) );
    }
protected:
    void mousePressEvent( QMouseEvent *e ) {
       if ( e->button() == QMouseEvent::LeftButton )
          zeigeDatum();
    }
private slots:
    void zeigeZeit() {
       dpkt = !dpkt; // Ein-/Aus blinkender Doppelpkt.
       display( QTime::currentTime().toString(dpkt ? "hh:mm:ss" : "hh mm ss") );
    }
    void stopDatum() {
       zeit->start( 500, false ); // Timer-Events fuer Zeit alle 0.5 Sek.
    }
private:
    void zeigeDatum() {
       display( QDate::currentDate().toString("dd.MM.yyyy") );
       zeit->stop();
       datum->start( 2000 ); // Timer-Event fuer Datum-Anzeige: 2 Sek.
    }
    QTimer  *zeit, *datum;
    bool    dpkt;
};
#include "digitaluhr1.moc"
//................................................................... main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    DigitalUhr *digUhr = new DigitalUhr;
    digUhr->resize( 270, 80 );
    a.setMainWidget( digUhr );
    digUhr->show();
    return a.exec();
}
