#include <qapplication.h>
#include <qlcdnumber.h>
#include <qdatetime.h>
//...................................................... Klasse DigitalUhr
class DigitalUhr : public QLCDNumber {
    Q_OBJECT
public:
    DigitalUhr( QWidget *p=0, const char *nam=0 ) : QLCDNumber( 10, p, nam ) {
       dpkt = false;
       setFrameStyle( QFrame::Panel | QFrame::Raised );
       setLineWidth( 5 );
       setPaletteBackgroundColor( Qt::blue.light( 160 ) );
       zeigeZeit();     // aktuelle Zeit anzeigen
       startTimer( 500 ); // Timer-Events fuer Zeit alle 0.5 Sek.
       datumTimerId = -1;  // Zu Beginn nicht das Datum zeigen
    }
protected:
    void timerEvent( QTimerEvent *e ) {
       if ( e->timerId() == datumTimerId )
          stopDatum();
       else if ( datumTimerId == -1 )
          zeigeZeit();
    }
    void mousePressEvent( QMouseEvent *e ) {
       if ( e->button() == QMouseEvent::LeftButton )
          zeigeDatum();
    }
private slots:
    void stopDatum() {
       killTimer( datumTimerId );
       datumTimerId = -1;
       zeigeZeit();
    }
    void zeigeZeit() {
       dpkt = !dpkt; // Ein-/Aus blinkender Doppelpkt.
       display( QTime::currentTime().toString(dpkt ? "hh:mm:ss" : "hh mm ss") );
    }
private:
    void zeigeDatum() {
       display( QDate::currentDate().toString("dd.MM.yyyy") );
       datumTimerId = startTimer( 2000 ); // Datum fuer 2 Sek. anzeigen
    }
    bool dpkt;
    int  datumTimerId;
};
#include "digitaluhr2.moc"
//................................................................... main
int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );
    DigitalUhr *digUhr = new DigitalUhr;
    digUhr->resize( 270, 80 );
    a.setMainWidget( digUhr );
    digUhr->show();
    return a.exec();
}
