#include <qapplication.h>
#include <qsocketnotifier.h>
#include <qtextbrowser.h>
#include <qfont.h>
#include <unistd.h> // Unter Windows (MS): #include <io.h>

#define BUFSIZE   1024
//................................................ class DisplayStdin
class DisplayStdin : public QTextBrowser {
   Q_OBJECT
public:
   DisplayStdin() : QTextBrowser() {
      setFont( QFont( "Courier", 10 ) );
      notify = new QSocketNotifier(0, QSocketNotifier::Read);
      QObject::connect ( notify, SIGNAL (activated(int) ),
                         this,   SLOT(receive (int) ) );
   }
private slots:
   void receive (int sock) {
      char buffer [BUFSIZE+1];
      int  len;
      if ( ( len = read(sock, buffer, BUFSIZE) ) <= 0 )
         delete notify;
      buffer[len] = 0;
      insert( (QString)buffer );
   }
private:
   QSocketNotifier *notify;
};
#include "displaystdin.moc"
//.............................................................. main
int main( int argc, char *argv[] ) {
   QApplication app (argc, argv);
   DisplayStdin *widget = new DisplayStdin();
   widget->resize( 700, 500 );
   widget->show();
   QObject::connect( &app, SIGNAL( lastWindowClosed() ),
                     &app, SLOT( quit() ) );
   return app.exec ();
}
