#include <qapplication.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <qimage.h>
#include <qdragobject.h>
#include <qpushbutton.h>
#include <stdlib.h>
#include <time.h>

//.......................................... Klasse MeinLabel ..................
class MeinLabel : public QLabel {

public:
    MeinLabel( int nr, QWidget* parent=0, const char* name=0)
                                                   : QLabel(parent,name) {
       QString dateiName;
       dateiName.sprintf("%d.bmp", nr );
       QPixmap b;
       b.load( dateiName );
       setPixmap( b );
       setGeometry( 10+(nr-1)%10*80, 50+(nr-1)/10*120, 1, 1 );
       adjustSize();
       resize( width(), height() );
       setAcceptDrops( true );
    }

protected:
    virtual void mousePressEvent( QMouseEvent * ) {
       if ( pixmap() ) {
          QPixmap  pm;
          QDragObject *d = new QImageDrag( pixmap()->convertToImage(), this );
          pm.convertFromImage(
              pixmap()->convertToImage().smoothScale( pixmap()->width()/2,
                                                      pixmap()->height()/2 ) );
          d->setPixmap( pm, QPoint( 35, 40 ) );
          d->dragCopy();
       }
    }
};

//.......................................... Klasse MyCards ....................
class MyCards : public QWidget {

public:
    MyCards( QWidget* parent=0, const char* name=0) : QWidget(parent,name) {
       for (int i=1; i<=20; i++) {
          MeinLabel *l = new MeinLabel( i, 0 );
          l->show();
        }
        setCaption( "Ablage fr die Karten" );
        setGeometry( 100, 300, 500, 200 );
        setAcceptDrops( true );
        QPushButton *b = new QPushButton( "Quit" , this );
        b->setGeometry( 0, 150, 500, 50 );
        QObject::connect( b, SIGNAL( clicked() ), qApp, SLOT( quit() ) );
        cardNo = 0;
    }
 
protected:
    void dragEnterEvent( QDragEnterEvent *e ) {
       if ( QImageDrag::canDecode( e ) )
          e->accept();
    }

    void dropEvent( QDropEvent *e ) {
       QPixmap pm;
       if ( QImageDrag::decode( e, pm ) ) {
          QLabel *l = new QLabel( this );
          l->setGeometry( cardNo++ * 30, 0, 1, 1 );
          l->setPixmap( pm );
          l->resize( l->width(), l->height() );
          l->adjustSize();
          l->show();
       }
    }

private:
    int  cardNo;
};

//.............................................................. main ..........
int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );
    ::srand( time(NULL) );

    MyCards *myCards = new MyCards;
    a.setMainWidget( myCards );
    myCards->show();
    return a.exec();
}

