#include <qapplication.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <qimage.h>
#include <qdragobject.h>
#include <qclipboard.h>
#include <stdlib.h>
#include <time.h>

//.......................................... Klasse MeinLabel ..................
class MeinLabel : public QLabel {
  public:
    MeinLabel( QWidget* parent=0, const char* name=0) : QLabel(parent,name) {
       QString dateiName;
       dateiName.sprintf("%d.bmp", ::rand()%52+1 );
       QPixmap b;
       b.load( dateiName );
       setPixmap( b );
       setGeometry( ::rand()%600, ::rand()%600, 1, 1 );
       adjustSize();
       resize( width()+50, height()+50 );
       strgGedrueckt = false;
       setAcceptDrops( true );
    }
  protected:
    void keyPressEvent( QKeyEvent *e ) {
       if ( e->key() == Key_Control )
          strgGedrueckt = true;
       else if ( strgGedrueckt ) {
          if ( e->key() == Key_C )
             copy();
          else if ( e->key() == Key_V )
             paste();
          strgGedrueckt = false;
       }
    }
    void dragEnterEvent( QDragEnterEvent *e ) {
       if ( QImageDrag::canDecode( e ) )
          e->accept();
    }
    void dropEvent( QDropEvent *e ) {
       QPixmap pm;
       if ( QImageDrag::decode( e, pm ) )
          setPixmap( pm );
    }
    virtual void mousePressEvent( QMouseEvent * ) {
       if ( pixmap() ) {
          QDragObject *d = new QImageDrag( pixmap()->convertToImage(), this );
          d->dragCopy();
       }
    }
  private:
    void copy( void ) {
       QApplication::clipboard()->setData(
          new QImageDrag( pixmap()->convertToImage() ), QClipboard::Clipboard );
    }
    void paste( void ) {
       QPixmap pm;
       if ( QImageDrag::decode(
                QApplication::clipboard()->data(QClipboard::Clipboard), pm ) )
          setPixmap( pm );
    }
    QImage  bild;
    bool    strgGedrueckt;
};
//.............................................................. main ..........
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    ::srand( time(NULL) );
    for (int i=0; i<3; i++) {
       MeinLabel *l = new MeinLabel( 0 );
       l->show();
    }
    QObject::connect(qApp, SIGNAL(lastWindowClosed()), qApp, SLOT(quit()));
    return a.exec();
}
