#include <qapplication.h>
#include <qlabel.h>
#include <qevent.h>
#include <qpixmap.h>
#include <qimage.h>
#include <qdragobject.h>
#include <stdlib.h>
#include <time.h>
//.......................................... Klasse MeinLabel ..................
class MeinLabel : public QLabel {
public:
    MeinLabel( QWidget* parent=0, const char* name=0)
                                                   : QLabel(parent,name) {
       QString dateiName;
       dateiName.sprintf("%d.bmp", ::rand()%52+1 );
       QPixmap b;
       b.load( dateiName );
       setPixmap( b );
       setGeometry( ::rand()%600, ::rand()%600, 1, 1 );
       adjustSize();
       resize( width()+10, height()+10 );
       setAcceptDrops( true );
    }
protected:
    void dragEnterEvent( QDragEnterEvent *e ) {
       if ( QImageDrag::canDecode( e ) )
          e->accept();
       setPaletteBackgroundColor( Qt::blue );
    }
    void dragLeaveEvent( QDragLeaveEvent* ) {
       setPaletteBackgroundColor( Qt::gray );
    }
    void dropEvent( QDropEvent *e ) {
       QPixmap pm;
       if ( QImageDrag::decode( e, pm ) ) {
          setPixmap( pm );
          setFrameStyle( QFrame::Sunken | QFrame::Panel );
          setLineWidth( 8 );
          resize( width()+10, height()+10 );
          adjustSize();
       }
    }
    virtual void mousePressEvent( QMouseEvent * ) {
       if ( pixmap() ) {
          QDragObject *d = new QImageDrag( pixmap()->convertToImage(), this );
          d->dragCopy();
          setPaletteBackgroundColor( Qt::red );
       }
    }
};
//.............................................................. main ..........
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    ::srand( time(NULL) );
    for (int i=0; i<3; i++) {
       MeinLabel *l = new MeinLabel( 0 );
       l->show();
    }
    QObject::connect(qApp, SIGNAL(lastWindowClosed()), qApp, SLOT(quit()));
    return a.exec();
}
