#include <qapplication.h>
#include <qdragobject.h>
#include <qtextedit.h>
//................................................ Klasse DragDropTextEdit
class DragDropTextEdit : public QTextEdit {
 public:
   DragDropTextEdit( QWidget *p=0, const char *nam=0) : QTextEdit(p, nam) { }
 protected:
   virtual void mousePressEvent( QMouseEvent *event ) {
      if ( event->button() == LeftButton )
         dragStartPos = event->pos();
      QTextEdit::mousePressEvent( event );
   }
   virtual void mouseMoveEvent( QMouseEvent *event ) {
      if ( event->state() & LeftButton )
            //... nur wenn Maus mind. 3 Pixel gezogen wurde
         if ( abs( event->pos().x() - dragStartPos.x() ) >= 3 ||
              abs( event->pos().y() - dragStartPos.y() ) >= 3 )  {
            QTextDrag *dragText = new QTextDrag( text(), this );
            dragText->dragCopy();
         }
      QTextEdit::mouseMoveEvent( event );
   }
   virtual void dragEnterEvent( QDragEnterEvent *event ) {
      if ( QTextDrag::canDecode( event ) )
         event->accept();
   }
   virtual void dropEvent( QDropEvent *event ) {
      QString  textdrop;
      if ( QTextDrag::decode( event, textdrop ) ) {
         int zeile, spalte;
         getCursorPosition( &zeile, &spalte );
         insertAt( textdrop, zeile, spalte );
      }
   }
 private:
   QPoint dragStartPos;
};
//................................................................... main
int main( int argc, char *argv[] ) {
   QApplication a( argc, argv );
   DragDropTextEdit *edit = new DragDropTextEdit;
   a.setMainWidget( edit );
   edit->show();
   return a.exec();
}
