#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qbrush.h>
#include <qdrawutil.h>
#include <stdlib.h>
#include <time.h>
//........................................................ Klasse MalFenster
class MalFenster : public QWidget {
 protected:
   virtual void mousePressEvent( QMouseEvent * ) { repaint( true ); }

   virtual void paintEvent( QPaintEvent* ) {
      int  x, i;
      QPainter p( this );
      p.setFont( QFont( "Times", 12 ) );
      p.drawText( 20, 40, "qDrawPlainRect" ); 
      for ( i=0; i<4; i++ )
         qDrawPlainRect( &p, x=i*150+50, 50, 100, 100, 
                         QColor( rand()&255, rand()&255, rand()&255 ), i,
                         new QBrush( QColor(rand()&255,rand()&255,rand()&255)));
      p.drawText( 20, 190, "qDrawShadeLine" ); 
      for ( i=0; i<4; i++ ) {
         p.drawText( x=i*150+50, 210, i%2 ?"versunken":"nicht versunken"); 
         qDrawShadeLine( &p, x, 230, x+100, 230, colorGroup(), i%2, (i+1)*2, 0);
      }
      p.drawText( 20, 280, "qDrawWinButton" ); 
      for ( i=0; i<4; i++ ) {
         p.drawText( x=i*150+50, 300, i%2 ? "versunken" : "nicht versunken"); 
         qDrawWinButton( &p, x, 310, 100, 40, colorGroup(), i%2,
                         new QBrush(QColor(rand()&255,rand()&255,rand()&255)));
      }
      p.drawText( 20, 380, "qDrawWinPanel" ); 
      for ( i=0; i<4; i++ ) {
         p.drawText( x=i*150+50, 400, i%2 ? "versunken" : "nicht versunken"); 
         qDrawWinPanel( &p, x, 410, 100, 40, colorGroup(), i%2,
                        new QBrush(QColor(rand()&255,rand()&255,rand()&255)));
      }
      p.drawText( 20, 480, "qDrawShadePanel" ); 
      for ( i=0; i<4; i++ ) {
         p.drawText( x=i*150+50, 500, i%2 ? "versunken" : "nicht versunken"); 
         qDrawShadePanel( &p, x, 510, 100, 40, colorGroup(), i%2, (i+1)*2,
                          new QBrush(QColor(rand()&255,rand()&255,rand()&255)));
      }
      p.drawText( 20, 580, "qDrawShadeRect" ); 
      for ( i=0; i<4; i++ ) {
         int  ml = rand()%5;
         QString text;
         text.sprintf("%s Midline %d", i%2 ? "versunken / " : "   ", ml); 
         p.drawText( x=i*150+50, 600, text );
         qDrawShadeRect( &p, x, 610, 100, 40, colorGroup(), i%2, (i+1)*2, ml, 
                         new QBrush(QColor(rand()&255,rand()&255,rand()&255)));
      }
   }
};
//..................................................................... main
int main( int argc, char *argv[] ) {
   QApplication myapp( argc, argv );
   MalFenster* mywidget = new MalFenster();
   mywidget->setGeometry( 0, 0, 650, 700 );
   srand( time( NULL ) ); 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
