#include <qapplication.h>
#include <qbuttongroup.h>
#include <qhbox.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <qgroupbox.h>
#include <qpushbutton.h>
#include <qvbox.h>

//........................................................ class ButtonGruppe
class ButtonGruppe : public QVBox
{
public:
    ButtonGruppe( QWidget *parent, const char *name ) : QVBox( parent, name )
    {
       QHBox *box1 = new QHBox( this, "box1" );
       QHBox *box2 = new QHBox( this, "box2" );

       QButtonGroup *grp1 = new QButtonGroup( 1, Horizontal,
                                              "Temperature", box1, "grp1" );
       grp1->setExclusive( true );
       (void)new QRadioButton( "&Cold", grp1, "cold" );
       (void)new QRadioButton( "&Warm", grp1, "warm" );

       QButtonGroup *grp2 = new QButtonGroup( 1, Horizontal,
                                              "Color", box1, "grp2" );
       grp2->setExclusive( false );
       (void)new QCheckBox( "&Red", grp2, "red" );
       (void)new QCheckBox( "&Green", grp2, "green" );
       qDebug( "........... Name of second ButtonGroup: %s", grp2->name() );

       QButtonGroup *grp3 = new QButtonGroup( 1, Horizontal,
                                         "Push or Toggle", box2, "grp3" );
       (void)new QPushButton( "&Push me", grp3, "push" );
       QPushButton *toggle = new QPushButton( "&Toggle", grp3, "toggle" );
       toggle->setToggleButton( true );
       toggle->setOn( true );

       qDebug( ".......................... dumpObjectTree()" );
       dumpObjectTree();
       qDebug( ".......................... dumpObjectInfo()" );
       dumpObjectInfo();
       qDebug( "........... Name of this Object: %s", this->name() );
    }
};

//........................................................ main ..........
int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );

    ButtonGruppe buttonGrp( 0, "ButtonGruppe" );
    buttonGrp.setCaption( "Buttons und Gruppen" );
    a.setMainWidget( &buttonGrp );
    buttonGrp.show();

    return a.exec();
}
