#include <qwidget.h>
#include <qapplication.h>
#include <qpushbutton.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qlayout.h>

class DynFocus: public QWidget {
    Q_OBJECT
public:
    DynFocus() {
       QString  t;

       QGridLayout *l = new QGridLayout( this, 5, 2, 20 );

       QButtonGroup *buttonBox = new QButtonGroup( 3, Vertical, this );
       buttonBox->setFrameStyle( QFrame::StyledPanel | QFrame::Sunken );

       r1 = new QRadioButton( "Normal Tab Order", buttonBox );
       r1->setFocusPolicy( NoFocus );
       r1->setChecked( true );

       r2 = new QRadioButton( "Reverse Tab Order", buttonBox );
       r2->setFocusPolicy( NoFocus );

       r3 = new QRadioButton( "2-step Tab Order", buttonBox );
       r3->setFocusPolicy( NoFocus );

       connect( buttonBox, SIGNAL( clicked( int ) ),
                this,      SLOT( newTabOrder( int ) ) );
       l->addMultiCellWidget( buttonBox, 0, 4, 0, 0 );

       for ( int i=0; i<5; i++ ) {
          t. sprintf( "Button %d", i+1 );
          b[i] = new QPushButton( t, this );
          l->addWidget( b[i], i, 1 );
       }
       b[0]->setFocus();
    }

private slots:
    void newTabOrder( int no ) {
       int  i;
       switch ( no ) {
          case 0:
             for ( i=0; i<4; i++ ) 
                 setTabOrder( b[i], b[i+1] );
             break;
          case 1:
             for ( i=4; i>0; i-- ) 
                 setTabOrder( b[i], b[i-1] );
             break;
          case 2:
             setTabOrder( b[0], b[2] );
             setTabOrder( b[2], b[4] );
             setTabOrder( b[4], b[1] );
             setTabOrder( b[1], b[3] );
             break;
       }
    }

private:
    QRadioButton  *r1, *r2, *r3;
    QPushButton   *b[5];
};

#include "dynfokus.moc"

int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );
    DynFocus r;
    a.setMainWidget( &r );
    r.show();
    return a.exec();
}
