#include <qlabel.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include "dynlayout.h"

//................................................... GridDemo (Konstruktor)
GridDemo::GridDemo() : QWidget( 0, 0 )
{
      //....................................... Initialisierungen
    z = s = 10;
    all = z*s;
    this->setPaletteBackgroundColor( Qt::green );
 
      //.................................... Toplevel-Grid-Layout
    g = new QGridLayout( this, 2, 2, 30, -1 );
    g->addWidget( new QLabel( "<b>Einstellungen:</b>", this ), 0, 0 );
    g->addWidget( new QLabel( "<b>Anzeige:</b>", this ), 0, 1 );

      //.................................... Ausgewaehlte Anzeige
    l = 0;
    zeigeBox();

      //..... Spinboxen-Auswahl fuer Zeilen-, Spalten-, Gesamtzahl
    QVBoxLayout * v = new QVBoxLayout;
    g->addLayout( v, 1, 0 );

    QHBoxLayout * h = new QHBoxLayout;
    v->addStretch( 100 );   //......... Wahl der Zeilenzahl
    v->addLayout( h );
    h->addWidget( new QLabel( "Zeilen:", this ) );
    zeilen = new QSpinBox( this );
    h->addWidget( zeilen );

    h = new QHBoxLayout;
    v->addStretch( 50 );    //........ Wahl der Spaltenzahl
    v->addLayout( h );
    h->addWidget( new QLabel( "Spalten:", this ) );
    spalten = new QSpinBox( this );
    h->addWidget( spalten );

    h = new QHBoxLayout;
    v->addStretch( 100 );    //......... Wahl der Gesamtzahl
    v->addLayout( h );
    h->addWidget( new QLabel( "Gesamt:", this ) );
    gesamt = new QSpinBox( this );
    h->addWidget( gesamt );
    v->addStretch( 100 );

    zeilen->setRange( 1, zMax ); //. SpinBoxen konfigurieren
    zeilen->setValue( z );
    spalten->setRange( 1, sMax );
    spalten->setValue( s );
    gesamt->setRange( 1, allMax );
    gesamt->setValue( all );
              //.... Spinbox-Aenderungen mit Slots verbinden
    connect( zeilen, SIGNAL( valueChanged(int) ),
             this,   SLOT( neuZeilenSlot(int) ) );
    connect( spalten, SIGNAL( valueChanged(int) ),
             this,    SLOT( neuSpaltenSlot(int) ) );
    connect( gesamt, SIGNAL( valueChanged(int) ),
             this,   SLOT( neuGesamtSlot(int) ) );
}


//................................................................ zeigeBox
void GridDemo::zeigeBox()
{
    int    i, j, c=0;
    QLabel *but;

    if ( l )
       delete l;
    l = new QLabel( this );
    l->setPaletteBackgroundColor( Qt::yellow );

    QGridLayout *a = new QGridLayout( l, z, s, 5, 0 );
    a->setSpacing( -1 ); 

    for (i=0; i < z; i++)
       a->setRowStretch( i, 1 );
    for (j=0; j < s; j++)
       a->setColStretch( j, 1 );
    for (i=0; i < z; i++) {
       for (j=0; j < s; j++) {
          but = new QLabel( "", l );
          if (++c <= all) {
             but->setPaletteBackgroundColor( Qt::blue.light( 180 ) );
             but->setFrameStyle( QFrame::PopupPanel | QFrame::Raised );
             but->setLineWidth(3);
          } else {
             but->setPalette( l->palette() );
             but->setFrameStyle( QFrame::Box | QFrame::Plain );
             but->setLineWidth(1);
          }
          but->setMinimumSize( 15, 15 );
          a->addWidget( but, i, j );
       }
    }
    g->addWidget( l, 1, 1 );
    this->setMinimumSize( this->minimumSize() );
    l->show();
}
