#include <qapplication.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qevent.h>
#include <qcursor.h>

//........................................................ Klasse MeinFenster
class MeinFenster : public QWidget
{
public:
   MeinFenster() {
      setGeometry( 50, 50, 350, 200 );
      setMinimumSize( 350, 200 );

      QString t( " noch keinmal wurde Maus in dieses Widget bewegt" );
      label = new QLabel( this );
      label->setFont( QFont ("Times", 12 ) );
      label->setText( t );
      label->setPaletteBackgroundColor( Qt::white );
      label->setFrameStyle( QFrame::Box | QFrame::Raised );
      label->setLineWidth( 2 );
      label->setAlignment( AlignCenter );
      label->setGeometry( 20, rect().center().y()-20, width()-40, 40 );
      wieoft = 0;
      nochImWidget = false;
   }

protected:
   virtual void enterEvent( QEvent* ) {
      if ( !nochImWidget ) {
         QString t;
         t.sprintf( " %d. mal wurde Maus in dieses Widget bewegt", ++wieoft);
         label->setGeometry( 20, rect().center().y()-20, width()-40, 40 );
         label->setText( t );
         setPaletteBackgroundColor( Qt::blue.light( 120 ) );
      } else
         nochImWidget = false;
   }

   virtual void leaveEvent( QEvent* ) {
      if ( geometry().contains( QCursor::pos() ) )
         nochImWidget = true;
      else {
         nochImWidget = false;
         setPaletteBackgroundColor( Qt::lightGray );
      }
   }

   virtual void resizeEvent( QEvent* ) {
      label->setText( label->text() );
      label->setGeometry( 20, rect().center().y()-20, width()-40, 40 );
   }

private:
   QLabel  *label;
   int     wieoft;
   bool    nochImWidget; // bentigt, um bei einem Wechsel in das im Widget
                         // eingebettete Label keine Farbnderung vorzunehmen
};

//.................................................................. main 
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   MeinFenster* mywidget = new MeinFenster();

   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
