#include <qapplication.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qradiobutton.h>
#include <qcheckbox.h>

//................................................ Klasse VerschiebFilter
class VerschiebFilter : public QObject
{
protected:
   bool eventFilter( QObject *object, QEvent *event ) {
      QWidget *w = (QWidget *)object;
      int sw = 0; //... sw = Schrittweite

      if ( event->type() == QEvent::MouseButtonDblClick )
         sw = 5;
      if ( event->type() == QEvent::MouseButtonPress )
         sw = 1;
      if ( sw > 0 ) {
         ButtonState b = ( (QMouseEvent *)event)->button(),
                     s = ( (QMouseEvent *)event)->state();
         if ( (b & LeftButton) && (s & ShiftButton) ) {
            w->move( w->x(), w->y()-sw );
            return true;
         } else if ( (b & LeftButton) && (s & ControlButton) ) {
            w->move( w->x()-sw, w->y() );
            return true;
         } else if ( (b & RightButton) && (s & ShiftButton) ) {
            w->move( w->x(), w->y()+sw );
            return true;
         } else if ( (b & RightButton) && (s & ControlButton) ) {
            w->move( w->x()+sw, w->y() );
            return true;
         }
      }
      return false;
   }
};

//.................................................................. main 
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   QWidget* mywidget = new QWidget();
   mywidget->resize( 260, 200 );

   QObject *verschiebFilter = new VerschiebFilter();

                                   //........................... Pushbutton
   QPushButton *button = new QPushButton( mywidget );
   button->setGeometry( 20, 20, 100, 50 );
   button->setText( "Button" );
   button->installEventFilter( verschiebFilter );
                                   //............................... Slider
   QSlider *slider = new QSlider( QSlider::Horizontal, mywidget );
   slider->setGeometry( 20, 120, 100, 30 );
   slider->installEventFilter( verschiebFilter );
                                   //............................. Checkbox
   QCheckBox *checkbox = new QCheckBox( "Checkbox", mywidget );
   checkbox->setGeometry( 150, 20, 100, 30 );
   checkbox->installEventFilter( verschiebFilter );
                                   //.......................... Radiobutton
   QRadioButton *radiobutton = new QRadioButton( "Radiobutton", mywidget );
   radiobutton->setGeometry( 150, 120, 100, 30 );
   radiobutton->installEventFilter( verschiebFilter );

   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
