#include <qapplication.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qradiobutton.h>
#include <qcheckbox.h>

//................................................... Klasse DeleteFilter
class DeleteFilter : public QObject
{
protected:
   bool eventFilter( QObject *object, QEvent *event ) {
      if ( event->type() == QEvent::MouseButtonPress )
         if ( ((QMouseEvent *)event)->button() == RightButton ) {
            QWidget *w = (QWidget *)object;
            QColor farbe( rand()&0xff, rand()&0xff, rand()&0xff );
            w->setPaletteBackgroundColor( farbe );
            return true;
         }
      return false;
   }
};

//.................................................................. main 
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   QWidget* mywidget = new QWidget();
   mywidget->resize( 260, 200 );

   QObject *delFilter = new DeleteFilter();

                                   //........................... Pushbutton
   QPushButton *button = new QPushButton( mywidget );
   button->setGeometry( 20, 20, 100, 50 );
   button->setText( "Button" );
   button->installEventFilter( delFilter );
                                   //............................... Slider
   QSlider *slider = new QSlider( QSlider::Horizontal, mywidget );
   slider->setGeometry( 20, 120, 100, 30 );
   slider->installEventFilter( delFilter );
                                   //............................. Checkbox
   QCheckBox *checkbox = new QCheckBox( "Checkbox", mywidget );
   checkbox->setGeometry( 150, 20, 100, 30 );
   checkbox->installEventFilter( delFilter );
                                   //.......................... Radiobutton
   QRadioButton *radiobutton = new QRadioButton( "Radiobutton", mywidget );
   radiobutton->setGeometry( 150, 120, 100, 30 );
   radiobutton->installEventFilter( delFilter );

   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
