#include <qapplication.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qlabel.h>

enum { ROT=200, GRUEN, GELB, BLAU, SCHWARZ };

class Farbmenu : public QWidget {
   Q_OBJECT
public:
   Farbmenu() {
      anzeige = new QLabel( this );
      anzeige->setGeometry( 0, 30, 200, 170 );
      anzeige->setPaletteBackgroundColor( Qt::black );
      farbeMenu = new QPopupMenu;
      farbeMenu->insertItem( "Rot", ROT);
      farbeMenu->insertItem( "Gruen", GRUEN);
      farbeMenu->insertItem( "Gelb", GELB);
      farbeMenu->insertItem( "Blau", BLAU);
      farbeMenu->insertItem( "Schwarz", SCHWARZ);
      connect( farbeMenu, SIGNAL( activated( int ) ),
               this,      SLOT( zeigeFarbe( int ) ) );
      menuBalken = new QMenuBar( this );
      menuBalken->insertItem( "Farbenwahl", farbeMenu );
   }
private slots:
   void zeigeFarbe( int f ) {
      switch ( f ) {
         case ROT:     anzeige->setPaletteBackgroundColor( Qt::red );    break;
         case GRUEN:   anzeige->setPaletteBackgroundColor( Qt::green );  break;
         case GELB:    anzeige->setPaletteBackgroundColor( Qt::yellow ); break;
         case BLAU:    anzeige->setPaletteBackgroundColor( Qt::blue );   break;
         case SCHWARZ: anzeige->setPaletteBackgroundColor( Qt::black );  break;
      }
      anzeige->show();
   }
private:
   QMenuBar*   menuBalken;
   QPopupMenu* farbeMenu;
   QLabel*     anzeige;
};
#include "farbmenu.moc"

int main( int argc, char* argv[] ) {
   QApplication myapp( argc, argv );
   Farbmenu* mywidget = new Farbmenu();
   mywidget->setGeometry( 10, 10, 200, 200 );
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
