#include <qapplication.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qpainter.h>
#include <qtimer.h>
//......................................................... Klasse MyWidget
class MyWidget : public QWidget {
   Q_OBJECT
public:
   MyWidget() {               //______________ MyWidget (Konstruktor)
      setPaletteBackgroundColor( Qt::white ); 
      maler = new QPainter(this);
      uebermalen = false;
      breite = 1;
      fileMenu = new QPopupMenu;  //.................... File-Menu
      fileMenu->insertItem( "&Lschen",    0 ); 
      fileMenu->insertItem( "&Uebermalen", 1 ); 
      fileMenu->insertItem( "&Beenden",    2 ); 
      fileMenu->setItemChecked( 0, true ); 
      QObject::connect( fileMenu, SIGNAL(activated(int)),
                        this,     SLOT( fileSLOT(int)) );
      penMenu = new QPopupMenu;    //............ Stiftbreite-Menu
      penMenu->insertItem( "&schmal",       1 );
      penMenu->insertItem( "&breit",        5 );
      penMenu->insertItem( "b&reiter",     15 );
      penMenu->insertItem( "&extra breit", 30 );
      penMenu->setItemChecked( 1, true );
      QObject::connect( penMenu, SIGNAL(activated(int)),
                        this,    SLOT( penSLOT(int)) );
      rotateMenu = new QPopupMenu;  //... DrehgeschwindigkeitsMenu
      rotateMenu->insertItem( "&schnell",       20 );
      rotateMenu->insertItem( "&langsam",       50);
      rotateMenu->insertItem( "s&ehr langsam", 200 );
      QObject::connect( rotateMenu, SIGNAL( activated(int) ),
                        this,       SLOT( rotateSLOT( int ) ) );
      rotateMenu->setItemChecked( 20, true);
      menuBalken = new QMenuBar( this );  //.......... Menu-Balken
      menuBalken->insertItem( "&File",   fileMenu );
      menuBalken->insertItem( "&Breite", penMenu );
      menuBalken->insertItem( "&Drehen", rotateMenu );
      t=new QTimer( this );
      t->start( 20 );
      connect(t, SIGNAL(timeout()), this, SLOT(rotiere()) );
   }
protected:
    void paintEvent( QPaintEvent * ) {
       static int   i=0, h=0, rndX = 0, rndY = 0, dx = 1, dy = 1;
       rndX += dx;
       rndY += dy;
       if ( rndX >= 99 || rndX <= 0) dx = -dx;
       if ( rndY >= 99 || rndY <= 0) dy = -dy;
       QPen p=maler->pen();
       p.setWidth( breite );
       QColor farbe;
       farbe.setHsv( h, 255, 255 );
       p.setColor( farbe );
       maler->save();
       maler->translate( 300, 300);
       maler->rotate(i);
       maler->setPen(p);
       maler->drawRoundRect( -200, -200, 400, 400, rndX, rndY );
       maler->restore();
       i = ++i % 360;
       h = ++h % 256;
    }  
private slots:
   void fileSLOT(int s) {
      if (s==2)
         qApp->quit();
      uebermalen = (s==1);
      fileMenu->setItemChecked( 0, !uebermalen ); 
      fileMenu->setItemChecked( 1, uebermalen ); 
    }
    void penSLOT(int s) {  // ........... Rahmenbreite ndern
       penMenu->setItemChecked(  1,  (s==1) );  
       penMenu->setItemChecked(  5,  (s==5) );  
       penMenu->setItemChecked( 15, (s==15) );  
       penMenu->setItemChecked( 30, (s==30) );  
       breite=s;
    }
    void rotateSLOT(int s) { // .. Drehgeschwindigkeit ndern
       rotateMenu->setItemChecked(  20, (s==20)  );  
       rotateMenu->setItemChecked(  50, (s==50)  );  
       rotateMenu->setItemChecked( 200, (s==200) );  
       t->changeInterval( s );
    }
    void rotiere() { repaint( !uebermalen ); }
private:
   QMenuBar   *menuBalken;
   QPopupMenu *fileMenu, *rotateMenu, *penMenu;
   QPainter   *maler;
   QTimer     *t;
   bool       uebermalen;
   int        breite;
};
#include "figrotate.moc"
//.................................................................... main
int main( int argc, char* argv[] ) {
   QApplication myapp( argc, argv );
   MyWidget*mywidget = new MyWidget();
   mywidget->setFixedSize( 600, 600 );
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
 }
