#include <qapplication.h>
#include <qlabel.h>
#include <qtextedit.h>
#include <qfiledialog.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtextstream.h>
#include <qmessagebox.h>

enum { SchliessenID=255, SpeichernID, SpeichernUnterID };
//.................................................................... Viewer
class Viewer : public QWidget {
   Q_OBJECT
public:
   Viewer();
private slots:
   void closeSlot() {      //..    .......................... closeSlot
      if ( view != NULL ) {
         delete view;
         view = NULL;
         dateiName = "";
         setzeTitel( "keine" );
         dateiMenu->setItemEnabled( SchliessenID, false );
         dateiMenu->setItemEnabled( SpeichernID, false );
         dateiMenu->setItemEnabled( SpeichernUnterID, false );
      }
   }
   void quitSlot() { closeSlot(); qApp->quit(); }
   void openSlot() {
      QString name = QFileDialog::getOpenFileName( ".", "*", this );
      if ( !name.isEmpty() ) {
         closeSlot();
         dateiName = name;
         leseDatei();
         dateiMenu->setItemEnabled( SchliessenID, true );
         dateiMenu->setItemEnabled( SpeichernID, true );
         dateiMenu->setItemEnabled( SpeichernUnterID, true );
      }
   }
   void saveSlot()   { if (view != NULL) speichereDatei( false ); }
   void saveAsSlot() { if (view != NULL) speichereDatei( true );  }
protected:
   virtual void resizeEvent( QResizeEvent* ) { //........... resizeEvent
      if (view != NULL) {
         view->setGeometry( 0, menuBalken->height(),
                            width(), height() - menuBalken->height() );
         if ( istBild )
            bildView->setGeometry(0, 0, width(), height()- menuBalken->height());
         else
            textView->setGeometry(0, 0, width(), height()- menuBalken->height());
         repaint();
      }
   }
private:
   void  setzeTitel( QString dateiname ) { //................ setzeTitel
      QString s = "Viewer - Datei: ";
      s += dateiname;
      setCaption( s );
   }
   void leseDatei() { //...................................... leseDatei
      QFile  datei;
      if ( !dateiName.isEmpty() ) {
         datei.setName( dateiName );
         setzeTitel( dateiName );
         view = new QWidget( this );
         if ( bild.load( dateiName ) ) {
            bildView = new QScrollView( view );
            bildView->viewport()->setPaletteBackgroundColor( Qt::white );
            QLabel *l = new QLabel( bildView->viewport() );
            l->setPixmap( bild ); 
            l->setFrameStyle( QFrame::Box | QFrame::Sunken );
            l->setLineWidth( 4 );
            l->resize( l->sizeHint() );
            istBild = true;
            bildView->addChild( l );
            bildView->setGeometry( 0, 0,
                             width(), height()- menuBalken->height() );
         } else if ( datei.open(IO_ReadOnly) ) {
            QString s;
            QTextStream text( &datei );     // verwende einen text stream
            textView = new QTextEdit( view );
            textView->setText( text.read() );
            datei.close();
            istBild = false;
            textView->setGeometry( 0, 0,
                             width(), height()- menuBalken->height() );
         }
         view->setGeometry( 0, menuBalken->height(),
                      width(), height() - menuBalken->height() );
         view->show();
      }
   }
   void speichereDatei( bool neuerName ) { //............ speichereDatei
      if ( dateiName.isEmpty() || neuerName == true )
         dateiName = QFileDialog::getSaveFileName( ".", "*", this );
      if ( !dateiName.isEmpty() ) {
         setzeTitel( dateiName );
         if ( istBild ) {
            QString extension = dateiName.mid(
                                    dateiName.findRev('.')+1 ).upper();
            if ( !bild.save( dateiName, extension ) )
               QMessageBox::information( this, "Fehler",
                     extension+"-Format wird nicht untersttzt");
         } else {
            QFile  datei;
            datei.setName( dateiName );
            if ( datei.open(IO_WriteOnly) ) {
               QString  text = textView->text();
               datei.writeBlock( text, strlen(text) );
               datei.close();
            }
         }
      }
   }
     //............................................... private-Variablen
   QMenuBar     *menuBalken;
   QPopupMenu   *dateiMenu;
   QString       dateiName;
   QWidget      *view;
   QTextEdit    *textView;
   QScrollView  *bildView;
   QPixmap      bild; 
   bool         istBild;
};
//........................................................ Viewer-Konstruktor
Viewer::Viewer() {
   view = NULL;
   dateiName   = "";
   setzeTitel( "keine");
   
   dateiMenu = new QPopupMenu; //... erzeugt ein Datei-Menue
   dateiMenu->insertItem( "Oe&ffnen...", this, SLOT( openSlot() ), CTRL + Key_O );
   dateiMenu->insertItem( "S&chliessen", this, SLOT( closeSlot() ),
                          CTRL + Key_W, SchliessenID );
   dateiMenu->setItemEnabled( SchliessenID, false );
    dateiMenu->insertSeparator();
   dateiMenu->insertItem( "&Speichern", this, SLOT( saveSlot() ),
                          CTRL + Key_S, SpeichernID );
   dateiMenu->setItemEnabled( SpeichernID, false );
   dateiMenu->insertItem( "Speichern &unter...", this, SLOT( saveAsSlot() ),
                          CTRL + Key_U, SpeichernUnterID );
   dateiMenu->setItemEnabled( SpeichernUnterID, false );
    dateiMenu->insertSeparator();
   dateiMenu->insertItem( "&Beenden", this, SLOT( quitSlot() ), CTRL + Key_Q );
   menuBalken = new QMenuBar( this ); //... erzeugt einen Menue-Balken
   menuBalken->insertItem( "&Datei", dateiMenu );
}
#include "filedialog.moc"
//...................................................................... main
int main( int argc, char* argv[] ) {
   QApplication myapp( argc, argv );
   Viewer* mywidget = new Viewer();
    mywidget->setGeometry( 10, 10, 600, 600 );
    myapp.setMainWidget( mywidget );
    mywidget->show();
   return myapp.exec();
}
