#include <qapplication.h>
#include <qtextview.h>
#include <qfileinfo.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qlabel.h>
#include <qtextbrowser.h>
#include <qstring.h>
#include <qfiledialog.h>
#include <qwidgetstack.h>
#include <qvbox.h>
#include <qhbox.h>
#include <qpixmap.h>
#include <qimage.h>
//.................................................................... ImageView
class ImageView : public QLabel {
   Q_OBJECT
public:
   ImageView( QWidget *parent ) : QLabel( parent ), breite(200), hoehe(200) { }
   void showPixmap( const QPixmap &pix ) {
      QPixmap pm;
      image = pix.convertToImage();
      image = image.scale( breite, hoehe, QImage::ScaleMax );
      pm.convertFromImage( image );
      setPixmap( pm ); 
   }
private:
   QImage image;
   int breite, hoehe;
};
//...................................................................... Preview
class Preview : public QWidgetStack {
   Q_OBJECT
public:
   Preview( QWidget *parent ) : QWidgetStack( parent ) {
      normalText = new QTextBrowser( this );
      normalText->setReadOnly( true );
      image = new ImageView( this );
      raiseWidget( normalText );
   }
   void showPreview( const QUrl &u );
private:
   QTextBrowser *normalText;
   ImageView    *image;
};
//................................................................ PreviewWidget
class PreviewWidget : public QVBox, public QFilePreview {
   Q_OBJECT
public:
   PreviewWidget( QWidget *parent=0 ) : QVBox( parent ), QFilePreview() {
      setSpacing( 5 );
      setMargin( 5 );
      QHBox *hbox = new QHBox( this );
      hbox->setSpacing( 5 );
      (void)new QLabel( "Vorschau:", hbox );
      hbox->setFixedHeight( 10 + this->sizeHint().height() );
      preview = new Preview( this );
   }
   void previewUrl( const QUrl &u ) {
      preview->setPaletteBackgroundColor( Qt::white );
      preview->showPreview( u );
   }
private:
   Preview *preview;
};
//......................................................... Preview::showPreview
void Preview::showPreview( const QUrl &u ) {
   QString path = u.path();
   QFileInfo fi( path );
   QPixmap pix( path );
   if ( pix.isNull() ) {
      if ( fi.isFile() ) {
         QFile f( path );
         if ( f.open( IO_ReadOnly ) ) {
            QTextStream ts( &f );
            QString text = ts.read();
            f.close();
            normalText->setText( text );
            raiseWidget( normalText );
            return;
         }
      }
      normalText->setText( QString::null );
      raiseWidget( normalText );
   } else {
      image->showPixmap( pix );
      raiseWidget( image );
   }
}
#include "filepreview.moc"
//......................................................................... main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    QString caption( "Whle Datei" );
    QFileDialog fd( QString::null,
                   "(*.cpp *.pro *.h *.html *.htm *.xpm *.png )", 0, 0, true );
    fd.setContentsPreviewEnabled( true );
    PreviewWidget *pw = new PreviewWidget( &fd );
    fd.setContentsPreview( pw, pw );
    fd.setPreviewMode( QFileDialog::Contents );
    fd.setCaption( "Whle Datei" );
    fd.setSelection( QDir::currentDirPath() );
    if ( fd.exec() == QDialog::Accepted ) {
       QString result = fd.selectedFile();
       printf("%s\n", (const char*)result);
       return 0;
    }
    return 1;
}
