#include <qapplication.h>
#include <qnetwork.h>
#include <qvbox.h>
#include <qstring.h>
#include <qpushbutton.h>
#include <qtextedit.h>
#include <qfiledialog.h>
#include <qurloperator.h>

//............................................................... class View
class View : public QVBox {
    Q_OBJECT
public:
    View() : QVBox() {
       setSpacing( 5 );
       setMargin( 5 );
       QPushButton *b = new QPushButton( "Download a file...", this );
       connect( b, SIGNAL( clicked() ), this, SLOT( downloadFile() ) );
       fileView = new QTextEdit( this );
       fileView->setReadOnly( true );
       connect( &op,  SIGNAL( data( const QByteArray &, QNetworkOperation * ) ),
                this, SLOT( newData( const QByteArray & ) ) );
    }
private slots:
    void downloadFile() {
         // QString file = QFileDialog::getOpenFileName();
         // unter Windows darf man nicht den zugrundliegenden Filedialog verwenden
       QString file = getOpenFileName();
       if ( !file.isEmpty() ) {
          fileView->clear();
          op = file;    // Download der Daten
          op.get();
       }
    }
    void newData( const QByteArray &ba ) { fileView->append( ba ); }
private:
    QTextEdit *fileView;
    QUrlOperator   op;
    QString getOpenFileName() {
       static QString workingDirectory = "ftp://ftp.suse.com/";

       QFileDialog *dlg = new QFileDialog( workingDirectory,
                                           QString::null, 0, 0, true );
       dlg->setCaption( "Open" );
       dlg->setMode( QFileDialog::ExistingFile );
       QString result;
       if ( dlg->exec() == QDialog::Accepted ) {
          result = dlg->selectedFile();
          workingDirectory = dlg->url();
       }
       delete dlg;
       return result;
    }
};
#include "filetransfer.moc"
//..................................................................... main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    qInitNetworkProtocols(); // Implementierte Netzwerkprotokolle initialisieren
    View v;
    v.resize( 600, 600 );
    v.show();
    a.setMainWidget( &v );
    return a.exec();
}
