#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qtimer.h>
#include <stdlib.h>
#include <time.h>

const char *pics[] = { "Butterfly.xpm", "Pinguin.xpm", "eggs.xpm",
                       "daemon.xpm", "ant.xpm", "xeyes.xpm", "suse.xpm",
                       "garfiled.xpm", "gv.xpm", "spider.xpm", "fish.xpm",
                       "radio.xpm", "phone.xpm" };

#define MovingObjects   50

//........................................................ Klasse malFenster
class malFenster : public QWidget
{
   Q_OBJECT

public:
    malFenster() {
       setPaletteBackgroundColor( Qt::gray );
       resize( 600, 600 );

       QTimer *timer = new QTimer( this );
       timer->start( 200, false );
       QObject::connect( timer, SIGNAL( timeout() ),
                         this,  SLOT( movePicture() ) );

       for ( int i=0; i<MovingObjects; i++ ) {
          pm[i].load( pics[::rand()%13] );
          posX[i] = ::rand()%600;
          posY[i] = ::rand()%600;
          directionX[i] = ::rand()%2 ? 2 : -2;
          directionY[i] = ::rand()%2 ? 2 : -2;
       }
       first = true;
    }

protected:
    void paintEvent( QPaintEvent *e ) {
       int  i, j;
       QPainter p( this );

       QRect r[100];
       for ( i=0; i<10; i++)
          for ( j=0; j<10; j++)
             r[i*10+j] = QRect(  10+i*60, 10+j*60, 40, 40 );
       QRegion reg;
       reg.setRects( r, 100 );
       p.setClipRegion( reg );

       if ( e->erased() ) {
          p.setBrush( Qt::blue.light( 180 ) );
          p.drawRect( 0, 0, 600, 600 );
          first = false;
       }

       p.setBrush( Qt::blue.light( 180 ) );
       p.setPen( NoPen );
       for ( i=0; i<MovingObjects; i++ ) {
          p.drawRect( posX[i], posY[i],
                      pm[i].size().width(), pm[i].size().height() );
          if ( posX[i] > 600 )
             directionX[i] = -directionX[i];
          else if ( posX[i] <= 0 )
             directionX[i] = -directionX[i];

          if ( posY[i] > 600 )
             directionY[i] = -directionY[i];
          else if ( posY[i] <= 0 )
             directionY[i] = -directionY[i];

          posX[i] += directionX[i];
          posY[i] += directionY[i];
          p.drawPixmap( posX[i], posY[i], pm[i] );
       }
    }
    void resizeEvent( QResizeEvent * ) {
       repaint( true );
    }

private slots:
    void movePicture( void ) {
       repaint( first );
    }

private:
    int      posX[MovingObjects],       posY[MovingObjects],
             directionX[MovingObjects], directionY[MovingObjects];
    QPixmap  pm[MovingObjects];
    bool     first;
};

#include "flywindow.moc"

int main( int argc, char *argv[] )
{
    ::srand( time( NULL ) );
    QApplication a( argc, argv );
    malFenster   bild;
    a.setMainWidget( &bild );
    bild.show();
    return a.exec();
}
