#include <qapplication.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <stdlib.h>
#include <time.h>

struct {
   const char  *focusName;
   int         focusTyp;
} focusRegel[] = { { "NoFocus",     QWidget::NoFocus     },
                   { "TabFocus",    QWidget::TabFocus    },
                   { "ClickFocus",  QWidget::ClickFocus  },
                   { "StrongFocus", QWidget::StrongFocus }  };
//.......................................................... Klasse Knopf
class Knopf: public QPushButton {
 public:
    Knopf( const QString &text, QWidget *p ) : QPushButton( text, p ) { }
 protected:
    virtual void focusInEvent( QFocusEvent *e ) {
       if ( e->gotFocus() )
          setPaletteBackgroundColor( Qt::white );
    }
    virtual void focusOutEvent( QFocusEvent *e ) {
       if ( e->lostFocus() )
          setPaletteBackgroundColor( Qt::lightGray );
    }
};
//...................................................... Klasse FokusDemo
class FokusDemo: public QWidget {
 public:
    FokusDemo() {
       int  i;
       ::srand( time( NULL ) );
       for ( i=0; i<10; i++) {
          int w = ::rand()%4;
          b[i] = new Knopf( focusRegel[w].focusName, this );
          b[i]->setFocusPolicy( (FocusPolicy)focusRegel[w].focusTyp );
       }
       QPushButton *quit = new QPushButton( "&Quit", this );
       quit->setFocusPolicy( NoFocus );
       connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );
       QGridLayout *l = new QGridLayout( this, 7, 2, 5 );
       for ( i=0; i<10; i++)
          l->addWidget( b[i], i/2, i%2 );
       l->addWidget( quit, 5, 1, AlignRight );
       b[0]->setFocus();
    }
 private:
    Knopf  *b[10];
};
//.................................................................. main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    FokusDemo r;
    r.resize( r.sizeHint() );
    a.setMainWidget( &r );
    r.show();
    return a.exec();
}
