#include <qwidget.h>
#include <qtextedit.h>
#include <qpushbutton.h>
#include <qapplication.h>
#include <qlayout.h>
#include <stdlib.h>
#include <time.h>

struct {
   const char  *focusName;
   int         focusTyp;
} focusRegel[] = { { "NoFocus",     QWidget::NoFocus     },
                   { "TabFocus",    QWidget::TabFocus    },
                   { "ClickFocus",  QWidget::ClickFocus  },
                   { "StrongFocus", QWidget::StrongFocus },
                   { "WheelFocus",  QWidget::WheelFocus  }  };
//................................................................... FokusDemo
class FokusDemo : public QWidget {
    Q_OBJECT
public:
    FokusDemo() {
       int  i;
       ::srand( time( NULL ) );
       links  = new QTextEdit( this, "links" );
       rechts = new QTextEdit( this, "rechts" );
       connect( links,  SIGNAL(textChanged()), this, SLOT(changeRight()) );
       connect( rechts, SIGNAL(textChanged()), this, SLOT(changeLeft()) );
       for ( i=0; i<10; i++) {
          int w = ::rand()%5;
          b[i] = new QPushButton( focusRegel[w].focusName, this );
          b[i]->setFocusPolicy( (FocusPolicy)focusRegel[w].focusTyp );
       }
       QPushButton *quit = new QPushButton( "&Quit", this );
       quit->setFocusPolicy( NoFocus );
       connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );
       QGridLayout *l = new QGridLayout( this, 7, 2, 5 );
       l->addWidget(  links, 0, 0 );
       l->addWidget( rechts, 0, 1 );
       for ( i=0; i<10; i++)
          l->addWidget( b[i], i/2+1, i%2 );
       l->addWidget( quit, 6, 1, AlignRight );
       links->setFocus();
    }
private slots:
    void changeLeft() {
       links->blockSignals( true ); // um Endlosrekursion bei
                                    // Signal textChanged() zu vermeiden
       links->setText( rechts->text().lower() );
       links->blockSignals( false ); // Signale wieder zulassen
    }
    void changeRight() {
       rechts->blockSignals( true ); // um Endlosrekursion bei
                                     // Signal textChanged() zu vermeiden
       rechts->setText( links->text().upper() );
       rechts->blockSignals( false ); // Signale wieder zulassen
    }
private:
    QTextEdit   *links, *rechts;
    QPushButton *b[10];
};
#include "fokus1.moc"
//........................................................................ main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    FokusDemo r;
    r.resize( 400, 400 );
    a.setMainWidget( &r );
    r.show();
    return a.exec();
}
