#include <qapplication.h>
#include <qlayout.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qfocusdata.h>
//........................................................... LieferDialog
class LieferDialog : public QWidget {
 public:
    LieferDialog( QWidget *p = 0, const char *n = 0 ) : QWidget( p, n ) {
       QGridLayout *box = new QGridLayout( this, 3, 3, 10, 20 );
       checkBox = new QCheckBox( "Zwischen 9.00 und 16.00 Uhr erreichbar", this);
       checkBox->setFocusPolicy( QWidget::StrongFocus );
       box->addWidget( checkBox, 0, 0 );
       QLabel *label1 = new QLabel( "Kommentar", this );
        box->addWidget( label1, 0, 1 );
        zeile1 = new QLineEdit( this );
        box->addWidget( zeile1, 0, 2 );
       QLabel *label2 = new QLabel( "Telefonnummer", this );
        box->addWidget( label2, 1, 1 );
        zeile2 = new QLineEdit( this );
        box->addWidget( zeile2, 1, 2 );
       this->setTabOrder( checkBox, zeile1 );
       this->setTabOrder( zeile1, zeile2 );
       this->setTabOrder( zeile2, checkBox );
       checkBox->setFocus();
    }
 protected:
    virtual bool focusNextPrevChild( bool forward ) {
       QFocusData *focusDaten = focusData();
       QWidget    *aktiv = focusDaten->home();
       if ( aktiv == checkBox ) {
          if ( !forward )
             zeile2->setFocus(); //... rueckwaerts zur 2. Zeile
          else if ( checkBox->isChecked() )
             zeile1->setFocus(); //... vorwaerts auf 1. Zeile
          else
             zeile2->setFocus(); //... Ueberspringe 1. Zeile
       } else {  //.... nichts Besonderes zu tun
          if ( !forward )
             focusDaten->prev()->setFocus();
          else
             focusDaten->next()->setFocus();
       }
       return true;
    }
 private:
    QCheckBox *checkBox;
    QLineEdit *zeile1, *zeile2;
};
//................................................................... main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    LieferDialog lieferDlg;
    lieferDlg.setCaption( "Demobeispiel zu dynamischen Fokus-Regeln" );
    lieferDlg.resize( lieferDlg.sizeHint() );
    lieferDlg.show();
    a.setMainWidget( &lieferDlg );
    return a.exec();
}
