#include <qwidget.h>
#include <qapplication.h>
#include <qvbox.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qfont.h>
#include <qfontdialog.h>
//................................................................ MeinFont
class MeinFont : public QVBox {
    Q_OBJECT
public:
    MeinFont::MeinFont() : QVBox( 0, 0) {
          //.................. Vertikaler Layoutmanger
        QVBox *v = new QVBox( this );
        v->setSpacing( 20 );
        v->setMargin( 20 );
        v->setPaletteBackgroundColor( Qt::blue.light( 180 ) );
          //.... Label zur Anzeige des aktuellen Fonts
        fontAnzeige = new QLabel( "Text", v );
        fontAnzeige->setPaletteBackgroundColor( Qt::white );
        fontAnzeige->setAlignment( AlignCenter );
        aktFont = fontAnzeige->font();
          //.... Label zur Anzeige der aktuellen Fontdaten
        fontDaten = new QLabel( "", v );
        fontDaten->setText( fontToString() );
        fontDaten->setAlignment( AlignCenter );
          //.... Button zum Einblenden QFontDialog-Fensters
        fontButton = new QPushButton( "Neuer Font", v );
        fontButton->setPalette( QPalette( Qt::red, Qt::red ) );
        connect( fontButton, SIGNAL( clicked() ), SLOT( neuerFont() ) );
        setGeometry( 0, 0, 400, 400 );
    }
private slots:
    void  neuerFont() {
       QFont  neuFont;
       bool   ok;
       neuFont = QFontDialog::getFont( &ok, aktFont );
       if ( ok ) {
          fontAnzeige->setFont( aktFont = neuFont );
          fontAnzeige->repaint();
          fontDaten->setText( fontToString() );
          fontDaten->repaint();
       }
    }
private:
    QFont       aktFont;
    QLabel      *fontAnzeige;
    QLabel      *fontDaten;
    QPushButton *fontButton;
      //... liefert die Font-Daten als String zurueck.
      //... Dazu ruft diese Funktion die von der Klasse QFont angebotenen
      //... Methoden family(), weight(), italic() pointSize(),
      //... underline() und strikeOut() auf.
    QString fontToString() {
        QString s, weight;
        switch ( aktFont.weight() ) {
           case QFont::Light:    weight = "Light";    break;
           case QFont::Normal:   weight = "Normal";   break;
           case QFont::DemiBold: weight = "DemiBold"; break;
           case QFont::Bold:     weight = "Bold";     break;
           case QFont::Black:    weight = "Black";    break;
        }
        s.sprintf("%s-%s-%s-%d\n\n%sUnderline-%sStrikeout\n",
                       (const char *)aktFont.family(),
                       (const char *)weight,
                       (const char *)aktFont.italic() ? "Italic" : "",
                       aktFont.pointSize(),
                       (const char *)aktFont.underline() ? "" : "No",
                       (const char *)aktFont.strikeOut() ? "" : "No" );
        return s;
    }
};
#include "fontdialog.moc"
//.................................................................... main
int main( int argc, char *argv[] ) {
  QApplication a( argc, argv );
  MeinFont *w = new MeinFont;
  w->setGeometry( 20, 20, 400, 400 );
  w->show();
  a.setMainWidget( w );
  return a.exec();
}
