#include <qwidget.h>
#include <qapplication.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qcolordialog.h>
#include <qfiledialog.h>
#include <qfontdialog.h>

//................................................................. MyLabel
class MyLabel  : public QWidget {
    Q_OBJECT
public:
    MyLabel () : QWidget( 0, 0) {
        palette = new QPalette;
        palette->setColor( QColorGroup::Foreground, aktFarbe = Qt::blue );
        palette->setColor( QColorGroup::Background, Qt::white );

        text = ".";
        font = QFont( "Helvetica", 12 );
        farbeButton = new QPushButton( "Neue Farbe", this );
        connect( farbeButton, SIGNAL( clicked() ), SLOT( neueFarbe() ) );
        farbeButton->setGeometry( 0, 0, 100, 30 );

        dateiButton = new QPushButton( "Neuer Dateiname", this );
        connect( dateiButton, SIGNAL( clicked() ), SLOT( neueDatei() ) );
        dateiButton->setGeometry( 100, 0, 150, 30 );

        fontButton = new QPushButton( "Neuer Font", this );
        connect( fontButton, SIGNAL( clicked() ), SLOT( neuerFont() ) );
        fontButton->setGeometry( 250, 0, 100, 30 );

        label = new QLabel( this );
        label->setPalette( *palette );
        label->setAlignment( Qt::AlignVCenter );
        label->setFont( font );
        label->setGeometry( 0, 30, 600, 370 );
        showText();
    }

private slots:
    void  neueFarbe() {
       QColor neuFarbe = QColorDialog::getColor( aktFarbe, 0 );
       if ( neuFarbe.isValid() ) {
          aktFarbe = neuFarbe;
          showText();
       }
    }

    void  neueDatei() {
       QStringList list( QFileDialog::getOpenFileNames( "*", 0, this) );
       if ( !list.isEmpty() ) {
          text = "\n";
          for ( QStringList::Iterator it = list.begin();
                it != list.end();
                ++it ) {
             text += *it;
             text += "\n";
          }
          showText();
       }
    }

    void  neuerFont() {
       bool ok = true;
       font = QFontDialog::getFont( &ok, font, this );
       if ( ok ) {
          label->setFont( font );
          showText();
       }
    }

private:
    void showText() {
       palette->setColor( QColorGroup::Foreground, aktFarbe );
       label->setPalette( *palette );
       label->setText( text );
       label->show();
    }

    QPushButton *farbeButton, *dateiButton, *fontButton;
    QColor       aktFarbe;
    QString      text;
    QFont        font;
    QPalette    *palette;
    QLabel      *label;
};

#include "fontdialog2.moc"

//.................................................................... main
int main( int argc, char *argv[] )
{
  QApplication a( argc, argv );

  MyLabel  *w = new MyLabel ;
  w->show();
  w->resize( 600, 400 );
 
  a.setMainWidget( w );
  return a.exec();
}
