#include <qapplication.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qframe.h>
#include <qlabel.h>
#include <stdlib.h>
#include <time.h>

const int  lId   = 0x4000;
const int  mlId  = 0x8000;

QString shapeName[] = {
       "NoFrame", "Box", "Panel", "WinPan", "HLine", "VLine", "StyledPan",
       "Popup", "MenuBar", "ToolBar", "LineEdit", "TabWid", "GroupBox" };
int shape[] = { QFrame::NoFrame,      QFrame::Box,           QFrame::Panel,
                QFrame::WinPanel,     QFrame::HLine,         QFrame::VLine,
                QFrame::StyledPanel,  QFrame::PopupPanel,    QFrame::MenuBarPanel,
                QFrame::ToolBarPanel, QFrame::LineEditPanel, QFrame::TabWidgetPanel,
                QFrame::GroupBoxPanel     };
int shapeNr = sizeof(shape) / sizeof(*shape);

const char *shadowName[] = { "Plain", "Raised", "Sunken" };
int shadow[] = { QFrame::Plain, QFrame::Raised, QFrame::Sunken };
int shadowNr = sizeof(shadow) / sizeof(*shadow);

//......................................................... Klasse MyWidget
class MyWidget : public QWidget {
   Q_OBJECT
public:
                               //______________ MyWidget (Konstruktor)
   MyWidget() {
      int  i, j;
         //............... Frames initialisieren
      for ( i=0; i<shapeNr; i++ ) {
         QLabel *l = new QLabel( shapeName[i], this ); 
         l->setFont( QFont( "Helvetica", 12 ) );
         l->setAlignment( Qt::AlignLeft | Qt::AlignVCenter );
         l->setGeometry( (i+1)*60+i*10, 20, 70, 50 );
      }
      for ( j=0; j<shadowNr; j++ ) {
         QLabel *l = new QLabel( shadowName[j], this ); 
         l->setFont( QFont( "Helvetica", 12 ) );
         l->setAlignment( Qt::AlignLeft | Qt::AlignVCenter );
         l->setGeometry( 10, 70+j*103, 90, 100 );
      }
      for ( j=0; j<shadowNr; j++ ) {
         QColor f( ::rand()&255, ::rand()&255, ::rand()&255 );
         for ( i=0; i<shapeNr; i++ ) {
            anzeige[i*3+j] = new QFrame( this );
            anzeige[i*3+j]->setGeometry( (i+1)*60+i*10, 70+j*103, 60, 100 );
            anzeige[i*3+j]->setFrameStyle( shape[i] | shadow[j] );
            anzeige[i*3+j]->setLineWidth( 1 );
            anzeige[i*3+j]->setMidLineWidth( 1 );
            anzeige[i*3+j]->setPaletteBackgroundColor( f );
         }
      }
         //............... lineWidth / midLineWidth-Menus
      lWidth = midlWidth = 1;
      lineWidthMenu = new QPopupMenu;
      midlineWidthMenu = new QPopupMenu;
      for ( i=0; i<= 20; i++ ) {
         QString s;
         s.sprintf("%d Pixel", i);
         lineWidthMenu->insertItem( s, i + 1000 );
         midlineWidthMenu->insertItem( s, i + 2000 );
      }
      lineWidthMenu->setItemChecked( lWidth + 1000, true );
      midlineWidthMenu->setItemChecked( midlWidth + 2000, true );
      QObject::connect( lineWidthMenu, SIGNAL( activated( int ) ),
                        this, SLOT( zeigeLineWidthSlot( int ) ) );
      QObject::connect( midlineWidthMenu, SIGNAL( activated( int ) ),
                        this, SLOT( zeigemidLineWidthSlot( int ) ) );

         //............... Menu-Balken
      menuBalken = new QMenuBar( this );
      menuBalken->setPaletteBackgroundColor( Qt::yellow );
      menuBalken->insertItem( "Line Width",    lineWidthMenu );
      menuBalken->insertItem( "Midline Width", midlineWidthMenu );
   }

private slots:
                               //_______________________________ Slots
   void zeigeLineWidthSlot( int l ) {
      int i, j;
      for ( j=0; j<shadowNr; j++ )
         for ( i=0; i<shapeNr; i++ ) {
            anzeige[i*3+j]->setLineWidth( l-1000 );
            anzeige[i*3+j]->update();
         }
      for ( i=0; i <= 20; i++)
         lineWidthMenu->setItemChecked( i+1000, false );
      lineWidthMenu->setItemChecked( l, true );
   }

   void zeigemidLineWidthSlot( int ml ) {
      int i, j;
      for ( j=0; j<shadowNr; j++ )
         for ( i=0; i<shapeNr; i++ ) {
            anzeige[i*3+j]->setMidLineWidth( ml-2000 );
            anzeige[i*3+j]->update();
         }
      for ( i=0; i <= 20; i++)
         midlineWidthMenu->setItemChecked( i+2000, false );
      midlineWidthMenu->setItemChecked( ml, true );
   }

private:
   QMenuBar   *menuBalken;
   QPopupMenu *lineWidthMenu, *midlineWidthMenu;
   QFrame     *anzeige[ 100 ];
   int         lWidth, midlWidth;
};

#include "frame2.moc"

//.................................................................... main
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   ::srand( time( NULL ) );
   MyWidget*mywidget = new MyWidget();
   mywidget->setGeometry( 10, 10, 1000, 420 );
 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
