#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <math.h>
#include <stdio.h>
#include "parser.h"

//..................................................... Konstruktor Parser
Parser::Parser( QString func, QWidget *p, const char *name )
                                                   : QWidget( p, name ) {
   this->func = new char [func.length()];
   this->func = func;
   errorMessage = "";
}

//........................................................ parseExpression
double Parser::parseExpression( double xValue, bool *error ) {
    tokenType  token;
    double     result;

    this->xValue = xValue;
    pos = 0;
    do {
        token=scanner();
        *error = this->error = false;
        result = expression( &token );
        if ( this->error || token != DONE ) {
            *error = true;
            if ( errorMessage.isEmpty() )
               errorMessage = "something missing";
            break;
        }
    } while ( token != DONE );
    return result;
}

//................................................................ scanner
tokenType Parser::scanner() {
   QChar   zeich;
   QString str;

   while (1) {
      zeich = func.at(pos);
      if ( pos >= func.length() )
         return DONE;
      else if (zeich==' ' || zeich=='\t') // Leer-/Tabzeichen ueberlesen
         ++pos;
      else if ( zeich.lower() == 'x' ) { ++pos; return X;
      } else if ( zeich == '+' ) { pos++; return PLUS;
      } else if ( zeich == '-' ) { pos++; return MINUS;
      } else if ( zeich == '*' ) { pos++; return MULT;
      } else if ( zeich == '/' ) { pos++; return DIV;
      } else if ( zeich == '^' ) { pos++; return POW;
      } else if ( zeich == '(' ) { pos++; return OPEN;
      } else if ( zeich == ')' ) { pos++; return CLOSE;
      } else if ( zeich.isDigit() ) {
         tokenValue = func.mid( pos ).toDouble();
         str = QString::number( tokenValue );
         pos += str.length();
         return ZAHL;
      } else if ( func.lower().mid( pos, 2 ) == "pi" ) {
         pos += 2; tokenValue = 4*atan(1); return ZAHL;
      } else if ( func.lower().mid( pos, 4 ) == "acos" ) {
         pos += 4; funcTyp = ACOS; return FUNCTION;
      } else if ( func.lower().mid( pos, 4 ) == "asin" ) {
         pos += 4; funcTyp = ASIN; return FUNCTION;
      } else if ( func.lower().mid( pos, 4) == "atan" ) {
         pos += 4; funcTyp = ATAN; return FUNCTION;
      } else if ( func.lower().mid( pos, 4 ) == "ceil" ) {
         pos += 4; funcTyp = CEIL; return FUNCTION;
      } else if ( func.lower().mid( pos, 4 ) == "cosh" ) {
         pos += 4; funcTyp = COSH; return FUNCTION;
      } else if ( func.lower().mid( pos, 3 ) == "cos" ) {
         pos += 3; funcTyp = COS; return FUNCTION;
      } else if ( func.lower().mid( pos, 3 ) == "exp" ) {
         pos += 3; funcTyp = EXP; return FUNCTION;
      } else if ( func.lower().mid( pos, 4 ) == "fabs" ) {
         pos += 4; funcTyp = FABS; return FUNCTION;
      } else if ( func.lower().mid( pos, 5 ) == "floor" ) {
         pos += 5; funcTyp = FLOOR; return FUNCTION;
      } else if ( func.lower().mid( pos, 3 ) == "log" ) {
         pos += 3; funcTyp = LOG; return FUNCTION;
      } else if ( func.lower().mid( pos, 5 ) == "log10" ) {
         pos += 5; funcTyp = LOG10; return FUNCTION;
      } else if ( func.lower().mid( pos, 4 ) == "sinh" ) {
         pos += 4; funcTyp = SINH; return FUNCTION;
      } else if ( func.lower().mid( pos, 3 ) == "sin" ) {
         pos += 3; funcTyp = SIN; return FUNCTION;
      } else if ( func.lower().mid( pos, 4 ) == "sqrt" ) {
         pos += 4; funcTyp = SQRT; return FUNCTION;
      } else if ( func.lower().mid( pos, 4 ) == "tanh" ) {
         pos += 4; funcTyp = TANH; return FUNCTION;
      } else if ( func.lower().mid( pos, 3 ) == "tan" ) {
         pos += 3; funcTyp = TAN; return FUNCTION;
      } else {
         pos++; return NONE;
      }
   }
}

//................................................................. factor
double Parser::factor( tokenType *token ) {
   double result = 0;

   switch ( *token ) {
      case ZAHL:  result = tokenValue; *token = scanner(); return result;
      case X:     result = xValue;     *token = scanner(); return result;
      case MINUS: *token = scanner();  return -expression( token );
      case FUNCTION:
         *token = scanner();
         if ( *token != OPEN ) {
            errorMessage = "missing `(";
            error = true;
         }
         *token = scanner();
         switch ( funcTyp ) {
            case ACOS:  result = acos( expression( token ) );  break;
            case ASIN:  result = asin( expression( token ) );  break;
            case ATAN:  result = atan( expression( token ) );  break;
            case CEIL:  result = ceil( expression( token ) );  break;
            case COS:   result = cos( expression( token ) );   break;
            case COSH:  result = cosh( expression( token ) );  break;
            case EXP:   result = exp( expression( token ) );   break;
            case FABS:  result = fabs( expression( token ) );  break;
            case FLOOR: result = floor( expression( token ) ); break;
            case LOG:   result = log( expression( token ) );   break;
            case LOG10: result = log10( expression( token ) ); break;
            case SIN:   result = sin( expression( token ) );   break;
            case SINH:  result = sinh( expression( token ) );  break;
            case SQRT:  result = sqrt( expression( token ) );  break;
            case TAN:   result = tan( expression( token ) );   break;
            case TANH:  result = tanh( expression( token ) );  break;
         }
         if ( *token != CLOSE ) {
            errorMessage = "missing `)";
            error = true;
         }
         *token = scanner();
         return result;
      case OPEN:
         *token = scanner();
         result = expression( token );
         if ( *token != CLOSE ) {
            errorMessage = "missing `)";
            error = true;
         }
         *token = scanner();
         return result;
      default:
         errorMessage = "unallowed character";
         error = true;
         return 0;
   }
}

//.................................................................. power
double Parser::power( tokenType *token ) {
     double result = factor( token );
   while (1)
      switch ( *token ) {
         case POW: *token = scanner();
                   result = pow( result, factor( token ) ); break;
         default : return result;
      }
}

//................................................................... term
double Parser::term( tokenType *token ) {
     double result = power( token );
   while (1)
      switch ( *token ) {
         case MULT: *token = scanner(); result *= power( token ); break;
         case DIV : *token = scanner(); result /= power( token ); break;
         default  : return result;
      }
}

//............................................................. expression
double Parser::expression( tokenType *token ) {
     double result = term( token );
   while (1)
      switch( *token ) {
         case PLUS : *token=scanner(); result += term( token ); break;
         case MINUS: *token=scanner(); result -= term( token ); break;
         default   : return result;
      }
}
