#ifndef  PARSER_H
#define  PARSER_H

#include  <qapplication.h>
#include  <qwidget.h>

typedef enum {
       ZAHL=10000,  PLUS, MINUS, MULT, DIV,  POW,  OPEN, CLOSE,
       FUNCTION, X, NONE, DONE                                 }  tokenType;

typedef enum {
       ACOS=20000, ASIN,  ATAN, CEIL,  COS,  COSH, EXP,  FABS,
       FLOOR,      LOG,  LOG10, SIN,  SINH,  SQRT, TAN,  TANH  } funcType;

//.......................................................... Klasse Parser
class Parser : public QWidget {

public:
    Parser( QString func, QWidget *p=0, const char *name=0 );
    double   parseExpression( double xValue, bool *error );
    unsigned getPos()          { return pos;          }
    QString  getErrorMessage() { return errorMessage; }

private:
    double tokenValue; // Variable, welcher im Falle
                       // einer Zahl der Zahlenwert zugewiesen wird.
    funcType funcTyp;

    bool     error; // Variable, die anzeigt, ob ein
                    // ein Fehler in einem Ausdruck aufgetreten ist
    unsigned pos;
    double   xValue;
    QString  func;
    QString  errorMessage;

    tokenType scanner(); // Lexikalische Analyse

    double    factor( tokenType *token ); // Parser-Routinen
    double    power( tokenType *token );
    double    term( tokenType *token );
    double    expression( tokenType *token );
};

#endif
