#include <qapplication.h>
#include <qlayout.h>
#include <qwidget.h>
#include <qlabel.h>
#include <math.h>
#include "functionplot.h"

//..................................................... Klasse MyFunction
class MyFunction: public FunctionPlot
{
public:
    MyFunction( int z, QWidget *p ) : FunctionPlot( z, p ) {
       setPalette( QPalette( Qt:: lightGray ) );
       setFocusPolicy( QWidget::StrongFocus );
    }
 
protected:
    virtual void focusInEvent( QFocusEvent *e ) {
       if ( e->gotFocus() )
          setPalette( QColor( Qt::gray.light(110) ) );
    }
 
    virtual void focusOutEvent( QFocusEvent *e ) {
       if ( e->lostFocus() )
          setPalette( QColor( Qt::gray.light(120) ) );
    }
};
                                                                        
//.................................................................. main
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   valuePair v;
   int       i, z=0;

   QWidget* myWidget = new QWidget;
   myWidget->setPalette( QPalette ( Qt::white ) );
   QGridLayout *grid = new QGridLayout( myWidget, 2, 2, 10 );

   for ( double x=-1; x<=20; x+=0.05 )  // Zaehlen der Werte
      z++;

   MyFunction* plotWindow1 = new MyFunction( z, myWidget );
   plotWindow1->setFocus();

   QLabel* label1 = new QLabel( "Fkt.: 1-exp(-0.5x) ", myWidget );
   grid->addWidget( label1, 0, 0 );   
   label1->setMaximumHeight( 30 );
   i = 0;
   for ( v.x=-1; v.x<=20; v.x+=0.05 ) {
      v.y = 1-exp(-0.5*v.x);
      plotWindow1->setValue( i, v );
      ++i;
   }
   plotWindow1->plotIt();
   plotWindow1->setMinimumSize( 200, 200 );
   grid->addWidget( plotWindow1, 1, 0 );   

   MyFunction* plotWindow2 = new MyFunction( z, myWidget );

   QLabel* label2 = new QLabel(
            "Ableitung zur Fkt. links: 0.5*exp(-0.5x) ", myWidget );
   label2->setMaximumHeight( 30 );
   grid->addWidget( label2, 0, 1 );   

   i = 0;
   for ( v.x=-1; v.x<=20; v.x+=0.05 ) {
      v.y = 0.5*exp(-0.5*v.x);
      plotWindow2->setValue( i, v );
      ++i;
   }
   plotWindow2->plotIt();
   plotWindow2->setMinimumSize( 200, 200 );
   grid->addWidget( plotWindow2, 1, 1 );   

   myapp.setMainWidget( myWidget );
   myWidget->resize( myWidget->sizeHint() );
   myWidget->show();
   return myapp.exec();
}




