//------------------------------------------------------------------------------
// Deklaration der Klasse GeomFigur
//------------------------------------------------------------------------------
class GeomFigur
{
protected:   // private: wuerde keinen Zugriff der abgeleiteten 
             //          Klassen auf die folg. Daten zulassen

   int   xm;            // Mittelpunkt: x-Koordinate 
   int   ym;            //              y-Koordinate
   bool  sichtbar;      // sichtbar oder nicht ?

public:
   GeomFigur(int Xm, int Ym);        // Konstruktor
   void show(char *name);            // Anzeigen der Figur
   void hide(char *name);            // Ausblenden der Figur
   void move(char *name, int neuXm, int neuYm);  // Verschieben der Figur
};

//------------------------------------------------------------------------------
// Deklaration der Klasse Punkt (abgeleitet von GeomFigur)
//------------------------------------------------------------------------------
class Punkt : public GeomFigur
{
   // Folgende Attribute werden von GeomFigur geerbt:
   //   int   xm;            // Mittelpunkt: x-Koordinate 
   //   int   ym;            //              y-Koordinate
   //   bool  sichtbar;      // sichtbar oder nicht ?

public:
   // Folgende Methoden werden von GeomFigur geerbt:
   //     GeomFigur(int Xm, int Ym);        // Konstruktor
   //     void show(char *name);            // Anzeigen des Punktes
   //     void hide(char *name);            // Ausblenden des Punktes
   //     void move(char *name, int neuXm, int neuYm); // Verschieben

     // Zusaetzliche neue Methode Punkt()
   Punkt(int Xm, int Ym);   // Konstruktor
};

//------------------------------------------------------------------------------
// Deklaration der Klasse Rechteck (abgeleitet von GeomFigur)
//------------------------------------------------------------------------------
class Rechteck : public GeomFigur
{
   // Folgende Attribute werden von GeomFigur geerbt:
   //   int   xm;            // Mittelpunkt: x-Koordinate 
   //   int   ym;            //              y-Koordinate
   //   bool  sichtbar;      // sichtbar oder nicht ?

private:
      // Zusaetzliche neue Attribute:
   int xe;   // x-Koordinate Ecke relativ zum Mittelpunkt
   int ye;   // y-Koordinate Ecke relativ zum Mittelpunkt

public:
   // Folgende Methoden werden von GeomFigur geerbt:
   //     GeomFigur(int Xm, int Ym);        // Konstruktor
   //     void show(char *name);            // Anzeigen des Rechtecks
   //     void hide(char *name);            // Ausblenden des Rechtecks
   //     void move(char *name, int neuXm, int neuYm); // Verschieben

      // Die Methoden show() und hide() werden neu implementiert.
   void show();   // neu zu implementierende Funktion
   void hide();   // neu zu implementierende Funktion

      // Zusaetzliche neue Methoden Rechteck(), setRectangleNew() und resize()
   Rechteck(int Xm, int Ym, int Xs, int Ys);             // Konstruktor
   void setRectangleNew(int Xm, int Ym, int Xe, int Ye); // neues Rechteck
   void resize(double factor);    // Vergroessern/Verkleinern des Rechtecks
};

//------------------------------------------------------------------------------
// Deklaration der Klasse Kreis (abgeleitet von GeomFigur)
//------------------------------------------------------------------------------
class Kreis : public GeomFigur
{
   // Folgende Attribute werden von GeomFigur geerbt:
   //   int   xm;            // Mittelpunkt: x-Koordinate 
   //   int   ym;            //              y-Koordinate
   //   bool  sichtbar;      // sichtbar oder nicht ?

private:
      // Zusaetzliches neues Attribut:
   int radius;   // Radius des Kreises

public:
   // Folgende Methoden werden von GeomFigur geerbt:
   //     GeomFigur();                     // Konstruktor
   //     void show();                     // Anzeigen des Kreises
   //     void hide();                     // Ausblenden des Kreises
   //     void move(int neuXm, int neuYm); // Verschieben des Kreises

      // Die Methoden show() und hide() werden neu implementiert.
   void show();  // neu zu implementierende Funktion
   void hide();  // neu zu implementierende Funktion

      // Zusaetzliche neue Methoden Kreis(), setCircleNew() und resize()
   Kreis(int Xm, int Ym, int Radius);             // Konstruktor
   void setCircleNew(int Xm, int Ym, int Radius); // neuer Kreis
   void resize(double factor);    // Vergroessern/Verkleinern des Kreises
};
