#include  <stdio.h>
#include  "graphik2.h"

//------------------------------------------------------------------------------
// Implementierung der Klasse GeomFigur
//------------------------------------------------------------------------------
GeomFigur::GeomFigur(int Xm, int Ym)
{
   printf("..... Konstruktor GeomFigur\n");
   xm = Xm;
   ym = Ym;
   sichtbar = true;
}

void GeomFigur::show(char *name)
{
   sichtbar = true;
   printf("show (%s): M=(%d;%d), %ssichtbar\n",
          name, xm, ym, sichtbar ? "" : "un");
}

void GeomFigur::hide(char *name)
{
   sichtbar = false;
   printf("hide (%s): M=(%d;%d), %ssichtbar\n",
          name, xm, ym, sichtbar ? "" : "un");
}

void GeomFigur::move(char *name, int neuXm, int neuYm)
{
   bool visible = sichtbar;

   printf(".... Start move (%s): M_old=(%d;%d)\n", name, xm, ym);
   if (visible) hide(name);
   xm = neuXm;
   ym = neuYm;
   if (visible) show(name);
   printf(".... Ende move (%s): M_new=(%d;%d)\n", name, xm, ym);
}

//------------------------------------------------------------------------------
// Implementierung der Klasse Punkt
//------------------------------------------------------------------------------
Punkt::Punkt(int Xm, int Ym) : GeomFigur(Xm, Ym)
{
   printf("......... Konstruktor Punkt\n");
}

//------------------------------------------------------------------------------
// Implementierung der Klasse Linie
//------------------------------------------------------------------------------
void Linie::show()
{
   sichtbar = true;
   printf("show (Linie): M=(%d;%d), P1=(%d;%d), P2=(%d;%d), %ssichtbar\n",
           xm, ym, xm-xs, ym-ys, xm+xs, ym+ys, sichtbar ? "" : "un");
}

void Linie::hide()
{
   sichtbar = false;
   printf("hide (Linie): M=(%d;%d), P1=(%d;%d), P2=(%d;%d), %ssichtbar\n",
           xm, ym, xm-xs, ym-ys, xm+xs, ym+ys, sichtbar ? "" : "un");
}

Linie::Linie(int Xm, int Ym, int Xs, int Ys) : GeomFigur(Xm, Ym)
{
   printf("......... Konstruktor Linie\n");
   xs = Xs;
   ys = Ys;
   sichtbar = true;
}

void Linie::setLineNew(int Xm, int Ym, int Xs, int Ys)
{
   xm = Xm;
   ym = Ym;
   xs = Xs;
   ys = Ys;
   sichtbar = true;
   printf("setLineNew: M=(%d;%d), P1=(%d;%d), P2=(%d;%d), %ssichtbar\n",
           xm, ym, xm-xs, ym-ys, xm+xs, ym+ys, sichtbar ? "" : "un");
}

void Linie::resize(double factor)
{
   xs = (int)(xs * factor);
   ys = (int)(ys * factor);
   printf("resize: M=(%d;%d), P1=(%d;%d), P2=(%d;%d), %ssichtbar\n",
           xm, ym, xm-xs, ym-ys, xm+xs, ym+ys, sichtbar ? "" : "un");
}

//------------------------------------------------------------------------------
// Implementierung der Klasse Rechteck
//------------------------------------------------------------------------------
void Rechteck::show()
{
   sichtbar = true;
   printf("show (Rechteck): M=(%d;%d), P1=(%d;%d), P2=(%d;%d), %ssichtbar\n",
           xm, ym, xm-xe, ym-ye, xm+xe, ym+ye, sichtbar ? "" : "un");
}

void Rechteck::hide()
{
   sichtbar = false;
   printf("hide (Rechteck): M=(%d;%d), P1=(%d;%d), P2=(%d;%d), %ssichtbar\n",
           xm, ym, xm-xe, ym-ye, xm+xe, ym+ye, sichtbar ? "" : "un");
}

Rechteck::Rechteck(int Xm, int Ym, int Xe, int Ye) : GeomFigur(Xm, Ym)
{
   printf("......... Konstruktor Rechteck\n");
   xe = Xe;
   ye = Ye;
   sichtbar = true;
}

void Rechteck::setRectangleNew(int Xm, int Ym, int Xe, int Ye)
{
   xm = Xm;
   ym = Ym;
   xe = Xe;
   ye = Ye;
   sichtbar = true;
   printf("setRectangleNew: M=(%d;%d), P1=(%d;%d), P2=(%d;%d), %ssichtbar\n",
           xm, ym, xm-xe, ym-ye, xm+xe, ym+ye, sichtbar ? "" : "un");
}

void Rechteck::resize(double factor)
{
   xe = (int)(xe * factor);
   ye = (int)(ye * factor);
   printf("resize: M=(%d;%d), P1=(%d;%d), P2=(%d;%d), %ssichtbar\n",
           xm, ym, xm-xe, ym-ye, xm+xe, ym+ye, sichtbar ? "" : "un");
}

//------------------------------------------------------------------------------
// Implementierung der Klasse Kreis
//------------------------------------------------------------------------------
void Kreis::show()
{
   sichtbar = true;
   printf("show (Kreis): M=(%d;%d), radius=%d, %ssichtbar\n",
          xm, ym, radius, sichtbar ? "" : "un");
}

void Kreis::hide()
{
   sichtbar = false;
   printf("hide (Kreis): M=(%d;%d), radius=%d, %ssichtbar\n",
          xm, ym, radius, sichtbar ? "" : "un");
}

Kreis::Kreis(int Xm, int Ym, int Radius) : GeomFigur(Xm, Ym)
{
   printf("......... Konstruktor Kreis\n");
   radius = Radius;
   sichtbar = true;
}

void Kreis::setCircleNew(int Xm, int Ym, int Radius)
{
   xm = Xm;
   ym = Ym;
   radius = Radius;
   printf("setCircleNew: M=(%d;%d), radius=%d, %ssichtbar\n",
           xm, ym, radius, sichtbar ? "" : "un");
}

void Kreis::resize(double factor)
{
   radius = (int)(radius * factor);
   printf("resize: M=(%d;%d), radius=%d, %ssichtbar\n",
           xm, ym, radius, sichtbar ? "" : "un");
}
