#include <qapplication.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <stdlib.h>
#include <time.h>

enum { oId = 0x1000, sId  = 0x2000 };
enum { NoOrient=oId, Horiz, Verti };
//......................................................... Klasse MyWidget
class MyWidget : public QWidget {
   Q_OBJECT
public:
   MyWidget() : groupbox(0), e(0), title(""), orient(Verti), strips(3) {
      srand( time(NULL) );
      oMenu = new QPopupMenu;
      oMenu->insertItem( "keine Angabe", NoOrient );
      oMenu->insertItem( "Horizontal",   Horiz );
      oMenu->insertItem( "Vertikal",     Verti );
      oMenu->setItemChecked( orient, true );
      QObject::connect( oMenu, SIGNAL( activated( int ) ),
                        this,  SLOT( orientationSlot( int ) ) );
      stripsMenu = new QPopupMenu;
      for (int i=0; i<= 10; i++) {
         QString s;
         s.sprintf("%d Strips", i);
         stripsMenu->insertItem( s, i | sId );
      }
      stripsMenu->setItemChecked( strips | sId, true );
      QObject::connect( stripsMenu, SIGNAL( activated( int ) ),
                        this,       SLOT( stripsSlot( int ) ) );
      menuBalken = new QMenuBar( this );
      menuBalken->insertItem( "Orientation", oMenu );
      menuBalken->insertItem( "Strips",  stripsMenu );
      zeigeGruppenBox();
   }
private slots:
   void orientationSlot( int s ) {
      orient = s;
      oMenu->setItemChecked( NoOrient, s == NoOrient );
      oMenu->setItemChecked( Horiz,    s == Horiz );
      oMenu->setItemChecked( Verti,    s == Verti );
      zeigeGruppenBox();
   }
   void stripsSlot( int s ) {
      strips = s & ~sId ;
      for (int i=0; i <= 10; i++)
         stripsMenu->setItemChecked( i | sId, strips == i );
      zeigeGruppenBox();
   }
   void holeTitleSlot( ) { title = e->text(); zeigeGruppenBox(); }
private:
   void zeigeGruppenBox( void ) {
       int          i;
       QLabel      *l;
       QPushButton *b;
       QString      s;
       if (groupbox != 0)
          delete groupbox;
                          //..... Unterschiedliche Konstruktorvarianten
       if ( title!="" && strips==0 && orient==NoOrient )
          groupbox = new QGroupBox( title,  this );
       else if ( title=="" && strips>0 && orient!=NoOrient )
          groupbox = new QGroupBox( strips, orient==Horiz ? Horizontal : Vertical,
                                    this );
       else if ( title!="" && strips>0 && orient!=NoOrient )
          groupbox = new QGroupBox( strips, orient==Horiz ? Horizontal : Vertical,
                                    title,  this );
       else
          groupbox = new QGroupBox( this );
       groupbox->setGeometry( 50, 50, 200, 200 );
               
       QColor farbe( rand()%255, rand()%255, rand()%255 );
       for (i=0; i<10; i++) {
          s.sprintf("l%d", i+1);
          l = new QLabel( s, groupbox );
          l->setAlignment( AlignCenter );
          l->setPaletteBackgroundColor( farbe );
          l->resize( l->sizeHint() );
       }
       farbe.setRgb( rand()%255, rand()%255, rand()%255 );
       for (i=0; i<10; i++) {
          s.sprintf("b%d", i+1);
          b = new QPushButton( s, groupbox );
          b->setPaletteBackgroundColor( farbe );
       }
       e = new QLineEdit( title, groupbox );
       e->setCursorPosition( 0 );
       QObject::connect( e,    SIGNAL( returnPressed() ),
                         this, SLOT( holeTitleSlot() ) );
       groupbox->show();
       groupbox->resize( groupbox->sizeHint() );
   }
   QGroupBox  *groupbox, *anzeige;
   QLineEdit  *e;
   QMenuBar   *menuBalken;
   QPopupMenu *oMenu, *stripsMenu;
   QString     title;
   int         orient, strips;
};
#include "groupbox.moc"
//.................................................................... main
int main( int argc, char* argv[] ) {
   QApplication myapp( argc, argv );
   MyWidget*mywidget = new MyWidget();
   mywidget->setGeometry( 10, 10, 1000, 700 );
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
