#include <qapplication.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qlabel.h>
#include <qgroupbox.h>
#include <qslider.h>
#include <stdlib.h>
#include <time.h>

//......................................................... Klasse MyWidget
class MyWidget : public QWidget {
   Q_OBJECT  // notwendig, da Slot enthalten sind

public:
   MyWidget() {
         //................................ Initialisierungen
      ::srand( time( NULL ) );
      schachbrett = 0;
      orientation = 0;
      strips      = 8;
      gesamt      = strips*strips;
         //................................. Orientation-Menu
      oMenu = new QPopupMenu;
      oMenu->insertItem( "Horizontal",   1000 );
      oMenu->insertItem( "Vertikal",     1001 );
      oMenu->setItemChecked( 1000+orientation, true );
      QObject::connect( oMenu, SIGNAL( activated( int ) ),
                        this,  SLOT( zeigeOrientationSlot( int ) ) );
         //...................................... Strips-Menu
      stripsMenu = new QPopupMenu;
      for (int i=1; i<=10; i++) {
         QString s;
         s.sprintf("%d Strips", i);
         stripsMenu->insertItem( s, 2000 + i );
      }
      stripsMenu->setItemChecked( strips + 2000, true );
      QObject::connect( stripsMenu, SIGNAL( activated( int ) ),
                        this,       SLOT( zeigeStripsSlot( int ) ) );
         //...................................... Menu-Balken
      menuBalken = new QMenuBar( this );
      menuBalken->insertItem( "Orientation", oMenu );
      menuBalken->insertItem( "Strips",  stripsMenu );

         //................... Schiebebalken fuer Gesamtfelder
      QSlider *s = new QSlider( 1, 200, 1, gesamt, Horizontal, menuBalken ); 
      s->setGeometry( 150, 5, 100, 20 );
      QString t;
      t.sprintf( "%d", gesamt );
      anzeige = new QLabel( t, menuBalken ); 
      anzeige->setPaletteBackgroundColor( Qt::white ); 
      anzeige->setGeometry( 260, 0, 30, 30 );

      QObject::connect( s,    SIGNAL( valueChanged( int ) ),
                        this, SLOT( neueGesamtZahl( int ) ) );

      zeigeSchachbrett();
   }

private slots:
                               //_______________________________ Slots
   void zeigeOrientationSlot( int s ) {
      orientation = s-1000;
      oMenu->setItemChecked( 1000, s == 1000 );
      oMenu->setItemChecked( 1001, s == 1001 );
      zeigeSchachbrett();
   }

   void zeigeStripsSlot( int s ) {
      strips = s-2000 ;
      for (int i=0; i <= 10; i++)
         stripsMenu->setItemChecked( 2000+i, strips == i );
      zeigeSchachbrett();
   }

   void neueGesamtZahl( int value ) {
      QString t;
      t.sprintf( "%d", gesamt = value );
      anzeige->setText( t );
      zeigeSchachbrett();
   }
private:
                               //____________________ private-Routinen
   void zeigeSchachbrett( void ) {
       if ( schachbrett != 0 )
          delete schachbrett;

       schachbrett = new QGroupBox( strips,
                          orientation==0 ? Horizontal : Vertical, this );
       schachbrett->setGeometry( 50, 50, 500, 500 );

       for ( int i=0; i<gesamt; i++ ) {
          QLabel *l = new QLabel( "  ", schachbrett );
          l->resize( 30, 30 );
          if ( i%2==0 )
             l->setPaletteBackgroundColor( Qt::white );
          else
             l->setPaletteBackgroundColor( Qt::black );
       }
       
       schachbrett->show();
       schachbrett->resize( schachbrett->sizeHint() );
   }
                               //___________________ private-Variablen
   QGroupBox  *schachbrett;
   QMenuBar   *menuBalken;
   QPopupMenu *oMenu, *stripsMenu;
   QLabel     *anzeige;
   int         gesamt, orientation, strips;
};

#include "groupbox2.moc"

//.................................................................... main
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   MyWidget*mywidget = new MyWidget();
   mywidget->setGeometry( 10, 10, 600, 600 );
 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
