#include <qapplication.h>
#include <qwidget.h>
#include <qmenubar.h>
#include <qlabel.h>
#include <qpopupmenu.h>
#include <qmessagebox.h>
#include <qpixmap.h>
#include <qmainwindow.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
//........................................ HauptFenster-Klasse .........
class HauptFenster : public QMainWindow {
    Q_OBJECT
public:
    HauptFenster();
signals:
    void    anzeige( const QString& );
private slots:
    void neu()            { emit anzeige( "Datei/Neu" );           }
    void oeffnen()        { emit anzeige( "Datei/Oeffnen" );       }
    void sichern()        { emit anzeige( "Datei/Speichern" );     }
    void drucken()        { emit anzeige( "Datei/Drucken" );       }
    void schliessen()     { emit anzeige( "Datei/Schliessen" );    }
    void normal()         { emit anzeige( "Schrift/Normal" );      }
    void fett()           { emit anzeige( "Schrift/Fett" );        }
    void kursiv()         { emit anzeige( "Schrift/Kursiv" );      }
private:
    QMenuBar     *menu;
    QToolBar     *dateiTools, *schriftTools;
    void erzeugeToolBars( void );
};
#include "hauptfenster.moc"
//................................... HauptFenster-Konstruktor .........
HauptFenster::HauptFenster() : QMainWindow( 0, "Beispiel zu QMainWindow" ) {
    erzeugeToolBars();
    QPopupMenu *datei = new QPopupMenu( this );  //... Anlegen der Mens ........
     datei->insertItem( QPixmap("new.xpm"),  "&Neu",      this, SLOT(neu()) );
     datei->insertItem( QPixmap("open.xpm"), "Oe&ffnen",  this, SLOT(oeffnen()));
     datei->insertItem( QPixmap("save.xpm"), "&Sichern",  this, SLOT(sichern()));
     datei->insertItem( "S&chliessen", this, SLOT(schliessen()) );
     datei->insertSeparator();
     datei->insertItem( QPixmap("print.xpm"), "&Drucken", this, SLOT(drucken()));
     datei->insertSeparator();
     datei->insertItem( "&Beenden", qApp, SLOT(quit()));
    menu = new QMenuBar( this );
     menu->insertItem( "&Datei", datei );
    QLabel *label = new QLabel( this );
     label->setAlignment( AlignCenter );
     label->setPaletteBackgroundColor( Qt::white );
    setCentralWidget( label );
    connect( this,  SIGNAL(anzeige(const QString&)),
             label, SLOT(setText(const QString&)) );
}
//............................................ erzeugeToolBars .........
void HauptFenster::erzeugeToolBars( void ) {
      //... Anlegen der dateiTools-Werkzeugleiste ........
    dateiTools = new QToolBar( this );
    new QToolButton( QPixmap("new.xpm"),  "Neue Datei", QString::null,
                     this, SLOT(neu()), dateiTools );
    new QToolButton( QPixmap("open.xpm"), "Oeffne Datei", QString::null,
                     this, SLOT(oeffnen()), dateiTools );
    new QToolButton( QPixmap("save.xpm"), "Sichere Datei", QString::null,
                     this, SLOT(sichern()), dateiTools );
    QToolButton *druckButton =
        new QToolButton( QPixmap("print.xpm"), "Drucke Datei", QString::null,
                         this, SLOT(drucken()), dateiTools );
    addDockWindow( dateiTools, "Datei-Operationen", Left, false );
    dateiTools->setOrientation( Vertical );
    dateiTools->setStretchableWidget( druckButton );
    druckButton->setToggleButton( true );
    druckButton->setOn( true );
      //... Anlegen der schriftTools-Werkzeugleiste ........
    schriftTools = new QToolBar( this );
    new QToolButton( QPixmap( "normal.xpm" ), "Normal", QString::null,
                     this, SLOT(normal()), schriftTools );
    QToolButton *fettSchrift =
              new QToolButton( QPixmap( "fett.xpm" ), "Fett", QString::null,
                               this, SLOT(fett()), schriftTools );
     fettSchrift->setUsesTextLabel( true );
    QToolButton *kursivSchrift =
              new QToolButton( QPixmap( "kursiv.xpm" ), "Kursiv", QString::null,
                               this, SLOT(kursiv()), schriftTools );
     kursivSchrift->setUsesTextLabel( true );
    addDockWindow( schriftTools, "Schriftarten" );
    fettSchrift->setToggleButton( true );
    fettSchrift->setOn( true );
    schriftTools->setStretchableWidget( fettSchrift );
}
//....................................................... main .........
int main( int argc, char ** argv ) {
    QApplication a( argc, argv );
    HauptFenster m;
    m.setGeometry( 10, 10, 400, 300 );
    a.setMainWidget( &m );
    m.show();
    return a.exec();
}
