#include  <qapplication.h>
#include  <qmessagebox.h>
#include  <qfile.h>
#include  <qdatastream.h>
#include  <qstring.h>
#include  <stdio.h>
#include  <stdlib.h>
#include  <ctype.h> 

static void hex_ausgabe( QFile *datei, QString dateiname );

//................................................................... main
int  main( int argc, char *argv[] )
{
   QString      msg;
   QApplication a( argc, argv );

   if (argc < 2) {
      msg.sprintf( "usage:  %s datei1 ...", argv[0] );
      QMessageBox::information( 0, "Falscher Aufruf", msg, QMessageBox::Ok );
      return 1;
   }
   for (int i=1; i<argc; i++) {
      QFile datei( argv[i] );
      if ( !datei.open( IO_ReadOnly ) ) {
         msg.sprintf( "Datei `%s' kann nicht goeffnet werden", argv[i] );
         QMessageBox::information( 0, "Fehler beim Oeffnen der Datei",
                                   msg, QMessageBox::Ok );
      } else {
         hex_ausgabe( &datei, argv[i] );
         datei.close();
      }
   }
   return 0;
}   

//............................................................. hex_ausgabe
static void hex_ausgabe( QFile *datei, QString dateiname )
{
    Q_UINT8   byte;
    QString   puffer = "";
    uint      i=0, gesamt=0;
    
    QDataStream streamEin( datei );

    printf("\n----%s----\n", (const char *)dateiname);
 
    while ( !streamEin.atEnd() ) { 
       if (  (i = i % 16) == 0) {
          if ( !puffer.isEmpty() ) {
             printf(" |%s|\n", (const char *)puffer);
             puffer = "";
          }
          printf("  %06x ", gesamt);
       }
       streamEin >> byte;
       printf(" %02x", byte);

       if ( iscntrl( byte ) ) // Steuerzeichen werden
          puffer += ".";      // durch '.' dargestellt
       else
          puffer += byte;
       if (i==7)   // Trennzeichen nach 8 Hexa-Bytemustern ausgeben
          printf(" ");
       i++;
       gesamt++;
    }
    for ( uint j=i; j<16; j++)
       printf("%s", (j==7) ? "    " : "   " );
    if ( !puffer.isEmpty() ) {
       puffer.at(i) = 0;
       printf(" |%-16s|\n", (const char *)puffer);
    }
}
