#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <stdlib.h>
#include <time.h>

#define MAXX  800
#define MAXY  600
#define MAXPICKS  100000
//........................................................ Klasse MalFenster
class MalFenster : public QWidget {
  protected:
   virtual void mousePressEvent( QMouseEvent *e ) {
       //... bei linken Mausbutton Malflaeche loeschen, sonst nicht
      repaint( e->button() == QMouseEvent::LeftButton );
   }
   virtual void paintEvent( QPaintEvent* ) {
      int x1 = rand() % MAXX,  y1 = rand() % MAXY,
          x2 = rand() % MAXX,  y2 = rand() % MAXY,
          x3 = rand() % MAXX,  y3 = rand() % MAXY,
          xs = rand() % MAXX,  ys = rand() % MAXY,
          n = rand() % MAXPICKS;
      QPainter wMaler; // erzeugt QPainter-Objekt zum Zeichnen im Window
      wMaler.begin( this );    // Start des Zeichnens im Window
      wMaler.setPen( QColor( rand()%256, rand()%256, rand()%256 ) );
      for ( int i=1 ; i<=n ; i++ ) {
         wMaler.drawPoint( xs, ys );
         switch (rand()%3+1) {
            case 1: xs += x1; ys += y1; break;
            case 2: xs += x2; ys += y2; break;
            case 3: xs += x3; ys += y3; break;
         }
         xs /= 2;
         ys /= 2;
      }
      wMaler.end();   // Beendigung des Zeichnens im Window
   }
};
//..................................................................... main
int main( int argc, char* argv[] ) {
   QApplication myapp( argc, argv );
   MalFenster* mywidget = new MalFenster();
   mywidget->setGeometry( 50, 50, MAXX, MAXY );
   srand( time( NULL ) ); 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
