#include <qwidget.h>
#include <qapplication.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qinputdialog.h>
//................................................................. MyLabel
class MyLabel  : public QWidget {
    Q_OBJECT
public:
    MyLabel() : QWidget(0,0), intZahl(25), doubleZahl(3.14), text("Text"),
                              passwordText(""), item1(""), item2("") {
        label = new QLabel( this );
         label->setPaletteBackgroundColor( Qt::white );
         label->setGeometry( 0, 0, 450, 400 );
         label->setIndent( 20 );
        list1 << "One" << "Two" << "Three" << "Four" << "Five";
         list2 << "Amsel" << "Drossel" << "Fink" << "Star" << "Spatz";
        intButton = new QPushButton( "Int-Zahl", this );
         intButton->setGeometry( 450, 0, 150, 30 );
         connect( intButton, SIGNAL( clicked() ), SLOT( neueIntZahl() ) );
        doubleButton = new QPushButton( "Double-Zahl", this );
         doubleButton->setGeometry( 450, 30, 150, 30 );
         connect( doubleButton, SIGNAL( clicked() ), SLOT( neueDoubleZahl() ) );
        textButton = new QPushButton( "Sichtbarer Text", this );
         textButton->setGeometry( 450, 60, 150, 30 );
         connect( textButton, SIGNAL( clicked() ), SLOT( neuerText() ) );
        passwordButton = new QPushButton( "Unsichtbarer Text", this );
         passwordButton->setGeometry( 450, 90, 150, 30 );
         connect( passwordButton, SIGNAL( clicked() ), SLOT( neuesPasswort() ) );
        item1Button = new QPushButton( "Editierbare Liste", this );
         item1Button->setGeometry( 450, 120, 150, 30 );
         connect( item1Button, SIGNAL( clicked() ), SLOT( neuItem1() ) );
        item2Button = new QPushButton( "Feste Liste", this );
         item2Button->setGeometry( 450, 150, 150, 30 );
         connect( item2Button, SIGNAL( clicked() ), SLOT( neuItem2() ) );
        showInput();
    }
private slots:
    void neueIntZahl() {
       bool ok = false;
       int z = QInputDialog::getInteger( "Eingabe einer int-Zahl", 
                                   "Gib Deine ganze Zahl hier ein",
                                   intZahl, -30, 50, 5, &ok, this );
       if ( ok ) {
          intZahl = z;
          showInput();
       }
    }
    void neueDoubleZahl() {
       bool ok = false;
       double z = QInputDialog::getDouble( "Eingabe einer double-Zahl", 
                                   "Gib Deine Gleitpunktzahl hier ein",
                                    doubleZahl, -10, 20, 2, &ok, this );
       if ( ok ) {
          doubleZahl = z;
          showInput();
       }
    }
    void neuerText() {
       bool ok = false;
       QString z = QInputDialog::getText( "Eingabe sichtbaren Textes",
                                   "Gib Deinen Text hier ein",
                                   QLineEdit::Normal, text, &ok, this );
       if ( ok ) {
          text = z;
          showInput();
       }
    }
    void neuesPasswort() {
       bool ok = false;
       QString z = QInputDialog::getText( "Eingabe unsichtbaren Textes",
                                   "Gib Deinen Text hier ein",
                                   QLineEdit::Password,
                                   passwordText, &ok, this );
       if ( ok ) {
          passwordText = z;
          showInput();
       }
    }
    void neuItem1() {
       bool ok = false;
       QString z = QInputDialog::getItem( "Editierbare Liste",
                                    "Whle eine Zahl aus", list1,
                                    1, true, &ok, this );
       if ( ok ) {
          item1 = z;
          showInput();
       }
    }
    void neuItem2() {
       bool ok = false;
       QString z = QInputDialog::getItem( "Nicht editierbare Liste",
                                    "Whle einen Vogel aus", list2,
                                    1, false, &ok, this );
       if ( ok ) {
          item2 = z;
          showInput();
       }
    }
private:
    void showInput() {
       QString t;
       t.sprintf( "intZahl = %d\n"
                  "doubleZahl = %g\n"
                  "sichtbarer Text = %s\n"
                  "unsichtbarer Text = %s\n"
                  "Wahl aus erster Liste = %s\n"
                  "Wahl aus zweiter Liste = %s\n",
                     intZahl, doubleZahl,
                     (const char *)text, (const char *)passwordText,
                     (const char *)item1, (const char *)item2 );
       label->setText( t );
       label->show();
    }
    QPushButton *intButton, *doubleButton, *textButton, *passwordButton,
                *item1Button, *item2Button;
    int          intZahl;
    double       doubleZahl;
    QString      text, passwordText, item1, item2;
    QStringList  list1, list2;
    QLabel      *label;
};
#include "inputdialog.moc"
//.................................................................... main
int main( int argc, char *argv[] ) {
  QApplication a( argc, argv );
  MyLabel  *w = new MyLabel ;
  w->show();
  w->resize( 600, 400 );
  a.setMainWidget( w );
  return a.exec();
}
