#include <qwidget.h>
#include <qapplication.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qinputdialog.h>

//................................................................. MyLabel
class MyLabel  : public QWidget {
    Q_OBJECT
public:
    MyLabel () : QWidget( 0, 0) {
        age = 30;
        name = "";
        country = "";

        label = new QLabel( this );
        label->setPaletteBackgroundColor( Qt::white );
        label->setGeometry( 0, 0, 450, 400 );
        label->setFont( QFont( "Courier", 18, QFont::Bold ) );
        label->setIndent( 20 );

        nameButton = new QPushButton( "Name", this );
        nameButton->setGeometry( 450, 0, 150, 30 );
        connect( nameButton, SIGNAL( clicked() ), SLOT( newName() ) );

        ageButton = new QPushButton( "Age", this );
        ageButton->setGeometry( 450, 30, 150, 30 );
        connect( ageButton, SIGNAL( clicked() ), SLOT( newAge() ) );

        countries << "Denmark" << "France" << "Germany" << "Great Britain";
        countries << "Italy" << "Norway" << "Sweden" << "USA";
        countryButton = new QPushButton( "Country", this );
        countryButton->setGeometry( 450, 60, 150, 30 );
        connect( countryButton, SIGNAL( clicked() ), SLOT( newCountry() ) );

        showInput();
    }

private slots:
    void newName() {
       bool ok = false;
       QString z = QInputDialog::getText( "Name", "What's your Name",
                                   QLineEdit::Normal, name, &ok, this );
       if ( ok ) {
          name = z;
          showInput();
       }
    }

    void newAge() {
       bool ok = false;
       int z = QInputDialog::getInteger( "Age", "What's your Age",
                                   age, 1, 150, 1, &ok, this );
       if ( ok ) {
          age = z;
          showInput();
       }
    }

    void newCountry() {
       bool ok = false;
       QString z = QInputDialog::getItem( "Country", "Where do you live",
                                    countries, 0, true, &ok, this );
       if ( ok ) {
          country = z;
          showInput();
       }
    }

private:
    void showInput() {
       QString t;
       t.sprintf( "Name   :  %s\n"
                  "Age    :  %d\n"
                  "Country:  %s\n", (const char *)name, age, 
                                    (const char *)country );
       label->setText( t );
       label->show();
    }

    QPushButton *nameButton, *ageButton, *countryButton;
    int          age;
    QString      name, country;
    QStringList  countries;
    QLabel      *label;
};

#include "inputdialog2.moc"

//.................................................................... main
int main( int argc, char *argv[] )
{
  QApplication a( argc, argv );

  MyLabel  *w = new MyLabel ;
  w->show();
  w->resize( 600, 400 );
 
  a.setMainWidget( w );
  return a.exec();
}
