#include <qapplication.h>
#include <qwidget.h>
#include <qlabel.h>

static struct {
      enum Qt::Key  name;
      const char   *text;
} tasten[] = {
  { Qt::Key_Escape, "Key_Escape" },
  { Qt::Key_Tab, "Key_Tab" }, { Qt::Key_Backtab, "Key_BackTab" }, 
  { Qt::Key_Backspace, "Key_Backspace" },
  { Qt::Key_Return, "Key_Return" }, { Qt::Key_Enter,  "Key_Enter"  }, 
  { Qt::Key_Insert, "Key_Insert" }, { Qt::Key_Delete, "Key_Delete" }, 
  { Qt::Key_Pause,  "Key_Pause"  }, { Qt::Key_Print,  "KeyPrint"   },
  { Qt::Key_SysReq, "Key_SysReq" }, 
  { Qt::Key_Home,  "Key_Home"  }, { Qt::Key_End,     "Key_End"     },
  { Qt::Key_Left,  "Key_Left"  }, { Qt::Key_Up,      "Key_Up"      },
  { Qt::Key_Right, "Key_Right" }, { Qt::Key_Down,    "Key_Down"    },
  { Qt::Key_Prior, "Key_Prior" }, { Qt::Key_Next,    "Key_Next"    },
  { Qt::Key_Shift, "Key_Shift" }, { Qt::Key_Control, "Key_Control" },
  { Qt::Key_Meta,  "Key_Meta"  }, { Qt::Key_Alt,     "Key_Alt"     },
  { Qt::Key_CapsLock, "Key_CapsLock" }, { Qt::Key_NumLock, "Key_NumLock" },
  { Qt::Key_ScrollLock, "Key_ScrollLock" }, 
  { Qt::Key_F1,  "Key_F1"  }, { Qt::Key_F2,  "Key_F2"  },
  { Qt::Key_F3,  "Key_F3"  }, { Qt::Key_F4,  "Key_F4"  },
  { Qt::Key_F5,  "Key_F5"  }, { Qt::Key_F6,  "Key_F6"  },
  { Qt::Key_F7,  "Key_F7"  }, { Qt::Key_F8,  "Key_F8"  },
  { Qt::Key_F9,  "Key_F9"  }, { Qt::Key_F10, "Key_F10" },
  { Qt::Key_F11, "Key_F11" }, { Qt::Key_F12, "Key_F12" },
  { Qt::Key_F13, "Key_F13" }, { Qt::Key_F14, "Key_F14" },
  { Qt::Key_F15, "Key_F15" }, { Qt::Key_F16, "Key_F16" },
  { Qt::Key_F17, "Key_F17" }, { Qt::Key_F18, "Key_F18" },
  { Qt::Key_F19, "Key_F19" }, { Qt::Key_F20, "Key_F20" },
  { Qt::Key_F21, "Key_F21" }, { Qt::Key_F22, "Key_F22" },
  { Qt::Key_F23, "Key_F23" }, { Qt::Key_F24, "Key_F24" },
  { Qt::Key_F25, "Key_F25" }, { Qt::Key_F26, "Key_F26" },
  { Qt::Key_F27, "Key_F27" }, { Qt::Key_F28, "Key_F28" },
  { Qt::Key_F29, "Key_F29" }, { Qt::Key_F30, "Key_F30" },
  { Qt::Key_F31, "Key_F31" }, { Qt::Key_F32, "Key_F32" },
  { Qt::Key_F33, "Key_F33" }, { Qt::Key_F34, "Key_F34" },
  { Qt::Key_F35, "Key_F35" },
  { Qt::Key_Super_L, "Key_Super_L" }, { Qt::Key_Super_R, "Key_Super_R" },
  { Qt::Key_Menu,    "Key_Menu"    }, { Qt::Key_Hyper_L, "Key_Hyper_L" },
  { Qt::Key_Hyper_R, "Key_Hyper_R" },
  { Qt::Key_Space,   "Key_Space"   }, { Qt::Key_Any,      "Key_Any"      },
  { Qt::Key_Exclam,  "Key_Exclam"  }, { Qt::Key_QuoteDbl, "Key_QuoteDbl" },
  { Qt::Key_NumberSign, "Key_NumberSign" },
  { Qt::Key_Dollar,     "Key_Dollar"     },
  { Qt::Key_Percent,    "Key_Percent"    },
  { Qt::Key_Ampersand,  "Key_Ampersand"  },
  { Qt::Key_Apostrophe, "Key_Apostrophe" },
  { Qt::Key_ParenLeft,  "Key_ParenLeft"  },
  { Qt::Key_ParenRight, "Key_ParenRight" },
  { Qt::Key_Asterisk,   "Key_Asterisk"   },
  { Qt::Key_Plus,  "Key_Plus" },  { Qt::Key_Comma,  "Key_Comma"  },
  { Qt::Key_Minus, "Key_Minus" }, { Qt::Key_Period, "Key_Period" },
  { Qt::Key_Slash, "Key_Slash" },
  { Qt::Key_0, "Key_0" }, { Qt::Key_1, "Key_1" }, { Qt::Key_2, "Key_2" },
  { Qt::Key_3, "Key_3" }, { Qt::Key_4, "Key_4" }, { Qt::Key_5, "Key_5" },
  { Qt::Key_6, "Key_6" }, { Qt::Key_7, "Key_7" }, { Qt::Key_8, "Key_8" },
  { Qt::Key_9, "Key_9" },
  { Qt::Key_Colon,   "Key_Colon"   }, { Qt::Key_Semicolon, "Key_Semicolon" },
  { Qt::Key_Less,    "Key_Less"    }, { Qt::Key_Equal,     "Key_Equal"     },
  { Qt::Key_Greater, "Key_Greater" }, { Qt::Key_Question,  "Key_Question"  },
  { Qt::Key_At, "Key_At" },
  { Qt::Key_A, "Key_A" }, { Qt::Key_B, "Key_B" }, { Qt::Key_C, "Key_C" },
  { Qt::Key_D, "Key_D" }, { Qt::Key_E, "Key_E" }, { Qt::Key_F, "Key_F" },
  { Qt::Key_G, "Key_G" }, { Qt::Key_H, "Key_H" }, { Qt::Key_I, "Key_I" },
  { Qt::Key_J, "Key_J" }, { Qt::Key_K, "Key_K" }, { Qt::Key_L, "Key_L" },
  { Qt::Key_M, "Key_M" }, { Qt::Key_N, "Key_N" }, { Qt::Key_O, "Key_O" },
  { Qt::Key_P, "Key_P" }, { Qt::Key_Q, "Key_Q" }, { Qt::Key_R, "Key_R" },
  { Qt::Key_S, "Key_S" }, { Qt::Key_T, "Key_T" }, { Qt::Key_U, "Key_U" },
  { Qt::Key_V, "Key_V" }, { Qt::Key_W, "Key_W" }, { Qt::Key_X, "Key_X" },
  { Qt::Key_Y, "Key_Y" }, { Qt::Key_Z, "Key_Z" },
  { Qt::Key_BracketLeft,  "Key_BracketLeft"  },
  { Qt::Key_Backslash,    "Key_Backslash"    },
  { Qt::Key_BracketRight, "Key_BracketRight" },
  { Qt::Key_AsciiCircum,  "Key_AsciiCircum"  },
  { Qt::Key_Underscore,   "Key_Underscore"   },
  { Qt::Key_QuoteLeft,    "Key_QuoteLeft"    },
  { Qt::Key_BraceLeft,    "Key_BraceLeft"    },
  { Qt::Key_Bar,          "Key_Bar"          },
  { Qt::Key_BraceRight,   "Key_BraceRight"   },
  { Qt::Key_AsciiTilde,   "Key_AsciiTilde"   },

  { Qt::Key_unknown, "Key_unknown" }
};

const int tastenGroesse = sizeof(tasten) / sizeof(tasten[0]);

//........................................................ Klasse MeinFenster
class MeinFenster : public QWidget
{
public:
   MeinFenster() {
      setPaletteBackgroundColor( Qt::white );
      gedrueckt = new QLabel( this );
      gedrueckt->setGeometry( 50, 50, 500, 50 );
      gedrueckt->setPaletteBackgroundColor( Qt::green.light(150) );
      losGelassen = new QLabel( this );
      losGelassen->setGeometry( 50, 250, 500, 50 );
      losGelassen->setPaletteBackgroundColor( Qt::red.light(150) );
   }

protected:
   virtual void keyPressEvent( QKeyEvent* event ) {
      textAusgabe( event, gedrueckt );
   }

   virtual void keyReleaseEvent( QKeyEvent* event ) {
      textAusgabe( event, losGelassen );
   }

private:
   void textAusgabe( QKeyEvent* event, QLabel *label ) {
      for (int i=0; i<tastenGroesse; i++)
         if ( event->key() == tasten[i].name ) {
            QString t( "  Tastencode: " );
            t += tasten[i].text;

            t += ";  Tastentext: ";
            if ( event->text().length() > 0 )
               t += event->text();
            else
               t += "Keiner";

            if ( event->state() & Qt::ShiftButton )
               t += ";  mit Shift";
            if ( event->state() & Qt::ControlButton )
               t += ";  mit Strg";
            if ( event->state() & Qt::AltButton )
               t += ";  mit Alt";

            label->setText( t );
            break;
         }
   }

   QLabel  *gedrueckt,
           *losGelassen;
};

//.................................................................. main 
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   MeinFenster* mywidget = new MeinFenster();
   mywidget->setGeometry( 50, 50, 600, 400 );
 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
