#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>

#define MAXX  300
#define MAXY  300

//........................................................ Klasse MeinFenster
class MeinFenster : public QWidget
{
public:
   MeinFenster() {
      setPaletteBackgroundColor( Qt::white );
      links = rechts = auf = ab = false;
      x = MAXX/2;
      y = MAXY/2;
   }

protected:
   virtual void keyPressEvent( QKeyEvent* event ) {
      switch ( event->key() ) {
          case Key_Left : links = true;   break;
          case Key_Right: rechts = true;  break;
          case Key_Up   : auf = true;     break;
          case Key_Down : ab = true;      break;
      }
      repaint( false );
   }

   virtual void keyReleaseEvent( QKeyEvent* event ) {
      switch ( event->key() ) {
          case Key_Left : links = false;   break;
          case Key_Right: rechts = false;  break;
          case Key_Up   : auf = false;     break;
          case Key_Down : ab = false;      break;
      }
   }
   virtual void paintEvent( QPaintEvent * ) {
      QPainter p( this );
      if ( links )       { if (x-1 >= 0)   x--; }
      else if ( rechts ) { if (x+1 < MAXX) x++; }
      else if ( auf )    { if (y-1 >= 0)   y--; }
      else if ( ab )     { if (y+1 < MAXY) y++; }
      p.drawPoint( x, y); 
   }

private:
   bool  links, rechts, auf, ab;
   int   x, y;
};

//.................................................................. main 
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   MeinFenster* mywidget = new MeinFenster();
   mywidget->setGeometry( 50, 50, MAXX, MAXY );
 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
