//-------------------------------------------------------------------------
// Klassendeklaration fuer Datentyp
//-------------------------------------------------------------------------

template <class T> class Datentyp
{
private:
   T  value;

public:

   Datentyp ( T init_value );  // Konstruktor zum Vorinitialisieren

   void   set( T init_value );  // Methode zum Setzen des Wertes
   T      get();                // Methode zum Ermitteln des Wertes
};

#include <iostream>

using namespace std;

//-------------------------------------------------------------------------
// Klassendefinition fuer Datentyp
//-------------------------------------------------------------------------

template <class T> Datentyp<T>::Datentyp( T init_value )
{
   value = init_value;   // Initialisieren des Wertes
}

template <class T> void Datentyp<T>::set( T init_value )
{
   value = init_value;   // Setzen des Wertes
}

template <class T> T Datentyp<T>::get()
{
   return value;
}

//-------------------------------------------------------------------------
// Verwendung von Datentyp
//-------------------------------------------------------------------------

int main(void) {
   Datentyp<int>    object_int    = 10;     // Objekt zur Verwaltung von ints
   Datentyp<char>   object_char   = 'a';    // Objekt zur Verwaltung von chars
   Datentyp<double> object_double = 15.4;   // Objekt zur Verwaltung von doubles
   Datentyp<char*>  object_string = "Text"; // Objekt zur Verwaltung von char*

   cout << object_int.get () << endl;     // Ausgabe des Wertes von Objekt 1
   cout << object_char.get () << endl;    // Ausgabe des Wertes von Objekt 2
   cout << object_double.get () << endl;  // Ausgabe des Wertes von Objekt 3
   cout << object_string.get () << endl;  // Ausgabe des Wertes von Objekt 4
   cout << endl;
   
   object_int.set (12);              // Setzen des Inhaltes fuer Objekt 1
   object_char.set ('b');            // Setzen des Inhaltes fuer Objekt 2
   object_double.set (20.1);         // Setzen des Inhaltes fuer Objekt 3
   object_string.set ("Neuer Text"); // Setzen des Inhaltes fuer Objekt 4

   cout << object_int.get () << endl;    // Ausgabe des Wertes von Objekt 1
   cout << object_char.get () << endl;   // Ausgabe des Wertes von Objekt 2
   cout << object_double.get () << endl; // Ausgabe des Wertes von Objekt 3
   cout << object_string.get () << endl; // Ausgabe des Wertes von Objekt 4

   return 0;
}
