#include <qapplication.h>
#include <qlabel.h>
#include <qgrid.h>
#include <qhbox.h>
#include <qvbox.h>

const char *zahl[] = { "null",  "eins",   "zwei", "drei", "vier", "fuenf",
                       "sechs", "sieben", "acht", "neun", "zehn"          };
class MeinLayout : public QVBox
{
public:
  MeinLayout( QWidget *parent=0, const char *name=0 ) : QVBox( parent, name ) {
     int  i;
     QLabel  *q;
        //........................... Horizontales Layout (QHBox)
     QHBox *hlayout = new QHBox( this );
     hlayout->setSpacing(10);
     hlayout->setMargin(20);
     hlayout->setPaletteBackgroundColor( Qt::gray.light(150) );
     for (i=0; i<=10; i++) {
        q = new QLabel( zahl[i], hlayout ); 
        q->setFrameStyle( QFrame::Panel | QFrame::Sunken );
        q->setLineWidth( 3 );
     }
        //............................. Vertikales Layout (QHVox)
     QVBox *vlayout = new QVBox( this );
     vlayout->setSpacing(10);
     vlayout->setMargin(10);
     vlayout->setPaletteBackgroundColor( Qt::blue.light(180) );
     for (i=0; i<5; i++) {
        q = new QLabel( zahl[i], vlayout ); 
        q->setFrameStyle( QFrame::Panel | QFrame::Sunken );
        q->setLineWidth( 3 );
     }
        //..................... spaltenweises Grid-Layout (QGrid)
     QGrid *sglayout = new QGrid( 4, this );
     sglayout->setSpacing(50);
     sglayout->setMargin(10);
     sglayout->setPaletteBackgroundColor( Qt::red.light(150) );
     for (i=0; i<=10; i++) {
        q = new QLabel( zahl[i], sglayout ); 
        q->setFrameStyle( QFrame::Panel | QFrame::Sunken );
        q->setLineWidth( 3 );
     }
        //...................... zeilenweises Grid-Layout (QGrid)
     QGrid *zglayout = new QGrid( 4, QGrid::Vertical, this );
     zglayout->setSpacing(20);
     zglayout->setMargin(30);
     zglayout->setPaletteBackgroundColor( Qt::green.light(180) );
     for (i=0; i<=10; i++) {
        q = new QLabel( zahl[i], zglayout ); 
        q->setFrameStyle( QFrame::Panel | QFrame::Sunken );
        q->setLineWidth( 3 );
     }
   }
};
int main( int argc, char *argv[] ) {
  QApplication a( argc, argv );
  MeinLayout* layout = new MeinLayout();
  layout->show();
  a.setMainWidget( layout );
  return a.exec();
}
