#include <qapplication.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
//......................................................... Klasse MyWidget
class MyWidget : public QWidget {
 public:
   MyWidget() {
       int          i;
       QString      s;
         //.......... Anlegen eines QGroupBox-Widgets
       QGroupBox  *groupbox = new QGroupBox( "GroupBox",  this );
       groupbox->setFrameStyle( QFrame::Box | QFrame::Sunken );
       groupbox->setLineWidth( 10 );
         //.......... Anlegen eines QVBoxLayout-Managers, dessen Elternwidget
         //.......... das QGroupBox-Widget ist und dessen Randbreite sich
         //.......... aus der Rahmenbreite des groupbox-Widgets ergibt;
         //.......... Zwischenraum zw. Subwidgets hier auf 2 eingestellt.
       QBoxLayout *bl = new QVBoxLayout( groupbox,
                                         groupbox->frameWidth(), 2 );
         //.......... Hinzufuegen eines statischen Zwischenraums, dessen
         //.......... Groesse sich aus dem verwendenden Zeichensatz
         //.......... ermittelt; so wird die Ueberschrift und der Rahmen
         //.......... des QGroupBox-Widgets nicht ueberschrieben.
       bl->addSpacing( groupbox->fontMetrics().height() );
         //.......... Anordnen (senkrecht) von 5 Labels
       for (i=0; i<5; i++) {
           s.sprintf("Label %d", i+1);
           QLabel *l = new QLabel( s, groupbox );
           bl->addWidget( l );
       }
         //.......... Anordnen (senkrecht) von 5 Buttons
       for (i=0; i<5; i++) {
           s.sprintf("Button %d", i+1);
           QPushButton *b = new QPushButton( s, groupbox );
           bl->addWidget( b );
       }
       groupbox->resize( groupbox->sizeHint() );
       this->resize( groupbox->sizeHint() );
   }
};
//.................................................................... main
int main( int argc, char* argv[] ) {
   QApplication myapp( argc, argv );
   MyWidget *mywidget = new MyWidget();
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
