#include <qapplication.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlcdnumber.h>
#include <qslider.h>
#include <qcolor.h>
#include <qfont.h>
//.......................................................... Klasse LCDZahl
class LCDZahl : public QWidget {
   Q_OBJECT
public:
   LCDZahl( const QString&           titel,
            int                      ziffernZahl,
            QLCDNumber::Mode         zsystem,
            QColor                   hintergrundFarbe,
            QLCDNumber::SegmentStyle stil,
            QWidget*                 parent ) : QWidget( parent ) {
      QLabel*    text = new QLabel( this );
       text->setGeometry( 0, 0, 150, 20 );
       text->setText( titel );
       text->setAlignment( QLabel::AlignCenter );
      QLCDNumber *lcd  = new QLCDNumber( ziffernZahl, this );
       lcd->setGeometry( 0, 20, 150, 150 );
       lcd->setMode( zsystem );
       lcd->setPaletteBackgroundColor( hintergrundFarbe );
       lcd->setSegmentStyle( stil );
       lcd->display( 100 );
      slider = new QSlider( 0, 65535, 1, 100, Horizontal, this );
       slider->setGeometry( 0, 180, 150, 20 );
       slider->setValue( 100 );
      QObject::connect( slider, SIGNAL(valueChanged(int)),
                        lcd,    SLOT(display(int)) );
      QObject::connect( slider, SIGNAL(valueChanged(int)),
                                SIGNAL(valueChanged(int)) );
   }
   int value() const { return slider->value(); }
public slots:
   void setValue( int value ) { slider->setValue( value ); }
signals:
   void valueChanged( int );
private:
   QSlider *slider;
};
#include "lcdwandel.moc"
//.................................................................... main
int main( int argc, char **argv ) {
   QApplication myapp( argc, argv );
   
   QWidget* mywidget = new QWidget();
   mywidget->setGeometry( 10, 10, 600, 300 );
   mywidget->setMinimumSize( 200, 300 );

   QColor blaugruen( 0, 255, 255 );
   LCDZahl* z[4];
   z[0] = new LCDZahl( "Dual", 16, QLCDNumber::BIN, blaugruen,
                       QLCDNumber::Flat, mywidget );
    z[0]->setGeometry(0, 10, 150, 200);
   z[1] = new LCDZahl( "Oktal", 6, QLCDNumber::OCT,
                       QLCDNumber::darkBlue,
                       QLCDNumber::Outline, mywidget );
    z[1]->setGeometry(150, 10, 150, 200);
   z[2] = new LCDZahl( "Dezimal", 5, QLCDNumber::DEC,
                       QLCDNumber::darkGray,
                       QLCDNumber::Filled, mywidget );
    z[2]->setGeometry(300, 10, 150, 200);
   z[3] = new LCDZahl( "Hexadezimal", 4, QLCDNumber::HEX,
                       QLCDNumber::darkYellow,
                       QLCDNumber::Filled, mywidget );
    z[3]->setGeometry(450, 10, 150, 200);

   for (int i=0; i<4; i++)
      for (int j=0; j < 4; j++)
         if (i != j)
            QObject::connect( z[i], SIGNAL(valueChanged(int)),
                              z[j], SLOT(setValue(int)) );
   QPushButton* quit = new QPushButton( "Quit", mywidget );
    quit->setGeometry( 0, 240, 600, 40 );
    quit->setFont( QFont( "Times", 18, QFont::Bold ) );
    quit->setPaletteBackgroundColor( Qt::yellow );
    QObject::connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
