#include <qapplication.h>
#include <qcolor.h>
#include <qpalette.h>
#include <qlabel.h>

QColor vorFarben[] = {
          Qt::black,      Qt::white,    Qt::darkGray, Qt::gray,
          Qt::lightGray,  Qt::red,      Qt::green,    Qt::blue,
          Qt::cyan,       Qt::magenta,  Qt::yellow,   Qt::darkRed,
          Qt::darkGreen,  Qt::darkBlue, Qt::darkCyan, Qt::darkMagenta,
          Qt::darkYellow, Qt::color0,   Qt::color1                     };
const int farbZahl = sizeof( vorFarben ) / sizeof( vorFarben[0] );

//........................................................ Klasse lightDark
class lightDark : public QWidget
{
public:
   lightDark( QWidget *parent ) : QWidget( parent ) {
      for ( int f=0; f<farbZahl; f++ ) {
         int  i;
         QColor farb( vorFarben[f] );

         for ( i=0; i<300; i+=10 ) {
            QLabel *l = new QLabel( this );
            l->setGeometry( i*2, f*25, 20, 10 );
            l->setPalette( QPalette( Qt::lightGray, farb.light( i+100 ) ) );
         }
         for ( i=0; i<300; i+=10 ) {
            QLabel *l = new QLabel( this );
            l->setGeometry( i*2, f*25+10, 20, 10 );
            l->setPalette( QPalette( Qt::lightGray, farb.dark( i+100 ) ) );
         }
      }
   }
};

//.................................................................... main
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );
   
   lightDark* mywidget = new lightDark( 0 );
   mywidget->setGeometry( 100, 100, 650, 500 );
  
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
