#include <qlineedit.h>
#include <qcombobox.h>
#include <qframe.h>
#include <qvalidator.h>
#include <qlabel.h>
#include <qhbox.h>
#include <qvbox.h>
//.............................................................. Klasse EinZeiler
class EinZeiler : public QVBox {
    Q_OBJECT
public:
    EinZeiler( QWidget *parent = 0, const char *name = 0 );
protected:
    QLineEdit *zeile1, *zeile2, *zeile3;
    QComboBox *combo1, *combo2, *combo3;
protected slots:
    void echoModusSlot( int i ) {
       switch ( i ) {
         case 0: zeile1->setEchoMode( QLineEdit::Normal );   break;
         case 1: zeile1->setEchoMode( QLineEdit::Password ); break;
         case 2: zeile1->setEchoMode( QLineEdit::NoEcho );   break;
       }
       zeile1->setFocus();
    }
    void eingabeArtSlot( int i ) {
       switch ( i ) {
         case 0: zeile2->setValidator( 0 ); break;
         case 1: zeile2->setValidator( new QIntValidator( zeile2 ) ); break;
         case 2: zeile2->setValidator(
                  new QDoubleValidator( -999.0, 999.0, 2, zeile2 ) ); break;
       }
       zeile2->setText( "" );
       zeile2->setFocus();
    }
    void ausrichtungSlot( int i ) {
       switch ( i ) {
         case 0: zeile3->setAlignment( QLineEdit::AlignLeft );   break;
         case 1: zeile3->setAlignment( QLineEdit::AlignCenter ); break;
         case 2: zeile3->setAlignment( QLineEdit::AlignRight );  break;
       }
       zeile3->setFocus();
    }
};
//.......................................................... EinZeiler::EinZeiler
EinZeiler::EinZeiler( QWidget *parent, const char *name ) : QVBox(parent, name) {
    setMargin( 10 );
    QHBox *box1 = new QHBox( this ); // Widget fuer das Layout
     box1->setMargin( 5 );
     (void)new QLabel( "Echo Modus: ", box1 );
     combo1 = new QComboBox( false, box1 );
     combo1->insertItem( "Normal", -1 );
     combo1->insertItem( "Password", -1 );
     combo1->insertItem( "NoEcho", -1 );
     connect( combo1, SIGNAL( activated( int ) ),
              this,   SLOT( echoModusSlot( int ) ) );
     zeile1 = new QLineEdit( this );
    QHBox *box2 = new QHBox( this ); // Weiteres Widget fuer das Layout
     box2->setMargin( 5 );
     (void)new QLabel( "Eingabeart: ", box2 );
     combo2 = new QComboBox( false, box2 );
     combo2->insertItem( "Beliebiger Text", -1 );
     combo2->insertItem( "Integer-Zahl", -1 );
     combo2->insertItem( "Double-Zahl", -1 );
     connect( combo2, SIGNAL( activated( int ) ),
              this,   SLOT( eingabeArtSlot( int ) ) );
     zeile2 = new QLineEdit( this );
    QHBox *box3 = new QHBox( this ); // Weiteres Widget fuer das Layout
    box3->setMargin( 5 );
     (void)new QLabel( "Ausrichtung: ", box3 );
     combo3 = new QComboBox( false, box3 );
     combo3->insertItem( "Links", -1 );
     combo3->insertItem( "Mitte", -1 );
     combo3->insertItem( "Rechts", -1 );
     connect( combo3, SIGNAL( activated( int ) ),
              this,   SLOT( ausrichtungSlot( int ) ) );
     zeile3 = new QLineEdit( this );
    zeile1->setFocus(); // Focus auf die erste Eingabezeile
}
#include "lineedit.moc"
//......................................................................... main
int main( int argc, char **argv ) {
    QApplication a( argc, argv );
    EinZeiler lineedits;
    lineedits.resize( 400, lineedits.sizeHint().height() );
    lineedits.setCaption( "QLineEdit-Beispiele" );
    a.setMainWidget( &lineedits );
    lineedits.show();
    return a.exec();
}
