#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qtimer.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

//........................................................ Klasse malFenster
class malFenster : public QWidget
{
    Q_OBJECT
public:
    malFenster() {
       PI = 4*atan(1);
       setPaletteBackgroundColor( Qt::white );
       radius = 0;
       QTimer *timer = new QTimer( this );
       timer->start( 200, false );
       QObject::connect( timer, SIGNAL( timeout() ),
                         this,  SLOT( newCircle() ) );
    }

protected:
    void paintEvent( QPaintEvent * ) {
       QPainter p( this );

       int mittex = width()/2,
           mittey = height()/2;
       int sw = ::rand()%20+1; 

       radius += ::rand()%100+30; 
       p.setPen( QColor( ::rand()&255, ::rand()&255, ::rand()&255 ) );

       for ( int i=0; i<=360; i += sw ) {
          double  x0 = mittex+sin(i/180.0*PI)*radius,
                  y0 = mittey-cos(i/180.0*PI)*radius;
          p.translate( x0, y0 );
          p.rotate( i );
          p.drawLine( -width(), 0, width(), 0 );
          p.rotate( -i );
          p.translate( -x0, -y0 );
       }
       if ( radius > mittex+50 )
          radius = 0;
    }

private slots:
    void newCircle( void ) {
       repaint( ::rand()%100==0 ? true : false );
    }

private:
    double PI;
    int    radius;
};

#include "linkreis.moc"

//..................................................................... main
int main( int argc, char *argv[] )
{
    srand( time( NULL ) );
    QApplication a( argc, argv );
    malFenster   bild;
    bild.setGeometry( 100, 100, 700, 700 );
    a.setMainWidget( &bild );
    bild.show();
    return a.exec();
}
