#include <qapplication.h>
#include <qwidget.h>
#include <qlistbox.h>
#include <qcombobox.h>
#include <qlabel.h>
#include <qstring.h>
#include <stdlib.h>
#include <time.h>

const char *continentName[] = {
         "Afrika", "Australien", "Europa", "Asien", "Amerika" };
const int continentNo = sizeof(continentName) / sizeof(continentName[0]);

const char *hobbyName[] = {
         "Lesen",       "Reiten",     "Angeln",  "Joggen", "Fahradfahren",
         "Musik hren", "Musizieren", "Fuball", "Tennis", "Faulenzen"  };
const int hobbyNo = sizeof(hobbyName) / sizeof(hobbyName[0]);

const char *farbeName[] = {
         "Rot",   "Gruen", "Blau", "Gelb", "Schwarz",
         "Weiss", "Lila",  "Braun"                  };
const int farbeNo = sizeof(farbeName) / sizeof(farbeName[0]);

//--------------------------------- Klasse Auswahl --------
class Auswahl : public QWidget
{
Q_OBJECT

public:
   Auswahl();

private slots:
   void zeigeWahl();

private:
   QListBox*  listeContinent;
   QListBox*  listeHobby;
   QComboBox* comboFarbe;
   QLabel*    textausgabe;
};

#include "listbox.moc"

//---------------------------- Konstruktor Buttons --------
Auswahl::Auswahl()
{
   int  i;

   setFont (QFont( "Times", 12 ) );
   listeContinent = new QListBox( this );
   listeContinent->setGeometry( 20, 20, 150, 100 );
   for ( i=0; i<continentNo; i++) 
      listeContinent->insertItem( continentName[i] );
   listeContinent->sort();

   listeHobby = new QListBox( this );
   listeHobby->setSelectionMode( QListBox::Extended );
   listeHobby->setGeometry( 210, 20, 150, 100 );
   for ( i=0; i<hobbyNo; i++)
      listeHobby->insertItem( hobbyName[i] );
   listeHobby->sort();

   comboFarbe = new QComboBox( true, this );
   comboFarbe->setGeometry( 400, 20, 150, 40 );
   for ( i=0; i<farbeNo; i++)
      comboFarbe->insertItem( farbeName[i] );

   QObject::connect( listeContinent, SIGNAL( highlighted( int ) ),
                     this,           SLOT( zeigeWahl() ) );
   QObject::connect( listeHobby, SIGNAL( selectionChanged( ) ),
                     this,       SLOT( zeigeWahl() ) );
   QObject::connect( comboFarbe, SIGNAL( activated( int ) ),
                     this,       SLOT( zeigeWahl() ) );

   textausgabe = new QLabel( this );
   textausgabe->setPaletteBackgroundColor( Qt::white ); 
   textausgabe->setText( "Bisher keine Wahl" );
   textausgabe->setGeometry( 20, 150, 750, 200 );
   textausgabe->setFrameStyle( QFrame::Box | QFrame::Sunken );
}

//--------------------------------------- zeigeWahl --------
void Auswahl::zeigeWahl()
{
   QColor neuFarbe( ::rand()&255, ::rand()&255, ::rand()&255 );
   QString neuer_text( "Deine bisherigen Daten:\n   Kontinent: ");
   uint  i;

   for ( i=0; i < listeContinent->count(); i++ )
      if ( listeContinent->isSelected( i ) )
         neuer_text += listeContinent->text( i );
      
   neuer_text += "\n   Hobbies: ";
   for ( i=0; i < listeHobby->count(); i++ )
      if ( listeHobby->isSelected( i ) ) {
         neuer_text += listeHobby->text( i );
         neuer_text += ", ";
      }
   neuer_text += "\n   Farbe: ";
   neuer_text += comboFarbe->currentText();

   textausgabe->setPaletteBackgroundColor( neuFarbe );
   textausgabe->setText( neuer_text );
}

//------------------------------------------- main --------
int main( int argc, char *argv[] )
{
   QApplication myapp( argc, argv );

   ::srand( time( NULL ) );
   Auswahl* mywidget = new Auswahl();
   mywidget->setGeometry( 10, 10, 800, 400 );
   mywidget->show();
  
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
