#include <qapplication.h>
#include <qlistview.h>

class Liste : public QListView {
   Q_OBJECT

public:
   Liste() {
      addColumn( "Klasse" );
      addColumn( "Headerdatei" );
      setColumnWidthMode( 1, Manual ); // Modus fr Spaltenbreite
                                       // per Hand festlegen waehlen
      setColumnWidth( 1, 200 );   // Festlegen der Spaltenbreite
      setColumnWidthMode( 0, Maximum );
      setRootIsDecorated( true ); // setzt einen Pfeil an die Hauptpunkte

      qt          = new QListViewItem( this, "Qt", "qnamespace.h" );
      paintdevice = new QListViewItem( this, "QPaintDevice",
                                             "qpaintdevice.h" );
      objekt      = new QListViewItem( qt, "QObject", "qobject.h" );
      widget      = new QListViewItem( objekt, paintdevice,
                                       "QWidget", "qwidget.h");
      button      = new QListViewItem( widget, "QButton", "qbutton.h" );
      frame       = new QListViewItem( widget, "QFrame", "qframe.h" );
      dialog      = new QListViewItem( widget, "QDialog", "qdialog.h" );
      scrollview  = new QListViewItem( frame, "QScrollView", "qscrollview.h" );
      groupbox    = new QListViewItem( frame, "QGroupBox", "qgroupbox.h" );
      tableview   = new QListViewItem( frame, "QTableView", "qtableview.h");
      widget2     = new QListViewItem( paintdevice, "QWidget",
                                       "auch eingebunden in Qt/QObject");
      pixmap      = new QListViewItem( qt, "QPixmap", "qpixmap.h" );
      pixmap2     = new QListViewItem( paintdevice, "QPixmap",
                                       "auch eingebunden in Qt" );

      item = new QListViewItem( button, "QRadioButton", "qradiobutton.h");
      item = new QListViewItem( button, "QCheckBox", "qcheckbox.h" );
      item = new QListViewItem( button, "QPushButton", "qpushbutton.h" );
      item = new QListViewItem( button, "QToolButton", "qtoolbutton.h");
      item = new QListViewItem( dialog, "QFileDialog", "qfiledialog.h" );
      item = new QListViewItem( dialog, "QMessageBox", "qmessagebox.h" );
      item = new QListViewItem( widget, "QComboBox", "qcombobox.h" );
      item = new QListViewItem( objekt, "QApplication", "qapplication.h" );
      item = new QListViewItem( frame, "QLCDNumber", "qlcdnumber.h" );
      item = new QListViewItem( frame, "QSpinBox", "qspinbox.h" );
      item = new QListViewItem( frame, "QLabel", "qlabel.h" );
      item = new QListViewItem( frame, "QMenuBar", "qmenubar.h" );
      item = new QListViewItem( frame, "QPopupMenu", "qpopupmenu.h" );
      item = new QListViewItem( widget, "QSlider", "qslider.h" );
      item = new QListViewItem( widget, "QLineEdit", "qlineedit.h" );
      item = new QListViewItem( widget, "QMainWindow", "qmainwindow.h" );
      item = new QListViewItem( scrollview, "QTextView", "qtextview.h" );
      item = new QListViewItem( scrollview, "QListView", "qlistview.h" );
      item = new QListViewItem( scrollview, "QListBox", "qlistbox.h" );
      item = new QListViewItem( groupbox, "QButtonGroup", "qbuttongroup.h" );
      item = new QListViewItem( tableview, "QTextEdit", "qtextedit.h" );
      item = new QListViewItem( this, "QString", "qstring.h" );
      item = new QListViewItem( qt, "QPainter", "qpainter.h" );
      item = new QListViewItem( qt, "QListViewItem", "qlistview.h" ); 
      setSorting( 0,       // Sortiergrundlage hier 1. Spalte, Klassen
                  false ); // Sortieren von z nach a
     
      setAllColumnsShowFocus( false ); // beim Anwaehlen wird nur
                                       // 1. Spalte markiert bzw. bei
                                       // true alle Spalten des Punkts
      setTreeStepSize( 25 );  // setzt den Einrueckabstand der Abzweige

      setMultiSelection( false );  // bei true kann man mehrere Punkte
                                   // gleichzeitig anwaehlen bzw.
                                   // bei false immer nur einen, dabei wird 
                                   // letzte Anwahl automatisch demarkiert
      QObject::connect( this, SIGNAL( doubleClicked( QListViewItem *) ),
                        this, SLOT( itemSlot( QListViewItem *) ) );            
   }

public slots:
    void itemSlot( QListViewItem * w2 ) {  
       if ( w2==widget2 || w2==pixmap2 ) {
          qt->setExpandable( true ); // noetig fr setOpen()
          setOpen( qt, true ); // Oeffnen des Qt-Zweigs;
                               // noetig, um Objekt-Zweig zu oeffnen
          if ( w2==widget2 ) {
             objekt->setExpandable( true );
             setOpen( objekt, true ); // Oeffnen des Objekt-Zweigs
             setCurrentItem( widget );
             setSelected( widget, true ); // bestimmt den markierten Punkt;
                                          // muss nicht gerade geoeffnet sein 
          } else if ( w2==pixmap2 ) {
             setCurrentItem( pixmap );
             setSelected( pixmap, true );  
          }
       }
    }
    
private:
   QListViewItem  *qt, *pixmap, *pixmap2, *paintdevice; 
   QListViewItem  *objekt,*widget, *widget2;
   QListViewItem  *button, *frame, *dialog, *scrollview;
   QListViewItem  *groupbox, *tableview, *item;
};

#include "listview2.moc"

int main( int argc, char *argv[] ) {
   QApplication a( argc, argv);
   Liste list;
   list.setMinimumSize( 520,400 );

   a.setMainWidget( &list );
   list.show();
   return a.exec();
}
