#include <qapplication.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
 
//......................................................... messageHandler
void messageHandler( QtMsgType type, const char *msg )
{
    static FILE *fp = 0;

    if ( fp == 0 ) {
       if ( ( fp = fopen("logfile.txt", "a" ) ) == 0 ) {
          fprintf( stderr, "cannot open file `logfile.txt for writing" );
          abort();    // core-dump
       }
    }
       
    switch ( type ) {
        case QtDebugMsg:
            fprintf( fp, "Debug: %s\n", msg );
            break;
        case QtWarningMsg:
            fprintf( fp, "Warning: %s\n", msg );
            break;
        case QtFatalMsg:
            fprintf( fp, "Fatal: %s\n", msg );
            abort();    // core-dump
    }
}
 
//................................................................... main
int main( int argc, char *argv[] )
{
    int  i;

    qInstallMsgHandler( messageHandler );

    time_t tim = time(NULL);
    qDebug( "Log-Messages for the run at time: %s"
            "=================================================================\n",
            ctime( &tim ) );

    qDebug( "program name: %s", argv[0] );
    for ( i=1; i<argc; i++)
       qDebug( "Argument %d: %s", i, argv[i] );

    qDebug( "\n" );
    qDebug( "Ich count until 5" );
    for ( i=1; i<=5; i++) {
       qDebug( "%d", i );
       ASSERT( i==4 );
    }
    qDebug( "\n" );

    qWarning( ".... and now i continue to count until 10" );
    for ( i=6; i<=10; i++)
       qWarning( "%d", i );

    qWarning( "\n" );
    qFatal( "I counted enough; Good bye" );

    return 0;
}
