#include <qapplication.h>
#include <qwidget.h>
#include <qpalette.h>
#include <qcolor.h>
#include <qpainter.h>
#include <stdlib.h>
#include <time.h>

const int maxx = 800, maxy = 600;

//........................................................ Klasse malFenster
class malFenster : public QWidget
{
public:
    malFenster() {
       setCaption( "Ein Maennchen mit Tisch" );
       resize( maxx, maxy );
    }

protected:
    virtual void paintEvent( QPaintEvent * ) {
       QPainter paint( this );
       zeichneMannTisch( &paint );
    }
    virtual void mousePressEvent( QMouseEvent * ) {
       repaint( true );
    }

private:
    void zufallsStift( QPainter *p ) {
       p->setPen( QColor( rand()&255, rand()&255, rand()&255 ) );
       p->setBrush(
          QBrush( QColor( rand()&255, rand()&255, rand()&255 ),
          (Qt::BrushStyle)(rand() % 16) ) );
    }

    void zeichneMannTisch( QPainter *p ) {
       int  mittex = maxx/2, mittey = maxy/2;

          //--------------------------- Bildschirm-Rahmen und -Hintergrund
       zufallsStift( p );
       p->drawRect( 0, 0, maxx, maxy ); // Bildschirm einrahmen
          //-------------------------------------------------------- Bauch
       zufallsStift( p );
       p->drawRect( mittex-50, mittey-50, 100, 100 ); // Bauch malen
          //--------------------------------------------------------- Kopf
       zufallsStift( p );
       p->drawEllipse( mittex-50, mittey-150, 100, 100 ); // Kopf malen
          //-------------------------------------------------------- Beine
       zufallsStift( p );
       p->drawRect( mittex-50, mittey+50, 20, 100 ); // Linkes Bein
       p->drawRect( mittex+30, mittey+50, 20, 100 ); // Rechtes Bein
          //--------------------------------------------------------- Arme
       zufallsStift( p );
       p->drawRect( mittex-100, mittey-50, 50, 20 ); // Linker Arm
       p->drawRect( mittex+50,  mittey-50, 50, 20 ); // Rechter Arm
          //-------------------------------------------------------- Augen
       zufallsStift( p );
       p->drawEllipse( mittex-20, mittey-100, 10, 10 ); // Linkes Auge
       p->drawEllipse( mittex+20, mittey-100, 10, 10 ); // Rechtes Auge
          //-------------------------------------------------------- Ohren
       p->drawArc( mittex-60, mittey-110, 20, 20, 75*16, 195*16 ); // Links
       p->drawArc( mittex+40, mittey-110, 20, 20, 90*16, -195*16 ); // Rechts
         //---------------------------------------------------------- Mund
       zufallsStift( p );
       p->drawArc( mittex-25, mittey-90, 50, 20, 180*16, 180*16 );
          //----------------------------------------------- Heiligenschein
       zufallsStift( p );
       p->drawArc( mittex-50, mittey-140, 100, 10, 130*16, 280*16 );
          //-------------------------------------------------------- Tisch
       zufallsStift( p );
       p->setBrush(
          QBrush( QColor( rand()&255, rand()&255, rand()&255 ),
          Qt::SolidPattern ) );
       p->drawEllipse( mittex+170, mittey+170, 100, 50);
       p->setBrush(
          QBrush( QColor( rand()&255, rand()&255, rand()&255 ),
          Qt::SolidPattern ) );
       p->drawEllipse( mittex+190, mittey, 60, 200 );
       p->setBrush(
          QBrush( QColor( rand()&255, rand()&255, rand()&255 ),
          Qt::SolidPattern ) );
       p->drawEllipse( mittex+120, mittey-50, 200, 100 );
    }
};

int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );
    srand( time(NULL) ); // Zufallszahlen-Generator initialisieren
    malFenster   bild;
    a.setMainWidget( &bild );
    bild.show();
    return a.exec();
}
