#include <qapplication.h>
#include <qfileinfo.h>
#include <iostream>
#include <iomanip>

using namespace std;

void perm( QFileInfo fi, int spec, QString c ) {
   if ( fi.permission(spec) )
      cout << c;
   else
      cout << "-";
}

int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );

    cout << setiosflags( ios::right );
    for ( int i=1; i<argc; i++) {
       QFileInfo  fi( argv[i] );
       if ( fi.isDir() )          cout << "d";
       else if ( fi.isSymLink() ) cout << "l";
       else                       cout << "-";

       perm( fi, QFileInfo::ReadOwner,  "r" );
       perm( fi, QFileInfo::WriteOwner, "w" );
       perm( fi, QFileInfo::ExeOwner,   "x" );
       perm( fi, QFileInfo::ReadGroup,  "r" );
       perm( fi, QFileInfo::WriteGroup, "w" );
       perm( fi, QFileInfo::ExeGroup,   "x" );
       perm( fi, QFileInfo::ReadOther,  "r" );
       perm( fi, QFileInfo::WriteOther, "w" );
       perm( fi, QFileInfo::ExeOther,   "x" );
    
       cout << " ";
       cout << setw(9)  << fi.owner();
       cout << setw(10) << fi.group();
       cout << setw(11) << fi.size();

       cout << " " << fi.lastModified().toString();
       cout << " " << fi.fileName();

       if ( fi.isSymLink() )
          cout << " -> " << fi.readLink();

       cout << endl;
    }
    return 0;
}
