#include <qmemarray.h>
#include <stdlib.h>
#include <stdio.h>

//............................................................... teufFolge
QMemArray<int> teufFolge( int startZahl ) 
{
    QMemArray<int> f;  // Leeres Array fuer int-Zahlen

      // Pruefen, ob positive ungerade Zahl uebergeben wurde
    if ( startZahl <= 0 || startZahl % 2 == 0 )
        return f;
    do {
       uint  len = f.size();
       f.resize( len+1 );  // Array um eine Stelle vergroessern
       f.at(len) = startZahl; // startZahl am Ende des Arrays einfuegen
       if ( startZahl % 2 == 0 )
          startZahl /= 2;
       else
          startZahl = (3*startZahl + 1) / 2;
    } while ( !f.contains( 1 ) );
    return f;
}

//.................................................................... main
int main( int argc, char *argv[] )
{
    QMemArray<int> a;

    if (argc < 2)
       return 1;

    a = teufFolge( atoi( argv[1] ) );
    for ( uint i=0; i<a.size(); i++ )
        printf( "%3d: %10d\n", i, a.at(i) );

    if ( a.size() > 0 ) {
       printf( "Zahl 1 ist %d mal enthalten\n", a.contains(1) );
       printf( "Zahl 5 befindet sich im Array beim Index %d\n", a.find(5) );
    }
    return 0;
}
