#include <qapplication.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qlineedit.h>
#include <qmessagebox.h>
#include <stdio.h>

QString typName[] = { "NoIcon", "Information", "Warning", "Critical", "Question"};
QString buttonName[] = { "NoButton", "Ok", "Cancel", "Yes",    "No",
                         "Abort", "Retry", "Ignore", "YesAll", "NoAll"    };
//......................................................... Klasse MyWidget
class MyWidget : public QWidget {
   Q_OBJECT
public:
   MyWidget() : caption(""), infoText("Informationstext") {
      texteMenu = new QPopupMenu;   //........................ Texte-Menu
      texteMenu->insertItem( "Caption", 0x1000 );
      texteMenu->insertItem( "Infotext", 0x1001 );
      entry = new QLineEdit( this );
      entry->setGeometry(10, 30, 100, 30 );
      entry->hide();
      connect( texteMenu, SIGNAL(activated(int)), SLOT(mySlot(int)) );
      connect( entry, SIGNAL(returnPressed()), SLOT(newText()) );

      iconMenu = new QPopupMenu;   //.......................... Icon-Menu
      for (int i=QMessageBox::NoIcon; i<= QMessageBox::Question; i++)
         iconMenu->insertItem( typName[i], i+0x2000 );
      iconMenu->setItemChecked( (icon = QMessageBox::NoIcon)+0x2000, true );
      connect( iconMenu, SIGNAL(activated(int)), SLOT(mySlot(int)) );

      for (int i=0; i<3; i++) {   //....................... button-Menues
         buttonMenu[i] = new QPopupMenu;
         for (int j=QMessageBox::NoButton; j<=QMessageBox::NoAll; j++)
            buttonMenu[i]->insertItem( buttonName[j], j+(i+1)*0x10000 );
         buttonMenu[i]->setItemChecked( (button[i] = i+1) + (i+1)*0x10000, true );
         connect( buttonMenu[i], SIGNAL(activated(int)), SLOT(mySlot(int) ) );
      }
      defaultMenu = new QPopupMenu;   //.................... Default-Menu
      defaultMenu->insertItem( "Button0", 0x4000   );
      defaultMenu->insertItem( "Button1", 0x4001 );
      defaultMenu->insertItem( "Button2", 0x4002 );
      defaultMenu->setItemChecked( 0x4000 + (defaultButton=0), true );
      button[defaultButton] |= QMessageBox::Default;
      connect( defaultMenu, SIGNAL( activated(int)), SLOT(mySlot(int) ) );

      escMenu = new QPopupMenu;   //............................ Esc-Menu
      escMenu->insertItem( "Button0", 0x5000 );
      escMenu->insertItem( "Button1", 0x5001 );
      escMenu->insertItem( "Button2", 0x5002 );
      escMenu->setItemChecked( 0x5000 + (escButton=2), true );
      button[escButton] |= QMessageBox::Escape;
      connect( escMenu, SIGNAL(activated(int)), SLOT( mySlot(int) ) );

      menuBalken = new QMenuBar( this );   //................ Menu-Balken
      menuBalken->insertItem( "Texte",   texteMenu );
      menuBalken->insertItem( "Icon",    iconMenu );
      menuBalken->insertItem( "Button0", buttonMenu[0] );
      menuBalken->insertItem( "Button1", buttonMenu[1] );
      menuBalken->insertItem( "Button2", buttonMenu[2] );
      menuBalken->insertItem( "Default", defaultMenu );
      menuBalken->insertItem( "Esc",     escMenu );
   }
private slots:
   void newText() {
      if (which == 0)
         caption = entry->text();
      else
         infoText = entry->text();
      entry->hide();
      neueMessage();
   }
   void mySlot( int s ) {
      if ( s == 0x1000 || s == 0x1001 ) {
         entry->setText( s == 0x1000 ? caption : infoText );
         entry->show();
         which = s % 0x1000;
      } else if (s >= 0x2000 && s <= QMessageBox::Question + 0x2000) {
         icon = QMessageBox::Icon( s-0x2000 );
         for (int i=QMessageBox::NoIcon; i<= QMessageBox::Question; i++)
            iconMenu->setItemChecked( i+0x2000, s-0x2000 == i );
         neueMessage();
      } else if (s >= 0x10000 && s <= 0x30000 ) {
          int nr = s / 0x10000 - 1,
              id = s % 0x10000;
          button[nr] = id;
          if ( nr == defaultButton )
             button[nr] |= QMessageBox::Default;
          if ( nr == escButton )
             button[nr] |= QMessageBox::Escape;
          for (int i=QMessageBox::NoButton; i <= QMessageBox::NoAll; i++)
             buttonMenu[nr]->setItemChecked( i+(nr+1)*0x10000, id == i );
          neueMessage();
      } else if (s >= 0x4000 && s <= 0x4002 ) {
         button[defaultButton] &= ~QMessageBox::Default;
         button[defaultButton=s-0x4000] |= QMessageBox::Default;
         for (int i=0x4000; i <= 0x40002; i++)
            defaultMenu->setItemChecked( i, s == i );
         neueMessage();
      } else if (s >= 0x5000 && s <= 0x5002 ) {
         button[escButton] &= ~QMessageBox::Escape;
         button[escButton=s-0x5000] |= QMessageBox::Escape;
         for (int i=0x5000; i <= 0x5002; i++)
            escMenu->setItemChecked( i, s == i );
         neueMessage();
      }
   }
private:
   void neueMessage() {
      QString neuInfoText;
      neuInfoText.sprintf("%s\n\n\n  (Button%d = Default-Button)\n"
                          "  (Button%d = Escape-Button)\n",
                   (const char *)infoText, defaultButton, escButton);
      QMessageBox *mb = new QMessageBox( caption, neuInfoText, icon,
                                     button[0], button[1], button[2], this ); 
      mb->setPaletteBackgroundColor( Qt::blue.light(150) );
      QString info;
      info.sprintf("Du hast den Button \"%s\" gewaehlt",
                   (const char *)buttonName[mb->exec()]);
      delete mb;
      QMessageBox::information( this, "Nur zur Info", info );
   }
   QMenuBar   *menuBalken;
   QPopupMenu *texteMenu, *iconMenu, *buttonMenu[3], *defaultMenu, *escMenu;
   QString     caption, infoText;
   int         button[3], defaultButton, escButton, which;
   QLineEdit  *entry;
   QMessageBox::Icon  icon;
};
#include "messagebox.moc"
//.................................................................... main
int main( int argc, char* argv[] ) {
   QApplication myapp( argc, argv );
   MyWidget*mywidget = new MyWidget();
   mywidget->setGeometry( 10, 10, 400, 300 );
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
