#include <qapplication.h>
#include <qwidget.h>
#include <qtable.h>

//......................................................... Klasse MyTable
class MyTable : public QTable
{
   Q_OBJECT
public:
    MyTable( int noRows, int noCols, QWidget* parent=0 )
                                 : QTable( noRows, noCols, parent ) {
       int  i, j;
       QString t;

       question.load( "question.xpm" );
       right.load( "pinguin.xpm" );
       wrong.load( "x.xpm" );
       setFont( QFont( "Helvetica", 16, QFont::Bold ) );
       resize( 600, 400 );

       for ( i=0; i < numRows(); i++ ) {
          for ( j=0; j < numCols(); j++ ) {
             t.sprintf( "%d x %d", i+1, j+1 );
             setText( i, j, t );
             setPixmap( i, j, question );
             adjustColumn( j );
          }
          adjustRow( i );
       }
       setCurrentCell( curRow = 0, curCol = 0 );

       QObject::connect( this, SIGNAL( valueChanged( int, int ) ),
                         this, SLOT( checkCurrent( int, int ) ) );
    }

private slots:
    void checkCurrent( int row, int col ) {
       QString t = text( row, col );
       bool ok = true;
       int input = t.toInt( &ok );
       if ( ok && input == (row+1)*(col+1) ) {
          setPixmap( row, col, right );
       } else {
          setPixmap( row, col, wrong );
          t.sprintf( "%d x %d", row+1, col+1 );
       }
       setText( row, col, t );
    }

private:
    int     curRow, curCol;
    QPixmap question, right, wrong;
};

#include "multtable.moc"

//................................................................... main
int main( int argc, char *argv[] )
{
   const int noRows = 30; 
   const int noCols = 30;

   QApplication a(argc,argv);   		

   MyTable t( noRows, noCols );

   a.setMainWidget( &t );
   t.show();
   return a.exec();
}
