#include <qapplication.h>
#include <qthread.h>
#include <stdio.h>

QMutex mutex;

//................................................... Klasse ThreadNoMutex
class ThreadNoMutex : public QThread
{
protected:
    void run() {
       printf( "Hallo, " ); msleep( 10 );
       printf( "wie " );    msleep( 10 );
       printf( "gehts " );  msleep( 10 );
       printf( "denn ");    msleep( 10 );
       printf( "so?\n" );
    }
};

//................................................. Klasse ThreadWithMutex
class ThreadWithMutex : public QThread
{
protected:
    void run() {
       mutex.lock();
       printf( "Hallo, " ); msleep( 10 );
       printf( "wie " );    msleep( 10 );
       printf( "gehts " );  msleep( 10 );
       printf( "denn ");    msleep( 10 );
       printf( "so?\n" );
       mutex.unlock();
    }
};

//................................................................... main
int main( int argc, char *argv[] ) {
    QApplication app( argc, argv );

    ThreadNoMutex tnm1,
                  tnm2;
    tnm1.start();
    tnm2.start();

    tnm1.wait();
    tnm2.wait();

    ThreadWithMutex twm1,
                    twm2;
    twm1.start();
    twm2.start();

    twm1.wait();
    twm2.wait();
    
    return 0;
}
