#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>

//........................................................ Klasse malFenster
class malFenster : public QWidget
{
public:
    malFenster() { setBackgroundMode( NoBackground ); }
protected:
    void paintEvent( QPaintEvent *event ) {
       int   rx = width()/20,
             ry = height()/20;

         //.... Pixmap mit passender Groesse erzeugen
       QPixmap  pix( event->rect().size() );

         //.... In pix und nicht in this nun zeichnen,
         //.... wobei Einstellungen von this bernommen werden
       QPainter p( &pix );

         //.... Koordinaten auf diesen Abschnitt transformieren
       p.setWindow( event->rect() );

         //.... Pixmap mit Hintergrund fuellen
       p.eraseRect( event->rect() );

       p.setPen( Qt::NoPen );
       for ( int i = 0; i < 10; i++ ) {
          QRect r( rx*i, ry*i, width()-rx*2*i, height()-ry*2*i );
          p.setBrush( i%2 ? Qt::black : Qt::white );
          p.drawRect( r );
       }

         //.... Pufferinhalt von pix in QPainter-Objekt kopieren
       bitBlt( this, event->rect().topLeft(), &pix );
    }
};

//..................................................................... main
int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );
    malFenster   bild;
    bild.setGeometry( 100, 100, 200, 200 );
    a.setMainWidget( &bild );
    bild.show();
    return a.exec();
}
