#include <qpainter.h>
#include <qmessagebox.h>
#include <qnp.h>
#include <stdlib.h>

//.................................................................. Nsplugin1
class Nsplugin1 : public QNPWidget {
    Q_OBJECT
public:
    void mousePressEvent(QMouseEvent*) {
       QMessageBox::about( this, "Nsplugin1",
                    "Qt-basierendes Plugin, das Text in ein Oval einbettet" );
    }

    void paintEvent(QPaintEvent* event) {
       QPainter p(this);
       p.setClipRect( event->rect() );
       int w = width();
       p.setPen( QPen( Qt::black, 5 ) );
       p.setBrush( Qt::white );
       p.drawRoundRect( rect(), 20, 20 );
       const char *fontFamily = instance()->arg("FONTFAMILY");
       if (fontFamily == 0 || strlen(fontFamily) == 0)
          fontFamily = "Helvetica";
       const char *fontSize = instance()->arg("FONTSIZE");
       int fSize;
       if (fontSize == 0 || strlen(fontSize) == 0)
          fSize = 24;
       else
          fSize = atoi(fontSize);
       p.setFont( QFont( fontFamily, fSize ) );
       p.drawText( w/8, 0, w-w/4, height(), AlignCenter|WordBreak,
                   "Mein erstes Plugin !\nToll, oder nicht");
    }
};

//.......................................................... Nsplugin1Instance
class Nsplugin1Instance : public QNPInstance {
    Q_OBJECT
public:
    QNPWidget* newWindow() { return new Nsplugin1; }
};

//............................................................ Nsplugin1Plugin
class Nsplugin1Plugin : public QNPlugin {
public:
    QNPInstance* newInstance() { return new Nsplugin1Instance; }

    const char* getMIMEDescription() const {
       return "Nsplugin1/very:xxx:Ein fiktives MIME (zum Schnuppern)";
    }

    const char * getPluginNameString() const {
       return "Nsplugin1 Qt-basierendes Plugin";
    }

    const char * getPluginDescriptionString() const {
       return "Qt-basierendes Plugin, das Text in ein Oval einbettet";
    }
};

//........................................................... QNPlugin::create
QNPlugin* QNPlugin::create()
{
    return new Nsplugin1Plugin;
}

#include "nsplugin1.moc"
