#include <qapplication.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qpainter.h>
#include <stdlib.h>
#include <time.h>

#define MAXX  1000
#define MAXY   600
//........................................................ Klasse MalFenster
class MalFenster : public QWidget {
 protected:
   virtual void mousePressEvent( QMouseEvent * ) {
      delete l;
      repaint( true );
   }
   virtual void paintEvent( QPaintEvent* ) {
      int     x, y;
      QColor  schicht[MAXX+1],
              schichtDrueber[MAXX+1];
      bool    nochOel = true;
         //.......... Beschaffenheit des Bodens zufaellig
      QString  s;
      int      prozent = rand() % 16 + 60; // 60..75%
      int      grenze = RAND_MAX/100*prozent;
      s.sprintf(" Bodendurchlssigkeit: %d %%", prozent );

      l = new QLabel( this );
      l->setGeometry( 0, MAXY, MAXX, 40 );
      l->setPaletteBackgroundColor( Qt::white );
      l->setText( s );
      l->show(); 
         //.......... Eindringen des Oels am Bildschirm simulieren
      QPainter maler( this ); // erzeugt QPainter-Objekt zum Zeichnen
      maler.setBackgroundColor( Qt::lightGray );

      for (x=0 ; x<=MAXX ; x++)
         schichtDrueber[x] = Qt::lightGray;
      for (x=MAXX/4 ; x<=MAXX*3/4 ; x++) {
         maler.setPen( schichtDrueber[x] = x%2 ? Qt::blue : Qt::lightGray );
         maler.drawPoint( x, 0 );
      }
      for (y=0 ; y<MAXY && nochOel; y++) {
         nochOel = false;
         for (x=0 ; x<=MAXX ; x++)
            if (schichtDrueber[x]==Qt::blue || schichtDrueber[x]==Qt::red) {
               nochOel = true;
               if ( x-1>=0 ) {
                  maler.setPen( schicht[x-1] =
                                rand()<=grenze ? Qt::blue : Qt::lightGray );
                  maler.drawPoint( x-1, y+1 );
               } 
               if ( x+1<=MAXX ) {
                  maler.setPen( schicht[x+1] =
                                rand()<=grenze ? Qt::red : Qt::lightGray );
                  maler.drawPoint( x+1, y+1 );
               }
            }
         for (x=0 ; x<=MAXX ; x++) {
            schichtDrueber[x] = schicht[x];
            schicht[x] = Qt::lightGray;
         }
      }
   }
 private:
   QLabel *l;
};
//..................................................................... main
int main( int argc, char* argv[] ) {
   QApplication myapp( argc, argv );
   srand( time(NULL) );
   MalFenster* mywidget = new MalFenster;
   mywidget->setGeometry( 50, 50, MAXX, MAXY+40 );
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
