#include <qdatetime.h>
#include <stdio.h>

//.......................................................... datumAusgabe
void easter( QDate date )
{
   int  ye = date.year();
   int  a = ye % 19,
        b = ye % 4,
        c = ye % 7,
        d, e, m, n;

   if ( ye < 1800 )      { m = 23; n = 3; }
   else if ( ye < 1900 ) { m = 23; n = 4; }
   else if ( ye < 2100 ) { m = 24; n = 5; }
   else if ( ye < 2200 ) { m = 24, n = 6; }
   else if ( ye < 2300 ) { m = 25, n = 0; }
   else if ( ye < 2400 ) { m = 26, n = 1; }
   else                  { m = 25, n = 1; }

   d = ( 19*a + m ) % 30;
   e = ( 2*b + 4*c + 6*d +n ) % 7;

   if ( 22+d+e <= 31 )                    date.setYMD( ye, 3, 22+d+e );
   else if ( d+e-9 == 26 )                date.setYMD( ye, 4, 19 );
   else if ( d+e-9==25 && d==28 && a>10 ) date.setYMD( ye, 4, 18 );
   else                                   date.setYMD( ye, 4, d+e-9 );

   printf("\n..................... Ostern %4d: %s\n"
          "    Aschermittwoch:      %s\n"
          "    Christi Himmelfahrt: %s\n"
          "    Pfingstsonntag:      %s\n"
          "    Fronleichnam:        %s\n",
       ye, (const char *)date.toString("ddd, dd.MMM.yyyy"),
       (const char *)date.addDays( -46 ).toString("ddd, dd.MMM.yyyy"),
       (const char *)date.addDays( 39 ).toString("ddd, dd.MMM.yyyy"),
       (const char *)date.addDays( 49 ).toString("ddd, dd.MMM.yyyy"),
       (const char *)date.addDays( 60 ).toString("ddd, dd.MMM.yyyy") );
}

//.................................................................. main
int  main(void)
{
   int year;

   QDate today( QDate::currentDate() ); //... Heutiges Datum
   QDate inputDate;             //... einzugebendes Datum

   printf("Welches Jahr (1782 - 2499): ");

   scanf("%d", &year);
   while ( year < 1782 || year > 2499) {
      printf("....Ungueltiges Jahr, ");
      printf("Welches Jahr (1782 - 2499): ");
      scanf("%d", &year);
   }

   easter( today );
   inputDate.setYMD( year, 1, 1 );
   easter( inputDate );

   return 0;
}
