#include "overlayout.h"
//................................................................ sizeHint
QSize OverLayout::sizeHint() const {
    QSize s(0,0);
    int n = list.count();
    if ( n > 0 )
        s = QSize(100,70); // einfach mal eine nette Annahme
    QPtrListIterator<QLayoutItem> it(list);
    QLayoutItem *o;
    while ( (o=it.current()) != 0 ) {
          // s, wenn noetig vergroessern
        s.expandedTo( o->minimumSize() );
        ++it;
    }
      // Rueckgabe der Ausmasse des groessten Elements plus
      // festgelegter Zischenraum zwischen den Elementen
    return s + n*QSize(spacing(),spacing());
}
//............................................................. minimumSize
QSize OverLayout::minimumSize() const {
    QSize s(0,0);
    int n = list.count();
    QPtrListIterator<QLayoutItem> it(list);
    QLayoutItem *o;
    while ( (o=it.current()) != 0 ) {
        s = s.expandedTo( o->minimumSize() );  // s, wenn noetig vergroessern
        ++it;
    }
      // Rueckgabe der Ausmasse des groessten Elements plus
      // festgelegter Zischenraum zwischen den Elementen
    return s + n*QSize(spacing(),spacing());
}
//............................................................. setGeometry
void OverLayout::setGeometry( const QRect &rect ) {
    QLayout::setGeometry( rect );

    QPtrListIterator<QLayoutItem> it( list );
    if ( it.count() == 0 )
        return;
    QLayoutItem *o;
    int w = rect.width() - ( list.count() - 1 ) * spacing();
    int h = rect.height() - ( list.count() - 1 ) * spacing();
    int i = 0;
    while ( ( o=it.current() ) != 0 ) {
        ++it;
          //.... Einzelne Elemente jeweils nacheinander um festgelegten
          //.... Zwischenraum immer nach links und nach unten verschieben
        o->setGeometry( QRect( rect.x() + i * spacing(),
                               rect.y() + i * spacing(), w, h ) );
        i++;
    }
}
