#ifndef OVERLAYOUT_H
#define OVERLAYOUT_H

#include <qlayout.h>
#include <qptrlist.h>
//................................................. Klasse OverLayoutIterator
class OverLayoutIterator : public QGLayoutIterator {
public:
  OverLayoutIterator( QPtrList<QLayoutItem> *l ) : pos(0), il(l) {}
  QLayoutItem *current()     { return pos < int(il->count()) ? il->at(pos) : 0;  }
  QLayoutItem *next()        { pos++;  return current();                         }
  QLayoutItem *takeCurrent() { return pos < int(il->count()) ? il->take(pos) : 0;}
private:
  int                pos;
  QPtrList<QLayoutItem> *il; // Liste mit QLayout-Elementen
};
//......................................................... Klasse OverLayout
class OverLayout : public QLayout {
public:
  OverLayout( QWidget *p, int space ) : QLayout( p, 0, space ) {}
  OverLayout( QLayout* p, int space ) : QLayout( p, space )    {}
  OverLayout( int space )             : QLayout( space )       {}
  ~OverLayout() { deleteAllItems(); } //.. loescht alle Elemente des Layouts
  void addItem( QLayoutItem *item ) { list.append( item ); }

  QLayoutIterator iterator() {        //.................. iterator
      return QLayoutIterator( new OverLayoutIterator( &list ) );
  }
    //..... sizeHint,  minimumSize und setGeometry (in .cpp implem.)
  QSize sizeHint() const;
  QSize minimumSize() const;
  void setGeometry( const QRect &rect );
private:
    QPtrList<QLayoutItem> list;
};
#endif
