#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <stdlib.h>
#include <time.h>

const char *penStyle[] = { "NoPen",   "SolidLine",   "DashLine",
                           "DotLine", "DashDotLine", "DashDotDotLine" };
const char *brushStyle[] = {
       "NoBrush",       "SolidPattern", 
       "Dense1Pattern", "Dense2Pattern", "Dense3Pattern", "Dense4Pattern",
       "Dense5Pattern", "Dense6Pattern", "Dense7Pattern",
       "HorPattern",    "VerPattern",    "CrossPattern", 
       "BDiagPattern",   "FDiagPattern", "DiagCrossPattern"              };
const int penStyleNr   = sizeof( penStyle ) / sizeof( penStyle[0] );
const int brushStyleNr = sizeof( brushStyle ) / sizeof( brushStyle[0] );
//........................................................ Klasse MalFenster
class MalFenster : public QWidget {
 protected:
   virtual void mousePressEvent( QMouseEvent * ) {
      repaint( true );
   }
   virtual void paintEvent( QPaintEvent* ) {
      int       breiteP = rand()%6, x, y;
      PenStyle  stilP = (PenStyle) (rand() % penStyleNr);
      QString   text;

      QPainter maler; // erzeugt QPainter-Objekt zum Zeichnen im Window
      maler.begin( this );    // Start des Zeichnens im Window
      maler.setPen( QPen( QColor( 0, 0, rand()&255 ), breiteP, stilP ) );
      text.sprintf(" Pen-Breite: %d, Pen-Stil: %s", breiteP, penStyle[stilP] );
      maler.drawText( 200, 50, text ); 
      maler.drawLine( 200, 60, 450, 60 );  // Linie: (200,60) -> (450,60)
      for (int i = 0; i< brushStyleNr; i++ ) {
         x = (i % 4) * 150+50;
         y = (i / 4) * 150+100;
         maler.setBrush( (BrushStyle) i );
         maler.drawRect( x, y+10, 100, 100 ); // Rechteck
         text.sprintf("%s", brushStyle[i] );
         maler.drawText( x, y, text ); 
      }
      maler.end();   // Beendigung des Zeichnens im Window
   }
};
//..................................................................... main
int main( int argc, char *argv[] ) {
   QApplication myapp( argc, argv );
   MalFenster* mywidget = new MalFenster();
   mywidget->setGeometry( 0, 0, 650, 700 );
   srand( time( NULL ) ); 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
