#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <qpointarray.h>
#include <stdlib.h>
#include <time.h>

const int  maxx = 600,  maxy = 600;
//........................................................ Klasse malFenster
class malFenster : public QWidget {
    Q_OBJECT
public:
    malFenster();
public slots:
    void neuMalen( int index ) {
       if ( index < maxIndex ) {
          bildIndex = index;
          update();
       }
    }
protected:
    void malen( QPainter *p ) {
       switch ( bildIndex ) {
          case 0:  zeichneFiguren( p );  break;
          case 1:  zeichnePolygone( p ); break;
          case 2:  zeichneFonts( p );    break;
          case 3:  zeichnePinguins( p ); break;
       }
    }
    void mousePressEvent(QPaintEvent *) { repaint( false ); }
    void paintEvent(QPaintEvent *)      { QPainter paint(this); malen(&paint); }
    void resizeEvent(QResizeEvent *)    { bgrp->move(width()-bgrp->width(),0); }
private:
    void zeichneFiguren( QPainter *p ) {  //................ zeichneFiguren
       p->setBrush( Qt::green.light(180) ); p->drawRect(10,10,maxx-50,maxy-100);
       p->setPen( Qt::red ); p->setBrush( Qt::blue ); p->drawRect(50,50,200,100);
       p->setBrush( QBrush( Qt::green, Qt::Dense6Pattern ) ); // gruen; 12%
       p->drawRoundRect( 50, 200, 200, 100, 80, 20 );         //
       p->setBrush( Qt::DiagCrossPattern );            //
       p->setPen( QPen( Qt::red, 2, Qt::SolidLine ) ); //
       p->drawPie( 50, 350, 200, 100, 45*16, 90*16 );  //
       p->setPen(QPen(Qt::blue,3,Qt::DashLine)); p->drawEllipse(300,50,200,100);
       p->setBrush(Qt::CrossPattern); p->drawChord(300,200,200,100,0*16,220*16);
       p->setPen( QPen( Qt::black, 2, Qt::SolidLine ) ); //
       p->drawArc( 300, 350, 200, 100, 10*16, 80*16 );   //
       p->setPen( QPen( Qt::red, 2, Qt::SolidLine ) );
       p->drawArc( 300, 350, 200, 100, 0, -160*16 );
    }
    void zeichnePolygone( QPainter *p ) {  //.............. zeichnePolygone
       QPointArray  poly( 9 );
       int  mx = maxx/2, my = maxy/2;
       bool ausfuellen = rand() % 2 == 0;
       p->setPen( Qt::red );
       p->setBrush( Qt::blue );
       p->drawRect( 0, 0, maxx, maxy );
       for ( int i=1; i<1000; i++ ) {
          poly.setPoint( 0, mx+rand()%mx,    my );              // 1.Eckpkt.
          poly.setPoint( 1, mx+20+rand()%50, my-20-rand()%50 ); // 2.Eckpkt.
          poly.setPoint( 2, mx,              my-rand()%my );    //  usw.
          poly.setPoint( 3, mx-20-rand()%50, my-20-rand()%50 );
          poly.setPoint( 4, mx-rand()%mx,    my );
          poly.setPoint( 5, mx-20-rand()%50, my+20+rand()%50 );
          poly.setPoint( 6, mx,              my+rand()%my );
          poly.setPoint( 7, mx+20+rand()%50, my+20+rand()%50 );
          poly.setPoint( 8, mx+rand()%mx,    my );              // 1.Eckpkt.
          if ( ausfuellen ) {
             p->setBrush( QBrush( QColor( rand()&255, rand()&255, rand()&255 ),
                                  Qt::SolidPattern ) );
             p->drawPolygon( poly, true, 0, 8 );
          } else {
             p->setPen( QPen( QColor( rand()&255, rand()&255, rand()&255 ) ) );
             p->drawPolyline( poly );
          }
          if (i%300 == 0) {
             for ( int j=0; j<8; j++ )
                poly.setPoint( j, rand()%maxx, rand()%maxy );
             p->setPen( QPen( QColor( rand()&255, rand()&255, rand()&255 ), 5 ) );
             p->drawLineSegments( poly );
             p->setPen( QPen( QColor( rand()&255, rand()&255, rand()&255 ), 1 ) );
          }
       }
    }
    void zeichneFonts( QPainter *p ) {  //.................... zeichneFonts
       static char *fonts[] = { "Helvetica", "Courier", "Times", 0 };
       static int    groesse[] = { 10, 24, 36, 0 };
       int y = 80;
       for ( int f=0; fonts[f] != 0; f++ )
          for ( int g = 0; groesse[g] != 0; g++ ) {
             QFont font( fonts[f], groesse[g] );
             p->setFont( font );
             QFontMetrics fm = p->fontMetrics();
             y += fm.ascent(); // + Anzahl der Pixel von Basislinie
                               // bis zur obersten Linie dieses Fonts
             p->setPen( Qt::green); p->drawLine( 0, y, 800, y );
              p->setPen( Qt::black);
              p->drawText( 10, y, "Zwlf Boxkmpfer jagen Victor quer" );
              y += fm.ascent();
             p->setPen( Qt::blue); p->drawLine( 0, y, 800, y );
              p->setPen( Qt::black);
              p->drawText( 10, y, "ber den groen Sylter Deich.");
              y += fm.descent(); // + Anzahl der Pixel von Basislinie
                                 // bis zur untersten Linie dieses Fonts
             p->drawLine( 0, y, 800, y );
             y+= 10;
          }
    }
    void zeichnePinguins( QPainter *p ) {  //.............. zeichnePinguins
       QPixmap ping;
       ping.load("penguin.xpm");
       p->setBrush( Qt::green.light( 120 ) );
       p->drawRect( 0, 0, maxx, maxy );
       p->drawTiledPixmap( 10, 10, maxx-20, maxy-20,
                           ping, rand()%100, rand()%100 );
    }
    QButtonGroup *bgrp;
    int           bildIndex, maxIndex;
};
//.............................................................. Konstruktor
malFenster::malFenster() {
    setCaption( "Demo zu Figuren und Text" );
     setPaletteBackgroundColor( Qt::yellow.light(180) );
    bgrp = new QButtonGroup( this ); // Gruppe von Buttons
     bgrp->resize( 200, 150 );
     connect( bgrp, SIGNAL(clicked(int)), SLOT(neuMalen(int)) );
    int maxBreite = 80; // Ausrechnen der Groesse fuer Buttongruppe
    int w;
    QFontMetrics fm = bgrp->fontMetrics();
    if ( ( w = fm.width( "Zeichne Figuren" )) > maxBreite)      maxBreite = w;
    if ( ( w = fm.width( "Zeichne Polygone" )) > maxBreite)     maxBreite = w;
    if ( ( w = fm.width( "Zeichne Fonts" )) > maxBreite)        maxBreite = w;
    if ( ( w = fm.width( "Pinguins als Kacheln" )) > maxBreite) maxBreite = w;
    maxBreite = maxBreite + 20; // 20 pixel dazu addieren

    QRadioButton *rb = new QRadioButton( "Zeichne Figuren", bgrp );
     rb->setGeometry( 10, 10, maxBreite, 30 );
     rb->setChecked( true );
     rb = new QRadioButton( "Zeichne Polygone", bgrp );
     rb->setGeometry( 10, 40, maxBreite, 30 );
     rb = new QRadioButton( "Zeichne Fonts", bgrp );
     rb->setGeometry( 10, 70, maxBreite, 30 );
     rb = new QRadioButton( "Pinguins als Kacheln", bgrp );
     rb->setGeometry( 10, 100, maxBreite, 30 );
    bildIndex = 0;   // erstes Bild zunaechst zeichnen
    maxIndex  = 4;
    resize( 800, 600 );
}
#include "painter2.moc"

int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    srand(time(NULL)); // Zufallszahlen-Generator initialisieren
    malFenster   bild;
    a.setMainWidget( &bild );
    bild.show();
    return a.exec();
}
