#include <qapplication.h>
#include <qpainter.h>
#include <stdlib.h>
#include <time.h>

//......................................................... Klasse MyWidget
class MyWidget : public QWidget
{
public:
   MyWidget() {
      setPaletteBackgroundColor( Qt::white ); 
   }    

protected:
    void paintEvent( QPaintEvent * ) {
       int  i;
       QPainter p( this );

       p.setBrush( Qt::yellow.light( 180 ) );
       p.drawRect( 0, 0, 300, 650 );
       p.setBrush( Qt::green.light( 180 ) );
       p.drawRect( 300, 0, 300, 650 );

       p.setBrush( Qt::SolidPattern );
       p.drawText( 30, 30, "save" );
       p.save();
       for ( i=0; i<20; i+=2 ) {
          QColor color1( ::rand()&255, ::rand()&255, ::rand()&255 );
          QColor color2( ::rand()&255, ::rand()&255, ::rand()&255 );
          p.setPen( QPen( color1, i, (Qt::PenStyle)(::rand()%6) ) );
          p.setBrush( QBrush( color2, (Qt::BrushStyle)(::rand()%16) ) );
          p.drawLine( 30, 40+i*30, 130, 40+i*30 );
          p.drawRect( 160, 40+i*30, 100, 30 );
          p.save();
       }

       for ( i=18; i>=0; i-=2 ) {
          p.restore();
          p.drawLine( 330, 40+i*30, 430, 40+i*30 );
          p.drawEllipse( 460, 40+i*30, 100, 30 );
       }
       p.restore();
       p.drawText( 330, 30, "restore" );
    }  

    void mousePressEvent( QMouseEvent * ) {
       repaint( true );
    }

};

//.................................................................... main
int main( int argc, char* argv[] )
{
   ::srand( time( NULL ) );
   QApplication myapp( argc, argv );

   MyWidget*mywidget = new MyWidget();
   mywidget->setFixedSize( 600, 650 );
   
   myapp.setMainWidget( mywidget );
   mywidget->show();
   
   return myapp.exec();
 }
