#ifndef BILDAUSWAHL_H
#define BILDAUSWAHL_H

#include <qgridview.h>
#include <qpixmap.h>
#define POSITION  rowAt(e->y()), columnAt(e->x())
//.................................................... Klasse Bildtabelle
class Bildtabelle : public QGridView {
    Q_OBJECT
public:
    //... Konstruktor, dem die Anzahl der Zeilen und Spalten
    //... der Bildertabelle uebergeben werden
    Bildtabelle( int zeilZahl, int spaltZahl, QWidget* p=0, const char* nam=0 );
    //... Destruktor; gibt den fr die Bilder reservierten
    //... Speicherplatz wieder frei
    ~Bildtabelle() { delete[] bilder; }
    //... legt fuer Zelle (i,j) den Dateinamen des
    //... anzuzeigenden Bildes bzw. das Bild selbst fest
    void setCell( int  i, int j, QString bildName );
    void setCell( int  i, int j, QPixmap bild );
    //... legt fuer alle Zellen deren Breite (w) und Hoehe (h) fest; auch
    //... Festlegung einer Rand- (border) und Rahmenbreite (frameWidth) mglich
    void setCellSize( int  w, int h, int border = 0, int frameWidth = 0 );
    //... setzt fuer Zelle (i,j) eine Markierung (mark=true) bzw.
    //... loescht eine Markierung fuer Zelle (i,j) bei mark=false
    void setCellMark( int i, int j, bool mark );
    //... liefert zurueck, ob  fuer Zelle (i,j) eine Markierung
    //... Markierung gesetzt ist oder nicht
    bool isCellMarkSet( int i, int j ) { return marks[ indexOf( i, j) ]; }
public slots:
       //... loescht die Markierungen aller Zellen 
    void resetAllMarks( void );
signals:
    void pressPos( int z, int s );
    void doubleClickPos( int z, int s );
    void movePos( int z, int s );
    void releasePos( int z, int s );
    void keyPressed( int key );
protected:
    void paintCell( QPainter*, int zeile, int spalte );
    void mousePressEvent(QMouseEvent *e)       { emit pressPos( POSITION );     }
    void mouseDoubleClickEvent(QMouseEvent *e) { emit doubleClickPos(POSITION); }
    void mouseMoveEvent(QMouseEvent *e)        { emit movePos(POSITION);        }
    void mouseReleaseEvent(QMouseEvent *e)     { emit releasePos(POSITION);     }
    void keyPressEvent(QKeyEvent *e)           { emit keyPressed(e->key());     }
private:
    int indexOf(int zeil, int spalt) const { return (zeil * numCols()) + spalt; }
    QPixmap  *bilder;
    bool     *marks;
    int      border, frameWidth;
};
#endif
