#include <qapplication.h>
#include <qpainter.h>
#include <qpicture.h>
#include <qpixmap.h>
#include <qwidget.h>
#include <qmessagebox.h>
#include <qfile.h>
//.................................................... class PictureDisplay
class PictureDisplay : public QWidget {
 public:
    PictureDisplay( const char *fileName ) {
       pict = new QPicture;
       name = fileName;
       if ( !pict->load(fileName) ) {
          delete pict;
          pict = 0;
          name.sprintf( "kann Picture %s nicht laden", fileName );
       }
    }
   ~PictureDisplay() { delete pict; }
 protected:
    void paintEvent( QPaintEvent * ) {
       QPainter paint( this );
       if ( pict )
          paint.drawPicture( 0, 0, *pict );
       else
          paint.drawText( rect(), AlignCenter, name );
       }
 private:
    QPicture   *pict;
    QString     name;
};
//.............................................................. paintHouse
void paintHouse( QPainter *p ) {
    QPointArray a;
    p->setPen( QPen( Qt::black, 5 ) );
    a.setPoints( 9, 200,400, 400,400, 200,250, 400,250, 300,100,
                    200,250, 200,400, 400,250, 400,400 );
    p->drawPolygon( a );
    p->setFont( QFont( "Helvetica", 18, QFont::Bold ) );
    p->setBrush( QBrush( Qt::blue.light(150) ) );
    p->setPen( QPen( Qt::black, 1 ) );
    p->drawRect( 20, 20, 250, 70 );
    p->drawText( 20, 20, 250, 70, Qt::AlignCenter,
                 "Das ist das Haus\nvom Nikolaus" );
    QPixmap pixmap;
    if ( pixmap.load("santa.png") )
       p->drawPixmap( 10, 150, pixmap );
}
//.................................................................... main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    const char *fileName = "house.pic";
    if ( argc == 2 )
       fileName = argv[1];
    if ( !QFile::exists(fileName) ) {
       QPicture pict;
       QPainter p;
       p.begin( &pict );
       paintHouse( &p );
       p.end();
       pict.save( fileName );
       QString t;
       t.sprintf( "Bild wurde aufgezeichnet...\n\n"
                  "Rufe nun `%s %s' auf!!", argv[0], fileName );
       QMessageBox::information( 0, "QPicture-Example", t);
       return 0;
    } else {
       PictureDisplay picture( fileName );
       picture.resize( 450, 450 );
       a.setMainWidget( &picture);
       picture.show();
       return a.exec();
    }
}
