#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qpointarray.h>
#include <stdlib.h>
#include <time.h>

//------------------------------------------ class MalFenster --------------
class MalFenster : public QWidget
{
public:
   MalFenster() {
       setBackgroundMode( NoBackground ); // beim Neumalen nicht loeschen
   }

protected:
   virtual void mousePressEvent( QMouseEvent* ) {
      mausPixel.resize( 0 );
      puffer.fill( white );
      bitBlt( this, 0, 0, &puffer );
   }

   virtual void mouseMoveEvent( QMouseEvent* event ) {
      uint  len = mausPixel.size(); 
      mausPixel.resize( len + 1 );
      mausPixel.at(len) = event->pos();
   }

   virtual void mouseReleaseEvent( QMouseEvent* ) {
      QPainter wMaler; // erzeugt QPainter-Objekt zum Zeichnen im Window
      QPainter pMaler; // erzeugt QPainter-Objekt zum Zeichnen im Puffer

      wMaler.begin( this );    // Start des Zeichnens im Window
      pMaler.begin( &puffer ); // Start des Zeichnens im Puffer
   
      int  len = mausPixel.size();
      for ( int i=0; i < len; i++)
         for ( int j=0; j<len; j++)
            if (i != j ) {
               int r = rand() % 256,
                   g = rand() % 256,
                   b = rand() % 256;
               wMaler.setPen( QColor( r, g, b ) );
               pMaler.setPen( QColor( r, g, b ) );
               wMaler.drawLine( mausPixel.at(i), mausPixel.at(j) );
               pMaler.drawLine( mausPixel.at(i), mausPixel.at(j) );
            }
      wMaler.end();   // Beendigung des Zeichnens im Window
      pMaler.end();   // Beendigung des Zeichnens im Puffer
   }

   virtual void paintEvent( QPaintEvent* ) {
      bitBlt( this, 0, 0, &puffer ); // kopiert Puffer-Bild auf Bildschirm
   }

   virtual void resizeEvent( QResizeEvent* event ) {
      QPixmap save( puffer );         
      puffer.resize( event->size() );
      puffer.fill( white );
      bitBlt( &puffer, 0, 0, &save );
   }

private:
   QPixmap     puffer;
   QPointArray mausPixel;
};

//------------------------------------------------------ main --------------
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   MalFenster* mywidget = new MalFenster();
   mywidget->setGeometry( 50, 50, 400, 400 );

   ::srand( time( NULL ) ); 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
