#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <stdlib.h>
#include <time.h>

#define width   600
#define height  500

QColor colors[] = {
          Qt::black,    Qt::white,    Qt::darkGray,    Qt::gray,
          Qt::red,      Qt::green,    Qt::blue,        Qt::cyan,
          Qt::magenta,  Qt::yellow,   Qt::darkRed,     Qt::darkGreen,
          Qt::darkBlue, Qt::darkCyan, Qt::darkMagenta, Qt::darkYellow };
const int colorNo = sizeof( colors ) / sizeof( colors[0] );

//------------------------------------------ class MalFenster --------------
class MalFenster : public QWidget
{
public:
   MalFenster() {
      currentColor = ::rand() % colorNo;
      startTimer( 40 ); // alle 1 Millisek. timerEvent aufrufen
      column.resize( width );
      for ( int i=0; i <width; i++ )
         column.setPoint( i, i, height );
   }

protected:
   virtual void timerEvent( QTimerEvent* ) {
      repaint( false );
   }

   virtual void paintEvent( QPaintEvent* ) {
      QPainter p( this );

      if ( ::rand() % 100 == 0 )
          currentColor = ::rand() % colorNo;
      p.setPen( colors[ currentColor ] );
 
      for ( int i=0; i<width; i++ )
         if ( rand() % 2 == 0 ) {
            int pos = column.point(i).y();
            if ( pos < 0 ) {
                pos = height;
                p.setPen( Qt::lightGray );
                for ( int j=0; j<height; j++ )
                    p.drawPoint( i, j );
                p.setPen( colors[ currentColor ] );
            }
            column.setPoint( i, i, --pos );
            p.drawPoint( column.point( i ) );
         }
   }

private:
   QPointArray column;
   int         currentColor;
};

//------------------------------------------------------ main --------------
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   MalFenster* mywidget = new MalFenster();
   mywidget->setGeometry( 50, 50, width, height );

   ::srand( time( NULL ) ); 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
