#include <qapplication.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qstring.h>
#include <qfileinfo.h>
#include <stdlib.h>
#include <stdio.h>

//........................................................ Klasse PostIstDa
class PostIstDa : public QWidget
{
public:
    PostIstDa( QWidget *parent=0, const char *name=0 );

protected:
    void timerEvent( QTimerEvent * ) {  //.................. timerEvent
       QFileInfo fi( briefKasten );
       if ( ( groesse = fi.size()) > altGroesse ) {
          postIstDa = true;
          altGroesse = groesse;
          repaint();
       } else if ( groesse < altGroesse ) {
          postIstDa = false;
          altGroesse = groesse;
          repaint();
       }
    }

    void mousePressEvent( QMouseEvent * ) {  //........ mousePressEvent
       QFileInfo fi( briefKasten );
       altGroesse = fi.size()+1;
    }

    void paintEvent( QPaintEvent * ) {  //.................. paintEvent
       if (postIstDa)
           fprintf(stderr, "\007");  // akustisches Signal
       bitBlt( this, 0, 0, postIstDa ? &postDaBild : &postLeerBild );
    }

private:
    QPixmap    postDaBild, postLeerBild;
    QString    briefKasten;
    uint       groesse, altGroesse;
    bool       postIstDa;
};

//................................................. PostIstDa (Konstruktor)
PostIstDa::PostIstDa( QWidget *parent, const char *name )
                                      : QWidget( parent, name ) {
    briefKasten = QString( getenv( "MAIL" ) ); 

    if ( briefKasten.isNull() ) {
       briefKasten = "/var/spool/mail/";
       briefKasten += QString( getenv( "LOGNAME" ) );
    }
    startTimer( 1000 );  // Jede Sek. nach neuer Post schauen

    postDaBild.load( "mail.xpm" );
    postLeerBild.load( "nomail.xpm" );
    resize( postDaBild.size() );

    QFileInfo fi(briefKasten);
    altGroesse = fi.size();
    postIstDa = false;
}

//.................................................................... main
int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );
    PostIstDa b;
    a.setMainWidget( &b );
    b.show();
    return a.exec();
}
