#include  <qapplication.h>
#include  <qlabel.h>
#include  <qlineedit.h>
//............................................................. Klasse Rechner
class Rechner : public QWidget {
   Q_OBJECT
public:
   Rechner() : basis(1), ergebnis(1), potenz(1) {
      basisEingabe = new QLineEdit( this );
       basisEingabe->setGeometry( 0, 0, 50, 30);
       basisEingabe->setText( "1" );
       basisEingabe->setPaletteBackgroundColor( QColor(0, 255, 255) );
      QLabel* label1 = new QLabel( "hoch", this );
       label1->setGeometry( 60, 0, 50, 30);
      potenzEingabe = new QLineEdit( this );
       potenzEingabe->setGeometry( 100, 0, 50, 30);
       potenzEingabe->setText( "1" );
       potenzEingabe->setPaletteBackgroundColor( QColor(0, 255, 255) );
      QLabel* label2 = new QLabel( "=", this );
       label2->setGeometry( 160, 0, 30, 30);
      ergebnisAnzeige = new QLabel( this );
       ergebnisAnzeige->setGeometry( 180, 0, 150, 30);
       ergebnisAnzeige->setNum( 1 );
       ergebnisAnzeige->setAlignment( QLabel::AlignCenter );
       ergebnisAnzeige->setPaletteBackgroundColor( QColor(0, 255, 255) );
      QObject::connect(basisEingabe, SIGNAL( textChanged( const QString & ) ),
                       this,         SLOT( neueBasis( const QString & ) ) );
      QObject::connect(potenzEingabe, SIGNAL( textChanged( const QString & ) ),
                       this,          SLOT( neuePotenz( const QString & ) ) );
   }
private slots:
   void neueBasis( const QString& neuWert ) {
      double bas = neuWert.toDouble(&ok);
      if (ok == true)
         basis = bas;
      berechne( basisEingabe );
   }
   void neuePotenz( const QString& neuWert ) {
      uint pot = neuWert.toUInt(&ok);
      if (ok == true)
         potenz = pot;
      berechne( potenzEingabe );
   }

private:
   QLineEdit *basisEingabe, *potenzEingabe;
   QLabel*    ergebnisAnzeige;
   double     basis, ergebnis;
   uint       potenz;
   bool       ok;

   void berechne( QLineEdit *eingabeWidget ) {
      if (ok == true) {
         uint  pot = potenz;
         ergebnis = 1;
         while (pot-- > 0)
             ergebnis *= basis;
         ergebnisAnzeige->setNum(ergebnis);
         eingabeWidget->setPaletteBackgroundColor( QColor( 0, 255, 255 ) );
         ergebnisAnzeige->setPaletteBackgroundColor( QColor( 0, 255, 255 ) );
      } else {
         eingabeWidget->setPaletteBackgroundColor( Qt::red );
         ergebnisAnzeige->setPaletteBackgroundColor( Qt::red );
         ergebnisAnzeige->setText( "undefiniert" );
      }
      repaint();
   }
};
#include "potenz.moc"
//...................................................................... main
int main( int argc, char *argv[] ) {
   QApplication  myapp( argc, argv );
   Rechner* mywidget = new Rechner();
   mywidget->setGeometry( 20, 20, 330, 30 );
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
