#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qprinter.h>
#include <qpixmap.h>
//------------------------------------------ class MalFenster --------------
class MalFenster : public QWidget {
 public:
   MalFenster() {
       meinDrucker = new QPrinter;
       setBackgroundMode( NoBackground ); // beim Neumalen nicht loeschen
   }
 protected:
   virtual void mousePressEvent( QMouseEvent* event) {
      letztepos = event->pos(); // Speichere die Koordinaten vom Event
   }
   virtual void mouseMoveEvent( QMouseEvent* event) {
      QPainter wMaler; // erzeugt QPainter-Object zum Zeichnen im Window
      QPainter pMaler; // erzeugt QPainter-Object zum Zeichnen im Puffer
      wMaler.begin( this );    // Start des Zeichnens im Window
      pMaler.begin( &puffer ); // Start des Zeichnens im Puffer
      wMaler.setPen( QPen( Qt::black, 5 ) );
      pMaler.setPen( QPen( Qt::black, 5 ) );
      wMaler.drawLine( letztepos, event->pos() ); // zeichnet Linie im Window
      pMaler.drawLine( letztepos, event->pos() ); // zeichnet Linie im Puffer
      wMaler.end();   // Beendigung des Zeichnens im Window
      pMaler.end();   // Beendigung des Zeichnens im Puffer
      letztepos = event->pos();  // merkt sich die akt. Mausposition
   }
   virtual void paintEvent( QPaintEvent* ) {
      bitBlt( this, 0, 0, &puffer ); // kopiert Puffer-Bild auf Bildschirm
   }
   virtual void resizeEvent( QResizeEvent* event ) {
      QPixmap save( puffer );
      puffer.resize( event->size() );
      puffer.fill( white );
      bitBlt( &puffer, 0, 0, &save );
   }
   virtual void mouseDoubleClickEvent( QMouseEvent* ) {
      if (meinDrucker->setup( this )) {
         QPainter p( meinDrucker );
         p.drawPixmap( 0, 0, puffer ); //... Bild auf Drucker kopieren
         p.drawRect( puffer.rect() );  //... Rahmen um Bild (auf Drucker)
      }
   }
private:
   QPoint    letztepos;
   QPixmap   puffer;
   QPrinter  *meinDrucker;
};
//------------------------------------------------------ main --------------
int main( int argc, char* argv[] ) {
   QApplication myapp( argc, argv );
   MalFenster* mywidget = new MalFenster();
   mywidget->setGeometry( 50, 50, 500, 500 );
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
