#include <qapplication.h>
#include <qpainter.h>
#include <qpaintdevicemetrics.h>
#include <qprinter.h>
#include <qmessagebox.h>
#include <qpixmap.h>

int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   QString msg;

   if (argc < 2) {
      msg.sprintf( "usage:  %s datei1 ", argv[0] );
      QMessageBox::information( 0, "Falscher Aufruf", msg, QMessageBox::Ok );
      return 1;
   }

   QPixmap bild;

   if ( !bild.load( argv[1] ) ) {
      msg.sprintf( "Kann Datei %s nicht laden ", argv[1] );
      QMessageBox::information( 0, "Falscher Aufruf", msg, QMessageBox::Ok );
      return 2;
   } 

   QPrinter meinDrucker;  // Einrichten eines QPrinter-Objekts

   //.... evtl. hier Standard-Einstellungen vornehmen
   // meinDrucker.setPrinterName( "training" );
   // meinDrucker.setPrintProgram( "lpr" );
   if ( meinDrucker.setup() ) { // nur, wenn Benutzer "OK" klickt
      QPainter druckerMaler( &meinDrucker );
      QPaintDeviceMetrics pdm( &meinDrucker );

      int wP = pdm.width(),    hP = pdm.height(),
          wPic = bild.width(), hPic = bild.height();
      int wDiff = wP - wPic,
          hDiff = hP - hPic;

      double  factor = 1;
      if ( wDiff < 0 || hDiff < 0 )
         if ( wDiff < hDiff )
            factor = (double)wP / wPic;
         else
            factor = (double)hP / hPic;

      druckerMaler.scale( factor, factor );
     
      druckerMaler.drawPixmap( 0, 0, bild );
      return 0;
   }
}
