#include <qapplication.h>
#include <qlabel.h>
#include <qprinter.h>
#include <qpainter.h>
#include <qpaintdevicemetrics.h>

class PrinterInfo: public QLabel
{
public:
    PrinterInfo() : QLabel( 0, 0 ) {
       QPrinter *printer = new QPrinter;
       if ( printer->setup() ) {
          QPaintDeviceMetrics printerWerte( printer );

          QString s;
          s.sprintf(" Druckername: %s\n"
                    " Hhe: %d\n"
                    " Hhe (in mm): %d\n"
                    " Breite: %d\n"
                    " Breite (in mm): %d\n"
                    " Seitenverhltnis: %f\n"
                    " Seitenverhltnis (Kehrwert): %f\n"
                    " Farbenzahl: %d\n",
                     (const char *)printer->printerName(),
                     printerWerte.height(),
                     printerWerte.heightMM(),
                     printerWerte.width(),
                     printerWerte.widthMM(),
                     (double)printerWerte.heightMM() / printerWerte.widthMM(),
                     (double)printerWerte.widthMM() / printerWerte.heightMM(),
                     printerWerte.numColors() );
          setCaption( "Informationen zu Ihrem Drucker" );
          setText( s );
          resize( 300, 200 );
          show();
       }
    }
};

int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );
    (void)new PrinterInfo();

    a.connect( &a, SIGNAL(lastWindowClosed()), &a, SLOT(quit()) );
    return a.exec();
}
