#include <qapplication.h>
#include <qprogressdialog.h>
#include <qpainter.h>
#include <qprinter.h>
#include <qdatetime.h>
#include <qpushbutton.h>
#include <qfont.h>

class Drucken : public QWidget {
    Q_OBJECT
public:
    Drucken() { 
       QPushButton *b = new QPushButton( "Drucken" , this );
       b->setGeometry( 50, 50, 100, 40 );
       connect( b, SIGNAL( clicked() ), this, SLOT( print() ) );
       resize( 200, 150 );
    }
private slots:
    void print() {
       drucker = new QPrinter( );
       drucker->setMinMax( 1, 10 );
       drucker->setOrientation( QPrinter::Landscape );

       if ( drucker->setup() ) {
          QString text;
          int maxSeite = drucker->toPage() > 10 ? 10 : drucker->toPage(); 
          druckStatus = new QProgressDialog( "", "Abbrechen",
                                             maxSeite - drucker->fromPage() + 1,
                                             this, "progress", true );
          druckStatus->setCaption( "Status des Druckvorgangs" );
          QTime zeit;   //... Eine Uhr
          zeit.start(); //... Uhr starten
          druckStatus->setProgress( 0 );
          qApp->processEvents();  // Einblenden/Aktualisieren des Progressdialogs
          QObject::connect( druckStatus, SIGNAL( canceled() ),
                            this,        SLOT( druckenAbbrechen() ) );
          QPainter p;
          p.begin( drucker );
          p.setFont( QFont( "Courier", 64, QFont::Bold ) );
          for (int s = drucker->fromPage(); s <= maxSeite; s++ ) {
             text.sprintf("..... Drucke gerade die Seite %d\n", s );
             druckStatus->setLabelText( text );
             druckStatus->setProgress( druckStatus->progress() + 1 );
             druckStatus->resize( druckStatus->sizeHint() );
             qApp->processEvents();  // Einblenden/Aktualisieren Progressdialog
             text.sprintf("..... Seite %d\n", s );
             p.drawText( 100, 100, text );
             if ( s < maxSeite )
                drucker->newPage();
             if (drucker->aborted() ) {
                p.end();
                return;
             }
             while ( zeit.elapsed() < 2000  ) // Alle 2 Sek. eine Seite drucken
                ;
             zeit.restart();  //... Uhr neu starten
          }
          p.end();
       }
    }
    void druckenAbbrechen() { drucker->abort(); }
private:
    QPrinter         *drucker;
    QProgressDialog  *druckStatus;
};
#include "printviel.moc"

int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    Drucken* langerDruck = new Drucken;
    a.setMainWidget( langerDruck );
    langerDruck->show();
    return a.exec();
}
