#include <qapplication.h>
#include <qtextedit.h>
#include <qdatetime.h>
#include <qprocess.h>

QTextEdit* edit;
QProcess* process;

class Leser : public QObject {
    Q_OBJECT
 public slots:
    void slotDataOnStdout() {
        while( process->canReadLineStdout() ) {
            QString line = process->readLineStdout();
            edit->append( line );
        }
    }
};

int main( int argc, char* argv[] ) {
    QApplication app( argc, argv );
      // Das Textedit-Fenster, das den Kalender anzeigt
    edit = new QTextEdit();
    app.setMainWidget( edit );
    edit->setFont( QFont( "Courier", 10 ) );
    edit->resize( 600, 550 );
    edit->show();
      // Der Leser, der die Standardausgabe liest
    Leser *reader = new Leser;
    process = new QProcess();
    process->addArgument( "cal" );
    process->addArgument( QDate::currentDate().toString("yyyy") );

    QObject::connect( process, SIGNAL( readyReadStdout() ),
                      reader,  SLOT( slotDataOnStdout() ) );
    if ( !process->start() )
        edit->append( "Konnte Prozess nicht starten" );
    int ret = app.exec();
    delete process;
    delete edit;
    return ret;
}
#include "process.moc"
