#include <qapplication.h>
#include <qtextedit.h>
#include <qprogressbar.h>
#include <qprocess.h>
#include <stdlib.h>
#include <time.h>

class Leser : public QObject {
    Q_OBJECT
 public:
    Leser( QWidget *widget, QProcess *proz) : proc(proz) {
       erstemal = true;
       text = new QTextEdit( widget );
       text->setGeometry(0, 0, 400, 300 );
       text->setFont( QFont( "Times", 12 ) );

       progressBar = new QProgressBar( widget );
       progressBar->setGeometry(0, 300, 400, 50 );
    }
    void cannotLaunch( void ) {
       text->append( "Konnte Prozess nicht starten" );
    }
 public slots:
    void slotDataOnStderr() {
        while ( proc->canReadLineStderr() ) {
            QString line = proc->readLineStderr();
            text->append( line );
            if (erstemal) {
               progressBar->reset();
               progressBar->setTotalSteps( line.toInt() );
               erstemal = false;
            }
            progressBar->setProgress ( line.toInt() );
        }
    }
 private:
    QProcess     *proc;
    QTextEdit    *text;
    QProgressBar *progressBar;
    int          wieoft;
    bool         erstemal;
};

#include "process2.moc"

int main( int argc, char* argv[] ) {
    QApplication app( argc, argv );
    ::srand(time(NULL));

    QWidget *widget = new QWidget;
    widget->setGeometry(50, 50, 400, 350 );

    QString anzahl;
    anzahl.sprintf("%d", ::rand()%21+5); // zwischen 5 und 25

      // Der Leser, der die Standardausgabe liest
    QProcess *process = new QProcess( QString("zaehle") );
    Leser *reader = new Leser( widget, process );
    QObject::connect( process, SIGNAL( readyReadStderr() ),
                      reader,  SLOT( slotDataOnStderr() ) );
    if ( !process->launch(anzahl) ) {
        reader->cannotLaunch();
        qApp->quit();
    }
    app.setMainWidget( widget );
    widget->show();
    QObject::connect( process, SIGNAL( processExited() ), qApp, SLOT( quit() ) );
    return app.exec();
}
