#include <qprogressdialog.h>
#include <qapplication.h>
#include <qlabel.h>
#include <stdlib.h>
#include <time.h>

class SechsWuerfel : public QWidget {
public:
    SechsWuerfel() : QWidget( 0 ) {
       int  i;
       QString  str;

       ::srand( time( NULL ) );
       resize( 600, 600 );
       setPaletteForegroundColor( Qt::white );
       for ( i=6; i<=36; i++ ) {
          str.sprintf("%d", i );
          label[i] = new QLabel( str, this );
          label[i]->setAlignment( Qt::AlignTop | Qt::AlignHCenter );
          label[i]->setPaletteBackgroundColor( Qt::darkBlue );
          augen[i] = 0;
       }
       max = 0;
       show();
       pb = new QProgressDialog( "Wrfeln mit sechs Wrfeln", "Abbrechen",
                                 100000000, this, 0, true );
       pb->setCaption( "Wrfeln mit sechs Wrfeln" );
       for ( i=0; i<=100000000; i++) {
          int wert = rand()%6 + rand()%6 + rand()%6 + 
                     rand()%6 + rand()%6 + rand()%6 + 6;
          if ( ++augen[wert] > max )
             max = augen[wert];
          if ( i%10000 == 0 ) {
             str.sprintf("%d Simulationen durchgefhrt\n", i );
             pb->setLabelText(str);
             pb->setProgress( i );
             factor = (double)height() / max;
             for ( int j=6; j<=36; j++ )
                label[j]->setGeometry( 
                            width()/31*(j-6)+1, int(height()-augen[j]*factor),
                            width()/31-2, int(augen[j]*factor) );
             pb->setProgress(i);
          }
          if ( pb->wasCanceled() )
             break;
       }
       pb->reset();
    }

private:
    int             max, augen[37];              
    QLabel          *label[37];
    double          factor;
    QProgressDialog *pb;
};

int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );

    SechsWuerfel* simulation = new SechsWuerfel;
    a.setMainWidget( simulation );
    simulation->show();
    return a.exec();
}
