#include <qapplication.h>
#include <qslider.h>
#include <qlcdnumber.h>
#include <qvariant.h>

#define ORIENT Qt::Horizontal
#define FILL   QLCDNumber::Filled

int main( int argc, char* argv[] ) {
   QApplication myapp( argc, argv );

   QWidget* mywidget = new QWidget();
   mywidget->setGeometry( 100, 100, 300, 200 );

   QSlider *slider1 = new QSlider(mywidget),
           *slider2 = new QSlider(mywidget);
   slider1->setGeometry( 10,  30, 180, 50 );
   slider2->setGeometry( 10, 120, 180, 50 );
   //... Normale Methode            ... gleicher Effekt mit setProperty
   slider1->setMinValue( 0 );       slider2->setProperty("minValue", 0 );
   slider1->setMaxValue( 99 );      slider2->setProperty("maxValue", 99 );
   slider1->setValue( 20 );         slider2->setProperty("value", 20 );
   slider1->setTracking( true );    slider2->setProperty("tracking", true );
   slider1->setOrientation(ORIENT); slider2->setProperty("orientation", ORIENT);

   QLCDNumber *lcdnum1 = new QLCDNumber( mywidget ),
              *lcdnum2 = new QLCDNumber( mywidget );
   lcdnum1->setGeometry( 200,  30, 80, 50 );
   lcdnum2->setGeometry( 200, 120, 80, 50 );
   //... Normale Methode           ... gleicher Effekt mit setProperty
   lcdnum1->display( 50 );         lcdnum2->setProperty("intValue", 50 );
   lcdnum1->setNumDigits( 2 );     lcdnum2->setProperty("numDigits", 2 );
   lcdnum1->setSegmentStyle(FILL); lcdnum2->setProperty("segmentStyle", FILL);

   QObject::connect( slider1, SIGNAL( valueChanged( int ) ), 
                     lcdnum1, SLOT( display( int ) ) );
   QObject::connect( slider2, SIGNAL( valueChanged( int ) ), 
                     lcdnum2, SLOT( display( int ) ) );
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
