#include <qstring.h>
#include <qptrlist.h>
#include <stdio.h>

//...................................................... Klasse Angestellter
class Angestellter {

public:
    Angestellter( const QString& name, int verdienst ) { n=name; v=verdienst; }
    QString     name()      const                      { return n; }
    int         verdienst() const                      { return v; }
private:
    QString     n;
    int         v;
};

//..................................................................... main
int  main( void )
{
   QPtrList<Angestellter> liste;     // Liste von Zeigern auf Angestellter

   liste.append( new Angestellter("Meyer Hans", 32000) );
   liste.append( new Angestellter("Aller Antonia", 37150) );
   liste.append( new Angestellter("Kohler Fritz", 52000) );

   QPtrListIterator<Angestellter> it(liste); // Iterator fuer Angestellter-Liste
   for ( ; it.current(); ++it ) {
      Angestellter *angest = it.current();
      printf( "%20s: %6d Euro\n", angest->name().ascii(), angest->verdienst() );
   } 
   printf("\n");

   liste.at( 1 );         // akt. Eintrag, auf den interner Listenzeiger
                          // zeigt: "Aller Antonia"
   it.toLast();     // it steht auf: "Kohler Fritz"
   --it;        // nun steht it auf: "Aller Antonia"
 
     // Eintrag "Aller Antonia" loeschen
     //     --> neuer akt. Eintrag: "Kohler Fritz"
   liste.remove();
   printf( "%s\n", (const char *)it.current()->name() );
   printf( "%s\n", (const char *)liste.current()->name() );

   return 0;
}
