#include <qwidget.h>
#include <qapplication.h>
#include <qradiobutton.h>
#include <qlabel.h>
#include <qsignalmapper.h>
#include <qlayout.h>

const int number[] = { 1, 5, 10, 100, 1000, 10000 };

//..................................................... Klasse RadioAdd
class RadioAdd: public QWidget {
    Q_OBJECT
public:
    RadioAdd() {
       QGridLayout *l = new QGridLayout( this, 6, 2, 20 );

       sum = 0;
       sm = new QSignalMapper( this );
       connect( sm,   SIGNAL( mapped( int ) ),
                this, SLOT( add( int ) ) );

       for ( int i=0; i<6; i++ ) {
          text.sprintf( "%d", number[i] );
          r[i] = new QRadioButton( text, this );
          l->addWidget( r[i], i, 0 );
          sm->setMapping( r[i], i );
          connect( r[i], SIGNAL( clicked() ),
                   sm,   SLOT( map() ) ); 
       }
       label = new QLabel( this );
       label->setAlignment( QLabel::AlignCenter );
       label->setPaletteBackgroundColor( Qt::white );
       label->setText( "       0       " );

       l->addMultiCellWidget( label, 1, 4, 1, 1 );
    }

private slots:
    void add( int id ) {
       text.sprintf( "%d", sum += number[id] );
       label->setText( text );
       r[id]->setChecked( false );
    }

private:
    int           sum;
    QSignalMapper *sm;
    QRadioButton  *r[6];
    QLabel        *label;
    QString       text;
};

#include "radioadd.moc"

//................................................................ main
int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );
    RadioAdd r;
    a.setMainWidget( &r );
    r.show();
    return a.exec();
}
