#include "rahmenlayout.h"
//................................................................. iterator
QLayoutIterator RahmenLayout::iterator() {
    return QLayoutIterator( new RahmenLayoutIterator( &list ) );
}
//................................................................. doLayout
void RahmenLayout::doLayout( const QRect &rect, bool /*testonly*/ ) {
    int  rechtsBreite=0, linksBreite=0, obenHoehe=0, untenHoehe=0, h=0;

    RahmenLayoutIterator it = RahmenLayoutIterator( &list );
    RahmenLayoutStruct *o, *center = 0;
    while ( ( o = it.currentStruct() ) != 0 ) {
        ++it;
        if ( o->pos == Oben ) {
            o->item->setGeometry( QRect( rect.x(), obenHoehe, rect.width(),
                                         o->item->sizeHint().height() ) );
            obenHoehe += o->item->geometry().height() + spacing();
        }
        if ( o->pos == Unten ) {
            o->item->setGeometry( QRect( o->item->geometry().x(),
                                         o->item->geometry().y(),
                                         rect.width(),
                                         o->item->sizeHint().height() ) );
            untenHoehe += o->item->geometry().height() + spacing();
            o->item->setGeometry(
                          QRect( rect.x(),
                                 rect.y() + rect.height() - untenHoehe + spacing(),
                                 o->item->geometry().width(),
                                 o->item->geometry().height() ) );
        }
        if ( o->pos == Mitte )
            center = o;
    }
    h = rect.height() - obenHoehe - untenHoehe;

    it.toFirst();
    while ( ( o = it.currentStruct() ) != 0 ) {
        ++it;
        if ( o->pos == Links ) {
            o->item->setGeometry( QRect( rect.x() + linksBreite, obenHoehe,
                                         o->item->sizeHint().width(), h ) );
            linksBreite += o->item->geometry().width() + spacing();
        }
        if ( o->pos == Rechts ) {
            o->item->setGeometry( QRect( o->item->geometry().x(),
                                         o->item->geometry().y(),
                                         o->item->sizeHint().width(), h ) );
            rechtsBreite += o->item->geometry().width() + spacing();
            o->item->setGeometry(
                   QRect( rect.x() + rect.width() - rechtsBreite + spacing(),
                          obenHoehe,
                          o->item->geometry().width(),
                          o->item->geometry().height() ) );
        }
    }
    if ( center )
        center->item->setGeometry(
                    QRect( linksBreite, obenHoehe,
                            rect.width() - rechtsBreite - linksBreite, h ) );
}
//.......................................................... berechneGroesse
void RahmenLayout::berechneGroesse( SizeType st ) {
    if ( ( st == Minimum && !msizeDirty ) ||
         ( st == SizeHint && !sizeDirty ) )
        return;
    int w = 0, h = 0;

    RahmenLayoutIterator it = RahmenLayoutIterator( &list );
    RahmenLayoutStruct *o;
    while ( ( o = it.currentStruct() ) != 0 ) {
        ++it;
        if ( o->pos == Oben || o->pos == Unten ) {
            if ( st == Minimum )
                h += o->item->minimumSize().height();
            else
                h += o->item->sizeHint().height();
        } else if ( o->pos == Links || o->pos == Rechts ) {
            if ( st == Minimum )
                w += o->item->minimumSize().width();
            else
                w += o->item->sizeHint().width();
        } else {
            if ( st == Minimum ) {
                h += o->item->minimumSize().height();
                w += o->item->minimumSize().width();
            } else {
                h += o->item->sizeHint().height();
                w += o->item->sizeHint().width();
            }
        }
    }
    if ( st == Minimum ) {
        msizeDirty = false;
        mcached = QSize( w, h );
    } else {
        sizeDirty = false;
        cached = QSize( w, h );
    }
}
