#include <qapplication.h>
#include <qlineedit.h>
#include <qvalidator.h>
#include <qregexp.h>
#include <qlabel.h>
#include <qvbox.h>
#include <stdio.h>
//............................................................ Klasse ipAdresse
class ipAdresse : public QVBox {
    Q_OBJECT
public:
    ipAdresse( QWidget *parent=0, const char *name=0 ) : QVBox( parent, name ) {
       setMargin( 10 );
       QVBox *box = new QVBox( this ); // Widget fuer das Layout
        box->setFont( QFont( "Times", 16 ) );
        box->setMargin( 5 );
        box->setSpacing( 20 );
        (void)new QLabel( "Geben Sie bitte eine IP-Adresse ein: ", box );
       eingabe = new QLineEdit( box );
       QRegExp ra( "[0-9][0-9]?[0-9]?\\.[0-9][0-9]?[0-9]?\\."
                   "[0-9][0-9]?[0-9]?\\.[0-9][0-9]?[0-9]?" );
        ipValidator = new QRegExpValidator( ra, this);
        eingabe->setValidator( ipValidator );
       logMeldung = new QLabel( "Noch nicht mit Eingabe begonnen", box );
        logMeldung->setFont( QFont( "Times", 16 ) );
        logMeldung->setPaletteBackgroundColor( Qt::blue.light(180) );
       QObject::connect( eingabe, SIGNAL( textChanged( const QString & ) ),
                         this,    SLOT( slotTextChanged( const QString & ) ) );
       QObject::connect( eingabe, SIGNAL( returnPressed() ),
                         this,    SLOT( slotReturnPressed() ) );
   }
private slots:
   void slotTextChanged( const QString &text ) {
       QString  t = text;
       int      pos;
       QValidator::State zustand = ipValidator->validate( t, pos );
       if ( zustand == QValidator::Acceptable ) {
          logMeldung->setPaletteBackgroundColor( Qt::green.light( 180 ) );
          t.sprintf("gltig, aber noch nicht besttigt: %s",
                    (const char *)text);
       } else if ( zustand == QValidator::Intermediate ) {
          logMeldung->setPaletteBackgroundColor( Qt::yellow.light( 160 ) );
          t.sprintf("gltig, aber noch nicht fertig; bisher: %s",
                    (const char *)text );
       }
       logMeldung->setText( t );
   }
   void slotReturnPressed() {
       QString  endeText;
       endeText.sprintf("Fertig und akzeptiert: %s",
                        (const char *)eingabe->text() ); 
       logMeldung->setText( endeText ); 
       logMeldung->setPaletteBackgroundColor( Qt::white );
   }
private:
   QRegExpValidator *ipValidator;
   QLineEdit        *eingabe;
   QLabel           *logMeldung;
};
#include "regexpvalidator.moc"
//........................................................................ main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    ipAdresse ip;
    ip.resize( 400, ip.sizeHint().height() );
    ip.setCaption( "Eingabe einer erlaubten IP-Adresse" );
    a.setMainWidget( &ip );
    ip.show();
    return a.exec();
}
