#include <qapplication.h>
#include <qwidget.h>
#include <qlabel.h>

//........................................................ Klasse MeinFenster
class MeinFenster : public QWidget
{
public:
   MeinFenster() {
      label = new QLabel( this );
      label->setGeometry( 20, rect().center().y()-20, width()-40, 40 );
      label->setFont( QFont( "Times", 12 ) );
      label->setPaletteBackgroundColor( Qt::white );
      label->setFrameStyle( QFrame::Box | QFrame::Raised );
      label->setLineWidth( 2 );
      label->setAlignment( AlignCenter );
   }

protected:
   virtual void resizeEvent( QResizeEvent* ev ) {
      QString t;
      t.sprintf( "  alte Gre: %d, %d; neue Gre: %d,%d",
                 ev->oldSize().width(), ev->oldSize().height(),
                 ev->size().width(), ev->size().height() );
      label->setGeometry( 20, rect().center().y()-20, width()-40, 40 );
      label->setText( t );
   }

private:
   QLabel  *label;
};

//.................................................................. main 
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   MeinFenster* mywidget = new MeinFenster();
   mywidget->setGeometry( 50, 50, 300, 200 );
   mywidget->setMinimumSize( 300, 200 );
 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
