#include <qapplication.h>
#include <qpushbutton.h>
#include <qtextbrowser.h>
#include <qbrush.h>
#include <qhbox.h>   // zum Anordnen der einzelnen Buttons
#include <qvbox.h>   //       ........
//........................................................ der anzuzeigende Text
static const char* texte[] = {
    "<b>1. Spruch:</b><br>"
      "<hr><br><br>"
      "<big>Der Mensch gleicht einem Bruch.<br>"
      "Der Zaehler ist, was er ist;<br>"
      "der Nenner, was er zu sein glaubt.<br>"
      "Je groesser der Nenner, desto kleiner der Bruch."
      "</big><br><br>"
      "<center><i>-- P. Ziehsen</i></center>",
    "<b>2. Spruch:</b><br>"
      "<hr><br><br>"
      "<big>Ein Mensch hoert staunend und empoert,<br>"
      "dass er, als Unmensch, alle stoert.<br>"
      "Er naemlich bildet selbst sich ein,<br>"
      "Der angenehmste Mensch zu sein.<br>"
      "Ein Beispiel macht Euch solches klar:<br>"
      "Der Schnarcher selbst schlaeft wunderbar.</big><br><br>"
      "<center><i>-- Eugen Roth, \"Ahnungslos\"</i></center>",
    "<b>3. Sprichwort:</b><br>"
      "<hr><br><br>"
      "<big>Wer nur einen Hammer besitzt,<br>"
      "fuer den sieht die ganze Welt wie ein Nagel aus.</big><br><br>"
      "<center><i>-- Sprichwort</i></center>",
    "<b>4. Sprichwort:</b><br>"
      "<hr><br><br>"
      "<big>Wirf Deinen Lendenschurz nicht fort,<br>"
      "wenn Du ein neues Kleid bekommen hast!</big><br><br>"
      "<center><i>-- Sprichwort aus dem Kongo</i></center>",
    "<b>5. Anekdote:</b><br>"
      "<hr><br><br>"
      "<big><b>Eine Anekdote von Mark Twain</b><br>"
      "<br><br>In besonders guter Laune fuehrte Mark Twain "
      "bei einem exklusiven Abendessen die Gemahlin "
      "des Gouverneurs zu Tisch."
      "<br>Galant sagte er: \"Wie schoen Sie sind, Madame!\" "
      "<br><br>Geschmeichelt nahm die Dame das Kompliment auf, "
      "entgegnete aber trotzdem boshaft: "
      "\"Wie schade, dass ich von Ihnen nicht dasselbe sagen kann.\""
      "<br><br>Mark Twain darauf: "
      "\"Machen Sie es wie ich, gnaedige Frau. Luegen Sie!\""
      "</big><br><br>",
    "<b>6. Ankedote:</b><br>"
      "<hr><br><br>"
      "<big>Alfred Polgar erhielt ein ausgeliehenes Buch "
      "voller Fettflecken zurueck.<br>"
      "Er schickte dem Entleiher eine Oelsardine und schrieb:<br>"
      "\"Ich bestaetige den Empfang meines Buches und "
      "erlaube mir, Ihnen anbei Ihr Lesezeichen zurueckzugeben.\""
      "</big><br><br>"
      "<center><i>-- Anekdote</i></center>",
    0
};
//.......................................................... Klasse MeinRichText
class MeinRichText : public QVBox {
    Q_OBJECT
public:
   MeinRichText( QWidget *parent=0, const char *name=0 ) : QVBox(parent, name) {
      setMargin( 5 );
      anzeige = new QTextBrowser( this );
       QBrush paper;
       paper.setPixmap( QPixmap( "marble.xpm" ) );
       anzeige->setPaper( paper );
       anzeige->setFont( QFont( "Times", 12 ) );
       anzeige->setText( texte[0] );
       anzeige->setMinimumSize( 450, 250 );
      QHBox *buttons = new QHBox( this );
       buttons->setMargin( 5 );
      bBeenden = new QPushButton( "&Beenden", this );
       QWidget *w = new QWidget( this );
       w->setMaximumHeight( bBeenden->sizeHint().height() );
      bZurueck = new QPushButton( "<< &Zurueck", buttons );
       bWeiter  = new QPushButton( "&Weiter >>", buttons );
      buttons->setMaximumHeight( bWeiter->sizeHint().height() + 10 );
       bZurueck->setEnabled( false );
      connect( bBeenden, SIGNAL( clicked() ), qApp, SLOT( quit() ) );
      connect( bZurueck, SIGNAL( clicked() ), this, SLOT( zurueck() ) );
      connect( bWeiter,  SIGNAL( clicked() ), this, SLOT( weiter() ) );
      nr = 0;
   }
protected:
   QTextBrowser *anzeige;
   QPushButton  *bBeenden, *bWeiter, *bZurueck;
   int nr;
protected slots:
   void zurueck() {
      if ( nr-- <= 0 )
         return;
      anzeige->setText( texte[nr] );
      bZurueck->setEnabled( nr > 0 );
      bWeiter->setEnabled( true );
   }
   void weiter() {
      if ( !texte[++nr] )
         return;
      anzeige->setText( texte[nr] );
      bWeiter->setEnabled( texte[nr + 1] );
      bZurueck->setEnabled( true );
   }
};
#include "richtext.moc"
//......................................................................... main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    MeinRichText richtext;
    richtext.resize( 450, 350 );
    richtext.setCaption( "Kluge Sprueche und Anekdoten" );
    a.setMainWidget( &richtext );
    richtext.show();
    return a.exec();
}
