#include <qapplication.h>
#include <qcolor.h>
#include <qpalette.h>
#include <qlabel.h>

QColor colors[] = {
          Qt::black,      Qt::white,    Qt::darkGray, Qt::gray,
          Qt::lightGray,  Qt::red,      Qt::green,    Qt::blue,
          Qt::cyan,       Qt::magenta,  Qt::yellow,   Qt::darkRed,
          Qt::darkGreen,  Qt::darkBlue, Qt::darkCyan, Qt::darkMagenta  };
const int colorNo = sizeof( colors ) / sizeof( colors[0] );
//.................................................. Klasse ColorLabel
class ColorLabel : public QLabel {
    Q_OBJECT
public:
    ColorLabel( QWidget* p=0, const char* name=0 ): QLabel(p, name) { }
protected:
    virtual void mousePressEvent( QMouseEvent *e ) {
       QRect  r = geometry();
       QMouseEvent  me( QEvent::MouseButtonPress,
                        QPoint( r.x() + e->pos().x(),
                                r.y() + e->pos().y() ),
                        QMouseEvent::LeftButton,
                        QMouseEvent::NoButton );
       QApplication::sendEvent( parentWidget(), &me );
    }
};
//.................................................... Klasse MyWidget
class MyWidget : public QWidget {
    Q_OBJECT
public:
    MyWidget( QWidget* p=0, const char* name=0 ): QWidget(p, name) {
       for ( int c=0; c<colorNo; c++ ) {
          l[c] = new ColorLabel( this );
          l[c]->setPaletteBackgroundColor( colors[c] );
          l[c]->setFrameStyle( QFrame::Box | QFrame::Raised );
          l[c]->setGeometry( width()-50, c*20, 50, 20 );
       }
    }
protected:
    virtual void mousePressEvent( QMouseEvent *e ) {
       if ( e->pos().x() > width()-50 && e->pos().y() < colorNo*20 )
          setPaletteBackgroundColor( l[e->pos().y()/20]->backgroundColor() );
    }
    virtual void resizeEvent( QResizeEvent * ) {
       for ( int c=0; c<colorNo; c++ )
          l[c]->setGeometry( width()-50, c*20, 50, 20 );
    }
private:
    ColorLabel *l[colorNo];
};
#include "sendevent.moc"
//............................................................... main
int main( int argc, char *argv[] ) {
    QApplication a(argc,argv);
    MyWidget w;
    a.setMainWidget( &w );
    w.resize( 450, 350 );
    w.show();
    return a.exec();
}
