#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <qpointarray.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
//........................................................ Klasse malFenster
class malFenster : public QWidget {
    Q_OBJECT
public:
    malFenster() {
       setCaption( "Weitere Demo zu Transformationen" );
       setPaletteBackgroundColor( Qt::yellow.light(180) );
       bgrp = new QButtonGroup( this ); // Gruppe von Buttons
        bgrp->resize( 200, 80 );
        bgrp->setPaletteBackgroundColor( Qt::lightGray );
        bgrp->setFont( QFont( "Times", 14 ) );
        connect( bgrp, SIGNAL(clicked(int)), SLOT(neuMalen(int)) );
       QRadioButton *rb = new QRadioButton( "Zeichne Farbenrad", bgrp );
        rb->setGeometry( 10, 10, 190, 30 );
        rb->setChecked( true );
        rb = new QRadioButton( "Zeichne Bezier-Text", bgrp );
        rb->setGeometry( 10, 40, 190, 30 );
       bildIndex = 0;   // erstes Bild zunaechst zeichnen
       resize( 800, 600 );
    }
public slots:
    void neuMalen( int index ) { bildIndex = index; update(); }
protected:
    void mousePressEvent( QPaintEvent * ) { repaint( false ); }
    void resizeEvent( QResizeEvent * ) { bgrp->move( width()-bgrp->width(), 0); }
    void paintEvent( QPaintEvent * ) {
       QPainter p( this );
       if (bildIndex==0)      zeichneFarbenRad( &p ); 
       else if (bildIndex==1) zeichneBezierText( &p );
    }
private:
    void zeichneFarbenRad( QPainter *p ) {  //............. zeichneFarbenRad
       p->setFont( QFont( "Times", 16, QFont::Bold ) );
        p->setWindow( 0, 0, 500, 500 );  // neues Koordinatensystem
        p->setViewport( 0, 0, 201+::rand()%300, 101+::rand()%300 );
        p->setBrush( Qt::white );
        p->drawRect( 0, 0, 500, 500 );
       for ( int i=0; i<36; i++ ) {  // 36 gedrehte Rechtecke zeichnen
           QWMatrix matrix;
            matrix.translate( 250.0, 250.0 ); // auf Mittelpkt. verschieben
            matrix.shear( 0.0, 0.6 );  // Scheren
            matrix.rotate( i*10.0 );   // Um 0,10,20,.. Grad drehen
            p->setWorldMatrix( matrix );
           QColor c;
            c.setHsv( i*10, 255, 255 ); // Regenbogen-Effekt
            p->setBrush( c );
            p->drawRect( 70, -10, 80, 10 ); // geflltes Rechteck zeichnen
           QString t;
            t.sprintf( "H=%d", i*10 );
            p->drawText( 80+70+5, 0, t );  // hue-Wert ausgeben
       }
    }
    void zeichneBezierText( QPainter *p ) {  //........... zeichneBezierText
       p->setWindow( 0, 0, 400, 300 );
        p->setViewport( 0, 0, 201+::rand()%400, 101+::rand()%400 );
        p->setBrush( Qt::white );
        p->drawRect( 0, 0, 400, 300 );
       QPointArray a( 4 );
        a.setPoint( 0, 100,200 );
        a.setPoint( 1, 150,75 );
        a.setPoint( 2, 250,75 );
        a.setPoint( 3, 300,200 );
        a = a.cubicBezier();  // Bezier-Kurve berechnen
        p->drawPolyline( a ); // Bezier-Kurve zeichnen 
       p->setFont( QFont( "Times", 24 ) );
        QString text( "Berg und Tal ");
        int ipos = a.size() / text.length();
        int cpos = ipos;
        for (unsigned i=0; i<text.length(); i++) { // fuer jedes Zeichen im Text
           QPoint p1 = a.point( cpos-1 );
           QPoint p2 = a.point( cpos+1 );
           QPoint pt = a.point(cpos);
           float dx = (p2.x() - p1.x());
           float dy = (p2.y() - p1.y());
           float winkel = atan(dy/dx);
           winkel *= 180.0 / (atan(1)*4);
           QWMatrix m;
            m.translate( pt.x(), pt.y() );
            m.rotate( winkel );
           p->setWorldMatrix( m );
            p->drawText( 0,0, text, i, 1 );
           cpos += ipos;
        }
    }
    QButtonGroup *bgrp;
    int          bildIndex;
};
#include "setviewport.moc"
//..................................................................... main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    malFenster   bild;
    a.setMainWidget( &bild );
    bild.show();
    return a.exec();
}
