#include <qapplication.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qevent.h>
#include <stdlib.h>

//........................................................ Klasse MeinFenster
class MeinFenster : public QWidget
{
   Q_OBJECT
public:
   MeinFenster() {
      setGeometry( 300, 50, 350, 200 );
      show();
   }

protected:
   virtual void showEvent( QShowEvent *ev ) {
      setPaletteBackgroundColor( QColor( rand()&255, rand()&255, rand()&255 ) );
      t.sprintf( "%sspontan sichtbar", ev->spontaneous() ? "" : "nicht " );
      emit andereTextFarbe( t, Qt::white );
   }

   virtual void hideEvent( QHideEvent *ev ) {
      t.sprintf( "%sspontan versteckt", ev->spontaneous() ? "" : "nicht " );
      emit andereTextFarbe( t, Qt::blue );
   }

   virtual void closeEvent( QCloseEvent *ev ) {
      ev->ignore();
      t.sprintf( "Schliessversuch" );
      emit andereTextFarbe( t, Qt::red.light( 180 ) );
   }

signals:
   void andereTextFarbe( QString, QColor );

private:
   QString  t;
};

//...................................................... Klasse SteuerFenster
class SteuerFenster : public QWidget
{
   Q_OBJECT
public:
   SteuerFenster() {
      myWindow = new MeinFenster();

      setCaption( "Steuerfenster" );
      setGeometry( 50, 50, 240, 300 );
      label = new QLabel( this );
      label->setAlignment( AlignCenter );
      label->setGeometry( 20, 20, 200, 100 );
      label->setPaletteBackgroundColor( Qt::white );

      QPushButton *s = new QPushButton( "Show", this );
      s->setGeometry( 20, 120, 200, 50 );
      QObject::connect( s, SIGNAL( clicked() ), myWindow, SLOT( show() ) ); 

      QPushButton *h = new QPushButton( "Hide", this );
      h->setGeometry( 20, 170, 200, 50 );
      QObject::connect( h, SIGNAL( clicked() ), myWindow, SLOT( hide() ) ); 

      QPushButton *q = new QPushButton( "Quit", this );
      q->setGeometry( 20, 220, 200, 50 );
      QObject::connect( q, SIGNAL( clicked() ), qApp, SLOT( quit() ) ); 

      show();

      QObject::connect(
         myWindow, SIGNAL( andereTextFarbe( QString, QColor ) ),
         this,     SLOT( setTextFarbe( QString, QColor ) ) ); 
   }

public slots:
   void setTextFarbe( QString text, QColor farbe ) {
      label->setPaletteBackgroundColor( farbe );
      label->setText( text );
   }

private:
   QLabel      *label;
   MeinFenster *myWindow;
};

#include "showhideclose.moc"

//.................................................................. main 
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   SteuerFenster* mywidget = new SteuerFenster();

   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
