#include <qsignal.h>
#include <qapplication.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <iostream>
using namespace std; 
//................................................ Klasse Receiver
class Receiver : public QWidget
{
    Q_OBJECT
public:
    Receiver() : QWidget( 0 ) {
       l = new QLabel( this );
       l->setGeometry( 0, 0, 300, 100 );
       l->setAlignment( QLabel::AlignCenter );
       l->setBackgroundColor( Qt::white );

       QPushButton *b = new QPushButton( "Quit", this );
       b->setGeometry( 0, 100, 300, 50 );
       connect( b, SIGNAL( clicked() ),
                qApp, SLOT( quit() ) );
       setGeometry( 100, 100, 300, 150 );
       show();
    }

public slots:
    void handleSignal() {
       l->setText( "You pressed the Return key" );
    }

private:
    QLabel *l;
};

//.................................................. Klasse Sender
class Sender
{
public:
    Sender() {
       Receiver *r = new Receiver();
       sig = new QSignal;
       connect( r, SLOT( handleSignal() ) );
    }
 
    ~Sender() {
       delete sig;
    }

    void sendSignal() {
       char  *text = new char [100];

       cout << "Please give me some Text" << endl;
       cin.getline( text, 100 );
       sig->activate();
    }
 
    void connect( QObject *receiver, const char *member ) {
       sig->connect( receiver, member );
    }
 
private:
    QSignal *sig;
};

#include "signal.moc"

//........................................................... main
int main( int argc, char *argv[] )
{
   QApplication a( argc, argv );
   Sender s;
   s.sendSignal();
   return a.exec();
} 
