#include <qapplication.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qframe.h>
#include <qsignalmapper.h>
//....................................................... Klasse Buttons
class Buttons : public QFrame {
   Q_OBJECT
public:
   Buttons( bool frame, QWidget *p ) : QFrame( p ), label(new QLabel(this) ) {
      if ( frame )
         setFrameStyle( QFrame::Box | QFrame::Sunken );
      QGridLayout *v = new QGridLayout( this, 4, 1, 10 );
      sm = new QSignalMapper( this );  //... Signalmapper-Objekt
      connect( sm,   SIGNAL( mapped( int ) ),
               this, SLOT( slotAlleButtons( int ) ) );
      for (int i=0; i<3; i++) {
         text.sprintf("Button %d", i+1);
         b[i] = new QPushButton( text, this );
         v->addWidget( b[i], i, 0 );
         sm->setMapping( b[i], i+1 ); //... Button b[i] hat Signal-Kennung 'i+1'
         connect( b[i], SIGNAL( clicked() ), sm, SLOT( map() ) );
      }
      label->setFont( QFont( "Times", 12 ) );
      label->setPalette( Qt::white );
      label->setText( " Noch kein Button gedrckt " );
      v->addWidget( label, 3, 0 );
   }
private slots:
   void slotAlleButtons( int i ) {
      text.sprintf( " Button %d gedrueckt ", i );
      label->setText( text );
   }
private:
   QSignalMapper *sm;
   QPushButton   *b[3];
   QLabel        *label;
   QString       text;
};
#include "signalmapper.moc"
//................................................................. main
int main( int argc, char* argv[] ) {
   QApplication myapp( argc, argv );
   QWidget* mywidget = new QWidget;
   QGridLayout *layout = new QGridLayout( mywidget, 1, 2, 20 );
   Buttons *buttons1 = new Buttons( true, mywidget );
    layout->addWidget( buttons1, 0, 0 );
   Buttons *buttons2 = new Buttons( false, mywidget );
    layout->addWidget( buttons2, 0, 1 );
   myapp.setMainWidget( mywidget );
   mywidget->show();
   mywidget->resize( mywidget->sizeHint() );
   return myapp.exec();
}
