#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qimage.h>
//....................................................... class SmoothScale
class SmoothScale : public QWidget {
 public:
    SmoothScale(QWidget* parent = 0) : QWidget( parent ) {
       setPaletteBackgroundColor( Qt::white );
       QApplication::setOverrideCursor( waitCursor );
       img.load("lausbub.xpm");
       QApplication::restoreOverrideCursor();
    }
 protected:
    void paintEvent( QPaintEvent * ) {
       male( 150, 100, 70 );
       male( 70, 150, 320 );
    }
    void male( int xs, int ys, int off ) {   
       scaleFree.convertFromImage(img.smoothScale(xs, ys, QImage::ScaleFree));
       scaleMin.convertFromImage(img.smoothScale(xs, ys, QImage::ScaleMin)); 
       scaleMax.convertFromImage(img.smoothScale(xs, ys, QImage::ScaleMax)); 
       QString text;
       text.sprintf("%d x %d", xs, ys );
       QPainter p( this );
       p.setFont( QFont( "Times", 20 ) );
       p.drawText( 20, off-40, text );
       p.setFont( QFont( "Times", 14 ) );
       p.setPen( QPen( Qt::black, 3 ) );
       p.drawPixmap( 20, off, scaleFree ); p.drawText( 20, off-10, "ScaleFree");
       p.drawPixmap( 200, off, scaleMin ); p.drawText( 200, off-10, "ScaleMin");
       p.drawPixmap( 380, off, scaleMax ); p.drawText( 380, off-10, "ScaleMax");
       p.drawRect(  20, off, xs, ys);
       p.drawRect( 200, off, xs, ys);
       p.drawRect( 380, off, xs, ys);
    }
 private:
    QImage   img;
    QPixmap  scaleFree, scaleMin, scaleMax;
};
//.................................................................... main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    SmoothScale *s = new SmoothScale();
    s->setGeometry( 50, 50, 550, 500 );
    s->show();
    a.setMainWidget( s );
    return a.exec();
}
