#include <qapplication.h>
#include <qmainwindow.h>
#include <qsound.h>
#include <qmessagebox.h>
#include <qmenubar.h>

class SoundPlayer : public QMainWindow {
    Q_OBJECT
public:
    SoundPlayer() : QMainWindow(), beethoven("fuenfte.wav"), applaus("applause.wav") {
       if ( !QSound::available() ) {
          QMessageBox::warning(this, "Kein Sound",
             "Fehlendes Network Audio System (NAS) oder keine Soundkarte" );
       }
       QPopupMenu *file = new QPopupMenu;
       file->insertItem("&Natur",     this, SLOT(spielNatur()),     CTRL+Key_N);
       file->insertItem("&Wellen",    this, SLOT(spielWellen()),    CTRL+Key_W);
       file->insertItem("&Applaus",   this, SLOT(spielApplaus()),   CTRL+Key_A);
       file->insertItem("&Beethoven", this, SLOT(spielBeethoven()), CTRL+Key_B);
       file->insertSeparator();
       file->insertItem("A&pplaus und Beethoven zugleich", this, SLOT(spiel34()));
       file->insertItem("&Alle zugleich",  this, SLOT(spiel1234()));
       file->insertSeparator();
       file->insertItem("Applaus &immerzu", this, SLOT(applausImmerzu()));
       file->insertItem("Beethoven &3 mal", this, SLOT(beethoven3Mal()));
       file->insertSeparator();
       file->insertItem("&Beenden",  qApp, SLOT(quit()));
       menuBar()->insertItem("&Datei", file);
    }
public slots:
    void spielNatur()     { QSound::play("nature.wav");              }
    void spielWellen()    { QSound::play("waves.wav");               }
    void spielApplaus()   { applaus.play();                          }
    void spielBeethoven() { beethoven.play();                        }
    void spiel34()        { applaus.play(); beethoven.play();        }
    void spiel1234()      { spielNatur(); spielWellen(); spiel34();  }
    void applausImmerzu() { applaus.setLoops(-1); applaus.play();    }
    void beethoven3Mal()  { beethoven.setLoops(3); beethoven.play(); }
private:
    QSound beethoven, applaus;
};
#include "sound.moc"
int main(int argc, char *argv[]) {
    QApplication app(argc,argv);
    SoundPlayer sp;
    app.setMainWidget(&sp);
    sp.show();
    return app.exec();
}
