#include <qapplication.h>
#include <qmainwindow.h>
#include <qsound.h>
#include <qfiledialog.h>
#include <qmessagebox.h>

//.................................................... Klasse SoundChoice
class SoundChoice : public QFileDialog {
    Q_OBJECT
public:
    SoundChoice(const char *dir) : QFileDialog(dir, "*.wav") {
        setMode( ExistingFile );
        connect(this, SIGNAL( fileSelected(const QString&) ),
                this, SLOT( playSound(const QString&) ));
    }

private slots:
    void done( int r ) {
       if ( r != Accepted )
          qApp->quit(); //... Ende bei `Cancel'
       setResult( r );
    }

    void playSound( const QString& fileName ) {
       if ( fileName )
          QSound::play( fileName );
    }
};

#include "sound2.moc"

//.................................................................. main
int main( int argc, char *argv[] )
{
    QApplication a(argc,argv);

    if ( !QSound::available() )
       QMessageBox::warning(0, "Kein Sound",
          "Fehlendes Network Audio System (NAS) oder keine Soundkarte" );

    SoundChoice* sc = new SoundChoice(".");

    a.setMainWidget( sc );
    sc->show();

    return a.exec();
}
