#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
const int     maxx = 500, maxy = 500;
const double  PI = 4*atan(1), bogMass = PI/180;
//........................................................ Klasse malFenster
class malFenster : public QWidget {
 public:
    malFenster() { berechneMinMax(); }
 protected:
    void mousePressEvent( QMouseEvent * ) {
       berechneMinMax();
       repaint( true );
    }
    void paintEvent( QPaintEvent * ) {
       QString text;
       QPainter  p( this );
       p.setFont( QFont( "Times", 12 ) );
       text.sprintf("Winkel=%d; Anzahl=%d", winkel, anzahl );
       p.drawText( 10, 15, text );
       p.setWindow( int(xMin), int(yMin), int(xMax-xMin+1), int(yMax-yMin+1) );
       p.setPen( Qt::blue );
       xAlt = yAlt = drehWinkel = 0;
       do {
          for ( int i=1 ; i<=anzahl ; i++ ) {
             x = xAlt + cos( drehWinkel*bogMass ) * i;
             y = yAlt + -sin( drehWinkel*bogMass ) * i;
             p.drawLine( int(xAlt), int(yAlt), int(x), int(y) );
             drehWinkel = ( drehWinkel + winkel ) % 360;
             xAlt = x;
             yAlt = y;
          }
          p.setPen( QColor( ::rand()&255, ::rand()&255, ::rand()&255 ) );
       } while ( drehWinkel != 0 );
    }
 private:
    void berechneMinMax( void ) {
       winkel = rand() % 360+1;
       anzahl = rand() % 1000+1;
       x = y = drehWinkel = 0;
       xMax = yMax = -100000;
       xMin = yMin = 100000;
       do {  //...... Probelauf mit Berechnung von xMin, xMax, yMin, yMax
          for ( int i=1 ; i<=anzahl ; i++ ) {
             x += cos( drehWinkel*bogMass ) * i;
             y += -sin( drehWinkel*bogMass ) * i;
             drehWinkel = ( drehWinkel + winkel ) % 360;
             if ( x<xMin ) xMin=x;
             if ( y<yMin ) yMin=y;
             if ( x>xMax ) xMax=x;
             if ( y>yMax ) yMax=y;
          }
       } while ( drehWinkel !=0 );
    }
    int     winkel, anzahl, drehWinkel;
    double  x, y, xAlt, yAlt, xMax, xMin, yMax, yMin;
};
//..................................................................... main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    malFenster   bild;
    ::srand( time( NULL ) );
    bild.setGeometry( 100, 100, maxx, maxy );
    a.setMainWidget( &bild );
    bild.show();
    return a.exec();
}
