#include <qapplication.h>
#include <qlabel.h>
#include <qsplitter.h>
#include <qtextedit.h>
#include <qpainter.h>
#include <stdlib.h>
#include <time.h>

static const char *zahl[] = { "Eins", "Zwei", "Drei", "Vier", "Fuenf" };
//........................................................ Klasse Billard
class Billard : public QWidget {
  public:
    Billard( QWidget* parent=0, const char* name=0, int f=0 ) :
                                        QWidget(parent, name, f) {
        p = new QPainter( this );
        p->setBrush( QColor( ::rand()%255, ::rand()%255, ::rand()%255 ) );
        x = y = 5;
        dx = dy = 1;
        startTimer(2); // alle 2 Millisek. Signal schicken (timerEvent
                       // aufrufen), um Bild zu aktualisieren
    }
    ~Billard() { delete p; }
    void timerEvent( QTimerEvent * ) {
       repaint( false ); // false: altes Bild nicht loeschen
    }
    void paintEvent( QPaintEvent * ) { //... Billardkugel laufen lassen
        int w = width()-30, h = height()-30;
 
        if (x+dx >= w || x+dx <= 0) dx = -dx;
        if (y+dy >= h || y+dy <= 0) dy = -dy;
        x += dx;
        y += dy;
        if (x > w) x = w;
        if (y > h) y = h;
        if (x <= 0) x = 30;
        if (y <= 0) y = 30;
        p->drawEllipse( x, y, 30, 30 );
    }
  private:
    int      x, y, dx, dy;
    QPainter *p;
};
//.................................................................. main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    ::srand(time(NULL));
     //... Hauptsplitter, in dem vertikal drei Subsplitter angeordnet werden
    QSplitter *s1 = new QSplitter( Qt::Vertical, 0 , "main" );
    s1->setGeometry( 0, 0, 600, 400 );
     //... Oberer Subsplitter mit fuenf horizontal angeordneten Subsplittern
    QSplitter *s2 = new QSplitter( Qt::Horizontal, s1, "top" );
    for (int i=0; i<5; i++) {
       QString s;
       s.sprintf("Label %s", zahl[i] );
       QLabel *l = new QLabel( s, s2 );
       l->setMinimumSize( l->sizeHint() );
       QColor farbe( ::rand()&255, ::rand()&255, ::rand()&255 ); 
       l->setPaletteBackgroundColor( farbe );
    }
     //... Mittlerer Subsplitter mit zwei horizontal angeordneten Subsplittern
    QSplitter *s3 = new QSplitter( Qt::Horizontal, s1, "medium" );
     Billard *b1 = new Billard( s3 );
      b1->setPaletteBackgroundColor( Qt::blue.light(180) );
      b1->setMinimumSize( 150, 150 );
     Billard *b2 = new Billard( s3 );
      b2->setPaletteBackgroundColor( Qt::green.light(180) );
      s3->setResizeMode( b2, QSplitter::KeepSize );
     //... Unterer Subsplitter mit drei horizontal angeordneten Subsplittern
    QSplitter *s4 = new QSplitter( Qt::Horizontal,  s1, "bottom" );
     Billard *b3 = new Billard( s4 );
      b3->setPaletteBackgroundColor( Qt::red.light(180) );
     Billard *b4 = new Billard( s4 );
      b4->setPaletteBackgroundColor( Qt::white );
     Billard *b5 = new Billard( s4 );
      b5->setMaximumHeight( 250 );
      b5->setMinimumSize( 80, 100 );
      b5->setPaletteBackgroundColor( Qt::yellow.dark(120) );
     //... Subwidgets der Splitter s1, s2 und s4
     //... erfahren sofort alle Resize-Events
    s1->setOpaqueResize( true );
    s2->setOpaqueResize( true );
//    s3->setOpaqueResize( true );  // s3 nicht
    s4->setOpaqueResize( true );
    a.setMainWidget( s1 );

    s1->show();
    return a.exec();
}
