#include <qapplication.h>
#include <qsplitter.h>
#include <qpainter.h>
#include <stdlib.h>
#include <time.h>

QColor farben[] = { Qt::gray,      Qt::red,      Qt::green,  Qt::blue,
                    Qt::cyan,      Qt::magenta,  Qt::yellow, Qt::darkRed,
                    Qt::darkGreen, Qt::darkBlue, Qt::darkCyan,
                    Qt::darkMagenta, Qt::darkYellow                     };
  
//........................................................ Klasse Billard
class Billard : public QWidget {
public:
    Billard( QWidget* parent=0, const char* name=0, int f=0 ) :
                                        QWidget(parent, name, f) {
        p = new QPainter( this );
        startTimer(0);
        f = 0;
        x = y = 1;
        dx = dy = 1;
        z = farbWechsel = ::rand() % 1000;
    }
    ~Billard() { delete p; }

    void timerEvent( QTimerEvent * ) {
       repaint( false ); // false: altes Bild nicht loeschen
    }

    void paintEvent( QPaintEvent * ) { //... Billardkugel laufen lassen
        int w = width(), h = height();
 
        if ( ++z >= farbWechsel ) {
           if ( ++f > 12 )
              f = 0;
           p->setPen( farben[f] );
           z = 0;
        }
        if (x+dx >= w || x+dx <= 0)
           dx = -dx;
        if (y+dy >= h || y+dy <= 0)
           dy = -dy;
        x += dx;
        y += dy;

        if (x > w) x = w;
        if (y > h) y = h;

        p->drawPoint( x, y );
    }

private:
    QPainter *p;
    int      x, y, dx, dy, farbWechsel, z, f;
};

//.................................................................. main
int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );

    ::srand(time(NULL));

     //... Hauptsplitter, in dem vertikal drei Subsplitter angeordnet werden
    QSplitter *s1 = new QSplitter( QSplitter::Vertical, 0 , "main" );
    s1->setGeometry( 0, 0, 600, 400 );

     //... Oberer Subsplitter mit zwei horizontal angeordneten Subsplittern
    QSplitter *s2 = new QSplitter( QSplitter::Horizontal, s1, "medium" );
     Billard *b1 = new Billard( s2 );
      b1->setBackgroundColor( Qt::blue.light(180) );
      b1->setMinimumSize( 150, 150 );
     Billard *b2 = new Billard( s2 );
      b2->setBackgroundColor( Qt::green.light(180) );
      s2->setResizeMode( b2, QSplitter::KeepSize );
      s2->moveToFirst( b2 );

     //... Unterer Subsplitter mit drei horizontal angeordneten Subsplittern
    QSplitter *s3 = new QSplitter( QSplitter::Horizontal,  s1, "bottom" );
     Billard *b3 = new Billard( s3 );
      b3->setBackgroundColor( Qt::red.light(180) );
     Billard *b4 = new Billard( s3 );
      b4->setBackgroundColor( Qt::white );
     Billard *b5 = new Billard( s3 );
      b5->setMaximumHeight( 250 );
      b5->setMinimumSize( 80, 100 );
      b5->setBackgroundColor( Qt::yellow.dark(120) );

     //... Subwidgets der Splitter s1, s2 und s3
     //... erfahren sofort alle Resize-Events
    s1->setOpaqueResize( true );
//    s2->setOpaqueResize( true );  // s2 nicht
    s3->setOpaqueResize( true );

    a.setMainWidget( s1 );
    s1->show();
    return a.exec();
}
