#include  <ctype.h>
#include  <math.h>
#include  <iostream>

using namespace std;

#define POS_ZAHL  5
enum farben      { kein=-1, weiss=0, blau, rot, gruen, schwarz, farb_zahl };
static char farb_name[] = { 'w',    'b',   'r', 'g',   's' };

//--------------------------------------- Struktur mastermind ---------------
struct mastermind {

       //........................................................ Konstruktor
   mastermind()
   {
      kombi_zahl  = noch_moeglich = (int)::pow(farb_zahl, POS_ZAHL);
      kombination = new farben* [kombi_zahl];

         //... Erstellen aller moeglichen Kombinationen
      for (int i=0; i<kombi_zahl; i++) {
         int z = i;
         kombination[i] = new farben [POS_ZAHL];
         for (int p=0; p<POS_ZAHL; z /= (int)farb_zahl, p++)
            kombination[i][p] = (farben) (z % farb_zahl);
      }
   }
       //......................................................... Destruktor
   ~mastermind()
   {
      for (int i=0; i<kombi_zahl; i++)
         if (kombination[i] != NULL)
            delete kombination[i];
      delete kombination;
   }

       //............. Streichen aller nicht in Frage kommender Kombinationen
   int  streichen( int pos_richtig, int farb_richtig )
   {
      int     i, p, p2, pr, fr;

      for (i=0; i<kombi_zahl; i++) {
         pr = fr = 0;
                    //.. Pruefen nicht notwendig, wenn 
                    //.. Kombination schon gestrichen
         if (kombination[i] == NULL)
            continue;
                    //.. Sichern, um Originale nicht zu zerstoeren
         for (p=0; p<POS_ZAHL; p++) {
            akt_temp[p]   = aktuelle_kombi[p];
            kompi_temp[p] = kombination[i][p];
         }
                    //.. Positionen ueberpruefen
         for (p=0; p<POS_ZAHL; p++)
            if (kompi_temp[p] == akt_temp[p]) {
               pr++;
               akt_temp[p] = kompi_temp[p] = kein; // bereits ausgewertet
            }
                    //.. Farben ueberpruefen
         for (p=0; p<POS_ZAHL; p++)
            for (p2=0; p2<POS_ZAHL; p2++)
               if (kompi_temp[p] != kein && kompi_temp[p] == akt_temp[p2]) {
                  fr++;
                  akt_temp[p2] = kompi_temp[p] = kein; // bereits ausgewertet
                  break;
               }
                    //.. Bei nicht in Frage kommend,
                    //.. diese Kombination streichen
         if (pr != pos_richtig || fr != farb_richtig) {
            delete kombination[i];
            kombination[i] = NULL;
            noch_moeglich--;
         }
      }
      return noch_moeglich;   
}

       //......................... Holen der naechsten moeglichen Kombination
   int naechste_kombination( void )
   {
      for (int i=0; i<kombi_zahl; i++)
         if (kombination[i] != NULL) {
            for (int p=0; p<POS_ZAHL; p++)
               cout << " " 
                    << farb_name[aktuelle_kombi[p] = kombination[i][p]];
            break;
         }
       return noch_moeglich;
   }

       //.................................................. private-Variablen
private:
   farben  **kombination, aktuelle_kombi[POS_ZAHL],
           akt_temp[POS_ZAHL], kompi_temp[POS_ZAHL];
   int     kombi_zahl, noch_moeglich;
};

//------------------------------------------------------ main ---------------
int main(void)
{
   struct mastermind  *spiel;
   int                pos_richtig, farb_richtig, rest;
   char               noch_ein_spiel;

   while (1) {
      spiel = new mastermind();
      while ( (rest = spiel->naechste_kombination()) > 1 ) {
         cout << "   ? ";
         cin >> pos_richtig >> farb_richtig;
         rest = spiel->streichen( pos_richtig, farb_richtig );
         if ( pos_richtig == 5 || rest == 1 )
            break;
      }

      if ( pos_richtig == 5 || rest == 1 ) {
         cout << "\n.... Ok, ich habe die Kombination gefunden: ";
         spiel->naechste_kombination(); cout << endl;;
      } else
         cout << "\n.... Irgendwo hast Du mir falsche Infos gegeben\n\n";

      cout << "\nNoch ein Spiel (j/n): ";
      cin >> noch_ein_spiel;
      cout << endl;

      if ( tolower(noch_ein_spiel) != 'j' )
         break;   
      delete spiel;  // Destruktor von spiel wird aufgerufen
   }
   return 0;
}
