#include <qapplication.h>
#include <qvbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qlistbox.h>
#include <qtabdialog.h>
#include <qtabbar.h>
#include <qpushbutton.h>
#include <qcolordialog.h>

QString staedte[] = { "Sydney",     "Portland",   "Austra-City","Melbourne",
                      "New London", "Manchester", "Kapstadt",   "Canberra",
                      "Jail-City",  "Koala-Town", "Suncity",    "Downunder-City"};
const uint  staedte_zahl   = sizeof(staedte) / sizeof(staedte[0]);

QString viertel_text[] = { "250000", "4000000", "2000000", "400000", "2500000" };
const uint  viertel_zahl   = sizeof(viertel_text) / sizeof(viertel_text[0]);
//........................................................... Klasse TabDialog
class TabDialog : public QTabDialog {
    Q_OBJECT
public:
    TabDialog( QString h, QString v, QString p, QColor f, QWidget *par = 0 )
               : QTabDialog(par), hauptstadt(h), viertel(v), preis(p), farbe(f) {
//     .... Zum Aendern des Stils der Tableiste (in folg. Zeile // entfernen)
//        QTabBar  *tb = new QTabBar( this );
//     .... Verschiedene Stilarten (in folg. 4 Zeilen ein // entfernen)
//        tb->setShape( QTabBar::RoundedAbove );
//        tb->setShape( QTabBar::RoundedBelow );
//        tb->setShape( QTabBar::TriangularAbove );
//        tb->setShape( QTabBar::TriangularBelow );
//     .... Zum Aendern des Stils der Tableiste (in folg. Zeile // entfernen)
//        setTabBar( tb );
        setupTab1();
         setupTab2();
         setupTab3();
         setzeAnfang();
        setApplyButton( "bernehmen" ); 
         setOkButton(); 
         setCancelButton( "Abbrechen" ); 
         setDefaultButton( "Voreinstellung" ); 
        connect( this, SIGNAL(applyButtonPressed()),  SLOT(setzeUebernehmen()) );
        connect( this, SIGNAL(defaultButtonPressed()), SLOT(setzeDefault()) );
    }
    QString getHauptstadt() { return hauptstadt; }
    QString getViertel()    { return viertel;    }
    QString getPreis()      { return preis;      }
    QColor  getFarbe()      { return farbe;      }
signals:
    void neuUebernommen();
private slots:
    void setzeUebernehmen() {  //...................... setzeUebernehmen
        uint  i;
        hauptstadt = viertel = "";
        for (i=0; i<cities->count(); i++)
           if ( cities->isSelected( i ) )
              hauptstadt = cities->text( i );
        for (i=0; i<viertel_zahl; i++)
           if ( frage2a[i]->isChecked() )
              viertel = frage2a[i]->text();
        preis = frage2b->text();
        farbe = neuFarbe;
        emit neuUebernommen();
    }
    void setzeDefault() {                 //............... setzeDefault
        uint i;
        cities->clear();
        for ( i=0; i < staedte_zahl; i++ )
            cities->insertItem( staedte[i], i );
        for ( i=0; i<viertel_zahl; i++)
            frage2a[i]->setChecked( false );
        frage2b->setText( "" );
        farbAnzeige->setPaletteBackgroundColor( neuFarbe = Qt::white );
    }
    void  neueFarbe() {             //........................ neueFarbe
       QColor f = QColorDialog::getColor( neuFarbe, 0 );
       if ( f.isValid() )
          farbAnzeige->setPaletteBackgroundColor( neuFarbe = f );
    }
private:
    QListBox     *cities;
    QRadioButton *frage2a[viertel_zahl];
    QLineEdit    *frage2b;
    QLabel       *farbAnzeige;
    QPushButton  *farbButton;
    QString      hauptstadt, viertel, preis;
    QColor       farbe, neuFarbe;
    void setupTab1();
    void setupTab2();
    void setupTab3();
    void setzeAnfang() {          //........................ setzeAnfang
        uint  i;
        for ( i=0; i < cities->count(); i++ )
           cities->setSelected( i, cities->text(i) == hauptstadt );
        for ( i=0; i<viertel_zahl; i++)
            frage2a[i]->setChecked( viertel == frage2a[i]->text() );
        frage2b->setText( preis );
        farbAnzeige->setPaletteBackgroundColor( neuFarbe = farbe );
    }
};
//.................................................................. setupTab1
void TabDialog::setupTab1() {
    QVBox *tab1 = new QVBox( this );
     tab1->setMargin( 5 );
     tab1->setSpacing( 5 );
    QLabel *l = new QLabel( "Wie heisst die Hauptstadt von Australien?", tab1 );
     l->setPaletteBackgroundColor( Qt::yellow );
    cities = new QListBox( tab1 );
     for ( uint i = 0; i < staedte_zahl; i++ )
        cities->insertItem( staedte[i], i );
     cities->setPaletteBackgroundColor( Qt::green.light( 180 ) );
    addTab( tab1, "Allgemeinwissen" );
}
//.................................................................. setupTab2
void TabDialog::setupTab2() {
    QVBox *tab2 = new QVBox( this );
     tab2->setMargin( 5 );
     tab2->setSpacing( 5 );
    QButtonGroup *bg = new QButtonGroup( 1, QGroupBox::Horizontal,
                 "Wieviel ist eine Million geteilt durch ein Viertel?", tab2 );
     for (uint i=0; i<viertel_zahl; i++) {
        frage2a[i]  = new QRadioButton( viertel_text[i], bg );
        frage2a[i]->setPaletteBackgroundColor( Qt::green.light( 180 ) );
     }
     bg->setPaletteBackgroundColor(  Qt::green.light( 180 ) );
     bg->setMinimumHeight( 200 );
    QLabel *l = new QLabel( tab2 );
     l->setText( "Eine Flasche Wein kostet zehn Euro,\n"
                 "Der Wein kostet acht Euro mehr als die Flasche.\n"
                 "Wie teuer ist die Flasche?" );
     l->setPaletteBackgroundColor( Qt::yellow );
    frage2b = new QLineEdit( tab2 );
     addTab( tab2, "Mathematik" );
}
//.................................................................. setupTab3
void TabDialog::setupTab3() {
    QVBox *tab3 = new QVBox( this );
     tab3->setMargin( 50 );
     tab3->setSpacing( 30 );
    farbButton = new QPushButton( "Farbauswahl", tab3 );
     connect( farbButton, SIGNAL( clicked() ), SLOT( neueFarbe() ) );
    farbAnzeige = new QLabel( tab3 );
    addTab( tab3, "Farben" );
}
//............................................................ Klasse MyWidget
class MyWidget : public QVBox {
    Q_OBJECT
public:
    MyWidget() : QVBox( 0, 0 ) {
       QPushButton *b1 = new QPushButton( "TabDialog", this);
         b1->setPaletteBackgroundColor( Qt::green.light( 180 ) );
       hauptstadt = viertel = preis = "";
       farbe = Qt::white;
       auswahlAnzeige = new QLabel( this );
       QString  s;
       s.sprintf( " Hauptstadt: %s\n"
                  " Eine Million geteilt durch ein Viertel: %s\n"
                  " Preis der Flasche: %s\n"
                  " Farbe (siehe Hintergrund)\n", (const char *)hauptstadt,
                  (const char *)viertel, (const char *)preis );
       auswahlAnzeige->setText( s );
        auswahlAnzeige->setPaletteBackgroundColor( farbe );
        auswahlAnzeige->resize( auswahlAnzeige->sizeHint() );
        auswahlAnzeige->setFixedSize( 400, 200 );
        auswahlAnzeige->show();
       QPushButton *b2 = new QPushButton( "Beenden", this);
         b2->setPaletteBackgroundColor( Qt::red.light( 180 ) );
       connect( b1, SIGNAL( clicked() ), this, SLOT( showTabDialog() ) );
       connect( b2, SIGNAL( clicked() ), qApp, SLOT( quit() ) );
   }
private slots:
   void neuAnzeige() {
      QString s;
        hauptstadt = tabdialog->getHauptstadt();
        viertel    = tabdialog->getViertel();
        preis      = tabdialog->getPreis();
        farbe      = tabdialog->getFarbe();
        s.sprintf( " Hauptstadt: %s (%s)\n"
            " Eine Million geteilt durch ein Viertel: %s (%s)\n"
            " Preis der Flasche: %s (%s)\n"
            " Farbe (siehe Hintergrund)\n",
            (const char *)hauptstadt,
             (hauptstadt=="Canberra") ? "Richtig" : "Falsch",
            (const char *)viertel, (viertel=="4000000") ? "Richtig" : "Falsch",
            (const char *)preis, (preis=="1") ? "Richtig" : "Falsch" );
        auswahlAnzeige->setText( s );
        auswahlAnzeige->setPaletteBackgroundColor( farbe );
        repaint();
   }
   void showTabDialog() {
      tabdialog = new TabDialog( hauptstadt, viertel, preis, farbe );
      tabdialog->resize( 450, 500 );
      tabdialog->setCaption( "Wissenstest mit Farbenwahl" );
      tabdialog->show();
       connect( tabdialog, SIGNAL( neuUebernommen() ),
                this, SLOT( neuAnzeige() ) );
   }
private:
   TabDialog *tabdialog;
   QLabel    *auswahlAnzeige;
   QString   hauptstadt, viertel, preis;
   QColor    farbe;
};
#include "tabdialog.moc"
//....................................................................... main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    MyWidget *w = new MyWidget;
    w->resize( 200, 100 );
    w->show();
    a.setMainWidget( w );
    return a.exec();
}
