#include <qapplication.h>
#include <qtable.h>
#include <qtextedit.h>
#include <qlabel.h>
#include <qpainter.h>
#include <stdlib.h>
QString bild[] = { "Suse.xpm", "eye.xpm",  "city.xpm", "home.png",
                   "xplz.xpm", "eggs.xpm", "date.xpm"             };
QString names[] = { "Name", "Vorname", "Wohnort", "Strasse",
                    "PLZ", "Monatsgehalt", "Alter" };
//.......................................................... Klasse Tabelle
class MyTable : public QTable {
    Q_OBJECT
public:
    MyTable( int zeilen, int spalten, QWidget *parent=0 )
                       : QTable(zeilen, spalten, parent), minTopHeight(0) {
       for ( unsigned i=0; i<sizeof(bild)/sizeof(*bild); i++ ) {
           showTopCell( i );
           kindOfSort[i] = false;
       }
       horizontalHeader()->setMinimumHeight( minTopHeight );
       setTopMargin( minTopHeight );
       colContent = new QTextEdit;
        colContent->setCaption( "Spalteninhalt" );
        colContent->show();
       statistik = new QWidget;
        statistik->setCaption( "Statistik" );
        statistik->resize( 200, 230 );
        statistik->show();
       QObject::connect( horizontalHeader(), SIGNAL( clicked( int ) ),
                         this,               SLOT( sortIt( int )) );
       QObject::connect( this, SIGNAL( clicked( int,int,int,const QPoint &) ),
                         this, SLOT( display( int,int,int, const QPoint &) ) );
    }
private slots:
    void sortIt( int section ) {
       int index = horizontalHeader()->mapToIndex( section );
       if ( index < 5 )
          sortColumn( index, kindOfSort[index], true );
       else if ( index < 7 ) {
          for ( int i=0; i < numRows()-1; i++)
             for ( int j=i+1; j < numRows(); j++)
                if ( !text( i, index ).isEmpty() && !text( j, index ).isEmpty() &&
                     ( kindOfSort[index] == false && 
                       text( i, index).toInt() > text( j, index).toInt() ) ||
                     ( kindOfSort[index] == true && 
                       text( i, index).toInt() < text( j, index).toInt() ) )
                   mySwapRows( i, j );
       }
       kindOfSort[index] = !kindOfSort[index];
    }
    void display( int, int col, int button, const QPoint & ) {
       if ( button == RightButton ) {
          int  i;
          QString  t;
          colContent->clear();
          if ( col < 5 ) {
             for ( i=0; i<numRows(); i++ )
                if ( !text( i, col ).isEmpty() ) {
                   t.sprintf("Line %d: %s", i+1, (const char *)text( i, col ) );
                   colContent->append( t );
                }
             colContent->show();
          } else if ( col >= 5 && col < 7) {
             int max = 0, z = 0, sum = 0;
             for ( i=0; i<numRows(); i++ ) {
                nr[i] = text( i, col).toInt();
                if ( nr[i] > max )
                   max = nr[i];
             }
             factor = 200.0 / max;

             QPainter p;
             p.begin( statistik );
             for ( i=0; i<numRows(); i++ ) {
                 p.eraseRect( i*5, 0, 5, 200 );
                 if ( nr[i] > 0 ) {
                     p.setBrush( QColor( rand()&255, rand()&255, rand()&255 ) );
                     p.drawRect( i*5, int(200-(nr[i]*factor)+0.5),
                                   5, int(nr[i]*factor+0.5) );
                     sum += nr[i];
                     z++;
                 }
             }
             p.end();
             QLabel *l = new QLabel( statistik );
             l->setAlignment( AlignCenter );
             l->setPaletteBackgroundColor( Qt::white );
             l->setGeometry( 0, 200, 200, 30 );
             if ( z > 0)
                t.sprintf("Sum=%d, Mittel=%.1f", sum, (float)sum/z);
             else
                t = "";
             l->setText( t );
             l->show();
             statistik->show();
          }
       }
    }
protected:
    virtual void mySwapRows( int row1, int row2 ) {
       QString  t;
       for ( int i=0; i<numCols(); i++) {
          t = text( row1, i );
          setText( row1, i, text( row2, i ) );
          setText( row2, i, t );
       }
    }
private:
    void showTopCell( int i ) {
       QPixmap *pic = new QPixmap( bild[i ] );
       horizontalHeader()->setLabel( i, *pic, names[i] );
       if ( pic->size().height() > minTopHeight )
          minTopHeight = pic->size().height(); 
    }
    int       minTopHeight, nr[40];
    bool      kindOfSort[10];
    double    factor;
    QTextEdit *colContent;
    QWidget   *statistik;
};
#include "table.moc"
//.................................................................... main
int main( int argc, char *argv[] ) {
    QApplication a(argc,argv);			
    MyTable *table = new MyTable( 40, 10 );
    a.setMainWidget( table );
    table->resize( 800, 400 );
    table->show();
    return a.exec();
}
