#ifndef TABLEVIEW_H
#define TABLEVIEW_H
#include <qgridview.h>

class Tableview : public QGridView {
  public:
    Tableview( int zeilZahl, int spaltZahl, QWidget* p=0, const char* nam=0 );
    ~Tableview() { delete[] inhalt; }
    const char* zellenInhalt(int z, int s) const { return inhalt[indexOf(z, s)]; }
    void setzeZellenInhalt(int z, int s, const char* c) {
       inhalt[indexOf(z, s)] = c; updateCell(z, s);
    }
    void setzeZellenFarbe(int z, int s, QColor f) {
       zellenFarbe[indexOf(z, s)] = f; updateCell(z, s);
    }
  protected:
    void paintCell( QPainter*, int zeile, int spalte );
    void mousePressEvent( QMouseEvent* );
    void keyPressEvent( QKeyEvent* );
  private:
    int indexOf(int z, int s) const { return (z*numCols()) + s; }
    void pruefEingabe( int zeile, int spalte ) {
       if ( eingabeGemacht ) {
          if ( spalte * zeile == eingabewert)
             setzeZellenFarbe( zeile, spalte, Qt::green );
          else {
             setzeZellenFarbe( zeile, spalte, Qt::red );
             setzeZellenInhalt( zeile, spalte, alt );
          }
          eingabewert = 0;
          eingabeGemacht = false;
       } else
          updateCell( zeile, spalte );
    }
    QString  *inhalt, alt;
    QColor   *zellenFarbe;
    int       aktZeile, aktSpalte, eingabewert;
    bool      eingabeGemacht;
};
#endif
