#include <qapplication.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qlcdnumber.h>
#include <qlabel.h>
#include "text_groes.h"  // enthlt neue Klasse 'Schrift'
                         // mit eigenem Slot 'stelle_neu_dar'
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   QWidget* mywidget = new QWidget();
   mywidget->setGeometry( 400, 300, 550, 150 );
  
   //.... Erzeugen eines Schiebebalkens
   QSlider* myslider = new QSlider(  0,  // kleinstmgl. Wert
                                    99,  // grtmgl. Wert
                                     1,  // Schrittweite
                                    20,  // Startwert
                                    QSlider::Horizontal,  // Ausrichtung
                                    mywidget );           // Elternwidget
   myslider->setGeometry( 10, 10, 180, 30 );

   //.... Erzeugen eines Objekts zur Anzeige von LCD-Nummern
   QLCDNumber* mylcdnum = new QLCDNumber( 2,          // Ziffernzahl
                                          mywidget ); // Elternwidget
   mylcdnum->setGeometry( 60, 50, 80, 50 );
   mylcdnum->display( 20 ); // zeige Startwert an

   // Verbinde Schiebebalken und Nummernanzeige
   QObject::connect( myslider, SIGNAL( valueChanged( int ) ), 
                     mylcdnum, SLOT( display( int ) ) );

   // Zwei Buttons zum schrittweisen Erhhen und 
   // Erniedrigen der Schiebebalken-Werte
   QPushButton* decrement = new QPushButton( "<", mywidget );
    decrement->setGeometry( 10, 110, 50, 30 );
    decrement->setFont(QFont("Times", 18, QFont::Bold) );
    decrement->setPaletteBackgroundColor( Qt::red );

   QPushButton* increment = new QPushButton( ">", mywidget );
    increment->setGeometry( 140, 110, 50, 30 );
    increment->setFont(QFont("Times", 18, QFont::Bold) );
    increment->setPaletteBackgroundColor( Qt::green );
  
   // Verbinde das clicked()-Signal der Buttons mit den Slots, die 
   // den Schiebebalken-Wert erhhen bzw. erniedrigen
   QObject::connect( decrement, SIGNAL( clicked() ),
                     myslider, SLOT( subtractStep() ) );
   QObject::connect( increment, SIGNAL( clicked() ),
                     myslider, SLOT( addStep() ) );
  
   // Label zur Anzeige der Schrift(-groesse)
   Schrift* anzeige = new Schrift( " Text", mywidget );
   anzeige->setGeometry( 200, 10, 340, 130 );
   anzeige->setFont(QFont("Times", 20) );
   anzeige->setPaletteBackgroundColor( Qt::white );

   // Verbinde Schiebebalken und Label (fr Textanzeige)
   QObject::connect( myslider, SIGNAL( valueChanged( int ) ), 
                     anzeige, SLOT( stelle_neu_dar( int ) ) );

   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
