#ifndef  TIER_H
#define  TIER_H

#include <string.h>
#include <iostream>

using namespace std;

//......................................... CTier (Abstrakte Klasse)
class CTier
{
public:
   virtual void ich_kann()               = 0; // reine virtuelle Methode
   virtual void als_spezies_kann_ich()   = 0; // reine virtuelle Methode
   virtual void als_individuum_bin_ich() = 0; // reine virtuelle Methode
};
    
//................................ CLandtier (auch abstrakte Klasse)
class CLandtier : public CTier
{
public:
   virtual void ich_kann() {
       cout << "       Als Landtier kann ich laufen" << endl;
   }
};

//.............................. CWassertier (auch abstrakte Klasse)
class CWassertier : public CTier
{
public:
   virtual void ich_kann() {
       cout << "       Als Wassertier kann ich schwimmen" << endl;
   }
};

//................................ CLufttier (auch abstrakte Klasse)
class CLufttier : public CTier
{
public:
   virtual void ich_kann() {
       cout << "       Als Lufttier kann ich fliegen" << endl;
   }
};

//.................................................... Makro SPEZIES
//   legt eine Klasse an, die von Land-, Wasser- oder Lufttier
//   abgeleitet ist. Ueber den Konstruktor wird der Name eines
//   speziellen Individuums festgelegt.

#define SPEZIES(cname,oberklasse,spezies,IchKann)                       \
    class cname : public oberklasse                                     \
    {                                                                   \
       public:                                                          \
         cname(char *name) { strcpy(m_Name, name); }                    \
         virtual void als_spezies_kann_ich() {                          \
            cout << "       Als " spezies " kann ich " IchKann << endl; \
         }                                                              \
         virtual void als_individuum_bin_ich() {                        \
            cout << "....Ich heisse " << m_Name << endl;                \
         }                                                              \
                                                                        \
       private:                                                         \
         char m_Name[20];                                               \
    };   

#endif
