#include <qapplication.h>
#include <qtimer.h>
#include <qdatetime.h>
#include <qlabel.h> 
#include <qprogressbar.h>

//.......................................................... Klasse TimeSlider
class TimeSlider : public QWidget
{
    Q_OBJECT
public:
    TimeSlider( QWidget *p=0, const char *t=0) : QWidget( p, t ) {
       QTimer *timer = new QTimer( this );
       connect( timer, SIGNAL( timeout() ),
                this,  SLOT( showNewTime() ) );
       timer->start( 1, false );

       timeShow = new QLabel( time.toString("hh:mm:ss"), this );
       timeShow->setAlignment( Qt::AlignCenter );
       timeShow->setFont( QFont( "Times", 40 ) );
       timeShow->setPaletteBackgroundColor( Qt::white );
       timeShow->setGeometry( 20, 20, 200, 100 );

       hourShow = new QProgressBar( 24, this );
       hourShow->setCenterIndicator( true );
       hourShow->setProgress( time.hour() );
       hourShow->setGeometry( 20, 150, 200, 30 );

       minuteShow = new QProgressBar( 60, this );
       minuteShow->setCenterIndicator( true );
       minuteShow->setProgress( time.minute() );
       minuteShow->setGeometry( 20, 190, 200, 25 );

       secondShow = new QProgressBar( 60, this );
       secondShow->setCenterIndicator( true );
       secondShow->setProgress( time.second() );
       secondShow->setGeometry( 20, 225, 200, 20 );

       msecShow = new QProgressBar( 1000, this );
       msecShow->setCenterIndicator( true );
       msecShow->setProgress( time.msec() );
       msecShow->setGeometry( 20, 255, 200, 20 );
    }

private slots:

   void showNewTime( void ) {
       time = QTime::currentTime();
       timeShow->setText( time.toString("hh:mm:ss") );
       hourShow->setProgress( time.hour() );
       minuteShow->setProgress( time.minute() );
       secondShow->setProgress( time.second() );
       msecShow->setProgress( time.msec() );
    }

private:
    QTime        time;
    QLabel       *timeShow;
    QProgressBar *hourShow,
                 *minuteShow,
                 *secondShow,
                 *msecShow;
};

#include "timeprogress.moc"

//....................................................................... main
int main( int argc, char *argv[] )
{
   QApplication myapp( argc, argv );
 
   QWidget* mywidget = new TimeSlider(); 
   mywidget->setGeometry( 100, 100, 240, 300 ); 

   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
