#include <qapplication.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qpushbutton.h>

//................................................. Klasse ButtonGruppe
class ButtonGruppe : public QWidget
{
    Q_OBJECT
public:
    ButtonGruppe::ButtonGruppe( QWidget *parent=0, const char *name=0 )
                                             : QWidget( parent, name ) {
           //..... Zwei RadioButtons
       QButtonGroup *grp = new QButtonGroup( 1, Horizontal,
                              "Togglebutton an/aus", this );
       grp->setFrameStyle( QFrame::StyledPanel | QFrame::Sunken );
       radio[0] = new QRadioButton( "&Geklickt", grp );
       grp->insert( radio[0] );
       radio[1] = new QRadioButton( "&Nicht geklickt", grp );
       grp->insert( radio[1] );
       radio[1]->setChecked( true );
       grp->setGeometry( 10, 10, 200, 100 );

       connect( grp,  SIGNAL( clicked( int ) ),
                this, SLOT( switchButton( int ) ) );

          //..... Ein Togglebutton
       button = new QPushButton( "&Togglebutton", this );
       button->setToggleButton( true );
       button->setGeometry( 220, 10, 200, 100 );

       connect( button, SIGNAL( clicked() ),
                this,   SLOT( switchRadio() ) );
    }

private slots:    
    void switchButton( int id ) {
       button->setOn( id == 0 );
    }

    void switchRadio( void ) { 
       radio[ button->isOn() ? 0 : 1 ]->setChecked( true );
    }

private:
    QPushButton  *button;
    QRadioButton *radio[2];
};

#include "togglebutton.moc"

//................................................................... main
int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );

    ButtonGruppe buttonGrp;
    a.setMainWidget( &buttonGrp );
    buttonGrp.setGeometry( 100, 100, 430, 120 );
    buttonGrp.show();

    return a.exec();
}
