#include  <qapplication.h>
#include  <qpainter.h>
#include  <stdlib.h>
#include  <qwidget.h>
#include  <qpushbutton.h>
#include  <qtooltip.h>
#include  <time.h>

#define  ZEIL_ZAHL    16
#define  SPALT_ZAHL   16
//.................................... FarbButton - Klasse ............
class FarbButton : public QPushButton {
    Q_OBJECT
public:
    FarbButton( QColor farb, QWidget *parent=0, const char *name=0 )
                                         : QPushButton( parent, name ) {
       setPaletteBackgroundColor( farb );
       setToggleButton( true );
       QString s;
       s.sprintf( "RGB: %d,%d,%d", farb.red(), farb.green(), farb.blue() );
       QToolTip::add( this, s );
       connect( this, SIGNAL( clicked() ), this, SLOT( klickSlot() ) );
    }
public slots:
    void klickSlot() {
       QString  s;
       QColor farb( rand()&0xff, rand()&0xff, rand()&0xff );
       setPaletteBackgroundColor( farb );
       s.sprintf( "RGBneu: %d,%d,%d", farb.red(), farb.green(), farb.blue() );
       QToolTip::add( this, s );
       this->setOn( true );
    }
};
//.................................... MeinWidget - Klasse ............
class MeinWidget : public QWidget {
  public:
     MeinWidget( QWidget *p=0, const char *nam=0 ) : QWidget( p, nam ) {
        ::srand( time(NULL) );
        setMinimumSize( 100, 100 );
        setGeometry(10, 10, 600, 600);
        setCaption( "Beispiel zu dynamischen ToolTips" );
        rgb_teil = rand()%3;
        breite = width()/SPALT_ZAHL;
        hoehe  = height()/ZEIL_ZAHL;
        rot = gruen = blau = 0;
        for (int i=0; i < SPALT_ZAHL; i++) {
           for (int j=0; j < ZEIL_ZAHL; j++) {
              f[i][j] = new FarbButton( QColor(rot, gruen, blau), this );
              f[i][j]->setGeometry( i*breite, j*hoehe, breite, hoehe );
              switch (rgb_teil) {
                 case 0: rot++;    break;
                 case 1: gruen++;  break;
                 case 2: blau++;   break;
              }
           }
        }
     }
  protected:
     void resizeEvent( QResizeEvent * ) {
        breite = width()/SPALT_ZAHL;
        hoehe  = height()/ZEIL_ZAHL;
        resize( breite*SPALT_ZAHL, hoehe*ZEIL_ZAHL );
        for (int i=0; i < SPALT_ZAHL; i++)
           for (int j=0; j < ZEIL_ZAHL; j++)
               f[i][j]->setGeometry( i*breite, j*hoehe, breite, hoehe );
        show();
     }
 private:
    int        breite, hoehe, rgb_teil, rot, gruen, blau;
    FarbButton *f[SPALT_ZAHL][ZEIL_ZAHL];
};
#include "tooltip.moc"
//................................................... main ............
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    MeinWidget mw;
    a.setMainWidget( &mw );
    mw.show();
    return a.exec();
}
