#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qtooltip.h>
#include <stdlib.h>
#include <time.h>
//................................................. Klasse DynTip .........
class DynTip : public QToolTip {
  public:
     DynTip( QWidget *parent ) : QToolTip( parent ) { }

  protected:
     void maybeTip( const QPoint &pos );
};
//............................................... Klasse WasIsLos .........
class WasIsLos : public QWidget {
    Q_OBJECT
public:
    WasIsLos( QWidget *parent=0, const char *name=0 ) : QWidget( parent, name ) {
       srand( time(NULL) );
       setMinimumSize( 30, 30 );
       setGeometry(100, 100, 300, 300);
       r1 = randomRect();
       r2 = randomRect();
       r3 = randomRect();
       t = new DynTip( this );
       QToolTip::add( this, r3, "Dieser Knopf kann nicht bewegt werden" );
    }
    ~WasIsLos() { delete t; t = 0; }
    QRect tip( const QPoint & p ) {
       if      ( r1.contains( p ) ) return r1;
       else if ( r2.contains( p ) ) return r2;
       else                         return QRect( 0,0, -1,-1 );
    }
protected:
    void paintEvent( QPaintEvent * ) {
       QPainter p( this );
       p.drawLine( r1.center(), r2.center() );
       p.drawLine( r1.center(), r3.center() );
       p.drawLine( r2.center(), r3.center() );
       p.setBrush( blue );  p.drawEllipse( r1 );
       p.setBrush( green ); p.drawEllipse( r2 );
       p.setBrush( red );   p.drawEllipse( r3 );
    }
    void mouseMoveEvent( QMouseEvent * e ) {
       if ( nr==1 ) {
          r1 = QRect( e->pos().x()-10, e->pos().y()-10, 20, 20 );
          repaint();
       } else if ( nr==2 ) {
          r2 = QRect( e->pos().x()-10, e->pos().y()-10, 20, 20 );
          repaint();
       }
    }
    void mousePressEvent( QMouseEvent * e ) {
       if      ( r1.contains( e->pos() ) ) nr = 1;
       else if ( r2.contains( e->pos() ) ) nr = 2;
       else    nr = 0;
    }
    void resizeEvent( QResizeEvent * ) {
       if ( !rect().contains( r1 ) ) r1 = randomRect();
       if ( !rect().contains( r2 ) ) r2 = randomRect();
    }
private:
    QRect randomRect() {
       return QRect( rand()%(width()-20), rand()%(height()-20), 20, 20 );
    }
    int     nr;
    QRect   r1, r2, r3;
    DynTip  *t;
};
//...................................... maybeTip-Implementierung .........
void DynTip::maybeTip( const QPoint &pos ) {
    if ( !parentWidget()->inherits( "WasIsLos" ) )
       return;
    QRect r( ((WasIsLos*)parentWidget())->tip(pos) );
    if ( !r.isValid() )
       return;
    QString s;
    s.sprintf( "Position: %d,%d", r.center().x(), r.center().y() );
    tip( r, s );
}
#include "tooltip2.moc"
//.......................................................... main .........
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    WasIsLos mw;
    mw.setCaption( "Weiteres Beispiel zu dynamischen Tooltips" );
    a.setMainWidget( &mw );
    mw.show();
    return a.exec();
}
