#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <stdlib.h>
#include <time.h>
//........................................................ Klasse malFenster
class malFenster : public QWidget {
    Q_OBJECT
public:
    malFenster();
public slots:
    void neuMalen( int index ) {
       if ( index < maxIndex ) {
          bildIndex = index;
          update();
       }
    }
protected:
    void malen( QPainter *p ) {
       switch ( bildIndex ) {
          case 0:  translate( p );   break;
          case 1:  rotate( p );      break;
          case 2:  scale( p );       break;
          case 3:  shear( p );       break;
       }
    }
    void mousePressEvent( QPaintEvent*) { repaint( false );                     }
    void resizeEvent( QResizeEvent*)    { bgrp->move(width()-bgrp->width(), 0); }
    void paintEvent( QPaintEvent* ) {
       QPainter paint( this );
       paint.setBrush( QBrush( Qt::red.light(180), Qt::SolidPattern ) );
       malen( &paint );
    }
private:
    void translate( QPainter *p ) {  //......................... translate
       double dx = rand()%500, dy = rand()%500;
       p->drawRect( 10, 10, bild.width(), bild.height() ); 
       p->translate( dx, dy );
       p->drawPixmap( 10, 10, bild ); 
       text.sprintf( "translate(%.2f, %.2f)", dx, dy );
       p->drawText( 0, 100, text ); 
       p->translate( -dx, -dy );
    }
    void rotate( QPainter *p ) {    //............................. rotate
       int r = rand()%361;
       p->drawRect( 300, 300, bild.width(), bild.height() ); 
       p->translate( 300, 300 );
       p->rotate( r );
       p->drawPixmap( 0, 0, bild ); 
       text.sprintf( "%d Grad gedreht", r );
       p->drawText( 0, 100, text ); 
       p->rotate( -r );
       p->translate( -300, -300 );
       p->drawText( 300, 450, text ); 
    }
    void scale( QPainter *p ) {   //................................ scale
       double xscale = rand()%600/100.0, yscale = rand()%600/100.0;
       p->drawRect( 10, 10, bild.width(), bild.height() ); 
       p->scale( xscale, yscale );  //... Verkleinern bzw. Vergroessern
       p->drawPixmap( 10, 10, bild ); 
       text.sprintf( "scale(%.2f, %.2f)", xscale, yscale );
       p->drawText( 0, 100, text ); 
       p->scale( 1/xscale, 1/yscale ); //... Skalierung rueckgaengig
       p->drawText( 300, 500, text ); 
    }
    void shear( QPainter *p ) {  //................................. shear
       double    xshear = (rand()%200-100)/100.0,
                 yshear = (rand()%200-100)/100.0;
       p->drawRect( 300, 300, bild.width(), bild.height() ); 
       p->shear( xshear, yshear );  //... Scherung
       p->drawPixmap( 300, 300, bild ); 
       text.sprintf( "shear(%.2f, %.2f)", xshear, yshear );
       p->drawText( 200, 200, text ); 
       p->resetXForm(); // alle Transformationen rueckgaengig 
       p->drawText( 300, 550, text ); 
    }
    QPixmap        bild;
    QString        text;
    QButtonGroup  *bgrp;
    int            bildIndex, maxIndex;
};
//.............................................................. Konstruktor
malFenster::malFenster() {
    setCaption( "Demo zu translate, rotate, scale und shear" );
    bgrp = new QButtonGroup( this ); // Gruppe von Buttons
    bgrp->resize( 150, 150 );
    bgrp->setPaletteBackgroundColor( Qt::blue.light(180) );
    connect( bgrp, SIGNAL(clicked(int)), SLOT(neuMalen(int)) );

    QRadioButton *rb = new QRadioButton( "translate", bgrp );
    rb->setChecked( true );                  rb->setGeometry( 10, 10, 100, 30 );
    rb = new QRadioButton( "rotate", bgrp ); rb->setGeometry( 10, 40, 100, 30 );
    rb = new QRadioButton( "scale", bgrp );  rb->setGeometry( 10, 70, 100, 30 );
    rb = new QRadioButton( "shear", bgrp );  rb->setGeometry( 10, 100, 100, 30 );
    bild.load( "penguin.xpm" );
    bildIndex = 0;   // erstes Bild zunaechst zeichnen
    maxIndex  = 4;
    resize( 800, 600 );
}
#include "transform.moc"
//..................................................................... main
int main( int argc, char *argv[] ) {
    QApplication a( argc, argv );
    srand(time(NULL)); // Zufallszahlen-Generator initialisieren
    malFenster   bild;
    a.setMainWidget( &bild );
    bild.show();
    return a.exec();
}
