#include  <qapplication.h> 
#include  <qdir.h>
#include  <qfileinfo.h>

unsigned long  gesamtBytes = 0,
               dateiZahl   = 0;

void tree( QString dirName );

//.................................................................... main
int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );

    if ( argc < 2 )
       tree( "." );
    else
       for (int i=1; i<argc; i++)
          tree( argv[i] );
    printf("-----------------------------------------"
           "-----------------------------------------\n" );
    printf("%43lu Dateien mit insgesamt: %9lu Bytes\n", dateiZahl, gesamtBytes );

    return 0;
}

//.................................................................... tree
void tree( QString dirName )
{
    uint g;
    QDir dir( dirName );

    dir.setFilter( QDir::Dirs | QDir::Files | QDir::NoSymLinks | QDir::Hidden );
    dir.setSorting( QDir::Name );

    QFileInfo             *fi;
    const QFileInfoList   *fil = dir.entryInfoList();
    QFileInfoListIterator it( *fil );

    while ( ( fi = it.current() ) ) {
       if ( fi->fileName() == "." || fi->fileName() == ".." ) 
          ;
       else {
          if ( fi->isDir() && fi->isReadable() )
             tree( fi->absFilePath() );
          else {
               // evtl. hier andere Operationen
             g = fi->size();
             printf("%-65s: %9u\n", (const char *)fi->absFilePath(), g );
             gesamtBytes += g;
             dateiZahl++;
          }
       }
       ++it;
    }
}
