#include <qvaluelist.h>
#include <qstring.h>
#include <stdio.h>

//...................................................... Klasse Angestellter
class Angestellter {

public:
    Angestellter() { }
    Angestellter( const QString& name, int gehalt ) { n=name; v=gehalt;    }

    QString     name()      const           { return n; }
    int         verdienst() const           { return v; }
    void        neuVerdienst( int gehalt )  { v = gehalt; }

private:
    QString     n;
    int         v;
};

//..................................................................... main
int  main( void )
{
   QValueList<Angestellter> liste;  // Liste von Angestellten (keine Zeiger)

   liste.append( Angestellter("Meyer Hans", 32000) );
   liste.append( Angestellter("Aller Antonia", 37150) );
   liste.append( Angestellter("Kohler Fritz", 52000) );

   Angestellter verona( "Verona Kuhner", 60000 );
   liste.append( verona );
   verona.neuVerdienst( 63000 );

   QValueList<Angestellter>::Iterator it;

   printf("..... Werte in der Liste\n" );
   for ( it=liste.begin(); it != liste.end(); ++it )
      printf( "%20s: %6d Euro\n", (*it).name().ascii(), (*it).verdienst() );
   printf("\n");

   printf("..... Verdienst vom Verona-Objekt, das nicht in der Liste ist\n" );
   printf( "%20s: %6d Euro\n", verona.name().ascii(), verona.verdienst() );

   return 0;
}
