#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <stdlib.h>
#include <time.h>

#define MAXX  1000
#define MAXY   600

//........................................................ Klasse MalFenster
class MalFenster : public QWidget
{
protected:
   virtual void mousePressEvent( QMouseEvent * ) {
      repaint( true );
   }

   virtual void paintEvent( QPaintEvent* )
   {
      int i, j,
          anzahl,       // Anzahl der gleichzeitig vorhandenen Wellen
          mx[7], my[7], // Mittelpunkte der einzelnen Wellen
          a,        // Wirklicher Wellen-Abstand bei jedem Durchgang
          abstand= rand() % 20+1;  // Maximal moeglicher Wellen-Abstand
      QColor farbe[7]; // unterschiedl. Farben fuer Kreise

      QPainter maler( this ); // erzeugt QPainter-Objekt zum Zeichnen

      //..................................... Simulation der Wellen-Ausbreitung
         // Anzahl, Farben und Mittelpunkte der Wellen zufaellig bestimmen
      anzahl=rand()%6+1;
      for (i=1 ; i<=6 ; i++) {
         farbe[i] = QColor( rand()&255, rand()&255, rand()&255 );
         mx[i] = rand() % MAXX; 
         my[i] = rand() % MAXY;
      }
      a = rand() % abstand+1; // Wellen-Abstand zufaellig ermitteln

         // Wellen-Ausbreitung simulieren
      for (i=0 ; i<=MAXX ; i+=a)
         for (j=1 ; j<=anzahl ; j++) {
            maler.setPen( farbe[j] );
            maler.drawEllipse( mx[j]-i/2, my[j]-i/2, i, i );
         }
   }
};

//..................................................................... main
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   srand(time(NULL));
   MalFenster* mywidget = new MalFenster;
   mywidget->setGeometry( 50, 50, MAXX, MAXY+40 );

   srand( time( NULL ) ); 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
