#include <qapplication.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qlabel.h>
#include <qwidgetstack.h>
#include <stdlib.h>
#include <time.h>
//......................................................... Klasse MyWidget
class MyWidget : public QWidget {
   Q_OBJECT
public:
   MyWidget( QWidget *parent=0, const char *name = 0, int f=0 )
                                 : QWidget(parent, name, f) {
      int     i;
      QString s;
      ::srand(time(NULL));
      frame = new QFrame( this );
      frame->setGeometry( 0, 0, 600, 600);
      wstack = new QWidgetStack( frame );
      wstack->setGeometry( 0, 0, 600, 600);
      for (i=0; i<20; i++) {
         QColor farbe(::rand()%255, ::rand()%255, ::rand()%255 );
         label[i] = new QLabel( wstack );
         label[i]->setPaletteBackgroundColor( farbe );
         label[i]->setAlignment( AlignCenter );
         label[i]->setFont( QFont( "Helvetica", 30 ) );
         s.sprintf("Label %d", i); 
         label[i]->setText( s );
         wstack->addWidget( label[i], i );
      }
      wstack->raiseWidget( 10 );
         //..... Menu zum Einblenden eines anderen Labels
      einblendMenu = new QPopupMenu;
      for (i=0; i<20; i++) {
         QString s;
         s.sprintf("Label %d", i);
         einblendMenu->insertItem( s, i );
      }
      einblendMenu->setItemChecked( 10, true );
      QObject::connect( einblendMenu, SIGNAL( activated( int ) ),
                        this,         SLOT( zeigeLabelSlot( int ) ) );
         //............... Menu-Balken
      menuBalken = new QMenuBar( this );
      menuBalken->insertItem( "Einblenden",  einblendMenu );
   }
private slots:
   void zeigeLabelSlot( int l ) {
      wstack->raiseWidget( l );
      for (int i=0; i <= 20; i++)
         einblendMenu->setItemChecked( i , l==i );
   }
private:
   QMenuBar     *menuBalken;
   QPopupMenu   *einblendMenu;
   QFrame       *frame;
   QWidgetStack *wstack;
   QLabel       *label[20];
};
#include "widgetstack.moc"
//.................................................................... main
int main( int argc, char *argv[] ) {
   QApplication myapp( argc, argv );
   MyWidget *mywidget = new MyWidget();
   mywidget->setGeometry( 0, 0, 600, 600 );
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
