#include  <qapplication.h> 
#include  <qdir.h>
#include  <qfileinfo.h>
#include  <qregexp.h>
#include  <iostream>

using namespace std;
void tree( QString dirName, QString fileName );

//.................................................................... main
int main( int argc, char *argv[] )
{
    QApplication a( argc, argv );

    if ( argc == 2 )
       tree( ".", QString( argv[1] ) );
    else if ( argc == 3 )
       tree( QString( argv[1] ), QString( argv[2] ) );
    else {
       QString usage;
       usage.sprintf("usage: %s [directory] filename", argv[0] );
       cerr << usage << endl;
       return 1;
    }
    return 0;
}

//.................................................................... tree
void tree( QString dirName, QString fileName )
{
    QDir dir( dirName );

    dir.setFilter( QDir::Dirs | QDir::Files |
                   QDir::NoSymLinks | QDir::Hidden );

    QFileInfo             *fi;
    const QFileInfoList   *fil = dir.entryInfoList();
    QFileInfoListIterator it( *fil );

    while ( ( fi = it.current() ) ) {
       if ( fi->fileName() == "." || fi->fileName() == ".." ) 
          ;
       else {
          if ( fi->isDir() && fi->isReadable() )
             tree( fi->absFilePath(), fileName );
          else if ( fi->fileName().find( QRegExp( fileName ) ) >= 0 )
             cout << fi->absFilePath() << endl;
       }
       ++it;
    }
}
