#include <qapplication.h>
#include <qlabel.h>
#include <qlcdnumber.h>
#include <qpaintdevicemetrics.h> 

class PosAnzeige : public QWidget
{
   Q_OBJECT

public:
    PosAnzeige( QWidget *p=0 ) : QWidget( p ) {
        setMouseTracking( true );
        xPos  = new QLCDNumber( this );
         xPos->setNumDigits( 3 );
         xPos->setGeometry( 0, 50, 50, 50 );
         xPos->setPaletteBackgroundColor( Qt::darkGray );
        yPos  = new QLCDNumber( this );
         yPos->setNumDigits( 3 );
         yPos->setGeometry( 50, 50, 50, 50 );
         yPos->setPaletteBackgroundColor( Qt::darkGray );
        QLabel *l  = new QLabel( this );
         l->setGeometry( 0, 0, 100, 50 );
         l->setPaletteBackgroundColor( Qt::black );
        linksOben  = new QLabel( this );
        linksOben->setPaletteBackgroundColor( Qt::white );
        rechtsOben  = new QLabel( this );
        rechtsOben->setPaletteBackgroundColor( Qt::white );
        linksUnten  = new QLabel( this );
        linksUnten->setPaletteBackgroundColor( Qt::white );
        rechtsUnten  = new QLabel( this );
        rechtsUnten->setPaletteBackgroundColor( Qt::white );

        QObject::connect( this, SIGNAL( mousePosChanged( int, int ) ),
                          this, SLOT( displayPos( int, int ) ) );
    }

protected:
    virtual  void mouseMoveEvent( QMouseEvent *e ) {
       emit mousePosChanged( e->x(), e->y() );
    }

public slots:
    void displayPos( int x, int y ) {
       xPos->display( x );
       yPos->display( y );

       int xP = (int) (x/800.0*100),
           yP = (int) (y/400.0*50);
       linksOben->setGeometry(   0,   0,   xP-1,  yP-1 );
       rechtsOben->setGeometry( xP,   0, 100-xP,  yP-1 );
       linksUnten->setGeometry(  0,  yP,   xP-1, 50-yP );
       rechtsUnten->setGeometry( xP, yP, 100-xP, 50-yP );
    }

signals:
    void mousePosChanged( int, int );

private:
    QLCDNumber *xPos, *yPos;
    QLabel     *linksOben, *rechtsOben, *linksUnten, *rechtsUnten;
};

#include "woistmaus.moc"

int main( int argc, char *argv[] )
{
   QApplication myapp( argc, argv );
   
   PosAnzeige *mywidget = new PosAnzeige;

   myapp.setMainWidget( mywidget );
   mywidget->setGeometry( 10, 10, 800, 400 );
   mywidget->show();
   return myapp.exec();
}
