#include <qapplication.h>
#include <qwidget.h>
#include <qmenubar.h>
#include <qlabel.h>
#include <qpopupmenu.h>
#include <qmessagebox.h>
#include <qmainwindow.h>
#include <qworkspace.h>
#include <stdlib.h>
#include <time.h>
//........................................ HauptFenster-Klasse .........
class HauptFenster : public QMainWindow {
    Q_OBJECT
public:
    HauptFenster() : QMainWindow( 0, "Beispiel zu QWorkspace" ) {
       QLabel *l[10];
       ::srand(time( NULL ) );
       ws = new QWorkspace( this );
       ws->setScrollBarsEnabled( true );
       for (int i=0; i<=10; i++) {
          l[i] = new QLabel( ws );
          l[i]->setPaletteBackgroundColor(
                   QColor( rand()&0xff, rand()&0xff, rand()&0xff ) );
          l[i]->setGeometry( 10+i*10, 10+i*10, 60, 60 );
       }
       toolbarMenu = new QPopupMenu( this );
        toolbarMenu->insertItem( "&Cascade", ws, SLOT( cascade()) );
        toolbarMenu->insertItem( "&Tile", ws, SLOT( tile()) );
        toolbarMenu->insertSeparator();
        toolbarMenu->insertItem( "&Scrollbars", this, SLOT( scrollBar()) );
       menu = new QMenuBar( this );
        menu->insertItem( "&Menu", toolbarMenu );
       setCentralWidget( ws );
    }
private slots:
    void scrollBar()  { ws->setScrollBarsEnabled( !ws->scrollBarsEnabled() ); }
private:
    QMenuBar   *menu;
    QPopupMenu *toolbarMenu;
    QWorkspace *ws;
};
#include "workspace.moc"
//....................................................... main .........
int main( int argc, char ** argv ) {
    QApplication a( argc, argv );
    HauptFenster m;
    m.setGeometry( 10, 10, 400, 300 );
    a.setMainWidget( &m );
    m.show();
    return a.exec();
}
