#include <qapplication.h>
#include <qdatetime.h>
#include <qlabel.h> 
#include <qpushbutton.h>
#include <qtextedit.h>

#include <stdlib.h>

//............................................................ Klasse WorkTime
class WorkTime : public QWidget
{
   Q_OBJECT
public:
    WorkTime( QWidget *p=0, const char *t=0) : QWidget( p, t )
    {
       startWork = new QDateTime [ 1000 ];
       endWork = new QDateTime [ 1000 ];
       number = 0;

       begin = new QPushButton( "Arbeitsbeginn", this );
       begin->setGeometry( 30, 10, 740, 30 );
       QObject::connect( begin, SIGNAL(clicked()),
                         this, SLOT(startWorkSlot()) );

       end = new QPushButton( "Arbeitsende", this );
       end->setGeometry( 30, 50, 740, 30 );
       QObject::connect( end, SIGNAL(clicked()),
                         this, SLOT(endWorkSlot()) );
       end->hide();

       show = new QPushButton( "Gesamtzeit", this );
       show->setGeometry( 30, 90, 740, 30 );
       QObject::connect( show, SIGNAL(clicked()),
                         this, SLOT(showWorkTimeSlot()) );
       show->hide();

       total = new QTextEdit( this );
       total->setFont( QFont( "Courier", 12 ) );
       total->setGeometry( 30, 150, 740, 300 );
       total->hide();
    }

private slots:
    void startWorkSlot() {
       begin->hide();
       end->show();
       total->hide();
       show->hide();
       
       startWork[number].setDate( QDate::currentDate() );
       startWork[number].setTime( QTime::currentTime() );
       // zum Testen:
       //   startWork[number] = startWork[number].addDays( number);
       //   startWork[number] = startWork[number].addSecs( ::rand()%4000-2000);
    }

    void endWorkSlot() {
       begin->show();
       end->hide();
       show->show();

       endWork[number].setDate( QDate::currentDate() );
       endWork[number].setTime( QTime::currentTime() );
       // zum Testen:
       //   endWork[number] = endWork[number].addDays( number);
       //   endWork[number] = endWork[number].addSecs( 4000+::rand()%35000);
       number++;
    }

    void showWorkTimeSlot() {
       int totalSecs = 0;
       QString  t;

       total->clear();
       for ( uint i=0; i<number; i++) {
          int secs = startWork[i].secsTo( endWork[i] );
          t.sprintf( "%s  -  %s: (%02d h, %02d min)\n",
                    (const char *)startWork[i].toString("dd.MM.yy (ddd) hh:mm.ss"),
                    (const char *)endWork[i].toString("dd.MM.yy (ddd) hh:mm.ss"),
                    secs/3600, secs%3600/60 );
          total->insert( t );
          totalSecs += secs;
       } 
       total->insert("====================================================================\n");
       t.sprintf( "%52s %3d h, %02d min\n", "Gesamte Arbeitszeit:",
                  totalSecs/3600, totalSecs%3600/60 );
       total->insert( t );
       total->show();
    }

private:
    QPushButton *begin, *end, *show;
    QTextEdit   *total;
    uint         number;
    QDateTime   *startWork,
                *endWork;
};

#include  "worktime.moc"

//....................................................................... main
int main( int argc, char *argv[] )
{
   QApplication myapp( argc, argv );
 
   QWidget* mywidget = new WorkTime(); 
   mywidget->setGeometry( 200, 100, 800, 500 ); 
   mywidget->setFixedSize( 800, 500 ); 


   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
