#include  <qxml.h>
#include  <iostream>
using namespace std;
//............................................................... MyXmlParser
class MyXmlParser : public QXmlDefaultHandler {
 public:
    bool startDocument() {
       indent = "";
       return true;
    }
    bool startElement( const QString&, const QString&,
                       const QString& qName, const QXmlAttributes& ) {
        cout << indent << qName << endl;
        indent += "   ";   // 3 Zeichen einruecken
        return true;
    }
    bool endElement( const QString&, const QString&, const QString& ) {
       indent.remove( 0, 3 );   // 3 Zeichen wieder ausruecken
       return true;
    }
 private:
    QString indent;
};
//...................................................................... main
int main( int argc, char *argv[] ) {
   for ( int i=1; i<argc; i++ ) {
      QFile            xmlFile( argv[i] ); //.. Datei, die XML-Dokument enthlt
      MyXmlParser      handler;  //... Handler-Objekt, das die Events empfngt
      QXmlInputSource  source( &xmlFile ); //... Festlegen der zu parsenden Datei
      QXmlSimpleReader reader;  //... Das Parser-Objekt (der Leser)
      cout << endl << argv[i] << endl << "===========" << endl;
      reader.setContentHandler( &handler ); //... Registrieren des Event-Handlers
      reader.parse( source ); //... Starten des Parsens
   }
   return 0;
}
