#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qrect.h>
#include <stdlib.h>
#include <time.h>

//------------------------------------------ class MalFenster --------------
class MalFenster : public QWidget
{
public:
   MalFenster() { }

protected:
   virtual void mousePressEvent( QMouseEvent* ) {
      QPainter p( this );

      QRect r1( ::rand()%200, ::rand()%200, ::rand()%300, ::rand()%300 ),
            r2( ::rand()%200, ::rand()%200, ::rand()%300, ::rand()%300 ),
            rDurch = r1,
            rUm    = r1;

      p.fillRect( 0, 0, 500, 500, backgroundColor() );
      rDurch &= r2;
      rUm |= r2;

      r1.normalize();
      r2.normalize();
      rDurch.normalize();
      rUm.normalize();

      p.setBrush( Qt::white );
      p.drawRect( rUm );
      p.setBrush( Qt::red );
      p.drawRect( r1 );
      p.setBrush( Qt::green );
      p.drawRect( r2 );
      if ( !rDurch.isEmpty() ) {
         p.setBrush( QBrush( Qt::yellow, QBrush::SolidPattern ) );
         p.drawRect( rDurch );
         p.setBrush( QBrush( Qt::black, QBrush::BDiagPattern ) );
         p.drawRect( rDurch );
         drawCenter( p, rDurch, Qt::yellow );
      }
      drawCenter( p, rUm, Qt::white );
      drawCenter( p, r1, Qt::red );
      drawCenter( p, r2, Qt::green );
   }

private:
   void drawCenter( QPainter &p, QRect r, QColor c ) {
      QRect center( r.left() + r.width()/2 - 4,
                    r.top() + r.height()/2 - 4, 8, 8 );
      p.setBrush( QBrush( c, QBrush::SolidPattern ) );
      p.drawEllipse( center );
   }
};

//------------------------------------------------------ main --------------
int main( int argc, char* argv[] )
{
   QApplication myapp( argc, argv );

   MalFenster* mywidget = new MalFenster();
   mywidget->setGeometry( 50, 50, 500, 500 );

   ::srand( time( NULL ) ); 
   myapp.setMainWidget( mywidget );
   mywidget->show();
   return myapp.exec();
}
