#include <stdio.h>
#include <stdlib.h>
#include <time.h>

class CZufall
{
   int m_value;
   static int m_cnt;   // Dies ist nur die DEKLARATION des statischen
                       // Datenelements 'm_cnt' --> noch kein Speicher belegt.
                       // Das Schlsselwort static ist erforderlich.
public:
   CZufall() {
      if (m_cnt==0)
         srand(time(NULL)); // nur erstemal Zuf.zahlengenerator initialisieren
      m_value = rand() % 1000; // Zufallszahl aus Intervall [0,999]
      m_cnt++;
   }
   ~CZufall() { m_cnt--; }

   int GetValue()      { return m_value; }
   int static GetCnt() { return m_cnt;   }  // statische Elementfunktion
};

int CZufall::m_cnt=0;   // DEFINITION des statischen Elements. 
                        // Das Schlsselwort static ist hier nicht erlaubt.
int main(void)
{
   CZufall* werte[5];

   for(int i=0; i<5; i++) {
      werte[i] = new CZufall;
      printf("%d. Zufallszahl; %d\n", i+1, werte[i]->GetValue());
   }
   printf(".... Momentan %d Zufallszahlen\n", CZufall::GetCnt());
      
   {
      CZufall zahl1, zahl2, zahl3;
      printf("...... Jetzt sind es %d Zufallszahlen\n", CZufall::GetCnt());
   }
   printf(".... Nach Block: %d Zufallszahlen\n", CZufall::GetCnt());

   delete werte[4];
   delete werte[3];
   printf(".... Nun noch: %d Zufallszahlen\n", CZufall::GetCnt());

   return 0;
}
