#include <qapplication.h>   //... in jedem Qt-Programm notwendig
#include <qlabel.h>         //... fr Klasse QLabel
#include <qpushbutton.h>    //... fr Klasse QPushbutton
#include <qfont.h>          //... fr Klasse QFont

int main( int argc, char* argv[] )
{
      // Instantiierung eines QApplication-Objekts; immer notwendig
   QApplication myapp( argc, argv );

      // Hauptwidget, in dem Buttons und Text untergebracht werden.
   QWidget* mywidget = new QWidget();
         //... horizontale, vertikale Position, Breite, Hhe in Pixel
   mywidget->setGeometry( 200, 100, 450, 150 );

      // Instantiierung eines ersten Buttons
   QPushButton* erster_button = new QPushButton(
               "Quit (pressed(): schon beim Mausclick)", mywidget );
         // Rel. Position (30,10) in mywidget (400 breit, 30 hoch)
   erster_button->setGeometry( 30, 10, 400, 30 );
         //... Tritt Signal 'pressed' bei erster_button auf, ist der
         //... SLOTcode 'quit' (Verlassen des Programms) aufzurufen
   QObject::connect( erster_button, SIGNAL( pressed() ), &myapp, SLOT( quit() ) );

      // Instantiierung eines Labels (nur Text)
   QLabel* mylabel = new QLabel( "Ein Programm mit zwei Quit-Buttons", mywidget );
         // Rel. Position (30,40) in mywidget (400 breit, 50 hoch)
   mylabel->setGeometry( 30, 40, 400, 50 );
   mylabel->setFont(QFont("Times", 18, QFont::Bold) );

      // Instantiierung eines zweiten Buttons
   QPushButton* zweiter_button = new QPushButton(
        "Quit (clicked(): erst nach Klick und Loslassen der Maus)", mywidget );
         // Rel. Position (30,90) in mywidget (400 breit, 50 hoch)
   zweiter_button->setGeometry( 30, 90, 400, 50 );
         // Tritt Signal 'clicked' bei zweiter_button auf, ist der
         // SLOTcode 'quit' (Verlassen des Programms) aufzurufen
   QObject::connect( zweiter_button, SIGNAL( clicked() ), &myapp, SLOT( quit() ) );

   myapp.setMainWidget( mywidget ); // 'mywidget' ist das Hauptwidget
   mywidget->show();    // Zeige Hauptwidget mit seinen Subwidgets an
   return myapp.exec(); // bergabe der Kontrolle an Methode 'exec'
                        // von QApplication
}
